<?
/*
 * paged_forms.php
 *
 * @(#) $Header: /opt2/ena/metal/forms/paged_forms.php,v 1.1 1999/04/20 04:53:52 mlemos Exp $
 *
 */

class paged_form_class extends form_class
{
	var $page_variable="page";
	var $back_variable="back";
	var $continue_variable="continue";
	var $submit_variable="submit";
	var $verify_field_mark="[X]";
	var $warning_color="";

	var $pages=array();
	var $page;
	var $next_page;

	Function Setup($pages)
	{
		for($page=0;$page<count($pages);$page++)
			$this->pages[$pages[$page]]=$page;
		Reset($this->pages);
		$first_page=Key($this->pages);
		if(!$this->IsSetGlobal($this->page_variable))
			$page=$first_page;
		else
		{
			$page=$this->GetGlobal($this->page_variable);
			if(!IsSet($this->pages[$page]))
				$page=$first_page;
		}
		$page_number=$this->pages[$page];
		UnSet($next_page);
		if($this->IsSetGlobal($this->continue_variable)
		&& $page_number<count($this->pages))
		{
			$page_number++;
			if($page_number>=count($this->pages))
				$next_page="";
		}
		else
		{
			if($this->IsSetGlobal($this->back_variable)
			&& $page_number>0)
				$page_number--;
			else
				$next_page=$page;
		}
		if(!IsSet($next_page))
		{
			for(Reset($this->pages);$this->pages[Key($this->pages)]!=$page_number;Next($this->pages));
			$next_page=Key($this->pages);
		}
		$this->page=$page;
		$this->next_page=$next_page;

		$this->AddInput(array(
			"TYPE"=>"hidden",
			"NAME"=>$this->page_variable,
			"VALUE"=>""
		));
		$this->AddInput(array(
			"TYPE"=>"hidden",
			"NAME"=>$this->submit_variable,
			"VALUE"=>1
		));
	}

	Function ValidationSubForm()
	{
		return(($this->IsSetGlobal($this->back_variable) || !strcmp($this->next_page,"")) ? $this->next_page : $this->page);
	}

	Function ValidatePage(&$verify,&$error_message)
	{
		$error_message=$this->Validate(&$verify,$this->ValidationSubForm());
		return("");
	}

	Function Verify(&$error_message,&$verify,&$submit)
	{
		$this->LoadInputValues($this->IsSetGlobal($this->submit_variable));
		$verify=array();
		if($this->IsSetGlobal($this->submit_variable))
		{
			if(strcmp($error=$this->ValidatePage(&$verify,&$error_message),""))
			{
				$submit=0;
				return($error);
			}
			if(($submit=(!strcmp($error_message,""))))
			{
				if(strcmp($this->next_page,$this->page))
				{
					$this->page=$this->next_page;
					$this->SetInputValue($this->page_variable,$this->page);
					$submit=(!strcmp($this->page,""));
				}
			}
			else
			{
				$error_message=HtmlEntities($error_message);
				Reset($verify);
				$verify_page=$verify[Key($verify)];
				if($this->pages[$this->page]>$this->pages[$verify_page])
				{
					$this->page=$verify_page;
					$this->SetInputValue($this->page_variable,$this->page);
				}
			}
		}
		else
		{
			$error_message="";
			$submit=0;
		}
		return("");
	}

	Function OutputForm($document_output,&$verify,$error_message,$labels)
	{
		if($this->pages[$this->page]>0)
		{
			for($page_number=0,Reset($this->pages);$page_number<count($this->pages);Next($this->pages),$page_number++)
			{
				$previous_page=Key($this->pages);
				if($this->pages[$this->page]==$page_number+1)
					break;
			}
			$this->AddInput(array(
				"TYPE"=>"submit",
				"NAME"=>$this->back_variable,
				"ID"=>$this->back_variable,
				"VALUE"=>$labels["Back"],
				"SubForm"=>$previous_page
			));
		}
		$this->AddInput(array(
			"TYPE"=>"submit",
			"NAME"=>$this->continue_variable,
			"ID"=>$this->continue_variable,
			"VALUE"=>$labels[$this->pages[$this->page]+1<count($this->pages) ? "Continue" : "Finish"],
			"SubForm"=>$this->page
		));
		$this->AddDataPart("<CENTER><TABLE BORDER>\n");

		if(strcmp($error_message,""))
		{
			$this->AddDataPart("<TR>\n<TH ALIGN=left".(strcmp($this->warning_color,"") ? " BGCOLOR=\"".$this->warning_color."\"" : "")."><UL>\n<LI><FONT SIZE=\"+1\">$error_message</FONT></LI>\n");
			if(count($verify)>1)
			{
				Reset($verify);
				$sub_form=$verify[Key($verify)];
				Next($verify);
				if(!strcmp($sub_form,$verify[Key($verify)]))
					$this->AddDataPart("<LI><FONT SIZE=\"+1\">".sprintf($labels["VerifyMessage"],$this->verify_field_mark)."</FONT></LI>\n");
			}
			$this->AddDataPart("</UL>\n</TH>\n</TR>\n");
		}
		
		$this->AddDataPart("<TR>\n<TD>\n");

		$focus=$this->OutputFormPage(&$verify,$this->verify_field_mark);

		$this->AddDataPart("</TD>\n</TR>\n");

		$this->AddDataPart("<TR>\n<TD COLSPAN=2>");
		if($this->pages[$this->page]==0)
		{
			$this->AddDataPart("<CENTER>");
			$this->AddInputPart($this->continue_variable);
			$this->AddDataPart("</CENTER>");
		}
		else
		{
			$this->AddDataPart("<TABLE WIDTH=\"100%\">\n<TR>\n<TD><CENTER>");
			$this->AddInputPart($this->continue_variable);
			$this->AddDataPart("</CENTER></TD>\n<TD><CENTER>");
			$this->AddInputPart($this->back_variable);
			$this->AddDataPart("</CENTER></TD>\n</TR>\n</TABLE>\n");
		}
		$this->AddDataPart("</TD>\n</TR>\n");

		$this->AddDataPart("</TABLE></CENTER>\n");

		$this->AddInputPart($this->page_variable);
		$this->AddInputPart($this->submit_variable);

		$this->OutputFormHiddenPages();


		$this->Output(array(
			"Function"=>$document_output,
			"EndOfLine"=>"\n"
		));
	}
	
	Function OutputFormPage(&$verify)
	{
		return("");
	}

	Function OutputFormHiddenPages()
	{
	}

};

?>