<?php
if(!defined("METAL_JAVA_CLASS_BINDINGS_INCLUDED"))
{
	define("METAL_JAVA_CLASS_BINDINGS_INCLUDED",1);

/*
 * java_class.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/java_class.php,v 1.21 2003/03/02 08:45:28 mlemos Exp $
 *
 */
 
class java_class_class extends metal_language_bindings_class
{
	Function GenerateComment(&$compiler,$comment,&$result)
	{
		for($line=$comment;strcmp($line,"");)
		{
			$line=$compiler->strtok($line,"\r\n");
			$result[]=array(
				"Data"=>" * $line",
				"Type"=>"COMMAND"
			);
			$line=$compiler->strtok("");
		}
	}

	Function GenerateVariables(&$compiler,&$context,&$module,&$result,$class,$package,$protected)
	{
		for($output_variable=0,Reset($module->classes[$class]["variables"]),$function=0;$function<count($module->classes[$class]["variables"]);$function++,Next($module->classes[$class]["variables"]))
		{
			$name=Key($module->classes[$class]["variables"]);
			if(($protected
			&& IsSet($module->classes[$class]["variables"][$name]["protected"]))
			|| ($package
			&& IsSet($module->classes[$class]["variables"][$name]["package"]))
			|| (!$protected
			&& !$package
			&& !IsSet($module->classes[$class]["variables"][$name]["protected"])
			&& !IsSet($module->classes[$class]["variables"][$name]["package"])))
			{
				if($output_variable==0
				&& !$protected)
				{
					$result[]=array(
						"Data"=>"",
						"Type"=>"COMMAND"
					);
				}
				$value=(IsSet($module->classes[$class]["variables"][$name]["value"]) ? "=".$module->classes[$class]["variables"][$name]["convertedvalue"] : "");
				switch($module->classes[$class]["variables"][$name]["type"])
				{
					case "STRING":
						$type="String";
						break;
					case "INTEGER":
						$type="int";
						break;
					case "FLOAT":
						$type="double";
						break;
					case "BOOLEAN":
						$type="boolean";
						break;
					case "ARRAY":
						$type="Vector";
						$result[]=array(
							"Data"=>"java.util.Vector",
							"Type"=>"IMPORTS"
						);
						break;
					case "HASH":
						$type="Hashtable";
						$result[]=array(
							"Data"=>"java.util.Hashtable",
							"Type"=>"IMPORTS"
						);
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,$module->classes[$class]["variables"][$name]["type"]." is not a supported class variable type");
						return(0);
				}
				$result[]=array(
					"Data"=>($protected ? "protected " : ($package ? "" : "public ")).($type=="" ? "" : "$type ")."$name$value;",
					"Type"=>"COMMAND"
				);
				$output_variable++;
			}
		}
		return(1);
	}

	Function GenerateFunctions(&$module,&$compiler,&$context,&$result,$class,$package,$protected)
	{
		for($output_function=0,Reset($module->classes[$class]["functions"]),$function=0;$function<count($module->classes[$class]["functions"]);$function++,Next($module->classes[$class]["functions"]))
		{
			$name=Key($module->classes[$class]["functions"]);
			if(($protected
			&& IsSet($module->classes[$class]["functions"][$name]["protected"]))
			|| ($package
			&& IsSet($module->classes[$class]["functions"][$name]["package"]))
			|| (!$package
			&& !$protected
			&& !IsSet($module->classes[$class]["functions"][$name]["protected"])
			&& !IsSet($module->classes[$class]["functions"][$name]["package"])))
			{
				if($output_function!=0
				|| !$protected)
				{
					$result[]=array(
						"Data"=>"",
						"Type"=>"COMMAND"
					);
				}
				if(!$module->GenerateFunction($compiler,$class,$name))
					return(0);
				$argument_list="";
				if(IsSet($module->classes[$class]["functions"][$name]["Arguments"]))
				{
					$arguments=$module->classes[$class]["functions"][$name]["Arguments"];
					for(Reset($arguments),$argument=0;$argument<count($arguments);Next($arguments),$argument++)
					{
						$argument_name=Key($arguments);
						if($argument>0)
							$argument_list.=", ";
						switch($arguments[$argument_name]["type"])
						{
							case "STRING":
								$type="String";
								break;
							case "INTEGER":
								$type="int";
								break;
							case "FLOAT":
								$type="double";
								break;
							case "BOOLEAN":
								$type="boolean";
								break;
							case "ARRAY":
								$type="Vector";
								$result[]=array(
									"Data"=>"java.util.Vector",
									"Type"=>"IMPORTS"
								);
								break;
							case "HASH":
								$type="Hashtable";
								$result[]=array(
									"Data"=>"java.util.Hashtable",
									"Type"=>"IMPORTS"
								);
								break;
							case "STRINGBUFFER":
								$type="String[]";
								break;
							case "INTEGERBUFFER":
								$type="int[]";
								break;
							case "FLOATBUFFER":
								$type="double[]";
								break;
							case "BOOLEANBUFFER":
								$type="boolean[]";
								break;
							case "ARRAYBUFFER":
								$type="Vector[]";
								$result[]=array(
									"Data"=>"java.util.Vector",
									"Type"=>"IMPORTS"
								);
								break;
							case "HASHBUFFER":
								$type="Hashtable[]";
								$result[]=array(
									"Data"=>"java.util.Hashtable",
									"Type"=>"IMPORTS"
								);
								break;
							default:
								$compiler->SetElementError($context->file,$context->path,$arguments[$argument_name]["type"]." is not a supported class function argument type");
								return(0);
						}
						$argument_list.=$type." ".$argument_name;
					}
				}
				switch($module->classes[$class]["functions"][$name]["type"])
				{
					case "VOID":
						$type="void";
						break;
					case "STRING":
						$type="String";
						break;
					case "INTEGER":
						$type="int";
						break;
					case "FLOAT":
						$type="double";
						break;
					case "BOOLEAN":
						$type="boolean";
						break;
					case "ARRAY":
						$type="Vector";
						break;
					case "HASH":
						$type="Hashtable";
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,$module->classes[$class]["functions"][$name]["type"]." is not a supported class function type");
						return(0);
				}
				if(count($module->classes[$class]["functions"][$name]["exceptions"]))
				{
					$exceptions=$module->classes[$class]["functions"][$name]["exceptions"];
					for(Reset($exceptions),$exception=0;$exception<count($exceptions);$exception++,Next($exceptions))
					{
						if($exception==0)
							$exception_list=" throws";
						else
							$exception_list.=",";
						$exception_list.=" ".Key($exceptions);
					}
				}
				else
					$exception_list="";
				$result[]=array(
					"Data"=>(IsSet($module->classes[$class]["functions"][$name]["protected"]) ? "protected " : (IsSet($module->classes[$class]["functions"][$name]["package"]) ? "" : "public "))."$type $name($argument_list)$exception_list",
					"Type"=>"COMMAND"
				);
				$result[]=array(
					"Data"=>"{",
					"Type"=>"COMMAND"
				);
				$result[]=array(
					"Data"=>1,
					"Type"=>"INDENT"
				);
				if(!$compiler->GenerateLocalVariables($context,$module->classes[$class]["functions"][$name]["variables"],$result))
					return(0);
				for($part=0;$part<count($module->classes[$class]["functions"][$name]["do"]["code"]);$part++)
				{
					if(strcmp($module->classes[$class]["functions"][$name]["do"]["code"][$part]["Type"],"INITIALIZATION"))
						$result[]=$module->classes[$class]["functions"][$name]["do"]["code"][$part];
					else
						$initialization_result[]=$module->classes[$class]["functions"][$name]["do"]["code"][$part];
				}
				$result[]=array(
					"Data"=>1,
					"Type"=>"OUTDENT"
				);
				$result[]=array(
					"Data"=>"}",
					"Type"=>"COMMAND"
				);
				$output_function++;
			}
		}
		return(1);
	}

	Function Execute(&$compiler,&$context,&$class,$function,&$message)
	{
		switch($function)
		{
			case "output":
				$subclass=$message["class"];
				if(strcmp($class->classes[$subclass]["file"],""))
				{
					$file_name=basename($class->classes[$subclass]["file"]);
					$class_name=$compiler->strtok($file_name,".");
					if(strcmp($compiler->strtok(""),"java"))
					{
						$compiler->SetElementError($context->file,$context->path,"the extension of the class file name ($file_name) is not .java");
						return(0);
					}
					if(strcmp($class_name,$class->classes[$subclass]["name"]))
					{
						$compiler->SetElementError($context->file,$context->path,"the class file name ($class_name) is not the same as the class name (".$class->classes[$subclass]["name"].")");
						return(0);
					}
				}
				$message["result"]=array();
				$message["result"][]=array(
					"Data"=>0,
					"Type"=>"RESETINDENT"
				);
				if(IsSet($class->classes[$subclass]["version"])
				|| IsSet($class->classes[$subclass]["copyright"]))
				{
					$message["result"][]=array(
						"Data"=>"/*",
						"Type"=>"COMMAND"
					);
					$message["result"][]=array(
						"Data"=>" *",
						"Type"=>"COMMAND"
					);
					if(IsSet($class->classes[$subclass]["copyright"]))
					{
						$this->GenerateComment($compiler,$class->classes[$subclass]["copyright"],$message["result"]);
						if(IsSet($class->classes[$subclass]["version"]))
						{
							$message["result"][]=array(
								"Data"=>" *",
								"Type"=>"COMMAND"
							);
						}
					}
					if(IsSet($class->classes[$subclass]["version"]))
						$this->GenerateComment($compiler,$class->classes[$subclass]["version"],$message["result"]);
					$message["result"][]=array(
						"Data"=>" *",
						"Type"=>"COMMAND"
					);
					$message["result"][]=array(
						"Data"=>" */",
						"Type"=>"COMMAND"
					);
					$message["result"][]=array(
						"Data"=>"",
						"Type"=>"COMMAND"
					);
				}
				if(IsSet($class->classes[$subclass]["package"]))
				{
					$message["result"][]=array(
						"Data"=>"package ".$class->classes[$subclass]["package"].";",
						"Type"=>"COMMAND"
					);
					$message["result"][]=array(
						"Data"=>"",
						"Type"=>"COMMAND"
					);
				}
				$result=array();
				$result[]=array(
					"Data"=>"public class ".$class->classes[$subclass]["name"].(IsSet($class->classes[$subclass]["parent"]) ? " extends ".$class->classes[$class->classes[$subclass]["parent"]]["name"] : ""),
					"Type"=>"COMMAND"
				);
				$result[]=array(
					"Data"=>"{",
					"Type"=>"COMMAND"
				);
				$result[]=array(
					"Data"=>1,
					"Type"=>"INDENT"
				);
				if(!$this->GenerateVariables($compiler,$context,$class,$result,$subclass,0,1)
				|| !$this->GenerateVariables($compiler,$context,$class,$result,$subclass,1,0)
				|| !$this->GenerateVariables($compiler,$context,$class,$result,$subclass,0,0))
					return(0);
				if(count($class->classes[$subclass]["variables"])
				&& count($class->classes[$subclass]["functions"]))
				{
					$result[]=array(
						"Data"=>"",
						"Type"=>"COMMAND"
					);
				}
				if(!$this->GenerateFunctions($class,$compiler,$context,$result,$subclass,0,1)
				|| !$this->GenerateFunctions($class,$compiler,$context,$result,$subclass,1,0)
				|| !$this->GenerateFunctions($class,$compiler,$context,$result,$subclass,0,0))
					return(0);
				$result[]=array(
					"Data"=>1,
					"Type"=>"OUTDENT"
				);
				$result[]=array(
					"Data"=>"};",
					"Type"=>"COMMAND"
				);
				$result[]=array(
					"Data"=>"",
					"Type"=>"COMMAND"
				);
				$result[]=array(
					"Data"=>0,
					"Type"=>"RESTOREINDENT"
				);
				$imports=array();
				for($part=0;$part<count($result);$part++)
				{
					if($result[$part]["Type"]=="IMPORTS")
					{
						$java_class=$result[$part]["Data"];
						if(!IsSet($imports[$java_class]))
						{
							$message["result"][]=array(
								"Data"=>"import $java_class;",
								"Type"=>"COMMAND"
							);
							$imports[$java_class]=1;
						}
					}
				}
				if(count($imports))
				{
					$message["result"][]=array(
						"Data"=>"",
						"Type"=>"COMMAND"
					);
				}
				for($part=0;$part<count($result);$part++)
				{
					if($result[$part]["Type"]!="IMPORTS")
						$message["result"][]=$result[$part];
				}
				break;
			case "functionargument":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$message["name"],
						"Type"=>$class->classes[$message["class"]]["functions"][$class->classes[$message["class"]]["function_name"]]["Arguments"][$message["name"]]["type"],
						"Side"=>"BOTH"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "return":
				$context->result[]=array(
					"Data"=>"return ".$message["value"].";",
					"Type"=>"COMMAND"
				);
				break;
			case "instancevariable":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"this.".$message["name"],
						"Type"=>$class->classes[$message["class"]]["variables"][$message["name"]]["type"],
						"Side"=>"BOTH"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "instancecall":
			case "call":
				if(!IsSet($class->generate_function[$message["class"]][$message["function"]]))
				{
					if(!$class->GenerateFunction($compiler,$message["class"],$message["function"]))
						return(0);
					$exceptions=$class->classes[$message["class"]]["functions"][$message["function"]]["exceptions"];
					for(Reset($exceptions),$exception=0;$exception<count($exceptions);$exception++,Next($exceptions))
					{
						$exception=array(
							"Throws"=>Key($exceptions)
						);
						if(!$compiler->DeclareException($context,$exception))
							return(0);
					}
				}
				for($argument_list="",$argument=0;$argument<count($message["argumentlist"]);$argument++)
				{
					if($argument>0)
						$argument_list.=",";
					$argument_list.=$message["argumentlist"][$argument];
				}
				$statement=(strcmp($function,"instancecall") ? $message["object"] : "this").".".$message["function"]."($argument_list)";
				if(strcmp($class->classes[$message["class"]]["functions"][$message["function"]]["type"],"VOID"))
				{
					$context->result[]=array(
						"Data"=>array(
							"Value"=>$statement,
							"Type"=>$class->classes[$message["class"]]["functions"][$message["function"]]["type"],
							"Side"=>"RIGHT"
						),
						"Type"=>"EXPRESSION"
					);
				}
				else
				{
					$context->result[]=array(
						"Data"=>$statement.";",
						"Type"=>"COMMAND"
					);
				}
				break;
			case "new":
				if(IsSet($message["classpointer"]))
				{
					$compiler->SetElementError($context->file,$context->path,"class dynamic loading is not yet supported for the language ".$compiler->language["name"]);
					return(0);
				}
				else
				{
					$class_name=$class->classes[$message["subclass"]]["name"];
					for($subclass=$message["subclass"];;$subclass=$class->classes[$subclass]["parent"])
					{
						$class->classes[$subclass]["staticload"]=1;
						if(!$subclass)
							break;
					}
				}
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"new $class_name()",
						"Type"=>"OBJECT:$class_name",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "objectvariable":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$message["object"].".".$message["name"],
						"Type"=>$class->classes[$message["subclass"]]["variables"][$message["name"]]["type"],
						"Side"=>"BOTH"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "examplecode":
				$stripped=array();
				$stripped[]=array(
					"Data"=>"{",
					"Type"=>"COMMAND"
				);
				$stripped[]=array(
					"Data"=>1,
					"Type"=>"INDENT"
				);
				if(!$compiler->GenerateLocalVariables($context,$message["variables"],$variables_result))
					return(0);
				for($part=0;$part<count($variables_result);$part++)
				{
					switch($variables_result[$part]["Type"])
					{
						case "IMPORTS":
							break;
						case "INITIALIZATION":
							if($message["initialization"])
								break;
						default:
							$stripped[]=$variables_result[$part];
							break;
					}
				}
				for($part=0;$part<count($message["result"]);$part++)
				{
					switch($message["result"][$part]["Type"])
					{
						case "IMPORTS":
							break;
						case "INITIALIZATION":
							if($message["initialization"])
								break;
						default:
							$stripped[]=$message["result"][$part];
							break;
					}
				}
				$stripped[]=array(
					"Data"=>1,
					"Type"=>"OUTDENT"
				);
				$stripped[]=array(
					"Data"=>"}",
					"Type"=>"COMMAND"
				);
				if(!$compiler->GenerateOutput($context,$stripped,$output,"",0))
					return(0);
				$context->result[]=array(
					"Data"=>$output,
					"Type"=>"DATA"
				);
				break;
			case "typename":
				switch($message["type"])
				{
					case "VOID":
						$message["name"]="";
						break;
					case "STRING":
						$message["name"]="String";
						break;
					case "INTEGER":
						$message["name"]="int";
						break;
					case "FLOAT":
						$message["name"]="double";
						break;
					case "BOOLEAN":
						$message["name"]="bool";
						break;
					case "OBJECT":
						$message["name"]="Object";
						break;
					case "ARRAY":
						$message["name"]="Vector";
						break;
					case "HASH":
						$message["name"]="Hashtable";
						break;
					case "STRINGBUFFER":
						$message["name"]="String[]";
						break;
					case "INTEGERBUFFER":
						$message["name"]="int[]";
						break;
					case "FLOATBUFFER":
						$message["name"]="double[]";
						break;
					case "BOOLEANBUFFER":
						$message["name"]="bool[]";
						break;
					case "OBJECTBUFFER":
						$message["name"]="Object[]";
						break;
					case "ARRAYBUFFER":
						$message["name"]="Vector[]";
						break;
					case "HASHBUFFER":
						$message["name"]="Hashtable[]";
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,$message["type"]." is not a supported class data type");
						return(0);
				}
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,"bindings for function \"$function\" are not implemented for language ".$compiler->language["name"]);
				return(0);
		}
		return(1);
	}
};
 
}
?>