<?php
if(!defined("METAL_JAVA_FLOW_BINDINGS_INCLUDED"))
{
	define("METAL_JAVA_FLOW_BINDINGS_INCLUDED",1);

/*
 * java_flow.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/java_flow.php,v 1.15 2003/03/02 08:46:29 mlemos Exp $
 *
 */
 
class java_flow_class extends metal_language_bindings_class
{
	Function Execute(&$compiler,&$context,&$class,$function,&$message)
	{
		switch($function)
		{
			case "loop.while":
				if($message["loopstart"])
				{
					$message["commands"][]=array(
						"Data"=>"if(!(".$message["condition"]."))",
						"Type"=>"COMMAND"
					);
					$message["commands"][]=array(
						"Data"=>1,
						"Type"=>"INDENT"
					);
					$message["commands"][]=array(
						"Data"=>"break;",
						"Type"=>"COMMAND"
					);
					$message["commands"][]=array(
						"Data"=>1,
						"Type"=>"OUTDENT"
					);
				}
				else
				{
					$message["commands"]=array(
						array(
							"Data"=>"for(;".$message["condition"].";)",
							"Type"=>"COMMAND"
						),
						array(
							"Data"=>"{",
							"Type"=>"COMMAND"
						),
						array(
							"Data"=>1,
							"Type"=>"INDENT"
						)
					);
					$message["loopstart"]=1;
				}
				break;
			case "loop.do":
				if(!$message["loopstart"])
				{
					$message["commands"]=array(
						array(
							"Data"=>"for(;;)",
							"Type"=>"COMMAND"
						),
						array(
							"Data"=>"{",
							"Type"=>"COMMAND"
						),
						array(
							"Data"=>1,
							"Type"=>"INDENT"
						)
					);
					$message["loopstart"]=1;
				}
				if(!$class->GetDoCommands($compiler,$context,$message["path"],$message["commands"],"invalid loop do statments",$message["skipwhitespace"]))
					return(0);
				break;
			case "loop.end":
				if(!$message["loopstart"])
				{
					$message["commands"]=array(
						array(
							"Data"=>"for(;;)",
							"Type"=>"COMMAND"
						),
						array(
							"Data"=>"{",
							"Type"=>"COMMAND"
						),
						array(
							"Data"=>1,
							"Type"=>"INDENT"
						)
					);
					$message["loopstart"]=1;
				}
				$message["commands"][]=array(
					"Data"=>1,
					"Type"=>"OUTDENT"
				);
				$message["commands"][]=array(
					"Data"=>"}",
					"Type"=>"COMMAND"
				);
				break;
			case "switch":
				if($message["valuetype"]=="STRING")
				{
					$variable=array(
						"Prefix"=>"switch_value",
						"Type"=>"STRING"
					);
					if(!$compiler->AllocateTemporaryVariable($context,$variable))
						return(0);
					$switch_value=$variable["Declaration"];
					$context->result[]=array(
						"Data"=>$switch_value."=".$message["value"].";",
						"Type"=>"COMMAND"
					);
					switch(count($message["case"]))
					{
						case 1:
							Reset($message["case"]);
							$case_0=Key($message["case"]);
							$switch_index=$switch_value.".equals(".$message["case"][$case_0]["value"].") ? 0 : 1";
							break;
						case 2:
							Reset($message["case"]);
							$case_0=Key($message["case"]);
							Next($message["case"]);
							$case_1=Key($message["case"]);
							$switch_index=$switch_value.".equals(".$message["case"][$case_0]["value"].") ? 0 : (".$switch_value.".equals(".$message["case"][$case_1]["value"].") ? 1 : 2)";
							break;
						case 3:
							Reset($message["case"]);
							$case_0=Key($message["case"]);
							Next($message["case"]);
							$case_1=Key($message["case"]);
							Next($message["case"]);
							$case_2=Key($message["case"]);
							$switch_index=$switch_value.".equals(".$message["case"][$case_0]["value"].") ? 0 : (".$switch_value.".equals(".$message["case"][$case_1]["value"].") ? 1 : (".$switch_value.".equals(".$message["case"][$case_2]["value"].") ? 2 : 3))";
							break;
						default:
							$variable=array(
								"Prefix"=>"switch_index",
								"Type"=>"INTEGER"
							);
							if(!$compiler->AllocateTemporaryVariable($context,$variable))
								return(0);
							$switch_index=$variable["Declaration"];
							for($case_values="",$case=0,Reset($message["case"]);$case<count($message["case"]);Next($message["case"]),$case++)
							{
								if($case>0)
									$case_values.=",";
								$case_values.=$message["case"][Key($message["case"])]["value"];
							}
							$variable=array(
								"Prefix"=>"switch_cases",
								"Type"=>"STRINGARRAY",
								"InitialValue"=>"{".$case_values."}"
							);
							if(!$compiler->AllocateTemporaryVariable($context,$variable))
								return(0);
							$switch_cases=$variable["Declaration"];
							$context->result[]=array(
								"Data"=>"for(".$switch_index."=0;".$switch_index."<".count($message["case"]).";".$switch_index."++)",
								"Type"=>"COMMAND"
							);
							$context->result[]=array(
								"Data"=>1,
								"Type"=>"INDENT"
							);
							$context->result[]=array(
								"Data"=>"if(".$switch_value.".equals(".$switch_cases."[".$switch_index."]))",
								"Type"=>"COMMAND"
							);
							$context->result[]=array(
								"Data"=>1,
								"Type"=>"INDENT"
							);
							$context->result[]=array(
								"Data"=>"break;",
								"Type"=>"COMMAND"
							);
							$context->result[]=array(
								"Data"=>1,
								"Type"=>"OUTDENT"
							);
							$context->result[]=array(
								"Data"=>1,
								"Type"=>"OUTDENT"
							);
							break;
					}
				}
				else
					$switch_index=$message["value"];
				$context->result[]=array(
					"Data"=>"switch(".$switch_index.")",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>"{",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>1,
					"Type"=>"INDENT"
				);
				for($case=0,Reset($message["case"]);$case<count($message["case"]);Next($message["case"]),$case++)
				{
					$value=Key($message["case"]);
					$context->result[]=array(
						"Data"=>"case ".($message["valuetype"]=="STRING" ? $case : $message["case"][$value]["value"]).":",
						"Type"=>"COMMAND"
					);
					$context->result[]=array(
						"Data"=>1,
						"Type"=>"INDENT"
					);
					if(!$class->GetDoCommands($compiler,$context,$message["case"][$value]["do"],$context->result,"invalid switch case do statments",1))
						return(0);
					$context->result[]=array(
						"Data"=>1,
						"Type"=>"OUTDENT"
					);
				}
				if(IsSet($message["default"]))
				{
					$context->result[]=array(
						"Data"=>"default:",
						"Type"=>"COMMAND"
					);
					$context->result[]=array(
						"Data"=>1,
						"Type"=>"INDENT"
					);
					if(!$class->GetDoCommands($compiler,$context,$message["default"],$context->result,"invalid switch case do statments",1))
						return(0);
					$context->result[]=array(
						"Data"=>1,
						"Type"=>"OUTDENT"
					);
				}
				$context->result[]=array(
					"Data"=>1,
					"Type"=>"OUTDENT"
				);
				$context->result[]=array(
					"Data"=>"}",
					"Type"=>"COMMAND"
				);
				break;
			case "break":
			case "continue":
				if($message["level"]!=1)
				{
					$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." does not support multilevel ".$function);
					return(0);
				}
				$message["commands"][]=array(
					"Data"=>$function.";",
					"Type"=>"COMMAND"
				);
				break;
			case "if":
				$message["commands"][]=array(
					"Data"=>"if(".(IsSet($message["istrue"]) ? $message["istrue"] : "!(".$message["isfalse"].")").")",
					"Type"=>"COMMAND"
				);
				if(!$class->GetCommands($compiler,$context,$message["then"],$message["commands"],"invalid then if statments",$message["skipwhitespace"]))
					return(0);
				if(IsSet($message["else"]))
				{
					$message["commands"][]=array(
						"Data"=>"else",
						"Type"=>"COMMAND"
					);
					if(!$class->GetCommands($compiler,$context,$message["else"],$message["commands"],"invalid then if statments",$message["skipwhitespace"]))
						return(0);
				}
				break;
			case "comment":
				for($line=0;$line<$message["linesbefore"];$line++)
				{
					$context->result[]=array(
						"Data"=>"",
						"Type"=>"COMMAND"
					);
				}
				$context->result[]=array(
					"Data"=>"/*",
					"Type"=>"COMMAND"
				);
				while(strcmp($message["comment"],""))
				{
					$message["comment"]=strtok($message["comment"],"\r\n");
					$context->result[]=array(
						"Data"=>" *  ".$message["comment"],
						"Type"=>"COMMAND"
					);
					$message["comment"]=strtok("");
				}
				$context->result[]=array(
					"Data"=>" */",
					"Type"=>"COMMAND"
				);
				for($line=0;$line<$message["linesafter"];$line++)
				{
					$context->result[]=array(
						"Data"=>"",
						"Type"=>"COMMAND"
					);
				}
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,"bindings for function \"$function\" are not implemented for language ".$compiler->language["name"]);
				return(0);
		}
		return(1);
	}
};

}
?>