<?php
if(!defined("METAL_BASE_BINDINGS_INCLUDED"))
{
	define("METAL_BASE_BINDINGS_INCLUDED",1);

/*
 * metal_base_bindings.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_base_bindings.php,v 1.21 2002/12/10 00:24:23 mlemos Exp $
 *
 */
 
class metal_base_bindings_class
{
	var $object_name="";
	var $initalized=0;
	var $language_bindings;
	var $indent_stack=array();
	var $scope_stack=array();
	var $temporary_variables_prefix="_";

	Function Setup(&$compiler,&$code,&$context)
	{
		return(1);
	}

	Function EvaluateOperation(&$compiler,&$context,&$left,&$right,&$operator)
	{
		$compiler->SetElementError($context->file,$context->path,"EvaluateOperation method is not implemented");
		return(0);
	}

	Function EvaluateExpression(&$compiler,&$context,&$expression,$position,&$result)
	{
		for(;$position<count($expression);$position++)
		{
			switch($expression[$position]["Type"])
			{
				case "INITIALIZATION":
				case "FILE":
					$context->result[]=$expression[$position];
					break;
				case "EXPRESSION":
					if(IsSet($left))
					{
						if(!IsSet($operator)
						|| IsSet($right))
						{
							$compiler->SetElementError($context->file,$context->path,"it was specified an expression with incorrect syntax");
							return(0);
						}
						$right=$expression[$position];
						$right_position=$position;
					}
					else
						$left=$expression[$position];
					break;
				case "OPERATOR":
					if(!IsSet($left))
					{
						$compiler->SetElementError($context->file,$context->path,"it was specified an operator where a expression was expected");
						return(0);
					}
					if(!IsSet($this->priorities[$expression[$position]["Data"]]))
					{

						$compiler->SetElementError($context->file,$context->path,"it was specified an operator (".$expression[$position]["Data"].") with unknown priority");
						return(0);
					}
					$new_priority=$this->priorities[$expression[$position]["Data"]];
					if(IsSet($operator))
					{
						if(IsSet($right))
						{
							if($new_priority>$priority)
							{
								if(!$this->EvaluateExpression($compiler,$context,$expression,$right_position,$right)
								|| !$this->EvaluateOperation($compiler,$context,$left,$right,$operator))
									return(0);
								Unset($operator);
								Unset($right);
								break 2;
							}
							else
							{
								if(!$this->EvaluateOperation($compiler,$context,$left,$right,$operator))
									return(0);
								Unset($operator);
								Unset($right);
								$operator=$expression[$position];
								$priority=$new_priority;
							}
						}
						else
						{
							$compiler->SetElementError($context->file,$context->path,"it were specified two consecutive operators without an expression between them");
							return(0);
						}
					}
					else
					{
						$operator=$expression[$position];
						$priority=$new_priority;
					}
					break;
				default:
					$compiler->SetElementError($context->file,$context->path,"it was specified a ".$expression[$position]["Type"]." within an expression");
					return(0);
			}
		}
		if(IsSet($right))
		{
			if(!IsSet($operator))
			{
				$compiler->SetElementError($context->file,$context->path,"it was specified an incomplete expression");
				return(0);
			}
			if(!$this->EvaluateOperation($compiler,$context,$left,$right,$operator))
				return(0);
			Unset($operator);
			Unset($right);
		}
		if(!IsSet($left))
		{
			$compiler->SetElementError($context->file,$context->path,"it was specified an empty expression");
			return(0);
		}
		$result=$left;
		return(1);
	}

	Function GetExpressionValue(&$compiler,&$context,&$expression,&$expression_value,&$expression_type)
	{
		$result=array();
		if(!$this->EvaluateExpression($compiler,$context,$expression,0,$result))
			return(0);
		$expression_value=$result["Data"]["Value"];
		$expression_type=$result["Data"]["Type"];
		return(1);
	}

	Function ComposeExpression(&$compiler,&$context,$type,$side,&$expression,$error)
	{
		$result=array();
		if(!$this->EvaluateExpression($compiler,$context,$expression,0,$result))
			return(0);
		$valid_expression=1;
		if(strcmp($side,"ANY")
		&& strcmp($result["Data"]["Side"],"ANY"))
		{
			switch($side)
			{
				case "LEFT":
				case "RIGHT":
				case "BOTH":
					if(strcmp($result["Data"]["Side"],$side))
						$valid_expression=0;
					break;
				case "NOTLEFT":
					if(!strcmp($result["Data"]["Side"],"LEFT"))
						$valid_expression=0;
					break;
				case "NOTRIGHT":
					if(!strcmp($result["Data"]["Side"],"RIGHT"))
						$valid_expression=0;
					break;
			}
		}
		$expression_type=$result["Data"]["Type"];
		if(GetType($colon=strpos($expression_type,":"))=="integer")
			$expression_type=substr($expression_type,0,$colon);
		$match_type=$type;
		if(GetType($colon=strpos($match_type,":"))=="integer")
			$match_type=substr($match_type,0,$colon);
		if(!$valid_expression
		|| (strcmp($type,"ANY")
		&& strcmp($expression_type,"ANY")
		&& strcmp($expression_type,$match_type)))
		{
			$compiler->SetElementError($context->file,$context->path,$error);
			return(0);
		}
		if(strcmp($type,"ANY")
		&& !strcmp($expression_type,"ANY"))
			$result["Data"]["Type"]=$type;
		$context->result[]=$result;
		return(1);
	}

	Function ConvertTypedData(&$compiler,&$context,$type,$data)
	{
		$compiler->SetElementError($context->file,$context->path,"ConvertTypedData method is not implemented");
		return(0);
	}

	Function GenerateOutput(&$compiler,&$context,$data,&$output,$indent,$evaluate)
	{
		$compiler->SetElementError($context->file,$context->path,"GenerateOutput method is not implemented");
		return(0);
	}

	Function GetBindingsProperty(&$compiler,&$context,$property,&$value)
	{
		$compiler->SetElementError($context->file,$context->path,"GetBindingsProperty method is not implemented");
		return(0);
	}

	Function StartScope(&$compiler,&$context,&$scope,$type)
	{
		$scope=count($this->scope_stack);
		$this->scope_stack[$scope]=array(
			"Type"=>$type,
			"Variables"=>array(),
			"Exceptions"=>array()
		);
		return(1);
	}

	Function EndScope(&$compiler,&$context,$scope)
	{
		if($scope<count($this->scope_stack)-1)
		{
			$compiler->SetElementError($context->file,$context->path,"attempt to end a scope before ending all the scopes nested inside");
			return(0);
		}
		if($scope>count($this->scope_stack)-1)
		{
			$compiler->SetElementError($context->file,$context->path,"attempt to end a non existing scope");
			return(0);
		}
		for($var=0,Reset($this->scope_stack[$scope]["Variables"]);$var<count($this->scope_stack[$scope]["Variables"]);Next($this->scope_stack[$scope]["Variables"]),$var++)
		{
			$name=Key($this->scope_stack[$scope]["Variables"]);
			switch($this->scope_stack[$scope]["Variables"][$name]["Type"])
			{
				case "ANY":
				case "UNDEFINED":
					$compiler->SetElementError($this->scope_stack[$scope]["Variables"][$name]["DeclarationFile"],$this->scope_stack[$scope]["Variables"][$name]["DeclarationPath"],"it was not defined the type of the variable \"$name\"");
					return(0);
			}
		}
		Unset($this->scope_stack[$scope]);
		return(1);
	}

	Function GetScopeVariables(&$compiler,&$context,$scope,&$variables)
	{
		if($scope>=count($this->scope_stack))
		{
			$compiler->SetElementError($context->file,$context->path,"attempt get the variables of an unknown scope");
			return(0);
		}
		$variables=$this->scope_stack[$scope]["Variables"];
		return(1);
	}

	Function QueryVariable(&$compiler,&$context,&$variable)
	{
		if(IsSet($variable["Name"]))
		{
			$name=$variable["Name"];
			$temporary=(IsSet($variable["Temporary"]) && $variable["Temporary"]);
			if($temporary)
				$name.=$this->temporary_variables_prefix;
			else
			{
				if(!strcmp(substr($name,0,strlen($this->temporary_variables_prefix)),$this->temporary_variables_prefix))
				{
					$compiler->SetElementError($context->file,$context->path,"the specified variable name uses a prefix that is reserved for temporary variables");
					return(0);
				}
			}
			$find="name";
		}
		else
		{
			if(IsSet($variable["DeclarationFile"])
			&& IsSet($variable["DeclarationPath"]))
				$find="context";
			else
			{
				$compiler->SetElementError($context->file,$context->path,"it was not specified the variable name");
				return(0);
			}
		}
		if(count($this->scope_stack)==0)
		{
			$compiler->SetElementError($context->file,$context->path,"it was not defined a variable scope");
			return(0);
		}
		$scope=count($this->scope_stack)-1;
		switch($find)
		{
			case "name":
				if(IsSet($this->scope_stack[$scope]["Variables"][$name]))
				{
					$variable=$this->scope_stack[$scope]["Variables"][$name];
					return(1);
				}
				break;
			case "context":
				for($var=0,Reset($this->scope_stack[$scope]["Variables"]);$var<count($this->scope_stack[$scope]["Variables"]);Next($this->scope_stack[$scope]["Variables"]),$var++)
				{
					$name=Key($this->scope_stack[$scope]["Variables"]);
					if($variable["DeclarationFile"]==$this->scope_stack[$scope]["Variables"][$name]["DeclarationFile"]
					&& $variable["DeclarationPath"]==$this->scope_stack[$scope]["Variables"][$name]["DeclarationPath"])
					{
						$variable=$this->scope_stack[$scope]["Variables"][$name];
						return(1);
					}
				}
				break;
		}
		$variable["Declared"]=0;
		return(1);
	}

	Function GetVariableDeclaration(&$compiler,&$context,&$variable)
	{
		$compiler->SetElementError($context->file,$context->path,"GetVariableDeclaration method is not implemented");
		return(0);
	}

	Function DeclareVariable(&$compiler,&$context,&$variable)
	{
		if(IsSet($variable["Type"]))
		{
			$type=$compiler->strtok($variable["Type"],":");
			if(strlen($sub_type=$compiler->strtok(":")))
				$type.=":".$sub_type;
		}
		else
			$type="UNDEFINED";
		$argument=((IsSet($variable["Argument"]) && $variable["Argument"]) ? 1 : 0);
		if(IsSet($variable["InitialValue"]))
			$initial_value=$variable["InitialValue"];
		else
		{
			if(IsSet($variable["Initialized"]))
				$initialized=($variable["Initialized"] ? 1 : 0);
		}
		if(!$this->QueryVariable($compiler,$context,$variable))
			return(0);
		if($variable["Declared"])
		{
			if($variable["Type"]=="UNDEFINED"
			&& $type!="UNDEFINED")
			{
				$this->scope_stack[$variable["Scope"]]["Variables"][$variable["Name"]]["Type"]=$type;
				if(IsSet($initialized)
				&& !IsSet($this->scope_stack[$variable["Scope"]]["Variables"][$variable["Name"]]["Initialized"]))
					$this->scope_stack[$variable["Scope"]]["Variables"][$variable["Name"]]["Initialized"]=$initialized;
				return(1);
			}
			$compiler->SetElementError($context->file,$context->path,"variable \"".$variable["Name"]."\" is already declared");
			return(0);
		}
		if(!$this->GetVariableDeclaration($compiler,$context,$variable))
			return(0);
		$scope=count($this->scope_stack)-1;
		$variable["Scope"]=$scope;
		$variable["ScopeType"]=$this->scope_stack[$scope]["Type"];
		$variable["Declared"]=1;
		$variable["Argument"]=$argument;
		if(IsSet($initial_value))
		{
			$variable["InitialValue"]=$initial_value;
			$variable["Initialized"]=1;
		}
		else
		$variable["DeclarationFile"]=$context->file;
		$variable["DeclarationPath"]=$context->path;
		$this->scope_stack[$scope]["Variables"][$variable["Name"]]=$variable;
		return(1);
	}

	Function AllocateTemporaryVariable(&$compiler,&$context,&$variable)
	{
		for($attempt=0;;$attempt++)
		{
			$variable["Name"]=$variable["Prefix"].($attempt==0 ? "" : $attempt);
			$variable["Temporary"]=1;
			if(!$this->QueryVariable($compiler,$context,$variable))
				return(0);
			if($variable["Declared"])
				continue;
			return($this->DeclareVariable($compiler,$context,$variable));
		}
	}

	Function DeclareException(&$compiler,&$context,&$exception)
	{
		if(count($this->scope_stack)==0)
		{
			$compiler->SetElementError($context->file,$context->path,"it was not defined a exception scope");
			return(0);
		}
		if(!IsSet($exception["Throws"]))
		{
			$compiler->SetElementError($context->file,$context->path,"it was not specified the exception that is thrown");
			return(0);
		}
		$scope=count($this->scope_stack)-1;
		$throws=$exception["Throws"];
		if(!IsSet($this->scope_stack[$scope]["Exceptions"][$throws]))
			$this->scope_stack[$scope]["Exceptions"][$throws]=array();
		$this->scope_stack[$scope]["Exceptions"][$throws][]=array(
			"file"=>$context->file,
			"path"=>$context->path
		);
		return(1);
	}

	Function GetScopeExceptions(&$compiler,&$context,$scope,&$exceptions)
	{
		if($scope>=count($this->scope_stack))
		{
			$compiler->SetElementError($context->file,$context->path,"attempt get the exceptions of an unknown scope");
			return(0);
		}
		$exceptions=$this->scope_stack[$scope]["Exceptions"];
		return(1);
	}

	Function GenerateLocalVariables(&$compiler,&$context,&$variables,&$result)
	{
		$compiler->SetElementError($context->file,$context->path,"GenerateLocalVariables method is not implemented");
		return(0);
	}
};

}
?>