<?php
if(!defined("METAL_CGI_INCLUDED"))
{
	define("METAL_CGI_INCLUDED",1);

/*
 * metal_cgi.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_cgi.php,v 1.15 2004/05/11 02:19:34 mlemos Exp $
 *
 */
 
class metal_cgi_class extends metal_base_class
{
	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the cgi class");
			return(0);
		}
		switch($function)
		{
			case "definedvalue":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid cgi definedvalue name")
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$value,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"IsSet(\$GLOBALS[$value])",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "getvalue":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid cgi getvalue name")
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$value,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"\$GLOBALS[$value]",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "geturi":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"\$GLOBALS[\"PHP_SELF\"]",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "cookiedetection":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"IsSet(\$GLOBALS[\"HTTP_COOKIE_VARS\"])",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "definedcookievalue":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid cgi definedcookievalue name")
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$value,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"IsSet(\$GLOBALS[\"HTTP_COOKIE_VARS\"][$value])",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "getcookievalue":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid cgi getcookievalue name")
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$value,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"\$GLOBALS[\"HTTP_COOKIE_VARS\"][$value]",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "setcookie":
				$values=array();
				$elements=$code->structure[$context->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "name":
							case "value":
							case "path":
							case "expires":
							case "domain":
							case "secure":
							  if(IsSet($values[$data["Tag"]]))
							  {
									$compiler->SetElementError($context->file,$element_path,"it was specified the ".$data["Tag"]." cgi setcookie argument more than once");
									return(0);
							  }
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid cgi setcookie ".$data["Tag"]." value")
								|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$values[$data["Tag"]],$expression_type))
									return(0);
								break;
							default:
								$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported cgi setcookie argument");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				if(!IsSet($values[$argument="name"])
				&& !IsSet($values[$argument="value"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified the cgi setcookie $argument argument");
					return(0);
				}
				$command="Header(\"Set-Cookie: \".UrlEncode(".$values["name"].").\"=\".UrlEncode(".$values["value"].")";
				if(IsSet($values["expires"]))
					$command.=".\"; expires=\".".$values["expires"];
				if(IsSet($values["path"]))
					$command.=".\"; path=\".".$values["path"];
				if(IsSet($values["domain"]))
					$command.=".\"; domain=\".".$values["domain"];
				if(IsSet($values["secure"]))
					$command.=".\"; secure\"";
				$command.=");";
				$context->result[]=array(
					"Data"=>$command,
					"Type"=>"COMMAND"
				);
				break;
			case "getvariable":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid cgi getvariable name")
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$value,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"getenv($value)",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "redirect":
				$types=array(
					"url"=>"STRING"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"cgi",$function))
					return(0);
				$context->result[]=array(
					"Data"=>"Header(\"HTTP/1.0 302 Moved Temporarily\");",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>"Header(\"Location: \".".$values["url"].");",
					"Type"=>"COMMAND"
				);
				break;
			case "responseheader":
				$types=array(
					"header"=>"STRING"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"cgi",$function))
					return(0);
				$context->result[]=array(
					"Data"=>"Header(".$values["header"].");",
					"Type"=>"COMMAND"
				);
				break;
			case "postdata":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"\$GLOBALS[\"HTTP_RAW_POST_DATA\"]",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "converthtmlentities":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid convertisonlatin1 string expression")
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$string,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"HtmlEntities($string)",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "urlencode":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid urlencode string expression")
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$string,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"UrlEncode($string)",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;

			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported cgi object function");
				return(0);
		}
		return(1);
	}

};
 
}
?>