<?php
if(!defined("METAL_CLASS_INCLUDED"))
{
	define("METAL_CLASS_INCLUDED",1);

/*
 * metal_class.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_class.php,v 1.108 2004/10/17 01:41:24 mlemos Exp $
 *
 */
 
class metal_class_class extends metal_base_class
{
	var $classes=array();
	var $subclasses=array();
	var $current_class=0;
	var $current_function="";
	var $current_argument="";
	var $current_argument_number=0;
	var $current_variable="";
	var $current_subclass=0;
	var $generate_function=array();
	var $dependencies=array();

	Function OutputDependencies(&$context,$class)
	{
		if(IsSet($this->classes[$class]["parent"]))
			$this->OutputDependencies($context,$this->classes[$class]["parent"]);
		if(IsSet($this->dependencies[$class]))
		{
			for($dependency=0;$dependency<count($this->dependencies[$class]);$dependency++)
			{
				$context->result[]=array(
					"Data"=>array(
						"Name"=>$this->dependencies[$class][$dependency],
						"Type"=>"DEPENDENCY"
					),
					"Type"=>"FILE"
				);
			}
		}
	}

	Function GetDocumentation(&$scope,&$compiler,&$code,&$attributes,$element_path,$default_scope)
	{
		Unset($idiom);
		$documentation=array();
		$documentation_elements=$code->structure[$element_path]["Elements"];
		for($documentation_element=0;$documentation_element<$documentation_elements;$documentation_element++)
		{
			$documentation_element_path=$element_path.",$documentation_element";
			$data=$code->structure[$documentation_element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "idiom":
						if(IsSet($idiom))
						{
							$compiler->SetElementError($attributes->file,$documentation_element_path,"it was defined the documentation idiom more than once");
							return(0);
						}
						if(!$compiler->GetValidName($attributes->file,$documentation_element_path,$idiom,"it was not specified a valid class documentation idiom option"))
							return(0);
						if(IsSet($scope["documentation"][$idiom]))
						{
							$compiler->SetElementError($attributes->file,$documentation_element_path,"it was specified the idiom of an already defined class documentation section");
							return(0);
						}
						break;
					default:
						if(IsSet($documentation[$data["Tag"]]))
						{
							$compiler->SetElementError($attributes->file,$documentation_element_path,"it was specified the documentation tag ".$data["Tag"]." more than once");
							return(0);
						}
						$compiler->CopyEmptyContext($attributes,$documentation[$data["Tag"]]);
						$documentation[$data["Tag"]]->path=$documentation_element_path;
						break;
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($attributes->file,$data,$documentation_element_path))
					return(0);
			}
		}
		if(!IsSet($idiom))
		{
			if(IsSet($default_scope["documentation"]))
			{
				Reset($default_scope["documentation"]);
				$idiom=Key($default_scope["documentation"]);
			}
			else
			{
				$compiler->SetElementError($attributes->file,$element_path,"it was not defined the class documentation idiom");
				return(0);
			}
		}
		$scope["documentation"][$idiom]=$documentation;
		return(1);
	}

	Function SetupClass(&$compiler,&$code,&$attributes,$file)
	{
		$index=count($this->classes);
		$this->classes[$index]["function_name"]="";
		$this->classes[$index]["return_type"]="";
		$this->classes[$index]["return_value_set"]=0;
		$this->classes[$index]["staticload"]=0;
		$this->classes[$index]["functions"]=array();
		$this->classes[$index]["variables"]=array();
		$this->classes[$index]["declarationfile"]=$attributes->file;
		$this->classes[$index]["declarationpath"]=$attributes->path;
		$parent=0;
		$elements=$code->structure[$attributes->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$attributes->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "parent":
						if(!$compiler->GetValidName($attributes->file,$element_path,$parent_name,"it was not specified a valid class parent name argument"))
							return(0);
						if(count($this->classes[$index]["functions"]))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was attempted to define the name of the parent class after having declared class functions");
							return(0);
						}
						if(count($this->classes[$index]["variables"]))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was attempted to define the name of the parent class after having declared class variables");
							return(0);
						}
						if(!IsSet($this->subclasses[$parent_name]))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was not specified the name of an existing parent class");
							return(0);
						}
						if($parent==$index)
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was not specified that the parent class is the class itself");
							return(0);
						}
						$parent=$this->subclasses[$parent_name];
						break;
					case "name":
						if(IsSet($this->classes[$index]["name"]))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was defined the class name more than once");
							return(0);
						}
						if(!$compiler->GetValidName($attributes->file,$element_path,$class_name,"it was not specified a valid class name argument"))
							return(0);
						if(IsSet($this->subclasses[$class_name]))
						{
							if(!strcmp($this->classes[$this->subclasses[$class_name]]["declarationfile"],$attributes->file)
							&& !strcmp($this->classes[$this->subclasses[$class_name]]["declarationpath"],$attributes->path))
							{
								Unset($this->classes[$index]);
								return(1);
							}
							$compiler->SetElementError($attributes->file,$element_path,"it was specified a subclass name (\"$class_name\") of an existing class");
							return(0);
						}
						$this->classes[$index]["name"]=$class_name;
						$this->subclasses[$class_name]=$index;
						break;
					case "package":
						if(IsSet($this->classes[$index]["package"]))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was defined the class package more than once");
							return(0);
						}
						if(!$compiler->GetValidData($attributes->file,$element_path,$class_package,"it was not specified a valid class package argument"))
							return(0);
						$this->classes[$index]["package"]=$class_package;
						break;
					case "function":
						Unset($name);
						$function=array();
						$function_elements=$code->structure[$element_path]["Elements"];
						for($function_element=0;$function_element<$function_elements;$function_element++)
						{
							$function_element_path=$element_path.",$function_element";
							$data=$code->structure[$function_element_path];
							if(GetType($data)=="array")
							{
								switch($data["Tag"])
								{
									case "name":
										if(IsSet($name))
										{
											$compiler->SetElementError($attributes->file,$function_element_path,"it was defined the class function name more than once");
											return(0);
										}
										if(!$compiler->GetValidName($attributes->file,$function_element_path,$name,"it was not specified a valid class function name option"))
											return(0);
										if(IsSet($this->classes[$index]["functions"][$name]))
										{
											$compiler->SetElementError($attributes->file,$function_element_path,"it was specified a name of an already defined class function");
											return(0);
										}
										if(IsSet($this->classes[$index]["variables"][$name]))
										{
											$compiler->SetElementError($attributes->file,$function_element_path,"it was specified the same name for a class variable and a class function");
											return(0);
										}
										if($index)
										{
											for($class_parent=$parent;;$class_parent=$this->classes[$class_parent]["parent"])
											{
												if(IsSet($this->classes[$class_parent]["functions"][$name]))
												{
													$function["type"]=$this->classes[$class_parent]["functions"][$name]["type"];
													if(IsSet($this->classes[$class_parent]["functions"][$name]["Arguments"]))
														$function["Arguments"]=$this->classes[$class_parent]["functions"][$name]["Arguments"];
													if(IsSet($this->classes[$class_parent]["functions"][$name]["protected"]))
														$function["protected"]=$this->classes[$class_parent]["functions"][$name]["protected"];
													if(IsSet($this->classes[$class_parent]["functions"][$name]["package"]))
														$function["package"]=$this->classes[$class_parent]["functions"][$name]["package"];
													break;
												}
												if(!IsSet($this->classes[$class_parent]["parent"]))
													break;
											}
										}
										break;
									case "type":
										if(!IsSet($name))
										{
											$compiler->SetElementError($attributes->file,$function_element_path,"it was defined the class function return type before specifying its name");
											return(0);
										}
										if($index
										&& IsSet($this->classes[$parent]["functions"][$name]))
										{
											$compiler->SetElementError($attributes->file,$function_element_path,"it was attempted to redefine the class return type of a inherited subclass function");
											return(0);
										}
										if(IsSet($function["type"]))
										{
											$compiler->SetElementError($attributes->file,$function_element_path,"it was defined the class function type more than once");
											return(0);
										}
										if(!$compiler->GetValidData($attributes->file,$function_element_path,$function["type"],"it was not specified a valid class function type option"))
											return(0);
										switch($compiler->strtok($function["type"],":"))
										{
											case "VOID":
											case "STRING":
											case "INTEGER":
											case "FLOAT":
											case "BOOLEAN":
											case "OBJECT":
											case "ARRAY":
											case "HASH":
												break;
											default:
												$compiler->SetElementError($attributes->file,$function_element_path,"it was not defined a valid class function return type");
												return(0);
										}
										break;
									case "package":
										if(!IsSet($this->classes[$index]["package"]))
										{
											$compiler->SetElementError($attributes->file,$function_element_path,"it was defined the class function package access status before specifying the class package");
											return(0);
										}
									case "protected":
										if(!IsSet($name))
										{
											$compiler->SetElementError($attributes->file,$function_element_path,"it was defined the class function ".$data["Tag"]." access status before specifying its name");
											return(0);
										}
										if($index
										&& IsSet($this->classes[$parent]["functions"][$name]))
										{
											$compiler->SetElementError($attributes->file,$function_element_path,"it was attempted to redefine the class ".$data["Tag"]." access status of a inherited subclass function");
											return(0);
										}
										if(IsSet($function["package"])
										|| IsSet($function["protected"]))
										{
											$compiler->SetElementError($attributes->file,$function_element_path,"it was defined the class function access status more than once");
											return(0);
										}
										$function[$data["Tag"]]=1;
										break;
									case "argument":
										if(!IsSet($name))
										{
											$compiler->SetElementError($attributes->file,$function_element_path,"it was defined the class function argument before specifying its name");
											return(0);
										}
										if($index
										&& IsSet($this->classes[$parent]["functions"][$name]))
										{
											$compiler->SetElementError($attributes->file,$function_element_path,"it was attempted to redefine a class argument of a inherited subclass function");
											return(0);
										}
										Unset($argument_name);
										$argument=array();
										$argument_elements=$code->structure[$function_element_path]["Elements"];
										for($argument_element=0;$argument_element<$argument_elements;$argument_element++)
										{
											$argument_element_path=$function_element_path.",$argument_element";
											$data=$code->structure[$argument_element_path];
											if(GetType($data)=="array")
											{
												switch($data["Tag"])
												{
													case "name":
														if(IsSet($argument_name))
														{
															$compiler->SetElementError($attributes->file,$argument_element_path,"it was defined the class function argument name more than once");
															return(0);
														}
														if(!$compiler->GetValidName($attributes->file,$argument_element_path,$argument_name,"it was not specified a valid class function argument name option"))
															return(0);
														if(IsSet($function["Arguments"][$argument_name]))
														{
															$compiler->SetElementError($attributes->file,$argument_element_path,"it was specified a name of an already defined class function argument");
															return(0);
														}
														break;
													case "type":
														if(IsSet($argument["type"]))
														{
															$compiler->SetElementError($attributes->file,$argument_element_path,"it was defined the class function argument type more than once");
															return(0);
														}
														if(!$compiler->GetValidData($attributes->file,$argument_element_path,$argument["type"],"it was not specified a valid class function type option"))
															return(0);
														switch($compiler->strtok($argument["type"],":"))
														{
															case "STRING":
															case "INTEGER":
															case "FLOAT":
															case "BOOLEAN":
															case "OBJECT":
															case "ARRAY":
															case "HASH":
																break;
															default:
																$compiler->SetElementError($attributes->file,$argument_element_path,"it was not defined a valid class function argument type");
																return(0);
														}
														break;
													case "defaultvalue":
														if(IsSet($argument["defaultvalue"]))
														{
															$compiler->SetElementError($attributes->file,$argument_element_path,"it was defined the class function argument defaultvalue more than once");
															return(0);
														}
														if(IsSet($argument["parameter"]))
														{
															switch($argument["parameter"])
															{
																case "out":
																case "inout":
																	$compiler->SetElementError($attributes->file,$argument_element_path,"it was defined a defaultvalue for a class function argument to be passed as ".$argument["parameter"]);
																	return(0);
															}
														}
														if(!IsSet($argument["type"]))
														{
															$compiler->SetElementError($attributes->file,$argument_element_path,"it was not defined the class function argument type before defining the defaultvalue");
															return(0);
														}
														if(!$compiler->GetValidData($attributes->file,$argument_element_path,$argument["defaultvalue"],"it was not specified a valid class argument defaultvalue option")
														|| !$compiler->ConvertData($attributes,$argument["type"],$argument["defaultvalue"],$argument["converteddefaultvalue"]))
															return(0);
														break;
													case "in":
													case "out":
													case "inout":
														if(IsSet($argument["parameter"]))
														{
															$compiler->SetElementError($attributes->file,$argument_element_path,"class function argument is already defined as ".$argument["parameter"]);
															return(0);
														}
														switch($data["Tag"])
														{
															case "out":
															case "inout":
																if(IsSet($argument["defaultvalue"]))
																{
																	$compiler->SetElementError($attributes->file,$argument_element_path,"it was defined a defaultvalue for a ".$data["Tag"]." class function argument");
																	return(0);
																}
																break;
														}
														$argument["parameter"]=$data["Tag"];
														break;
													case "documentation":
														if(!$this->GetDocumentation($argument,$compiler,$code,$attributes,$argument_element_path,$this->classes[$index]))
															return(0);
														break;
													default:
														$compiler->SetElementError($attributes->file,$argument_element_path,$data["Tag"]." is not a supported class function argument attribute");
														return(0);
												}
											}
											else
											{
												if(!$compiler->CheckWhiteSpace($attributes->file,$data,$argument_element_path))
													return(0);
											}
										}
										if(!IsSet($argument_name))
										{
											$compiler->SetElementError($attributes->file,$function_element_path,"it was not defined the class function argument name");
											return(0);
										}
										if(!IsSet($argument["type"]))
										{
											$compiler->SetElementError($attributes->file,$function_element_path,"it was not defined the class function argument type");
											return(0);
										}
										if(GetType($colon=strpos($type=$argument["type"],":"))=="integer")
										{
											$class=substr($argument["type"],$colon);
											$type=substr($argument["type"],0,$colon);
										}
										else
											$class="";
										if(!IsSet($argument["parameter"]))
										{
											switch($type)
											{
												case "ARRAY":
												case "HASH":
												case "OBJECT":
													$argument["parameter"]="inout";
													break;
												default:
													$argument["parameter"]="in";
													break;
											}
										}
										switch($argument["parameter"])
										{
											case "out":
											case "inout":
												switch($type)
												{
													case "ARRAY":
													case "HASH":
													case "OBJECT":
														$buffer="";
														break;
													default:
														$buffer="BUFFER";
												}
												$argument["type"]=$type.$buffer.$class;
												break;
											default:
												switch($type)
												{
													case "ARRAY":
													case "HASH":
													case "OBJECT":
														$compiler->SetElementError($attributes->file,$function_element_path,"arguments of type \"$type\" may only be \"out\" or \"inout\" parameters");
														return(0);
												}
												break;
										}
										$function["Arguments"][$argument_name]=$argument;
										break;
									case "do":
										if(IsSet($function["do"]))
										{
											$compiler->SetElementError($attributes->file,$function_element_path,"it was defined the class function do statements more than once");
											return(0);
										}
										$function["do"]=array(
											"file"=>$attributes->file,
											"path"=>$function_element_path
										);
										$this->classes[$index]["functions"][$name]=$function;
										break;
									case "documentation":
										if(!$this->GetDocumentation($function,$compiler,$code,$attributes,$function_element_path,$this->classes[$index]))
											return(0);
										break;
									default:
										$compiler->SetElementError($attributes->file,$function_element_path,$data["Tag"]." is not a supported class object attribute");
										return(0);
								}
							}
							else
							{
								if(!$compiler->CheckWhiteSpace($attributes->file,$data,$function_element_path))
									return(0);
							}
						}
						if(!IsSet($name))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was not defined the class function name");
							return(0);
						}
						if(!IsSet($function["type"]))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was not defined the class function return type");
							return(0);
						}
						if(!IsSet($function["do"]))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was not defined the class function do statements");
							return(0);
						}
						break;
					case "variable":
						if(count($this->classes[$index]["functions"]))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was attempted to define a class variable after having declared class functions");
							return(0);
						}
						Unset($name);
						$variable=array();
						$variable_elements=$code->structure[$element_path]["Elements"];
						for($variable_element=0;$variable_element<$variable_elements;$variable_element++)
						{
							$variable_element_path=$element_path.",$variable_element";
							$data=$code->structure[$variable_element_path];
							if(GetType($data)=="array")
							{
								switch($data["Tag"])
								{
									case "name":
										if(IsSet($name))
										{
											$compiler->SetElementError($attributes->file,$variable_element_path,"it was defined the class variable name more than once");
											return(0);
										}
										if(!$compiler->GetValidName($attributes->file,$variable_element_path,$name,"it was not specified a valid class variable name option"))
											return(0);
										if(IsSet($this->classes[$index]["variables"][$name]))
										{
											$compiler->SetElementError($attributes->file,$variable_element_path,"it was specified a name of an already defined class variable");
											return(0);
										}
										if($index
										&& IsSet($this->classes[$parent]["variables"][$name]))
										{
											$variable["type"]=$this->classes[$parent]["variables"][$name]["type"];
											if(IsSet($this->classes[$parent]["variables"][$name]["protected"]))
												$variable["protected"]=$this->classes[$parent]["variables"][$name]["protected"];
											if(IsSet($this->classes[$parent]["variables"][$name]["package"]))
												$variable["protected"]=$this->classes[$parent]["variables"][$name]["package"];
										}
										break;
									case "type":
										if(!IsSet($name))
										{
											$compiler->SetElementError($attributes->file,$variable_element_path,"it was defined the class variable type before specifying its name");
											return(0);
										}
										$class=$parent;
										if($this->InheritedVariableClass($class,$name))
										{
											$compiler->SetElementError($attributes->file,$variable_element_path,"it was attempted to redefine the type of a inherited subclass variable");
											return(0);
										}
										if(IsSet($variable["type"]))
										{
											$compiler->SetElementError($attributes->file,$variable_element_path,"it was defined the class variable type more than once");
											return(0);
										}
										if(!$compiler->GetValidData($attributes->file,$variable_element_path,$variable["type"],"it was not specified a valid class variable type option"))
											return(0);
										switch($compiler->strtok($variable["type"],":"))
										{
											case "STRING":
											case "INTEGER":
											case "FLOAT":
											case "BOOLEAN":
											case "OBJECT":
											case "ARRAY":
											case "HASH":
												break;
											default:
												$compiler->SetElementError($attributes->file,$variable_element_path,"it was not defined a valid class variable type");
												return(0);
										}
										break;
									case "package":
									case "protected":
										if(!IsSet($name))
										{
											$compiler->SetElementError($attributes->file,$variable_element_path,"it was defined the class variable ".$data["Tag"]." access status before specifying its name");
											return(0);
										}
										$class=$parent;
										if($this->InheritedVariableClass($class,$name))
										{
											$compiler->SetElementError($attributes->file,$variable_element_path,"it was attempted to redefine the ".$data["Tag"]." access status of a inherited subclass variable");
											return(0);
										}
										if(IsSet($variable["package"])
										|| IsSet($variable["protected"]))
										{
											$compiler->SetElementError($attributes->file,$variable_element_path,"it was defined the class variable access status more than once");
											return(0);
										}
										$variable[$data["Tag"]]=1;
										break;
									case "notnull":
										if(!IsSet($name))
										{
											$compiler->SetElementError($attributes->file,$variable_element_path,"it was defined the class variable notnull status before specifying its name");
											return(0);
										}
										$class=$parent;
										if($this->InheritedVariableClass($class,$name))
										{
											$compiler->SetElementError($attributes->file,$variable_element_path,"it was attempted to redefine the notnull status of a inherited subclass variable");
											return(0);
										}
										if(IsSet($variable["notnull"]))
										{
											$compiler->SetElementError($attributes->file,$variable_element_path,"it was defined the class variable notnull status more than once");
											return(0);
										}
										$variable["notnull"]=1;
										break;
									case "value":
										$class=$parent;
										if($this->InheritedVariableClass($class,$name))
											$type=$this->classes[$class]["variables"][$name]["type"];
										else
										{
											if(!IsSet($variable["type"]))
											{
												$compiler->SetElementError($attributes->file,$variable_element_path,"it was defined a class variable value before specifying the variable type");
												return(0);
											}
											$type=$variable["type"];
										}
										if(IsSet($variable["value"]))
										{
											$compiler->SetElementError($attributes->file,$variable_element_path,"it was defined the class variable initial value more than once");
											return(0);
										}
										if(!$compiler->GetValidData($attributes->file,$variable_element_path,$variable["value"],"it was not specified a valid class variable value option")
										|| !$compiler->ConvertData($attributes,$type,$variable["value"],$variable["convertedvalue"]))
											return(0);
										break;
									case "documentation";
										if(!$this->GetDocumentation($variable,$compiler,$code,$attributes,$variable_element_path,$this->classes[$index]))
											return(0);
										break;
									default:
										$compiler->SetElementError($attributes->file,$variable_element_path,$data["Tag"]." is not a supported class object variable attribute");
										return(0);
								}
							}
							else
							{
								if(!$compiler->CheckWhiteSpace($attributes->file,$data,$variable_element_path))
									return(0);
							}
						}
						if(!IsSet($name))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was not defined the class variable name");
							return(0);
						}
						$class=$parent;
						if(!$this->InheritedVariableClass($class,$name)
						&& !IsSet($variable["type"]))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was not defined the class variable type");
							return(0);
						}
						if(IsSet($variable["notnull"])
						&& !IsSet($variable["value"]))
							return($compiler->SetElementError($attributes->file,$element_path,"it was not defined the default value of a notnull class variable"));
						$this->classes[$index]["variables"][$name]=$variable;
						break;
					case "abstract":
						$this->classes[$index][$data["Tag"]]=1;
						break;
					case "file":
					case "basepath":
					case "tag":
					case "version":
					case "copyright":
					case "title":
					case "author":
					case "authoraddress":
						if(!$compiler->GetValidData($attributes->file,$element_path,$this->classes[$index][$data["Tag"]],"it was not specified a valid class ".$data["Tag"]." property"))
							return(0);
						if(strlen($this->classes[$index][$data["Tag"]])==0)
							return($compiler->SetElementError($attributes->file,$element_path,"it was specified an empty class ".$data["Tag"]." property"));
						break;
					case "documentation":
						if(!$this->GetDocumentation($this->classes[$index],$compiler,$code,$attributes,$element_path,$this->classes[$index]))
							return(0);
						break;
					default:
						$compiler->SetElementError($attributes->file,$element_path,$data["Tag"]." is not a supported class object class attribute");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($attributes->file,$data,$element_path))
					return(0);
			}
		}
		if(!IsSet($this->classes[$index]["name"]))
		{
			if($index)
			{
				$compiler->SetElementError($attributes->file,$attributes->path,"it was not specified the class name");
				return(0);
			}
			else
			{
				$this->classes[$index]["name"]=$this->object_name;
				$this->subclasses[$this->object_name]=$index;
			}
		}
		if($index)
		{
			if(IsSet($this->classes[$index]["abstract"])
			&& !IsSet($this->classes[$parent]["abstract"]))
			{
				$compiler->SetElementError($attributes->file,$attributes->path,"it was defined the abstract attribute for a subclass of a class that is not abstract");
				return(0);
			}
			$this->classes[$index]["parent"]=$parent;
		}
		if(strlen($file))
		{
			$include_path=$compiler->GetIncludePath($file);
			$this->dependencies[$index][]=$include_path.$file;
		}
		return(1);
	}

	Function Setup(&$compiler,&$code,&$attributes)
	{
		$elements=$code->structure[$attributes->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$attributes->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "class":
						if(count($this->classes))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was attempted to redefine the base class");
							return(0);
						}
						$class_attributes=$attributes;
						$class_attributes->path=$element_path;
						if(!$this->SetupClass($compiler,$code,$class_attributes,""))
							return(0);
						break;
					case "definition":
						if(!$compiler->GetValidData($attributes->file,$element_path,$file,"it was not specified a valid class definition file"))
							return(0);
						if(!$compiler->ParseDefinitionFile($file))
							return(0);
						$compiler->CreateFileContext($class_attributes,$file);
						$compiler->GetParser($parser,$file);
						if(!$this->SetupClass($compiler,$parser,$class_attributes,$file))
							return(0);
						break;
					default:
						$compiler->SetElementError($attributes->file,$element_path,$data["Tag"]." is not a supported class object attribute");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($attributes->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function GenerateFunction(&$compiler,$class,$name)
	{
		if(!IsSet($this->classes[$class]["functions"][$name]["do"]["code"]))
		{
			if(IsSet($this->generate_function[$class][$name]))
			{
				$compiler->SetElementError($this->classes[$class]["functions"][$name]["do"]["file"],$this->classes[$class]["functions"][$name]["do"]["path"],"Generate function is being called recursively for class function \"$name\"");
				return(0);
			}
			$this->generate_function[$class][$name]=1;
			$this->classes[$class]["functions"][$name]["do"]["code"]=array();
			$function_name=$this->classes[$class]["function_name"];
			$return_type=$this->classes[$class]["return_type"];
			$return_value_set=$this->classes[$class]["return_value_set"];
			$this->classes[$class]["function_name"]=$name;
			$this->classes[$class]["return_type"]=$this->classes[$class]["functions"][$name]["type"];
			$this->classes[$class]["return_value_set"]=0;
			$compiler->CreateFileContext($action_context,$this->classes[$class]["functions"][$name]["do"]["file"]);
			$action_context->path=$this->classes[$class]["functions"][$name]["do"]["path"];
			$functions=array(
				"instance",
				"instancevariable",
				"instancevariableisnotnull",
				"instancecall",
				"functionargument",
				"setinstancevariablenull",
				"return",
				"classpackage"
			);
			if(!$compiler->AddContextFunctions($action_context,$this->object_name,$functions,$level)
			|| !$compiler->StartScope($action_context,$scope,"method"))
				return(0);
			if(IsSet($this->classes[$class]["functions"][$name]["Arguments"]))
			{
				$arguments=$this->classes[$class]["functions"][$name]["Arguments"];
				for(Reset($arguments),$argument=0;$argument<count($arguments);Next($arguments),$argument++)
				{
					$argument_name=Key($arguments);
					$variable=array(
						"Name"=>$argument_name,
						"Type"=>$arguments[$argument_name]["type"],
						"Argument"=>1
					);
					if(!$compiler->DeclareVariable($action_context,$variable))
						return(0);
				}
			}
			$current_subclass=$this->current_subclass;
			$this->current_subclass=$class;
			if(!$compiler->GetOutputData($this->classes[$class]["functions"][$name]["do"]["file"],$this->classes[$class]["functions"][$name]["do"]["path"],$this->classes[$class]["functions"][$name]["do"]["code"],"it were not defined valid class function do statements",1)
			|| !$compiler->GetScopeVariables($context,$scope,$this->classes[$class]["functions"][$name]["variables"])
			|| !$compiler->GetScopeExceptions($context,$scope,$this->classes[$class]["functions"][$name]["exceptions"]))
				return(0);
			$this->current_subclass=$current_subclass;
			$success=$compiler->EndScope($action_context,$scope);
			if(!$compiler->RemoveContextFunctions($action_context,$this->object_name,$level)
			|| !$success)
				return(0);
			if(strcmp($this->classes[$class]["functions"][$name]["type"],"VOID")
			&& $this->classes[$class]["return_value_set"]==0)
			{
				$compiler->SetElementError($this->classes[$class]["functions"][$name]["do"]["file"],$this->classes[$class]["functions"][$name]["do"]["path"],"it was not set the class function return value");
				return(0);
			}
			$this->classes[$class]["function_name"]=$function_name;
			$this->classes[$class]["return_type"]=$return_type;
			$this->classes[$class]["return_value_set"]=$return_value_set;
			Unset($this->generate_function[$class][$name]);
		}
		return(1);
	}

	Function InheritedFunctionClass(&$class,$function)
	{
		for(;;$class=$this->classes[$class]["parent"])
		{
			if(IsSet($this->classes[$class]["functions"][$function]))
				return(1);
			if($class==0)
				return(0);
		}
	}

	Function InheritedVariableClass(&$class,$variable)
	{
		for(;;$class=$this->classes[$class]["parent"])
		{
			if(IsSet($this->classes[$class]["variables"][$variable]))
				return(1);
			if($class==0)
				return(0);
		}
	}

	Function Call(&$compiler,&$code,&$context,&$call,$function)
	{
		$class=$subclass=(IsSet($call["subclass"]) ? $call["subclass"] : $this->current_subclass);
		$elements=$code->structure[$context->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$context->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "subclass":
						if(count($call))
						{
							$compiler->SetElementError($context->file,$element_path,"it was specified the class $function subclass argument after having specified other arguments");
							return(0);
						}
						if(!$this->GetSubclassArgument($compiler,$context->file,$element_path,$call))
							return(0);
						$subclass=$call["subclass"];
						break;
					case "function":
						$argument=$data["Tag"];
						if(IsSet($call[$argument]))
						{
							$compiler->SetElementError($context->file,$element_path,"it was specified the class $function $argument argument more than once");
							return(0);
						}
						if(!$compiler->GetValidData($context->file,$element_path,$call["function"],"it was not specified a valid class $function function argument"))
							return(0);
						$class=$subclass;
						if(!$this->InheritedFunctionClass($class,$call["function"]))
						{
							$compiler->SetElementError($context->file,$element_path,"it was requested to $function a class function (\"".$call["function"]."\") that was not defined");
							return(0);
						}
						break;
					case "arguments":
						if(!IsSet($call["function"]))
						{
							$compiler->SetElementError($context->file,$element_path,"it was not defined the function to call before specifying the $function arguments");
							return(0);
						}
						$class=$subclass;
						if(!$this->InheritedFunctionClass($class,$call["function"]))
						{
							$compiler->SetElementError($context->file,$element_path,"it was requested to $function a class function (\"".$call["function"]."\") that was not defined");
							return(0);
						}
						if(!IsSet($this->classes[$class]["functions"][$call["function"]]["Arguments"]))
						{
							$compiler->SetElementError($context->file,$element_path,"the specified function to $function does not take any arguments");
							return(0);
						}
						$function_arguments=$this->classes[$class]["functions"][$call["function"]]["Arguments"];
						$argument_elements=$code->structure[$element_path]["Elements"];
						for($argument_element=0;$argument_element<$argument_elements;$argument_element++)
						{
							$argument_element_path=$element_path.",$argument_element";
							$data=$code->structure[$argument_element_path];
							if(GetType($data)=="array")
							{
								if(!IsSet($function_arguments[$data["Tag"]]))
								{
									$compiler->SetElementError($context->file,$argument_element_path,"it was not specified a valid $function function argument");
									return(0);
								}
								if(IsSet($call["arguments"][$data["Tag"]]))
								{
									$compiler->SetElementError($context->file,$argument_element_path,"it was specified the ".$data["Tag"]." $function function argument more than once");
									return(0);
								}
								$call["arguments"][$data["Tag"]]=array(
									"file"=>$context->file,
									"path"=>$argument_element_path,
									"type"=>$function_arguments[$data["Tag"]]["type"]
								);
							}
							else
							{
								if(!$compiler->CheckWhiteSpace($context->file,$data,$argument_element_path))
									return(0);
							}
						}
						break;
					case "object":
					case "package":
						if(strcmp($function,"instancecall"))
						{
							if($data["Tag"]=="package")
							{
								if(IsSet($call["package"]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified the class call package argument more than once");
									return(0);
								}
								if(!$compiler->GetValidData($context->file,$element_path,$call["package"],"it was not specified a valid class $function function argument"))
									return(0);
								break;
							}
							else
							{
								$argument=$data["Tag"];
								if(IsSet($call[$argument]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified the class $function $argument argument more than once");
									return(0);
								}
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidExpression($evaluate_context,"OBJECT","NOTRIGHT","it was not specified a valid class object expression",1)
								|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$call["object"],$expression_type))
									return(0);
								break;
							}
						}
					default:
						$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported class $function argument");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function GetSubclassArgument(&$compiler,$file,$path,&$values)
	{
		if(IsSet($value["subclass"]))
		{
			$compiler->SetElementError($file,$path,"it was specified the class object subclass argument more than once");
			return(0);
		}
		if(!$compiler->GetValidData($file,$path,$subclass,"it was not specified a valid class subclass argument"))
			return(0);
		if(!IsSet($this->subclasses[$subclass]))
		{
			$compiler->SetElementError($file,$path,"it was not specified a defined subclass (\"$subclass\")");
			return(0);
		}
		$values["subclass"]=$this->subclasses[$subclass];
		return(1);
	}

	Function GetClassScope(&$compiler,&$arguments_code,&$arguments,&$class,$allow_tags,&$tags)
	{
		$output=array();
		$elements=$arguments_code->structure[$arguments->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$arguments->path.",$element";
			$data=$arguments_code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "subclass":
						if(!$this->GetSubclassArgument($compiler,$arguments->file,$element_path,$output))
							return(0);
						break;
					default:
						if(!$allow_tags)
						{
							$compiler->SetElementError($arguments->file,$element_path,$data["Tag"]." is not a supported class object scope tag");
							return(0);
						}
						if(IsSet($tags[$data["Tag"]]))
						{
							$compiler->SetElementError($arguments->file,$element_path,"it was specified the class scope tag ".$data["Tag"]." more than once");
							return(0);
						}
						$compiler->CopyEmptyContext($arguments,$tags[$data["Tag"]]);
						$tags[$data["Tag"]]->path=$element_path;
						break;
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($arguments->file,$data,$element_path))
					return(0);
			}
		}
		$class=(IsSet($output["subclass"]) ? $output["subclass"] : $this->current_subclass);
		return(1);
	}

	Function IterateVariables(&$compiler,&$context,$class,&$variables,$package,$protected,$public,$inherited)
	{
		if(IsSet($this->classes[$class]["parent"]))
		{
			$parent=$this->classes[$class]["parent"];
			switch($inherited)
			{
				case "0":
					$inherit=0;
					$current=1;
					break;
				case "1":
					$inherit=1;
					$current=0;
					break;
				case "all":
					$inherit=1;
					$current=1;
					break;
				default:
					$compiler->SetElementError($context->file,$context->path,"$inherited is not a supported inherited variable type");
					return(0);
			}
		}
		else
		{
			$inherit=0;
			$current=1;
		}
		for($class_variable=0,Reset($this->classes[$class]["variables"]);$class_variable<count($this->classes[$class]["variables"]);Next($this->classes[$class]["variables"]),$class_variable++)
		{
			$this->current_class=$class;
			$this->current_variable=Key($this->classes[$class]["variables"]);
			if(!IsSet($variables[$this->current_variable])
			&& (($public
			&& !IsSet($this->classes[$class]["variables"][$this->current_variable]["package"])
			&& !IsSet($this->classes[$class]["variables"][$this->current_variable]["protected"]))
			|| ($package
			&& IsSet($this->classes[$class]["variables"][$this->current_variable]["package"]))
			|| ($protected
			&& IsSet($this->classes[$class]["variables"][$this->current_variable]["protected"]))))
			{
				if($current
				&& !$compiler->GetOutputData($context->file,$context->path,$context->result,"it was not defined valid action for the class variables",1))
					return(0);
				$variables[$this->current_variable]=$class;
			}
		}
		if($inherit)
			return($this->IterateVariables($compiler,$context,$parent,$variables,$package,$protected,$public,$inherited));
		return(1);
	}

	Function IterateFunctions(&$compiler,&$context,$class,&$functions,$package,$protected,$public,$inherited)
	{
		if(IsSet($this->classes[$class]["parent"]))
		{
			$parent=$this->classes[$class]["parent"];
			switch($inherited)
			{
				case "0":
					$inherit=0;
					$current=1;
					break;
				case "1":
					$inherit=1;
					$current=0;
					break;
				case "all":
					$inherit=1;
					$current=1;
					break;
				default:
					$compiler->SetElementError($context->file,$context->path,"$inherited is not a supported inherited function type");
					return(0);
			}
			if($inherit)
				return($this->IterateFunctions($compiler,$context,$parent,$functions,$package,$protected,$public,$inherited));
		}
		else
		{
			$inherit=0;
			$current=1;
		}
		for($class_function=0,Reset($this->classes[$class]["functions"]);$class_function<count($this->classes[$class]["functions"]);Next($this->classes[$class]["functions"]),$class_function++)
		{
			$this->current_class=$class;
			$this->current_function=Key($this->classes[$class]["functions"]);
			if(!IsSet($functions[$this->current_function])
			&& (($public
			&& !IsSet($this->classes[$class]["functions"][$this->current_function]["package"])
			&& !IsSet($this->classes[$class]["functions"][$this->current_function]["protected"]))
			|| ($package
			&& IsSet($this->classes[$class]["functions"][$this->current_function]["package"]))
			|| ($protected
			&& IsSet($this->classes[$class]["functions"][$this->current_function]["protected"]))))
			{
				if($current
				&& !$compiler->GetOutputData($context->file,$context->path,$context->result,"it was not defined valid action for the class functions",1))
					return(0);
				$functions[$this->current_function]=$class;
			}
		}
		if($inherit)
			return($this->IterateFunctions($compiler,$context,$parent,$functions,$package,$protected,$public,$inherited));
		return(1);
	}

	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		switch($compiler->language["name"])
		{
			case "Java":
				switch($function)
				{
					case "output":
					case "functionargument":
					case "return":
					case "instancevariable":
					case "instancecall":
					case "call":
					case "getproperty":
					case "definedproperty":
					case "getdocumentation":
					case "defineddocumentation":
					case "examplecode":
					case "new":
					case "objectvariable":
					case "forallvariables":
					case "forallfunctions":
					case "variablename":
					case "variabletype":
					case "variabletypename":
					case "definedvariabledefaultvalue":
					case "variabledefaultvalue":
					case "variableconvertedvalue":
					case "functionname":
					case "functiontype":
					case "functiontypename":
					case "functionistype":
					case "functionhasarguments":
					case "forallarguments":
					case "argumentname":
					case "argumenttype":
					case "argumenttypename":
					case "argumentparameter":
					case "inargument":
					case "outargument":
					case "inoutargument":
					case "lastargument":
					case "definedargumentdefaultvalue":
					case "argumentdefaultvalue":
					case "argumentconvertedvalue":
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,"$function function of the class class is not implemented for the language ".$compiler->language["name"]);
						return(0);
				}
				break;
			case "PHP":
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the class class");
				return(0);
		}
		switch($function)
		{
			case "load":
				$load=array();
				$elements=$arguments_code->structure[$arguments->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$arguments->path.",$element";
					$data=$arguments_code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "subclass":
								if(!$this->GetSubclassArgument($compiler,$arguments->file,$element_path,$load))
									return(0);
								break;
							case "classpointer":
							case "error":
								if(IsSet($load[$data["Tag"]]))
								{
									$compiler->SetElementError($arguments->file,$element_path,"it was specified the class load ".$data["Tag"]." argument more than once");
									return(0);
								}
								$evaluate_context=$arguments;
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidExpression($evaluate_context,"STRING","NOTRIGHT","it was not specified a valid class load ".$data["Tag"]." variable",1)
								|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$load[$data["Tag"]],$expression_type))
									return(0);
								break;
							default:
								$compiler->SetElementError($arguments->file,$element_path,$data["Tag"]." is not a supported class load argument");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($arguments->file,$data,$element_path))
							return(0);
					}
				}
				$subclass=(IsSet($load["subclass"]) ? $load["subclass"] : 0);
				if(IsSet($this->classes[$subclass]["abstract"]))
				{
					$compiler->SetElementError($context->file,$context->path,"an abstract class can not be loaded");
					return(0);
				}
				if(!IsSet($this->classes[$subclass]["file"])
				|| strlen($this->classes[$subclass]["file"])==0)
					return($compiler->SetElementError($context->file,$context->path,"it was not specified the class output file"));
				if(!IsSet($this->classes[$subclass]["tag"]))
					$this->classes[$subclass]["tag"]="CLASS_".strtoupper(ereg_replace("[^A-Za-z0-9]","_",$this->classes[$subclass]["file"]));
				$relative_path=$compiler->RelativePath($this->classes[$subclass]["basepath"],$this->classes[$subclass]["file"]);
				$context->result[]=array(
					"Data"=>array(
						"Name"=>$this->classes[$subclass]["file"],
						"Type"=>"SUPPLIED"
					),
					"Type"=>"FILE"
				);
				$context->result[]=array(
					"Data"=>"if(!defined(\"".$this->classes[$subclass]["tag"]."\")",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>"&& file_exists(\"$relative_path\"))",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>"{",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>1,
					"Type"=>"INDENT"
				);
				$context->result[]=array(
					"Data"=>"include(\"$relative_path\");",
					"Type"=>"COMMAND"
				);
				if(IsSet($load["error"]))
				{
					$context->result[]=array(
						"Data"=>$load["error"]."=\"\";",
						"Type"=>"COMMAND"
					);
				}
				$context->result[]=array(
					"Data"=>1,
					"Type"=>"OUTDENT"
				);
				$context->result[]=array(
					"Data"=>"}",
					"Type"=>"COMMAND"
				);
				if(IsSet($load["error"]))
				{
					$context->result[]=array(
						"Data"=>"else",
						"Type"=>"COMMAND"
					);
					$context->result[]=array(
						"Data"=>1,
						"Type"=>"INDENT"
					);
					$context->result[]=array(
						"Data"=>$load["error"]."=\"could not access the class code file \\\"$relative_path\\\"\";",
						"Type"=>"COMMAND"
					);
					$context->result[]=array(
						"Data"=>1,
						"Type"=>"OUTDENT"
					);
				}
				if(IsSet($load["classpointer"]))
				{
					$context->result[]=array(
						"Data"=>$load["classpointer"]."=\"".$this->classes[$subclass]["name"]."\";",
						"Type"=>"COMMAND"
					);
				}
				$this->OutputDependencies($context,$subclass);
				break;
			case "new":
				$message=array();
				$elements=$arguments_code->structure[$arguments->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$arguments->path.",$element";
					$data=$arguments_code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "subclass":
								if(!$this->GetSubclassArgument($compiler,$arguments->file,$element_path,$message))
									return(0);
								break;
							case "classpointer":
								if(IsSet($message[$data["Tag"]]))
								{
									$compiler->SetElementError($arguments->file,$element_path,"it was specified the class new ".$data["Tag"]." argument more than once");
									return(0);
								}
								$evaluate_context=$arguments;
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidExpression($evaluate_context,"STRING","NOTLEFT","it was not specified a valid class new ".$data["Tag"]." argument",1)
								|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message[$data["Tag"]],$expression_type))
									return(0);
								break;
							default:
								$compiler->SetElementError($arguments->file,$element_path,$data["Tag"]." is not a supported class new argument");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($arguments->file,$data,$element_path))
							return(0);
					}
				}
				if(!IsSet($message["subclass"]))
					$message["subclass"]=0;
				$subclass=$message["subclass"];
				if(IsSet($this->classes[$subclass]["abstract"]))
				{
					$compiler->SetElementError($context->file,$context->path,"an abstract class can not be instanciated");
					return(0);
				}
				if(!$this->language_bindings->Execute($compiler,$context,$this,$function,$message))
					return(0);
				$this->OutputDependencies($context,$subclass);
				break;
			case "instancecall":
			case "call":
				$message=array();
				if(!$this->Call($compiler,$arguments_code,$arguments,$message,$function)
				|| !$this->Call($compiler,$code,$context,$message,$function))
					return(0);
				if((strcmp($function,"instancecall")
				&& !IsSet($message[$argument="object"]))
				|| !IsSet($message[$argument="function"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not defined the class $function $argument argument");
					return(0);
				}
				$message["class"]=$subclass=(IsSet($message["subclass"]) ? $message["subclass"] : $this->current_subclass);
				if(IsSet($this->classes[$subclass]["abstract"])
				&& !strcmp($function,"call"))
				{
					$compiler->SetElementError($context->file,$context->path,"an abstract class can not be called");
					return(0);
				}
				$this->InheritedFunctionClass($message["class"],$message["function"]);
				if($function=="call")
				{
					if(IsSet($this->classes[$message["class"]]["functions"][$message["function"]]["protected"]))
					{
						$compiler->SetElementError($context->file,$context->path,"it was attempted to call an object protected function (\"".$message["function"]."\") from outside the class scope");
						return(0);
					}
					if(IsSet($this->classes[$message["class"]]["functions"][$message["function"]]["package"]))
					{
						if(!IsSet($message["package"]))
							return($compiler->SetElementError($context->file,$context->path,"it was attempted to call an object package function (\"".$message["function"]."\") from outside the class scope"));
						if(strcmp($this->classes[$message["class"]]["package"],$message["package"]))
							return($compiler->SetElementError($context->file,$context->path,"it was attempted to call an object package function (\"".$message["function"]."\") from a different package"));
					}
				}
				$message["argumentlist"]=array();
				if(IsSet($this->classes[$message["class"]]["functions"][$message["function"]]["Arguments"]))
				{
					$arguments=$this->classes[$message["class"]]["functions"][$message["function"]]["Arguments"];
					for(Reset($arguments),$argument=0;$argument<count($arguments);Next($arguments),$argument++)
					{
						$argument_name=Key($arguments);
						if(IsSet($message["arguments"][$argument_name]))
						{
							$argument_context=$message["arguments"][$argument_name];
							$compiler->CopyEmptyContext($context,$evaluate_context);
							$evaluate_context->file=$argument_context["file"];
							$evaluate_context->path=$argument_context["path"];
							switch($this->classes[$message["class"]]["functions"][$message["function"]]["Arguments"][$argument_name]["parameter"])
							{
								case "in":
									$side="NOTLEFT";
									$error="it was not specified a valid class function $function argument ".$argument_context["type"]." input expression";
									break;
								case "out":
									$side="NOTRIGHT";
									$error="it was not specified a valid class function $function argument ".$argument_context["type"]." output expression";
									break;
								case "inout":
									$side="BOTH";
									$error="it was not specified a valid class function $function argument ".$argument_context["type"]." input/output expression";
									break;
							}
							if(!$compiler->GetValidExpression($evaluate_context,"ANY",$side,$error,0)
							|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$argument_value,$expression_type))
								return(0);
							if($expression_type=="UNDEFINED"
							&& $side=="NOTRIGHT")
							{
								$variable=array(
									"DeclarationFile"=>$evaluate_context->file,
									"DeclarationPath"=>$evaluate_context->path.",0"
								);
								if(!$compiler->QueryVariable($context,$variable))
									return(0);
								if($variable["Declared"])
								{
									$variable["Type"]=$argument_context["type"];
									$variable["Initialized"]=0;
									if(!$compiler->DeclareVariable($context,$variable))
										return(0);
									if(!$compiler->GetValidExpression($evaluate_context,$argument_context["type"],$side,$error,0)
									|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$argument_value,$expression_type))
										return(0);
								}
							}
							if($expression_type!=$argument_context["type"])
							{
								$compiler->SetElementError($evaluate_context->file,$evaluate_context->path,"it was specified an expression of type \"$expression_type\" where it was expected a ".$argument_context["type"]." expression for class $function ".$argument_name." argument");
								return(0);
							}
						}
						else
						{
							if(!IsSet($arguments[$argument_name]["defaultvalue"]))
							{
								$compiler->SetElementError($context->file,$context->path,"it was not specified the class $function ".$argument_name." argument");
								return(0);
							}
							$argument_value=$arguments[$argument_name]["converteddefaultvalue"];
						}
						$message["argumentlist"][]=$argument_value;
					}
				}
				if(!$this->language_bindings->Execute($compiler,$context,$this,$function,$message))
					return(0);
				$this->OutputDependencies($context,$subclass);
				break;
			case "return":
				if(!$this->GetClassScope($compiler,$arguments_code,$arguments,$class,0,$tags))
					return(0);
				if(!strcmp($this->classes[$class]["return_type"],""))
				{
					$compiler->SetElementError($context->file,$context->path,"the return function is being from called outside a class function");
					return(0);
				}
				$message=array();
				if(!strcmp($this->classes[$class]["return_type"],"VOID"))
				{
					if($code->structure[$context->path]["Elements"])
					{
						$compiler->SetElementError($context->file,$context->path,"it was attempted to return a value from a function with return type set to VOID");
						return(0);
					}
					$message["value"]="";
				}
				else
				{
					$compiler->CopyEmptyContext($context,$evaluate_context);
					if(!$compiler->GetValidExpression($evaluate_context,$this->classes[$class]["return_type"],"NOTLEFT","it was not specified a valid class function return ".$this->classes[$class]["return_type"]." expression",1)
					|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message["value"],$expression_type))
						return(0);
				}
				if(!$this->language_bindings->Execute($compiler,$context,$this,"return",$message))
					return(0);
				$this->classes[$class]["return_value_set"]=1;
				$this->OutputDependencies($context,$class);
				break;
			case "instance":
				$message=array();
				if(!$this->GetClassScope($compiler,$arguments_code,$arguments,$message["class"],0,$tags))
					return(0);
				$class=$message["class"];
				if(!strcmp($this->classes[$message["class"]]["return_type"],""))
				{
					$compiler->SetElementError($context->file,$context->path,"the instance variable is being accessed from outside a class function");
					return(0);
				}
				if(!$this->language_bindings->Execute($compiler,$context,$this,"instance",$message))
					return(0);
				$this->OutputDependencies($context,$class);
				break;
			case "instancevariable":
			case "instancevariableisnotnull":
			case "setinstancevariablenull":
				$message=array();
				if(!$this->GetClassScope($compiler,$arguments_code,$arguments,$message["class"],0,$tags))
					return(0);
				$class=$message["class"];
				if(!strcmp($this->classes[$message["class"]]["return_type"],""))
				{
					$compiler->SetElementError($context->file,$context->path,"the instance variable is being accessed from outside a class function");
					return(0);
				}
				if(!$compiler->GetValidName($context->file,$context->path,$message["name"],"it was not specified a valid class variable name"))
					return(0);
				if(!$this->InheritedVariableClass($message["class"],$message["name"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified a defined class variable name (\"".$message["name"]."\")");
					return(0);
				}
				switch($function)
				{
					case "instancevariableisnotnull":
					case "setinstancevariablenull":
						if(IsSet($this->classes[$message["class"]]["variables"][$message["name"]]["notnull"]))
							return($compiler->SetElementError($context->file,$context->path,"it was specified a class variable name (\"".$message["name"]."\") that is notnull"));
				}
				if(!$this->language_bindings->Execute($compiler,$context,$this,$function,$message))
					return(0);
				$this->OutputDependencies($context,$class);
				break;
			case "classpackage":
				if(!$this->GetClassScope($compiler,$arguments_code,$arguments,$class,0,$tags))
					return(0);
				if(!strcmp($this->classes[$class]["return_type"],""))
				{
					$compiler->SetElementError($context->file,$context->path,"the class package is being retrieved from outside a class function");
					return(0);
				}
				if(!IsSet($this->classes[$class]["package"]))
				{
					$compiler->SetElementError($context->file,$context->path,"the package name was not defined for this class");
					return(0);
				}
				$context->result[]=array(
					"Data"=>$this->classes[$class]["package"],
					"Type"=>"DATA"
				);
				break;
			case "objectvariable":
			case "objectvariableisnotnull":
			case "setobjectvariablenull":
				$message=array();
				$elements=$arguments_code->structure[$arguments->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$arguments->path.",$element";
					$data=$arguments_code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "subclass":
								if(!$this->GetSubclassArgument($compiler,$arguments->file,$element_path,$message))
									return(0);
								break;
							case "object":
								if(IsSet($message["object"]))
								{
									$compiler->SetElementError($arguments->file,$element_path,"it was specified the class object variable object argument more than once");
									return(0);
								}
								$evaluate_context=$arguments;
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidExpression($evaluate_context,"OBJECT","NOTLEFT","it was not specified a valid class object variable object expression",1)
								|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message["object"],$expression_type))
									return(0);
								break;
							case "package":
								if(IsSet($message["package"]))
								{
									$compiler->SetElementError($arguments->file,$element_path,"it was defined the class object variable package argument more than once");
									return(0);
								}
								if(!$compiler->GetValidData($arguments->file,$element_path,$message["package"],"it was not specified a valid class object variable package argument"))
									return(0);
								break;
							default:
								$compiler->SetElementError($arguments->file,$element_path,$data["Tag"]." is not a supported class object variable argument");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($arguments->file,$data,$element_path))
							return(0);
					}
				}
				if(IsSet($message["object"]))
				{
					if(!$compiler->GetValidName($context->file,$context->path,$name,"it was not specified a valid class variable name"))
						return(0);
				}
				else
				{
					$values=array();
					$required_types=array(
						"object"=>"OBJECT",
						"variable"=>"NAME"
					);
					$optional_types=array(
					);
					if(!IsSet($message["package"]))
						$optional_values["package"]="DATA";
					if(!$compiler->GetOptionalArgumentValues($context,$values,$required_types,$optional_types,"class",$function,1))
						return(0);
					$message["object"]=$values["object"];
					$name=$values["variable"];
					if(IsSet($values["package"]))
						$message["package"]=$values["package"];
				}
				if(!IsSet($message["subclass"]))
					$message["subclass"]=0;
				$subclass=$message["subclass"];
				if(IsSet($this->classes[$subclass]["abstract"]))
				{
					$compiler->SetElementError($context->file,$context->path,"abstract class variables can not be accessed");
					return(0);
				}
				if(!$this->InheritedVariableClass($subclass,$name))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified a defined class variable name (\"$name\")");
					return(0);
				}
				if(IsSet($this->classes[$subclass]["variables"][$name]["protected"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was attempted to access an object protected variable (\"$name\") from outside the class scope");
					return(0);
				}
				if(IsSet($this->classes[$subclass]["variables"][$name]["package"]))
				{
					if(!IsSet($message["package"]))
						return($compiler->SetElementError($context->file,$context->path,"it was attempted to access an object package variable (\"".$name."\") from outside the class scope"));
					if(strcmp($this->classes[$subclass]["package"],$message["package"]))
						return($compiler->SetElementError($context->file,$context->path,"it was attempted to access an object package variable (\"".$name."\") from a different package"));
				}
				$message["subclass"]=$subclass;
				$message["name"]=$name;
				if(!$this->language_bindings->Execute($compiler,$context,$this,$function,$message))
					return(0);
				$this->OutputDependencies($context,$subclass);
				break;
			case "functionargument":
				$message=array();
				if(!$this->GetClassScope($compiler,$arguments_code,$arguments,$message["class"],0,$tags))
					return(0);
				$class=$message["class"];
				if(!strcmp($this->classes[$message["class"]]["function_name"],""))
				{
					$compiler->SetElementError($context->file,$context->path,"the function argument function is being from called outside a class function");
					return(0);
				}
				if(!$compiler->GetValidName($context->file,$context->path,$message["name"],"it was not specified a valid class function argument name"))
					return(0);
				if(!IsSet($this->classes[$message["class"]]["functions"][$this->classes[$message["class"]]["function_name"]]["Arguments"][$message["name"]]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was specified an unknown class function argument (\"".$message["name"]."\")");
					return(0);
				}
				if(!$this->language_bindings->Execute($compiler,$context,$this,"functionargument",$message))
					return(0);
				$this->OutputDependencies($context,$class);
				break;
			case "output":
				if(!$this->GetClassScope($compiler,$arguments_code,$arguments,$class,0,$tags))
					return(0);
				if(IsSet($this->classes[$class]["abstract"]))
				{
					$compiler->SetElementError($context->file,$context->path,"abstract classes can not be generated");
					return(0);
				}
				if(!IsSet($this->classes[$class]["file"])
				|| strlen($this->classes[$class]["file"])==0)
					return($compiler->SetElementError($context->file,$context->path,"it was not specified the class output file"));
				$message=array(
					"class"=>$class,
					"result"=>array(),
					"initialization"=>array()
				);
				if(!$this->language_bindings->Execute($compiler,$context,$this,"output",$message)
				|| !$compiler->GenerateOutput($context,$message["result"],$output,"",0)
				|| !$compiler->CreateContextOutputDirectory(dirname($this->classes[$class]["file"]),$context,"it was not possible to create the directory for the class output file \"".dirname($this->classes[$class]["file"])."\""))
					return(0);
				if(!($output_file=@fopen($this->classes[$class]["file"],"w")))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not possible to open the class output file \"".$this->classes[$class]["file"]."\"");
					return(0);
				}
				$written=fwrite($output_file,$output);
				$closed=fclose($output_file);
				if($written!=strlen($output)
				|| !$closed)
				{
					$compiler->SetElementError($context->file,$context->path,"it was not possible to write to the class output file");
					return(0);
				}
				$context->result[]=array(
					"Data"=>array(
						"Name"=>$this->classes[$class]["file"],
						"Type"=>"GENERATED"
					),
					"Type"=>"FILE"
				);
				$this->OutputDependencies($context,$class);
				break;
			case "subclass":
				$types=array(
				);
				$optional_types=array(
					"class"=>"CONTEXT",
					"definition"=>"DATA",
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"class",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$types,$optional_types,"class",$function,1))
					return(0);
				if(IsSet($values["class"]))
				{
					if(IsSet($values["definition"]))
					{
						$compiler->SetElementError($context->file,$context->path,"it was specified both an internal and an external subclass definition");
						return(0);
					}
					$compiler->CopyEmptyContext($values["class"],$class_attributes);
					$compiler->GetParser($parser,$class_attributes->file);
					if(!$this->SetupClass($compiler,$parser,$class_attributes,""))
						return(0);
				}
				elseif(IsSet($values["definition"]))
				{
					if(!$compiler->ParseDefinitionFile($values["definition"]))
						return(0);
					$compiler->CreateFileContext($class_attributes,$values["definition"]);
					$compiler->GetParser($parser,$values["definition"]);
					if(!$this->SetupClass($compiler,$parser,$class_attributes,$values["definition"]))
						return(0);
				}
				else
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified the subclass definition");
					return(0);
				}
				break;
			case "getproperty":
			case "definedproperty":
				if(!$this->GetClassScope($compiler,$arguments_code,$arguments,$class,0,$tags))
					return(0);
				if(!$compiler->GetValidName($context->file,$context->path,$property,"it was not specified a valid class property name"))
					return(0);
				switch($property)
				{
					case "file":
					case "basepath":
					case "package":
					case "version":
					case "copyright":
					case "title":
					case "author":
					case "authoraddress":
						if(!strcmp($function,"getproperty"))
						{
							if(!IsSet($this->classes[$class][$property]))
							{
								$compiler->SetElementError($context->file,$context->path,"it was requested a property value (\"$property\") not defined for the specified class");
								return(0);
							}
							$context->result[]=array(
								"Data"=>$this->classes[$class][$property],
								"Type"=>"DATA"
							);
						}
						else
						{
							$context->result[]=array(
								"Data"=>(IsSet($this->classes[$class][$property]) ? "1" : "0"),
								"Type"=>"DATA"
							);
						}
						break;
					case "subclass":
						$context->result[]=array(
							"Data"=>(!strcmp($function,"getproperty") ? (IsSet($this->classes[$class]["parent"]) ? "1" : "0") : "1"),
							"Type"=>"DATA"
						);
						break;
					case "abstract":
						$context->result[]=array(
							"Data"=>(!strcmp($function,"getproperty") ? (IsSet($this->classes[$class]["abstract"]) ? "1" : "0") : "1"),
							"Type"=>"DATA"
						);
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,"\"$property\" is not a supported class property");
						return(0);
				}
				break;
			case "forallfunctions":
				if(!$this->GetClassScope($compiler,$arguments_code,$arguments,$class,1,$tags))
					return(0);
				if(IsSet($tags["idiom"])
				&& !$compiler->GetValidName($tags["idiom"]->file,$tags["idiom"]->path,$idiom,"it was not specified a valid class documentation idiom tag"))
					return(0);
				$package=$protected=$public=1;
				$inherited=0;
				if(IsSet($tags["package"]))
				{
					if(!$compiler->GetValidData($tags["package"]->file,$tags["package"]->path,$value,"it was not specified a valid class function package value"))
						return(0);
					switch($value)
					{
						case "1":
						case "":
							$package=1;
							break;
						case "0":
							$package=0;
							break;
						default:
							$compiler->SetElementError($tags["package"]->file,$tags["package"]->path,"it was not specified a valid class function package value");
							return(0);
					}
				}
				if(IsSet($tags["protected"]))
				{
					if(!$compiler->GetValidData($tags["protected"]->file,$tags["protected"]->path,$value,"it was not specified a valid class function protected value"))
						return(0);
					switch($value)
					{
						case "1":
						case "":
							$protected=1;
							break;
						case "0":
							$protected=0;
							break;
						default:
							$compiler->SetElementError($tags["protected"]->file,$tags["protected"]->path,"it was not specified a valid class function protected value");
							return(0);
					}
				}
				if(IsSet($tags["public"]))
				{
					if(!$compiler->GetValidData($tags["public"]->file,$tags["public"]->path,$value,"it was not specified a valid class function public value"))
						return(0);
					switch($value)
					{
						case "1":
						case "":
							$public=1;
							break;
						case "0":
							$public=0;
							break;
						default:
							$compiler->SetElementError($tags["public"]->file,$tags["public"]->path,"it was not specified a valid class function public value");
							return(0);
					}
				}
				if(IsSet($tags["inherited"]))
				{
					if(!$compiler->GetValidData($tags["inherited"]->file,$tags["inherited"]->path,$value,"it was not specified a valid class function inherited value"))
						return(0);
					switch($value)
					{
						case "1":
						case "":
							$inherited="1";
							break;
						case "0":
							$inherited="0";
							break;
						case "all":
							$inherited="all";
							break;
						default:
							$compiler->SetElementError($tags["inherited"]->file,$tags["inherited"]->path,"it was not specified a valid class function inherited value");
							return(0);
					}
				}
				$functions=array(
					"functionname",
					"functiontype",
					"functiontypename",
					"functionistype",
					"functionhasarguments",
					"forallarguments"
				);
				if(!$compiler->AddContextFunctions($context,$this->object_name,$functions,$level))
					return(0);
				$current_class=$this->current_class;
				$current_function=$this->current_function;
				$functions=array();
				$success=$this->IterateFunctions($compiler,$context,$class,$functions,$package,$protected,$public,$inherited);
				$this->current_class=$current_class;
				$this->current_function=$current_function;
				if(!$success
				|| !$compiler->RemoveContextFunctions($context,$this->object_name,$level))
					return(0);
				$this->OutputDependencies($context,$class);
				break;
			case "forallvariables":
				if(!$this->GetClassScope($compiler,$arguments_code,$arguments,$class,1,$tags))
					return(0);
				if(IsSet($tags["idiom"])
				&& !$compiler->GetValidName($tags["idiom"]->file,$tags["idiom"]->path,$idiom,"it was not specified a valid class documentation idiom tag"))
					return(0);
				$package=$protected=$public=1;
				$inherited=0;
				if(IsSet($tags["package"]))
				{
					if(!$compiler->GetValidData($tags["package"]->file,$tags["package"]->path,$value,"it was not specified a valid class variable package value"))
						return(0);
					switch($value)
					{
						case "1":
						case "":
							$package=1;
							break;
						case "0":
							$package=0;
							break;
						default:
							$compiler->SetElementError($tags["package"]->file,$tags["package"]->path,"it was not specified a valid class variable package value");
							return(0);
					}
				}
				if(IsSet($tags["protected"]))
				{
					if(!$compiler->GetValidData($tags["protected"]->file,$tags["protected"]->path,$value,"it was not specified a valid class variable protected value"))
						return(0);
					switch($value)
					{
						case "1":
						case "":
							$protected=1;
							break;
						case "0":
							$protected=0;
							break;
						default:
							$compiler->SetElementError($tags["protected"]->file,$tags["protected"]->path,"it was not specified a valid class variable protected value");
							return(0);
					}
				}
				if(IsSet($tags["public"]))
				{
					if(!$compiler->GetValidData($tags["public"]->file,$tags["public"]->path,$value,"it was not specified a valid class variable public value"))
						return(0);
					switch($value)
					{
						case "1":
						case "":
							$public=1;
							break;
						case "0":
							$public=0;
							break;
						default:
							$compiler->SetElementError($tags["public"]->file,$tags["public"]->path,"it was not specified a valid class variable public value");
							return(0);
					}
				}
				if(IsSet($tags["inherited"]))
				{
					if(!$compiler->GetValidData($tags["inherited"]->file,$tags["inherited"]->path,$value,"it was not specified a valid class variable inherited value"))
						return(0);
					switch($value)
					{
						case "1":
						case "":
							$inherited="1";
							break;
						case "0":
							$inherited="0";
							break;
						case "all":
							$inherited="all";
							break;
						default:
							$compiler->SetElementError($tags["inherited"]->file,$tags["inherited"]->path,"it was not specified a valid class variable inherited value");
							return(0);
					}
				}
				$functions=array(
					"variablename",
					"variabletype",
					"variabletypename",
					"definedvariabledefaultvalue",
					"variabledefaultvalue",
					"variableconvertedvalue"
				);
				if(!$compiler->AddContextFunctions($context,$this->object_name,$functions,$level))
					return(0);
				$current_class=$this->current_class;
				$current_variable=$this->current_variable;
				$variables=array();
				$success=$this->IterateVariables($compiler,$context,$class,$variables,$package,$protected,$public,$inherited);
				$this->current_class=$current_class;
				$this->current_variable=$current_variable;
				if(!$success
				|| !$compiler->RemoveContextFunctions($context,$this->object_name,$level))
					return(0);
				$this->OutputDependencies($context,$class);
				break;
			case "forallarguments":
				if(!strcmp($this->current_function,""))
				{
					$compiler->SetElementError($context->file,$context->path,"it was requested to iterate over function arguments outside a function definition scope");
					return(0);
				}
				if(IsSet($tags["idiom"])
				&& !$compiler->GetValidName($tags["idiom"]->file,$tags["idiom"]->path,$idiom,"it was not specified a valid class documentation idiom tag"))
					return(0);
				$current_class=$this->current_class;
				$current_function=$this->current_function;
				$current_argument=$this->current_argument;
				if(!IsSet($this->classes[$current_class]["functions"][$current_function]["Arguments"]))
					break;
				$functions=array(
					"argumentname",
					"argumenttype",
					"argumenttypename",
					"argumentparameter",
					"inargument",
					"outargument",
					"inoutargument",
					"lastargument",
					"definedargumentdefaultvalue",
					"argumentdefaultvalue",
					"argumentconvertedvalue"
				);
				if(!$compiler->AddContextFunctions($context,$this->object_name,$functions,$level))
					return(0);
				for($this->current_argument_number=0,Reset($this->classes[$current_class]["functions"][$current_function]["Arguments"]);$this->current_argument_number<count($this->classes[$current_class]["functions"][$current_function]["Arguments"]);Next($this->classes[$current_class]["functions"][$current_function]["Arguments"]),$this->current_argument_number++)
				{
					$this->current_class=$current_class;
					$this->current_function=$current_function;
					$this->current_argument=Key($this->classes[$current_class]["functions"][$current_function]["Arguments"]);
					if(!$compiler->GetOutputData($context->file,$context->path,$context->result,"it was not defined valid action for the class function arguments",0))
					{
						$this->current_class=$current_class;
						$this->current_function=$current_function;
						$this->current_argument=$current_argument;
						return(0);
					}
				}
				$this->current_class=$current_class;
				$this->current_function=$current_function;
				$this->current_argument=$current_argument;
				if(!$compiler->RemoveContextFunctions($context,$this->object_name,$level))
					return(0);
				$this->OutputDependencies($context,$current_class);
				break;
			case "forallparentclasses":
				if(!$this->GetClassScope($compiler,$arguments_code,$arguments,$class,1,$tags))
					return(0);
				if(IsSet($tags["idiom"])
				&& !$compiler->GetValidName($tags["idiom"]->file,$tags["idiom"]->path,$idiom,"it was not specified a valid class documentation idiom tag"))
					return(0);
				$functions=array();
				if(!$compiler->AddContextFunctions($context,$this->object_name,$functions,$level))
					return(0);
				$current_class=$this->current_class;
				$this->current_class=$class;
				$success=1;
				while(IsSet($this->classes[$this->current_class]["parent"]))
				{
					$this->current_class=$this->classes[$this->current_class]["parent"];
					if(!($success=$compiler->GetOutputData($context->file,$context->path,$context->result,"it was not defined valid action for the class parentclasses",0)))
						break;
				}
				$this->current_class=$current_class;
				if(!$success
				|| !$compiler->RemoveContextFunctions($context,$this->object_name,$level))
					return(0);
				$this->OutputDependencies($context,$class);
				break;
			case "getdocumentation":
			case "defineddocumentation":
				if(!$this->GetClassScope($compiler,$arguments_code,$arguments,$class,1,$tags))
					return(0);
				if(!IsSet($tags["idiom"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified the class documentation idiom");
					return(0);
				}
				if(!$compiler->GetValidName($tags["idiom"]->file,$tags["idiom"]->path,$idiom,"it was not specified a valid class documentation idiom tag"))
					return(0);
				if(!$compiler->GetValidName($context->file,$context->path,$tag,"it was not specified a valid class documentation tag"))
					return(0);
				$inherited=0;
				if(IsSet($tags["inherited"]))
				{
					if(!$compiler->GetValidData($tags["inherited"]->file,$tags["inherited"]->path,$value,"it was not specified a valid class function inherited value"))
						return(0);
					switch($value)
					{
						case "1":
						case "":
							$inherited=1;
							break;
						case "0":
							$inherited=0;
							break;
						default:
							$compiler->SetElementError($tags["inherited"]->file,$tags["inherited"]->path,"it was not specified a valid class function inherited value");
							return(0);
					}
				}
				if(strcmp($this->current_argument,""))
				{
					if($inherited)
					{
						while(!IsSet($this->classes[$class]["functions"][$this->current_function]["Arguments"][$this->current_argument]["documentation"][$idiom][$tag])
						&& IsSet($this->classes[$class]["parent"]))
							$class=$this->classes[$class]["parent"];
					}
					if(strcmp($function,"defineddocumentation"))
					{
						if(!IsSet($this->classes[$class]["functions"][$this->current_function]["Arguments"][$this->current_argument]["documentation"][$idiom][$tag]))
						{
							$compiler->SetElementError($context->file,$context->path,"it was requested the value of a documentation tag (\"$tag\") that is not defined for the specified class function argument");
							return(0);
						}
						if(!$compiler->GetOutputData($this->classes[$class]["functions"][$this->current_function]["Arguments"][$this->current_argument]["documentation"][$idiom][$tag]->file,$this->classes[$class]["functions"][$this->current_function]["Arguments"][$this->current_argument]["documentation"][$idiom][$tag]->path,$context->result,"it was not defined valid class function argument documentation tag",0))
							return(0);
					}
					else
					{
						$context->result[]=array(
							"Data"=>(IsSet($this->classes[$class]["functions"][$this->current_function]["Arguments"][$this->current_argument]["documentation"][$idiom][$tag]) ? "1" : "0"),
							"Type"=>"DATA"
						);
					}
				}
				else
				{
					if(strcmp($this->current_function,""))
					{
						if($inherited)
						{
							while(!IsSet($this->classes[$class]["functions"][$this->current_function]["documentation"][$idiom][$tag])
							&& IsSet($this->classes[$class]["parent"]))
								$class=$this->classes[$class]["parent"];
						}
						if(strcmp($function,"defineddocumentation"))
						{
							if(!IsSet($this->classes[$class]["functions"][$this->current_function]["documentation"][$idiom][$tag]))
							{
								$compiler->SetElementError($context->file,$context->path,"it was requested the value of a documentation tag (\"$tag\") that is not defined for the specified class function");
								return(0);
							}
							if(!$compiler->GetOutputData($this->classes[$class]["functions"][$this->current_function]["documentation"][$idiom][$tag]->file,$this->classes[$class]["functions"][$this->current_function]["documentation"][$idiom][$tag]->path,$context->result,"it was not defined valid class function argument documentation tag",0))
								return(0);
						}
						else
						{
							$context->result[]=array(
								"Data"=>(IsSet($this->classes[$class]["functions"][$this->current_function]["documentation"][$idiom][$tag]) ? "1" : "0"),
								"Type"=>"DATA"
							);
						}
					}
					else
					{
						if(strcmp($this->current_variable,""))
						{
							if($inherited)
							{
								while(!IsSet($this->classes[$class]["variables"][$this->current_variable]["documentation"][$idiom][$tag])
								&& IsSet($this->classes[$class]["parent"]))
									$class=$this->classes[$class]["parent"];
							}
							if(strcmp($function,"defineddocumentation"))
							{
								if(!IsSet($this->classes[$class]["variables"][$this->current_variable]["documentation"][$idiom][$tag]))
								{
									$compiler->SetElementError($context->file,$context->path,"it was requested the value of a documentation tag (\"$tag\") that is not defined for the specified class variable");
									return(0);
								}
								if(!$compiler->GetOutputData($this->classes[$class]["variables"][$this->current_variable]["documentation"][$idiom][$tag]->file,$this->classes[$class]["variables"][$this->current_variable]["documentation"][$idiom][$tag]->path,$context->result,"it was not defined valid class variable argument documentation tag",0))
									return(0);
							}
							else
							{
								$context->result[]=array(
									"Data"=>(IsSet($this->classes[$class]["variables"][$this->current_variable]["documentation"][$idiom][$tag]) ? "1" : "0"),
									"Type"=>"DATA"
								);
							}
						}
						else
						{
							if(strcmp($function,"defineddocumentation"))
							{
								if(!IsSet($this->classes[$class]["documentation"][$idiom][$tag]))
								{
									$compiler->SetElementError($context->file,$context->path,"it was requested the value of a documentation tag (\"$tag\") that is not defined for the specified class");
									return(0);
								}
								if(!$compiler->GetOutputData($this->classes[$class]["documentation"][$idiom][$tag]->file,$this->classes[$class]["documentation"][$idiom][$tag]->path,$context->result,"it was not defined valid class documentation tag",0))
									return(0);
							}
							else
							{
								$context->result[]=array(
									"Data"=>(IsSet($this->classes[$class]["documentation"][$idiom][$tag]) ? "1" : "0"),
									"Type"=>"DATA"
								);
							}
						}
					}
				}
				break;
			case "functionname":
			case "functiontype":
			case "functiontypename":
			case "functionistype":
			case "functionhasarguments":
				if(!strcmp($this->current_function,""))
				{
					$compiler->SetElementError($context->file,$context->path,"it was requested the $function of function outside a function definition scope");
					return(0);
				}
				switch($function)
				{
					case "functionname":
						$value=$this->current_function;
						break;
					case "functiontype":
						$value=$this->classes[$this->current_class]["functions"][$this->current_function]["type"];
						break;
					case "functiontypename":
						$message=array("type"=>$this->classes[$this->current_class]["functions"][$this->current_function]["type"]);
						if(!$this->language_bindings->Execute($compiler,$context,$this,"typename",$message))
							return(0);
						$value=$message["name"];
						break;
					case "functionistype":
						if(!$compiler->GetValidData($context->file,$context->path,$type,"it was not specified a valid class function return type"))
							return(0);
						switch($compiler->strtok($type,":"))
						{
							case "VOID":
							case "STRING":
							case "INTEGER":
							case "FLOAT":
							case "BOOLEAN":
							case "OBJECT":
							case "ARRAY":
							case "HASH":
								break;
							default:
								$compiler->SetElementError($context->file,$context->path,"it was not defined a valid class function return type");
								return(0);
						}
						$value=(strcmp($type,$this->classes[$this->current_class]["functions"][$this->current_function]["type"]) ? "0" : "1");
						break;
					case "functionhasarguments":
						$value=(IsSet($this->classes[$this->current_class]["functions"][$this->current_function]["Arguments"]) ? "1" : "0");
						break;
				}
				$context->result[]=array(
					"Data"=>$value,
					"Type"=>"DATA"
				);
				break;
			case "argumentname":
			case "argumenttype":
			case "argumenttypename":
			case "argumentparameter":
			case "inargument":
			case "outargument":
			case "inoutargument":
			case "lastargument":
			case "definedargumentdefaultvalue":
			case "argumentdefaultvalue":
			case "argumentconvertedvalue":
				if(!strcmp($this->current_argument,""))
				{
					$compiler->SetElementError($context->file,$context->path,"it was requested the $function of function argument outside a function argument definition scope");
					return(0);
				}
				switch($function)
				{
					case "argumentname":
						$value=$this->current_argument;
						break;
					case "argumenttype":
						$value=$this->classes[$this->current_class]["functions"][$this->current_function]["Arguments"][$this->current_argument]["type"];
						break;
					case "argumenttypename":
						$message=array("type"=>$this->classes[$this->current_class]["functions"][$this->current_function]["Arguments"][$this->current_argument]["type"]);
						if(!$this->language_bindings->Execute($compiler,$context,$this,"typename",$message))
							return(0);
						$value=$message["name"];
						break;
					case "argumentparameter":
						$value=$this->classes[$this->current_class]["functions"][$this->current_function]["Arguments"][$this->current_argument]["parameter"];
						break;
					case "inargument":
						$value=($this->classes[$this->current_class]["functions"][$this->current_function]["Arguments"][$this->current_argument]["parameter"]=="in" ? "1" : "0");
						break;
					case "outargument":
						$value=($this->classes[$this->current_class]["functions"][$this->current_function]["Arguments"][$this->current_argument]["parameter"]=="out" ? "1" : "0");
						break;
					case "inoutargument":
						$value=($this->classes[$this->current_class]["functions"][$this->current_function]["Arguments"][$this->current_argument]["parameter"]=="inout" ? "1" : "0");
						break;
					case "lastargument":
						$value=($this->current_argument_number+1==count($this->classes[$this->current_class]["functions"][$this->current_function]["Arguments"]) ? "1" : "0");
						break;
					case "definedargumentdefaultvalue":
						$value=(IsSet($this->classes[$this->current_class]["functions"][$this->current_function]["Arguments"][$this->current_argument]["defaultvalue"]) ? "1" : "0");
						break;
					case "argumentdefaultvalue":
					case "argumentconvertedvalue":
						$value=(strcmp($function,"argumentconvertedvalue") ? "defaultvalue" : "converteddefaultvalue");
						if(!IsSet($this->classes[$this->current_class]["functions"][$this->current_function]["Arguments"][$this->current_argument][$value]))
						{
							$compiler->SetElementError($context->file,$context->path,"it was requested the default value of an argument (".$this->current_argument.") of a function (".$this->current_function.") that does not have a defined default value");
							return(0);
						}
						$value=$this->classes[$this->current_class]["functions"][$this->current_function]["Arguments"][$this->current_argument][$value];
						break;
				}
				$context->result[]=array(
					"Data"=>$value,
					"Type"=>"DATA"
				);
				break;
			case "variablename":
			case "variabletype":
			case "variabletypename":
			case "definedvariabledefaultvalue":
			case "variabledefaultvalue":
			case "variableconvertedvalue":
				if(!strcmp($this->current_variable,""))
				{
					$compiler->SetElementError($context->file,$context->path,"it was requested the $function of variable outside a variable definition scope");
					return(0);
				}
				switch($function)
				{
					case "variablename":
						$value=$this->current_variable;
						break;
					case "variabletype":
						$value=$this->classes[$this->current_class]["variables"][$this->current_variable]["type"];
						break;
					case "variabletypename":
						$message=array("type"=>$this->classes[$this->current_class]["variables"][$this->current_variable]["type"]);
						if(!$this->language_bindings->Execute($compiler,$context,$this,"typename",$message))
							return(0);
						$value=$message["name"];
						break;
					case "definedvariabledefaultvalue":
						$value=(IsSet($this->classes[$this->current_class]["variables"][$this->current_variable]["value"]) ? "1" : "0");
						break;
					case "variabledefaultvalue":
						if(!IsSet($this->classes[$this->current_class]["variables"][$this->current_variable]["value"]))
						{
							$compiler->SetElementError($context->file,$context->path,"it was requested the value of a class variable (".$this->current_variable.") that does not have a defined default value");
							return(0);
						}
						$value=$this->classes[$this->current_class]["variables"][$this->current_variable]["value"];
						break;
					case "variableconvertedvalue":
						if(!IsSet($this->classes[$this->current_class]["variables"][$this->current_variable]["convertedvalue"]))
						{
							$compiler->SetElementError($context->file,$context->path,"it was requested the convertedvalue of a class variable (".$this->current_variable.") that does not have a defined default value");
							return(0);
						}
						$value=$this->classes[$this->current_class]["variables"][$this->current_variable]["convertedvalue"];
						break;
				}
				$context->result[]=array(
					"Data"=>$value,
					"Type"=>"DATA"
				);
				break;
			case "examplecode":
				$message=array();
				if(!$this->GetClassScope($compiler,$arguments_code,$arguments,$class,1,$tags))
					return(0);
				$result=array();
				if(!$compiler->StartScope($context,$scope,"global")
				|| !$compiler->GetOutputData($context->file,$context->path,$message["result"],"invalid example code",1)
				|| !$compiler->GetScopeVariables($context,$scope,$message["variables"])
				|| !$compiler->GetScopeExceptions($context,$scope,$message["exceptions"])
				|| !$compiler->EndScope($context,$scope))
					return(0);
				$initialization=1;
				if(IsSet($tags["initialization"]))
				{
					if(!$compiler->GetValidData($tags["initialization"]->file,$tags["initialization"]->path,$value,"it was not specified a valid class example code initialization value"))
						return(0);
					switch($value)
					{
						case "1":
						case "":
							$message["initialization"]=1;
							break;
						case "0":
							$message["initialization"]=0;
							break;
						default:
							$compiler->SetElementError($tags["initialization"]->file,$tags["initialization"]->path,"it was not specified a valid class example code initialization value");
							return(0);
					}
				}
				if(!$this->language_bindings->Execute($compiler,$context,$this,$function,$message))
					return(0);
				$this->OutputDependencies($context,$class);
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported class object function");
				return(0);
		}
		return(1);
	}

	Function Initialization(&$compiler,&$context,$object_context)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the class class");
			return(0);
		}
		$class=$this->subclasses[$object_context];
		if(IsSet($this->classes[$class]["abstract"]))
		{
			$compiler->SetElementError($context->file,$context->path,"abstract class functions arguments can not be accessed");
			return(0);
		}
		for($parent=$class;$parent!=0 && !IsSet($this->classes[$parent=$this->classes[$parent]["parent"]]["abstract"]);)
		{
			$context->result[]=array(
				"Data"=>array(
					"Object"=>$this->object_name,
					"Context"=>$this->classes[$parent]["name"]
				),
				"Type"=>"INITIALIZATION"
			);
		}
		if(!IsSet($this->classes[$class]["file"])
		|| strlen($this->classes[$class]["file"])==0)
			return($compiler->SetElementError($context->file,$context->path,"it was not specified the class output file"));
		if(strcmp($this->classes[$class]["file"],""))
		{
			for(Reset($this->classes[$class]["functions"]),$function=0;$function<count($this->classes[$class]["functions"]);$function++,Next($this->classes[$class]["functions"]))
			{
				$name=Key($this->classes[$class]["functions"]);
				if(!$this->GenerateFunction($compiler,$class,$name))
					return(0);
				for($part=0;$part<count($this->classes[$class]["functions"][$name]["do"]["code"]);$part++)
				{
					switch($this->classes[$class]["functions"][$name]["do"]["code"][$part]["Type"])
					{
						case "INITIALIZATION":
						case "FILE":
							$context->result[]=$this->classes[$class]["functions"][$name]["do"]["code"][$part];
							break;
					}
				}
			}
			$relative_path=(IsSet($this->classes[$class]["basepath"]) ? $compiler->RelativePath($this->classes[$class]["basepath"],$this->classes[$class]["file"]) : $this->classes[$class]["file"]);
			$context->result[]=array(
				"Data"=>array(
					"Name"=>$this->classes[$class]["file"],
					"Type"=>"SUPPLIED"
				),
				"Type"=>"FILE"
			);
			if($this->classes[$class]["staticload"])
			{
				$context->result[]=array(
					"Data"=>"require(\"$relative_path\");",
					"Type"=>"COMMAND"
				);
			}
		}
		else
		{
			$message=array(
				"class"=>$class,
				"result"=>array(),
				"initialization"=>array()
			);
			if(!$this->language_bindings->Execute($compiler,$context,$this,"output",$message))
				return(0);
			for($part=0;$part<count($message["initialization"]);$part++)
				$context->result[]=$message["initialization"][$part];
			for($part=0;$part<count($message["result"]);$part++)
				$context->result[]=$message["result"][$part];
		}
		$this->OutputDependencies($context,$class);
		return(1);
	}
};

}
?>