<?php
if(!defined("METAL_DATABASE_INCLUDED"))
{
	define("METAL_DATABASE_INCLUDED",1);

/*
 * metal_database.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_database.php,v 1.47 2005/09/11 22:42:22 mlemos Exp $
 *
 */
 
class metal_database_class extends metal_base_class
{
	var $database_path="";
	var $database_base_path="";
	var $needs_manager=0;
	var $needs_interface=0;

	Function Setup(&$compiler,&$code,&$attributes)
	{
		$elements=$code->structure[$attributes->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$attributes->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "databasepath":
						if(!$compiler->GetValidData($attributes->file,$element_path,$database_path,"it was not specified a valid database path"))
							return(0);
						if(!($directory=@opendir($database_path)))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was not specified an existing database path (\"$database_path\")");
							return(0);
						}
						closedir($directory);
						$this->database_path=$database_path;
						break;
					case "databasebasepath":
						if(!$compiler->GetValidData($attributes->file,$element_path,$this->database_base_path,"it was not specified a valid database base path"))
							return(0);
						break;
					default:
						$compiler->SetElementError($attributes->file,$element_path,$data["Tag"]." is not a supported database object attribute");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($attributes->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function GetObject(&$compiler,&$context,$element_path,&$object)
	{
		if(strcmp($object,""))
		{
			$compiler->SetElementError($context->file,$element_path,"it was specified the database object argument more than once");
			return(0);
		}
		$compiler->CopyEmptyContext($context,$evaluate_context);
		$evaluate_context->path=$element_path;
		if(!$compiler->GetValidExpression($evaluate_context,"OBJECT","NOTRIGHT","it was not specified a valid database object expression",1)
		|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$object,$expression_type))
			return(0);
		return(1);
	}

	Function GetObjectArguments(&$compiler,&$code,&$context,&$object)
	{
		$elements=$code->structure[$context->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$context->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "object":
						if(!$this->GetObject($compiler,$context,$element_path,$object))
							return(0);
						break;
					default:
						$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported database argument");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function VerifyObjectArguments(&$compiler,&$code,&$context,&$object)
	{
		$object="";
		if(!$this->GetObjectArguments($compiler,$code,$context,$object))
			return(0);
		If(!strcmp($object,""))
		{
			$compiler->SetElementError($context->file,$context->path,"it was not specified the database object argument");
			return(0);
		}
		return(1);
	}

	Function NewHandle(&$compiler,&$result_context,&$code,&$context,&$new_handle)
	{
		$elements=$code->structure[$context->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$context->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "arguments":
						$compiler->CopyEmptyContext($context,$evaluate_context);
						$evaluate_context->path=$element_path;
						if(!$compiler->GetValidTypedExpression($evaluate_context,"HASH","it was not specified a valid database newhandle arguments argument")
						|| !$compiler->GetExpressionValue($result_context,$evaluate_context->result,$new_handle["arguments"],$expression_type))
							return(0);
						break;
					case "handle":
						$compiler->CopyEmptyContext($context,$evaluate_context);
						$evaluate_context->path=$element_path;
						if(!$compiler->GetValidExpression($evaluate_context,"INTEGER","NOTRIGHT","it was not specified a valid database newhandle handle argument",1)
						|| !$compiler->GetExpressionValue($result_context,$evaluate_context->result,$new_handle["handle"],$expression_type))
							return(0);
						break;
					case "error":
						$compiler->CopyEmptyContext($context,$evaluate_context);
						$evaluate_context->path=$element_path;
						if(!$compiler->GetValidExpression($evaluate_context,"STRING","NOTRIGHT","it was not specified a valid database newhandle error argument",1)
						|| !$compiler->GetExpressionValue($result_context,$evaluate_context->result,$new_handle["error"],$expression_type))
							return(0);
						break;
					default:
						$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported database object newhandle parameter");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		switch($compiler->language["name"])
		{
			case "Java":
				switch($function)
				{
/*
					case "output":
						break;
*/
					default:
						$compiler->SetElementError($context->file,$context->path,"$function function of the class class is not implemented for the language ".$compiler->language["name"]);
						return(0);
				}
				break;
			case "PHP":
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the database class");
				return(0);
		}
		switch($function)
		{
			case "newhandle":
				$types=array(
					"handle"=>"INTEGER:NOTRIGHT"
				);
				$optional_types=array(
					"error"=>"STRING:NOTRIGHT",
					"arguments"=>"HASH",
					"connection"=>"STRING",
					"includepath"=>"STRING"
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"database",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$types,$optional_types,"database",$function,1))
					return(0);
				$this->needs_interface=1;
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				if(IsSet($values["arguments"]))
				{
					if(IsSet($values[$argument="connection"])
					|| IsSet($values[$argument="includepath"]))
						return($compiler->SetElementError($context->file,$context->path,"it was specified both the database $function arguments and $argument arguments"));
					$arguments=$values["arguments"];
				}
				else
				{
					$arguments="array(";
					if(!IsSet($values["connection"]))
						return($compiler->SetElementError($context->file,$context->path,"it was not specified the database $function connection argument"));
					$arguments.="\"Connection\"=>".$values["connection"];
					if(IsSet($values["includepath"]))
						$arguments.=",\"IncludePath\"=>".$values["includepath"];
					$arguments.=")";
				}
				$expression="MetabaseSetupDatabase(".$arguments.",".$values["handle"].")";
				if(IsSet($values["error"]))
					$expression="(".$values["error"]."=$expression)";
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"strlen($expression)==0",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "closesetup":
				$types=array(
					"handle"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>"MetabaseCloseSetup(".$values["handle"].");",
					"Type"=>"COMMAND"
				);
				break;
			case "setselectedrowrange":
				$types=array(
					"handle"=>"INTEGER",
					"first"=>"INTEGER",
					"limit"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseSetSelectedRowRange(".$values["handle"].",".$values["first"].",".$values["limit"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "query":
				$types=array(
					"handle"=>"INTEGER",
					"statement"=>"STRING"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseQuery(".$values["handle"].",".$values["statement"].")",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "setresulttypes":
				$types=array(
					"handle"=>"INTEGER",
					"result"=>"INTEGER",
					"types"=>"ARRAY"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseSetResultTypes(".$values["handle"].",".$values["result"].",".$values["types"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "fetchresultrow":
				$types=array(
					"handle"=>"INTEGER",
					"result"=>"INTEGER",
					"row"=>"INTEGER",
					"array"=>"ARRAY:NOTRIGHT"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseFetchResultArray(".$values["handle"].",".$values["result"].",".$values["array"].",".$values["row"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "queryall":
				$types=array(
					"handle"=>"INTEGER",
					"statement"=>"STRING",
					"data"=>"ARRAY:NOTRIGHT",
					"types"=>"ARRAY"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseQueryAll(".$values["handle"].",".$values["statement"].",".$values["data"].",".$values["types"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "queryrow":
				$types=array(
					"handle"=>"INTEGER",
					"statement"=>"STRING",
					"data"=>"ARRAY:NOTRIGHT",
					"types"=>"ARRAY"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseQueryRow(".$values["handle"].",".$values["statement"].",".$values["data"].",".$values["types"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "querycolumn":
				$types=array(
					"handle"=>"INTEGER",
					"statement"=>"STRING",
					"data"=>"ARRAY:NOTRIGHT",
					"type"=>"DATA"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$valid_types=array(
					"integer"=>"INTEGER",
					"text"=>"STRING",
					"boolean"=>"BOOLEAN",
					"decimal"=>"STRING",
					"float"=>"FLOAT",
					"time"=>"STRING",
					"date"=>"STRING",
					"timestamp"=>"STRING"
				);
				if(!IsSet($valid_types[$values["type"]]))
					return($compiler->SetElementError($context->file,$context->path,$values["type"]." is not a database field type"));
				if(!$compiler->ConvertData($context,"STRING",$values["type"],$type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseQueryColumn(".$values["handle"].",".$values["statement"].",".$values["data"].",".$type.")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "queryfield":
				$types=array(
					"handle"=>"INTEGER",
					"statement"=>"STRING",
					"data"=>"CONTEXT",
					"type"=>"DATA"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$valid_types=array(
					"integer"=>"INTEGER",
					"text"=>"STRING",
					"boolean"=>"BOOLEAN",
					"decimal"=>"STRING",
					"float"=>"FLOAT",
					"time"=>"STRING",
					"date"=>"STRING",
					"timestamp"=>"STRING"
				);
				if(!IsSet($valid_types[$values["type"]]))
					return($compiler->SetElementError($context->file,$context->path,$values["type"]." is not a database field type"));
				$compiler->CopyEmptyContext($values["data"],$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,$valid_types[$values["type"]],"NOTRIGHT","it was not specified a valid data ".$valid_types[$values["type"]]." expression",1)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$data,$expression_type))
					return(0);
				if(!$compiler->ConvertData($context,"STRING",$values["type"],$type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseQueryField(".$values["handle"].",".$values["statement"].",".$data.",".$type.")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "queryintegerfield":
				$type="INTEGER";
				$field_type="integer";
				$types=array(
					"handle"=>"INTEGER",
					"query"=>"STRING",
					"value"=>$type.":NOTRIGHT"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseQueryField(".$values["handle"].",".$values["query"].",".$values["value"].",\"".$field_type."\")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "preparequery":
				$types=array(
					"handle"=>"INTEGER",
					"query"=>"STRING"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabasePrepareQuery(".$values["handle"].",".$values["query"].")",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "executequery":
				$types=array(
					"handle"=>"INTEGER",
					"statement"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseExecuteQuery(".$values["handle"].",".$values["statement"].")",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "validresult":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,"INTEGER","NOTLEFT","it was not specified a valid database query result",1)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$result,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"$result!=0",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "endofresult":
			case "resultrows":
				$types=array(
					"handle"=>"INTEGER",
					"result"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>($function=="endofresult" ? "MetabaseEndOfResult" : "MetabaseNumberOfRows")."(".$values["handle"].",".$values["result"].")",
						"Type"=>($function=="endofresult" ? "BOOLEAN" : "INTEGER"),
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "fetchresult":
				$types=array(
					"handle"=>"INTEGER",
					"result"=>"INTEGER",
					"row"=>"INTEGER",
					"type"=>"DATA"
				);
				$optional_types=array(
					"columnname"=>"STRING",
					"column"=>"INTEGER"
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"database",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$types,$optional_types,"database",$function,1))
					return(0);
				if(IsSet($values["column"]))
				{
					if(IsSet($values["columnname"]))
					{
						$compiler->SetElementError($context->file,$context->path,"it was specified both the column and the columnname arguments");
						return(0);
					}
					$column=$values["column"];
				}
				else
				{
					if(!IsSet($values["columnname"]))
					{
						$compiler->SetElementError($context->file,$context->path,"it was not specified either the column or the columnname argument");
						return(0);
					}
					$column=$values["columnname"];
				}
				$value="(".$values["handle"].",".$values["result"].",".$values["row"].",".$column.")";
				switch($values["type"])
				{
					case "TEXT";
						$value="MetabaseFetchResult$value";
						$type="STRING";
						break;
					case "INTEGER":
						$value="intval(MetabaseFetchResult$value)";
						$type="INTEGER";
						break;
					case "BOOLEAN":
						$value="intval(MetabaseFetchBooleanResult$value)";
						$type="BOOLEAN";
						break;
					case "DECIMAL":
						$value="MetabaseFetchDecimalResult$value";
						$type="STRING";
						break;
					case "FLOAT":
						$value="doubleval(MetabaseFetchFloatResult$value)";
						$type="FLOAT";
						break;
					case "DATE":
						$value="MetabaseFetchDateResult$value";
						$type="STRING";
						break;
					case "TIME":
						$value="MetabaseFetchTimeResult$value";
						$type="STRING";
						break;
					case "TIMESTAMP":
						$value="MetabaseFetchTimestampResult$value";
						$type="STRING";
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,"it was not specified a supported database fetch result type (\"".$values["type"]."\")");
						return(0);
				}
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$value,
						"Type"=>$type,
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "resultisnull":
				$types=array(
					"handle"=>"INTEGER",
					"result"=>"INTEGER",
					"row"=>"INTEGER",
					"columnname"=>"STRING"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseResultIsNull(".$values["handle"].",".$values["result"].",".$values["row"].",".$values["columnname"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "freequeryresult":
				$types=array(
					"handle"=>"INTEGER",
					"result"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>"MetabaseFreeResult(".$values["handle"].",".$values["result"].");",
					"Type"=>"COMMAND"
				);
				break;
			case "affectedrows":
				$types=array(
					"handle"=>"INTEGER",
					"rows"=>"INTEGER:NOTRIGHT"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseAffectedRows(".$values["handle"].",".$values["rows"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "querysettext":
			case "querysetinteger":
			case "querysetboolean":
			case "querysetdate":
			case "querysettimestamp":
			case "querysettime":
			case "querysetfloat":
			case "querysetdecimal":
				switch($function)
				{
					case "querysettext":
						$type="STRING";
						$call="MetabaseQuerySetText";
						break;
					case "querysetinteger":
						$type="INTEGER";
						$call="MetabaseQuerySetInteger";
						break;
					case "querysetboolean":
						$type="BOOLEAN";
						$call="MetabaseQuerySetBoolean";
						break;
					case "querysetdate":
						$type="STRING";
						$call="MetabaseQuerySetDate";
						break;
					case "querysettimestamp":
						$type="STRING";
						$call="MetabaseQuerySetTimeStamp";
						break;
					case "querysettime":
						$type="STRING";
						$call="MetabaseQuerySetTime";
						break;
					case "querysetfloat":
						$type="FLOAT";
						$call="MetabaseQuerySetFloat";
						break;
					case "querysetdecimal":
						$type="STRING";
						$call="MetabaseQuerySetDecimal";
						break;
				}
				$types=array(
					"handle"=>"INTEGER",
					"statement"=>"INTEGER",
					"argument"=>"INTEGER",
					"value"=>$type
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"$call(".$values["handle"].",".$values["statement"].",".$values["argument"].",".$values["value"].")",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "querysetnull":
				$types=array(
					"handle"=>"INTEGER",
					"statement"=>"INTEGER",
					"argument"=>"INTEGER",
					"type"=>"STRING"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseQuerySetNull(".$values["handle"].",".$values["statement"].",".$values["argument"].",".$values["type"].")",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "freepreparedquery":
				$types=array(
					"handle"=>"INTEGER",
					"statement"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseFreePreparedQuery(".$values["handle"].",".$values["statement"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "gettextfieldvalue":
			case "getintegerfieldvalue":
			case "getbooleanfieldvalue":
			case "getdatefieldvalue":
			case "gettimestampfieldvalue":
			case "gettimefieldvalue":
			case "getfloatfieldvalue":
			case "getdecimalfieldvalue":
				switch($function)
				{
					case "gettextfieldvalue":
						$type="STRING";
						$call="MetabaseGetTextFieldValue";
						break;
					case "getintegerfieldvalue":
						$type="INTEGER";
						$call="";
						break;
					case "getbooleanfieldvalue":
						$type="BOOLEAN";
						$call="MetabaseGetBooleanFieldValue";
						break;
					case "getdatefieldvalue":
						$type="STRING";
						$call="MetabaseGetDateFieldValue";
						break;
					case "gettimestampfieldvalue":
						$type="STRING";
						$call="MetabaseGetTimeStampFieldValue";
						break;
					case "gettimefieldvalue":
						$type="STRING";
						$call="MetabaseGetTimeFieldValue";
						break;
					case "getfloatfieldvalue":
						$type="FLOAT";
						$call="MetabaseGetFloatFieldValue";
						break;
					case "getdecimalfieldvalue":
						$type="STRING";
						$call="MetabaseGetDecimalFieldValue";
						break;
				}
				$types=array(
					"handle"=>"INTEGER",
					"value"=>$type
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>(strcmp($call,"") ? "$call(".$values["handle"].",".$values["value"].")" : "strval(".$values["value"].")"),
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "support":
				$types=array(
					"handle"=>"INTEGER",
					"feature"=>"STRING"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseSupport(".$values["handle"].",".$values["feature"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "autocommit":
				$types=array(
					"handle"=>"INTEGER",
					"autocommit"=>"BOOLEAN"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseAutoCommitTransactions(".$values["handle"].",".$values["autocommit"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "rollback":
				$types=array(
					"handle"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseRollbackTransaction(".$values["handle"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "getsequencenextvalue":
				$types=array(
					"handle"=>"INTEGER",
					"name"=>"STRING",
					"sequence"=>"INTEGER:NOTRIGHT"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseGetSequenceNextValue(".$values["handle"].",".$values["name"].",".$values["sequence"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "getnextkey":
				$types=array(
					"handle"=>"INTEGER",
					"table"=>"STRING",
					"key"=>"STRING:TRIGHT"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseGetNextKey(".$values["handle"].",".$values["table"].",".$values["key"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "getinsertedkey":
				$types=array(
					"handle"=>"INTEGER",
					"table"=>"STRING",
					"key"=>"INTEGER:TRIGHT"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseGetInsertedKey(".$values["handle"].",".$values["table"].",".$values["key"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "setdatabase":
				$types=array(
					"handle"=>"INTEGER",
					"name"=>"STRING"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>"MetabaseSetDatabase(".$values["handle"].",".$values["name"].");",
					"Type"=>"COMMAND"
				);
				break;
			case "error":
				$types=array(
					"handle"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseError(".$values["handle"].")",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "newmanager":
				$this->needs_manager=$this->needs_interface=1;
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"new metabase_manager_class",
						"Type"=>"OBJECT:metabase_manager_class",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "updatedatabase":
				$types=array(
					"object"=>"OBJECT",
					"schema"=>"STRING",
					"success"=>"BOOLEAN:NOTRIGHT"
				);
				$optional_types=array(
					"arguments"=>"HASH",
					"variables"=>"HASH",
					"installedschema"=>"STRING",
					"connection"=>"STRING",
					"includepath"=>"STRING",
					"error"=>"STRING:NOTRIGHT"
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"database",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$types,$optional_types,"database",$function,1))
					return(0);
				if(IsSet($values["arguments"]))
				{
					if(IsSet($values[$argument="connection"])
					|| IsSet($values[$argument="includepath"]))
						return($compiler->SetElementError($context->file,$context->path,"it was specified both the database $function arguments and $argument arguments"));
					$arguments=$values["arguments"];
				}
				else
				{
					$arguments_array="array(";
					if(!IsSet($values["connection"]))
						return($compiler->SetElementError($context->file,$context->path,"it was not specified the database $function connection argument"));
					$arguments_array.="\"Connection\"=>".$values["connection"];
					if(IsSet($values["includepath"]))
						$arguments_array.=",\"IncludePath\"=>".$values["includepath"];
					$arguments_array.=")";
					$variable=array(
						"Prefix"=>"arguments",
						"Type"=>"STRING"
					);
					if(!$compiler->AllocateTemporaryVariable($context,$variable))
						return(0);
					$arguments=$variable["Declaration"];
					$context->result[]=array(
						"Data"=>$arguments."=".$arguments_array.";",
						"Type"=>"COMMAND"
					);
				}
				if(IsSet($values["variables"]))
					$variables=$values["variables"];
				else
				{
					$variables_array="array()";
					$variable=array(
						"Prefix"=>"variables",
						"Type"=>"STRING"
					);
					if(!$compiler->AllocateTemporaryVariable($context,$variable))
						return(0);
					$variables=$variable["Declaration"];
					$context->result[]=array(
						"Data"=>$variables."=".$variables_array.";",
						"Type"=>"COMMAND"
					);
				}
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$command=$values["success"]."=".$values["object"]."->UpdateDatabase(".$values["schema"].",".(IsSet($values["installedschema"]) ? $values["installedschema"] : $values["schema"].".\".installed\"").",".$arguments.",".$variables.")";
				if(IsSet($values["error"]))
				{
					$context->result[]=array(
						"Data"=>"if(!($command))",
						"Type"=>"COMMAND"
					);
					$context->result[]=array(
						"Data"=>1,
						"Type"=>"INDENT"
					);
					$context->result[]=array(
						"Data"=>$values["error"]."=".$values["object"]."->error;",
						"Type"=>"COMMAND"
					);
					$context->result[]=array(
						"Data"=>1,
						"Type"=>"OUTDENT"
					);
				}
				else
				{
					$context->result[]=array(
						"Data"=>$command,
						"Type"=>"COMMAND"
					);
				}
				break;
			case "managererror":
				$types=array(
					"object"=>"OBJECT"
				);
				$optional_types=array();
				$values=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"database",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$types,$optional_types,"database",$function,1))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$values["object"]."->error",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "debugmessage":
				$types=array(
					"handle"=>"INTEGER",
					"message"=>"STRING"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>"MetabaseDebug(".$values["handle"].",".$values["message"].");",
					"Type"=>"COMMAND"
				);
				break;
			case "capturedebugoutput":
				$types=array(
					"handle"=>"INTEGER",
					"capture"=>"BOOLEAN"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>"MetabaseCaptureDebugOutput(".$values["handle"].",".$values["capture"].");",
					"Type"=>"COMMAND"
				);
				break;
			case "debugoutput":
				$types=array(
					"handle"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseDebugOutput(".$values["handle"].")",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "managerdebugoutput":
				$types=array(
					"manager"=>"OBJECT"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"database",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"(".$values["manager"]."->database ? MetabaseDebugOutput(".$values["manager"]."->database) : \"\")",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "now":
			case "today":
			case "time":
			  $functions=array(
			   "now"=>"MetabaseNow",
			   "today"=>"MetabaseToday",
			   "time"=>"MetabaseTime"
			  );
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$functions[$function]."()",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "datatype":
				$types=array(
					"type"=>"DATA"
				);
				$optional_types=array();
				$values=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"database",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$types,$optional_types,"database",$function,1))
					return(0);
				switch($values["type"])
				{
					case "text":
						$value="STRING";
						break;
					case "integer":
						$value="INTEGER";
						break;
					case "boolean":
						$value="BOOLEAN";
						break;
					case "float":
						$value="FLOAT";
						break;
					case "decimal":
						$value="STRING";
						break;
					case "time":
						$value="STRING";
						break;
					case "date":
						$value="STRING";
						break;
					case "timestamp":
						$value="STRING";
						break;
					case "handle":
						$value="INTEGER";
						break;
					case "result":
						$value="INTEGER";
						break;
					default:
						return($compiler->SetElementError($context->file,$context->path,"\"".$values["type"]."\" is not a supported database data type"));
				}
				$context->result[]=array(
					"Data"=>$value,
					"Type"=>"DATA"
				);
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported database object function");
				return(0);
		}
		return(1);
	}

	Function Initialization(&$compiler,&$context,$object_context)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the database class");
			return(0);
		}
		$relative_path=$compiler->RelativePath($this->database_base_path,$this->database_path);
		if(strcmp($relative_path,""))
			$relative_path.="/";
		$database_path=$this->database_path;
		if(strcmp($database_path,""))
			$database_path.="/";
		if($this->needs_manager)
		{
			$context->result[]=array(
				"Data"=>array(
					"Name"=>$database_path."metabase_manager.php",
					"Type"=>"SUPPLIED"
				),
				"Type"=>"FILE"
			);
			$context->result[]=array(
				"Data"=>"require(\"$relative_path"."metabase_manager.php\");",
				"Type"=>"COMMAND"
			);
			$context->result[]=array(
				"Data"=>array(
					"Name"=>$database_path."metabase_parser.php",
					"Type"=>"SUPPLIED"
				),
				"Type"=>"FILE"
			);
			$context->result[]=array(
				"Data"=>"require(\"$relative_path"."metabase_parser.php\");",
				"Type"=>"COMMAND"
			);
			$context->result[]=array(
				"Data"=>array(
					"Name"=>$database_path."xml_parser.php",
					"Type"=>"SUPPLIED"
				),
				"Type"=>"FILE"
			);
			$context->result[]=array(
				"Data"=>"require(\"$relative_path"."xml_parser.php\");",
				"Type"=>"COMMAND"
			);
		}
		if($this->needs_interface)
		{
			$context->result[]=array(
				"Data"=>array(
					"Name"=>$database_path."metabase_interface.php",
					"Type"=>"SUPPLIED"
				),
				"Type"=>"FILE"
			);
			$context->result[]=array(
				"Data"=>"require(\"$relative_path"."metabase_interface.php\");",
				"Type"=>"COMMAND"
			);
			$context->result[]=array(
				"Data"=>array(
					"Name"=>$database_path."metabase_database.php",
					"Type"=>"SUPPLIED"
				),
				"Type"=>"FILE"
			);
			$context->result[]=array(
				"Data"=>array(
					"Name"=>$database_path."manager_database.php",
					"Type"=>"SUPPLIED"
				),
				"Type"=>"FILE"
			);
			$context->result[]=array(
				"Data"=>"require(\"$relative_path"."metabase_database.php\");",
				"Type"=>"COMMAND"
			);
		}
		return(1);
	}

};

}
?>