<?
if(!defined("METAL_EMAIL_INCLUDED"))
{
	define("METAL_EMAIL_INCLUDED",1);

/*
 * metal_email.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_email.php,v 1.3 2004/05/11 02:19:34 mlemos Exp $
 *
 */
 
class metal_email_class extends metal_base_class
{
	var $default_class_file="email_message.php";
	var $class_files=array();
	var $class_base_path="";

	Function Setup(&$compiler,&$code,&$attributes)
	{
		$elements=$code->structure[$attributes->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$attributes->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "classfile":
						if(!$compiler->GetValidData($attributes->file,$element_path,&$class_file,"it was not specified a valid email class file"))
							return(0);
						if(IsSet($this->class_files[$class_file]))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was specified a email class file (\"$class_file\") more than once");
							return(0);
						}
						if(!file_exists($class_file))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was not specified a valid an existing email class file (\"$class_file\")");
							return(0);
						}
						$this->class_files[$class_file]=$element_path;
						break;
					case "classbasepath":
						if(!$compiler->GetValidData($attributes->file,$element_path,&$this->class_base_path,"it was not specified a valid email class base path"))
							return(0);
						break;
					case "classname":
						if(!$compiler->GetValidData($attributes->file,$element_path,&$this->class_name,"it was not specified a valid email class name"))
							return(0);
						break;
					default:
						$compiler->SetElementError($attributes->file,$element_path,$data["Tag"]." is not a supported email object attribute");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($attributes->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function GetObject(&$compiler,&$context,$element_path,&$object)
	{
		if(strcmp($object,""))
		{
			$compiler->SetElementError($context->file,$element_path,"it was specified the email object argument");
			return(0);
		}
		$compiler->CopyEmptyContext($context,$evaluate_context);
		$evaluate_context->path=$element_path;
		if(!$compiler->GetValidExpression(&$evaluate_context,"OBJECT","NOTRIGHT","it was not specified a valid email object expression",1)
		|| !$compiler->GetExpressionValue(&$context,&$evaluate_context->result,&$object,&$expression_type))
			return(0);
		return(1);
	}

	Function GetEmailArguments(&$compiler,&$code,&$context,&$object)
	{
		$elements=$code->structure[$context->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$context->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "object":
						if(!$this->GetObject(&$compiler,&$context,$element_path,&$object))
							return(0);
						break;
					default:
						$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported email argument");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function VerifyEmailArguments(&$compiler,&$code,&$context,&$object)
	{
		$object="";
		if(!$this->GetEmailArguments(&$compiler,&$code,&$context,&$object))
			return(0);
		If(!strcmp($object,""))
		{
			$compiler->SetElementError($context->file,$context->path,"it was not specified the email object argument");
			return(0);
		}
		return(1);
	}

	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the email class");
			return(0);
		}
		switch($function)
		{
			case "new":
				if(!$this->VerifyEmailArguments(&$compiler,&$arguments_code,&$arguments,&$object))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>$object."=new ".$this->class_name.";",
					"Type"=>"COMMAND"
				);
				break;
			case "setencodedheader":
				$required_types=array(
					"object"=>"OBJECT",
					"header"=>"STRING",
					"value"=>"STRING"
				);
				$optional_types=array(
					"encoding"=>"OBJECT",
					"error"=>"STRING:NOTRIGHT",
					"check"=>"DATA"
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues(&$arguments,&$values,&$required_types,&$optional_types,"email",$function,0)
				|| !$compiler->GetOptionalArgumentValues(&$context,&$values,&$required_types,&$optional_types,"email",$function,1))
					return(0);
				$expression=$values["object"]."->SetEncodedHeader(".$values["header"].",".$values["value"].(IsSet($values["encoding"]) ? ",".$values["encoding"] : "").")";
				if(IsSet($values["error"]))
					$expression=$values["error"]."=$expression";
				if(IsSet($values["check"]))
				{
					$type="BOOLEAN";
					$expression="!strcmp($expression,\"\")";
				}
				else
					$type="STRING";
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$expression,
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "setencodedaddressheader":
				$required_types=array(
					"object"=>"OBJECT",
					"header"=>"STRING",
					"address"=>"STRING",
					"name"=>"STRING"
				);
				$optional_types=array(
					"encoding"=>"OBJECT",
					"error"=>"STRING:NOTRIGHT",
					"check"=>"DATA"
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues(&$arguments,&$values,&$required_types,&$optional_types,"email",$function,0)
				|| !$compiler->GetOptionalArgumentValues(&$context,&$values,&$required_types,&$optional_types,"email",$function,1))
					return(0);
				$expression=$values["object"]."->SetEncodedEmailHeader(".$values["header"].",".$values["address"].",".$values["name"].(IsSet($values["encoding"]) ? ",".$values["encoding"] : "").")";
				if(IsSet($values["error"]))
					$expression=$values["error"]."=$expression";
				if(IsSet($values["check"]))
				{
					$type="BOOLEAN";
					$expression="!strcmp($expression,\"\")";
				}
				else
					$type="STRING";
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$expression,
						"Type"=>$type,
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "compose":
				$required_types=array(
					"object"=>"OBJECT",
					"part"=>"CONTEXT:MULTIPLE"
				);
				$optional_types=array(
					"error"=>"STRING:NOTRIGHT",
					"check"=>"DATA"
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues(&$arguments,&$values,&$required_types,&$optional_types,"email",$function,0)
				|| !$compiler->GetOptionalArgumentValues(&$context,&$values,&$required_types,&$optional_types,"email",$function,1))
					return(0);
				$part_required_types=array(
					"type"=>"DATA",
					"content"=>"STRING"
				);
				$part_optional_types=array(
					"transferencoding"=>"DATA",
					"characterset"=>"STRING"
				);
				for($expression="",$part=0;$part<count($values["part"]);$part++)
				{
					$part_values=array();
					if(!$compiler->GetOptionalArgumentValues(&$values["part"][$part],&$part_values,&$part_required_types,&$part_optional_types,"email",$function,1))
						return(0);
					switch($part_values["type"])
					{
						case "text":
							break;
						default:
							$compiler->SetElementError($values["part"][$part]->file,$values["part"][$part]->path,"it was not specified a supported message part type (\"".$part_values["type"]."\")");
							return(0);
					}
					switch(IsSet($part_values["transferencoding"]) ? $part_values["transferencoding"] : "")
					{
						case "quoted-printable":
							$part_expression=$values["object"]."->AddQuotedPrintableTextPart(".$part_values["content"].(IsSet($part_values["characterset"]) ? ",".$part_values["characterset"] : "").")";
							break;
						case "":
							$part_expression=$values["object"]."->AddPlainTextPart(".$part_values["content"].")";
							break;
						default:
							$compiler->SetElementError($values["part"][$part]->file,$values["part"][$part]->path,"it was not specified a supported message part transfer encoding (\"".$part_values["transferencoding"]."\")");
							return(0);
					}
					if(IsSet($values["error"]))
						$part_expression=$values["error"]."=$part_expression";
					if(IsSet($values["error"])
					|| IsSet($values["check"]))
					{
						if(strcmp($expression,""))
							$expression.="&& ";
						$expression.="!strcmp($part_expression,\"\")";
					}
					else
					{
						$context->result[]=array(
							"Data"=>$part_expression.";",
							"Type"=>"COMMAND"
						);
					}
				}
				if(IsSet($values["error"])
				|| IsSet($values["check"]))
				{
					$context->result[]=array(
						"Data"=>array(
							"Value"=>$expression,
							"Type"=>"BOOLEAN",
							"Side"=>"RIGHT"
						),
						"Type"=>"EXPRESSION"
					);
				}
				break;
			case "send":
				$required_types=array(
					"object"=>"OBJECT"
				);
				$optional_types=array(
					"error"=>"STRING:NOTRIGHT",
					"check"=>"DATA"
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues(&$arguments,&$values,&$required_types,&$optional_types,"email",$function,0)
				|| !$compiler->GetOptionalArgumentValues(&$context,&$values,&$required_types,&$optional_types,"email",$function,1))
					return(0);
				$expression=$values["object"]."->Send()";
				if(IsSet($values["error"]))
					$expression=$values["error"]."=$expression";
				if(IsSet($values["check"]))
				{
					$type="BOOLEAN";
					$expression="!strcmp($expression,\"\")";
				}
				else
					$type="STRING";
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$expression,
						"Type"=>$type,
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "wrap":
				$required_types=array(
					"object"=>"OBJECT",
					"message"=>"STRING"
				);
				$optional_types=array(
					"linelength"=>"INTEGER",
					"linebreak"=>"STRING"
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues(&$arguments,&$values,&$required_types,&$optional_types,"email",$function,0)
				|| !$compiler->GetOptionalArgumentValues(&$context,&$values,&$required_types,&$optional_types,"email",$function,1))
					return(0);
				$expression=$values["object"]."->WrapText(".$values["message"].(IsSet($values["linelength"]) ? ",".$values["linelength"] : "").(IsSet($values["linebreak"]) ? ",".$values["linebreak"] : "").")";
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$expression,
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported email object function");
				return(0);
		}
		return(1);
	}

	Function Initialization(&$compiler,&$context,$object_context)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the email class");
			return(0);
		}
		for($file=0,Reset($this->class_files);$file<count($this->class_files);Next($this->class_files),$file++)
		{
			$class_file=Key($this->class_files);
			$relative_path=$compiler->RelativePath($this->class_base_path,$class_file);
			$context->result[]=array(
				"Data"=>array(
					"Name"=>$class_file,
					"Type"=>"SUPPLIED"
				),
				"Type"=>"FILE"
			);
			$context->result[]=array(
				"Data"=>"require(\"$relative_path\");",
				"Type"=>"COMMAND"
			);
		}
		return(1);
	}

};
 
}
?>