<?php
if(!defined("METAL_EXPRESSIONS_INCLUDED"))
{
	define("METAL_EXPRESSIONS_INCLUDED",1);

/*
 * metal_expressions.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_expressions.php,v 1.108 2004/05/11 04:52:04 mlemos Exp $
 *
 */
 
class metal_expressions_class extends metal_base_class
{
	Function GetArrayElements(&$compiler,&$context,&$code,&$evaluate_context,$type,$skip_white_space,&$message)
	{
		$elements=$code->structure[$evaluate_context->path]["Elements"];
		for($value_type="ANY",$part=0,$element=0;$element<$elements;$element++)
		{
			$element_path=$evaluate_context->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				$compiler->CopyEmptyContext($evaluate_context,$entry_context);
				$entry_context->path=$element_path;
				if(!strcmp($type,"ARRAY")
				|| ($part % 2))
				{
					$array_type=$value_type;
					$error="it was not specified a valid value array entry value";
				}
				else
				{
					$array_type="STRING";
					$error="it was not specified a valid value array entry index";
				}
				if(!$compiler->GetValidTypedExpression($entry_context,$array_type,$error,1,$skip_white_space)
				|| !$compiler->GetExpressionValue($context,$entry_context->result,$message["elements"][$part],$message["types"][$part]))
					return(0);
				if($part==0)
				{
					if(!strcmp($type,"ARRAY"))
						$value_type=$message["types"][$part];
				}
				$part++;
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($evaluate_context->file,$data,$element_path))
					return(0);
			}
		}
		if(!strcmp($type,"HASH")
		&& ($part % 2))
		{
			$compiler->SetElementError($context->file,$element_path,"it is missing the last HASH entry value");
			return(0);
		}
		return(1);
	}

	Function GetValue(&$compiler,&$code,&$context,&$result,$path="",$type="",$skip_white_space=0,$error="it was not specifid a valid value")
	{
		$compiler->CopyEmptyContext($context,$evaluate_context);
		if(strcmp($path,""))
			$evaluate_context->path=$path;
		if(!strcmp($type,""))
			$type="ANY";
		switch($type)
		{
			case "ARRAY":
			case "HASH":
				$message=array(
					"type"=>$type,
					"elements"=>array(),
					"types"=>array(),
					"value"=>""
				);
				if(!$this->GetArrayElements($compiler,$context,$code,$evaluate_context,$type,$skip_white_space,$message))
					return(0);
				$compiler->CopyEmptyContext($context,$array_context);
				if(!$this->language_bindings->Execute($compiler,$array_context,$this,"value",$message))
					return(0);
				$total=count($array_context->result);
				for($part=0;$part<$total;$part++)
					$result[]=$array_context->result[$part];
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$message["value"],
						"Type"=>$message["type"],
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "CHARACTER":
				if(!$compiler->GetValidData($context->file,$context->path,$character,"it was not specified a valid character value"))
					return(0);
				if(strcmp($character,strval(intval($character))))
				{
					$compiler->SetElementError($arguments->file,$element_path,"it was not specified a valid character code value value");
					return(0);
				}
				$result[]=array(
					"Data"=>Chr($character),
					"Type"=>"DATA"
				);
				break;
			default:
				$evaluate_context->result=array();
				if(!$compiler->GetValidTypedExpression($evaluate_context,$type,$error,0,$skip_white_space))
					return(0);
				$total=count($evaluate_context->result);
				for($part=0;$part<$total;$part++)
					$result[]=$evaluate_context->result[$part];
				break;
		}
		return(1);
	}

	Function GetFormatArguments(&$compiler,&$arguments_code,&$arguments,&$format,&$values)
	{
		$elements=$arguments_code->structure[$arguments->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$arguments->path.",$element";
			$data=$arguments_code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "string":
					case "integer":
					case "float":
						switch($data["Tag"])
						{
							case "string":
								$type="STRING";
								break;
							case "integer":
								$type="INTEGER";
								break;
							case "float":
								$type="FLOAT";
								break;
						}
						if(!$this->GetValue($compiler,$arguments_code,$arguments,$values[count($values)],$element_path,$type))
							return(0);
						break;
					case "format":
						if(count($format))
						{
							$compiler->SetElementError($arguments->file,$element_path,"it was specified the format string more than once");
							return(0);
						}
						if(!$this->GetValue($compiler,$arguments_code,$arguments,$format,$element_path,"STRING",0,"it was not specifid a valid FORMAT STRING value"))
							return(0);
						break;
					default:
						$compiler->SetElementError($arguments->file,$element_path,$data["Tag"]." is not a valid format argument");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($arguments->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		switch($compiler->language["name"])
		{
			case "PHP":
				break;
			case "Java":
				switch($function)
				{
					case "data":
					case "getbindingsproperty":
					case "hashreset":
					case "set":
					case "setbuffer":
					case "variable":
					case "value":
					case "length":
					case "less":
					case "substring":
					case "code":
					case "group":
					case "join":
					case "convert":
					case "concatenate":
					case "increment":
					case "decrement":
					case "incrementbuffer":
					case "decrementbuffer":
					case "equalstrings":
					case "lowercase":
					case "uppercase":
					case "utf8encode":
					case "utf8decode":
					case "setentry":
					case "entry":
					case "entryindex":
					case "entrydefined":
					case "undefineentry":
					case "count":
					case "more":
					case "reset":
					case "next":
					case "not":
					case "conditional":
					case "differentstrings":
					case "plus":
					case "and":
					case "conditionalvalue":
					case "void":
					case "typedvalue":
					case "buffervalue":
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,"$function function of the expressions class is not implemented for the language ".$compiler->language["name"]);
						return(0);
				}
				break;
			case "Perl":
				switch($function)
				{
					case "data":
					case "getbindingsproperty":
					case "value":
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,"$function function of the expressions class is not implemented for the language ".$compiler->language["name"]);
						return(0);
				}
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the expressions class");
				return(0);
		}
		switch($function)
		{
			case "set":
			case "setbuffer":
				$message=array();
				$side=0;
				$message["type"]="ANY";
				$elements=$code->structure[$context->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						if($side>=2)
						{
							$compiler->SetElementError($context->file,$element_path,"it was specified some garbage after the right hand side of the set command expression");
							return(0);
						}
						$compiler->CopyEmptyContext($context,$evaluate_context);
						$evaluate_context->path=$element_path;
						if($side==0)
						{
							if(!$compiler->GetValidExpression($evaluate_context,$message["type"],"NOTRIGHT","it was not specified a valid set left hand expression",0,1)
							|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$expression_value,$message["type"]))
								return(0);
							if($message["type"]=="UNDEFINED")
								$compiler->CopyEmptyContext($evaluate_context,$left_context);
							else
							{
								if($function=="setbuffer")
								{
									switch($message["type"])
									{
										case "INTEGERBUFFER":
											$message["type"]="INTEGER";
											break;
										case "STRINGBUFFER":
											$message["type"]="STRING";
											break;
										case "BOOLEANBUFFER":
											$message["type"]="BOOLEAN";
											break;
										case "FLOATBUFFER":
											$message["type"]="FLOAT";
											break;
										case "OBJECTBUFFER":
											$message["type"]="OBJECT";
											break;
										case "ARRAYBUFFER":
											$message["type"]="ARRAY";
											break;
										case "HASHBUFFER":
											$message["type"]="HASH";
											break;
										case "INTEGER":
										case "STRING":
										case "BOOLEAN":
										case "FLOAT":
										case "OBJECT":
										case "ARRAY":
										case "HASH":
											$compiler->SetElementError($context->file,$element_path,$message["type"]." is not a valid left hand buffer expression type");
											return(0);
										default:
											$compiler->SetElementError($context->file,$element_path,$message["type"]." is not a supported left hand buffer expression type");
											return(0);
									}
								}
							}
						}
						else
						{
							if(!$compiler->GetValidExpression($evaluate_context,$message["type"]=="UNDEFINED" ? "ANY" : $message["type"],"NOTLEFT","it was not specified a valid set right hand".(strcmp($message["type"],"ANY") ? " ".$message["type"] : "")." expression",0,1)
							|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$expression_value,$right_expression_type))
								return(0);
							if($message["type"]=="UNDEFINED")
							{
								switch($right_expression_type)
								{
									case "ANY":
									case "UNDEFINED":
										$compiler->SetElementError($context->file,$context->path,"it was attemped to assign a value of type $right_expression_type to a variable of type ".$message["type"]);
										return(0);
								}
								$variable=array(
									"DeclarationFile"=>$left_context->file,
									"DeclarationPath"=>$left_context->path
								);
								if(!$compiler->QueryVariable($context,$variable))
									return(0);
								if(!$variable["Declared"])
								{
									$compiler->SetElementError($left_context->file,$left_context->path,"the specified left hand expression does not declare its type nor is a local variable");
									return(0);
								}
								if($function=="setbuffer")
								{
									$variable["Type"]=$compiler->strtok($right_expression_type,":")."BUFFER";
									if(strlen($sub_type=$compiler->strtok("")))
										$variable["Type"].=":".$sub_type;
								}
								else
									$variable["Type"]=$right_expression_type;
								$variable["Initialized"]=1;
								if(!$compiler->DeclareVariable($context,$variable))
									return(0);
							}
							$message["type"]=$right_expression_type;
						}
						if($side==0)
							$message["left"]=$expression_value;
						else
							$message["right"]=$expression_value;
						$side++;
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				if($side<2)
				{
					$compiler->SetElementError($context->file,$context->path,"it was not defined a complete set expression");
					return(0);
				}
				if(!$this->language_bindings->Execute($compiler,$context,$this,$function,$message))
					return(0);
				break;
			case "hashreset":
			case "arrayreset":
				if($function=="hashreset")
				{
					$type="HASH";
					$value="hash";
					$types=array(
						"hash"=>"HASH:NOTRIGHT",
						"index"=>"STRING",
						"values"=>"CONTEXT"
					);
				}
				else
				{
					$type="ARRAY";
					$value="array";
					$types=array(
						"array"=>"ARRAY:NOTRIGHT",
						"index"=>"INTEGER",
						"values"=>"CONTEXT"
					);
				}
				$optional_types=$values=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"expressions",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$types,$optional_types,"expressions",$function,1))
					return(0);
				$message=array(
					$value=>$values[$value],
					"index"=>$values["index"],
					"elements"=>array(),
					"types"=>array()
				);
				$compiler->GetParser($parser,$values["values"]->file);
				if(!$this->GetArrayElements($compiler,$context,$parser,$values["values"],$type,1,$message))
					return(0);
				if(!$this->language_bindings->Execute($compiler,$context,$this,$function,$message))
					return(0);
				break;
			case "variable":
				$variable_type=$variable_name="";
				$elements=$arguments_code->structure[$arguments->path]["Elements"];
				for($variable_position=-1,$element=0;$element<$elements;$element++)
				{
					$element_path=$arguments->path.",$element";
					$data=$arguments_code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "type":
								if(strcmp($variable_type,""))
								{
									$compiler->SetElementError($arguments->file,$element_path,"it was attempted to the define the $function type more than once");
									return(0);
								}
								if(!$compiler->GetValidData($arguments->file,$element_path,$variable_type,"it was not specified a valid $function type"))
									return(0);
								if(!strcmp($variable_type,""))
								{
									$compiler->SetElementError($arguments->file,$element_path,"it was not specified a valid $function type");
									return(0);
								}
								break;
							case "name":
								if(strcmp($variable_name,""))
								{
									$compiler->SetElementError($arguments->file,$element_path,"it was attempted to the define the $function name more than once");
									return(0);
								}
								if(!$compiler->GetValidData($arguments->file,$element_path,$variable_name,"it was not specified a valid $function name"))
									return(0);
								$variable_position=$element;
								break;
							default:
								$compiler->SetElementError($arguments->file,$element_path,$data["Tag"]." is not a valid $function argument");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($arguments->file,$data,$element_path))
							return(0);
					}
				}
				if(!$compiler->GetOutputData($context->file,$context->path,$result,"it was not specified a valid variable expression",0))
					return(0);
				for($error="",$position=0;$position<count($result);$position++)
				{
					switch($result[$position]["Type"])
					{
						case "INITIALIZATION":
						case "FILE":
							$context->result[]=$result[$position];
							break;
						case "EXPRESSION":
							switch($result[$position]["Data"]["Side"])
							{
								case "LEFT":
								case "BOTH":
									if($variable_position>=0)
									{
										$error="it was defined more than one variable expression";
										break 3;
									}
									$type=$result[$position]["Data"]["Type"];
									if(strcmp($variable_type,""))
									{
										if($type!="ANY"
										&& $type!=$variable_type)
										{
											$error="it was specified a variable type (\"".$variable_type."\") that is not compatible with the specified expression type (\"$type\")";
											break 3;
										}
										$type=$variable_type;
									}
									$variable_position=$position;
									break;
								default:
									$error="it was not defined a valid LEFT hand variable expression";
									break 3;
							}
							$context->result[]=array(
								"Data"=>array(
									"Value"=>$result[$position]["Data"]["Value"],
									"Type"=>$type,
									"Side"=>$result[$position]["Data"]["Side"]
								),
								"Type"=>"EXPRESSION"
							);
							break;
						case "DATA":
							if(strcmp($variable_name,""))
							{
								$error="the variable name was already defined";
								break 2;
							}
							if($variable_position>=0)
							{
								$error="it was defined more than one variable expression";
								break 2;
							}
							$variable_name=$result[$position]["Data"];
							$variable_position=$position;
							break;
						default:
							$error="it was not defined a valid LEFT hand variable expression";
							break 2;
					}
				}
				if(!strcmp($error,"")
				&& $variable_position<0)
					$error="it was not defined a LEFT hand variable expression";
				if(strcmp($error,""))
				{
					$compiler->SetElementError($context->file,$context->path,$error);
					return(0);
				}
				if(strcmp($variable_name,""))
				{
					if(!$compiler->ValidateVariableName($variable_name))
					{
						$compiler->SetElementError($context->file,$context->path,"it was not defined a valid variable name");
						return(0);
					}
					$variable=array(
						"Name"=>$variable_name,
						"Temporary"=>0
					);
					if(!$compiler->QueryVariable($context,$variable))
						return(0);
					if($variable["Declared"])
					{
						if($variable["Argument"])
						{
							$compiler->SetElementError($context->file,$context->path,"it was attempted to redefine the variable named \"".$variable["Name"]."\" that is already defined as argument");
							return(0);
						}
						if($variable_type=="")
							$variable_type=$variable["Type"];
						else
						{
							if($variable_type!=$variable["Type"])
							{
								$compiler->SetElementError($context->file,$context->path,"it was attempted to redefine a ".$variable["Type"]." variable named \"".$variable["Name"]."\" as of type \"$variable_type\"");
								return(0);
							}
						}
					}
					else
					{
						if($variable_type=="")
							$variable_type="UNDEFINED";
						$variable["Type"]=$variable_type;
						if(!$compiler->DeclareVariable($context,$variable))
							return(0);
					}
					$context->result[]=array(
							"Data"=>array(
							"Value"=>$variable["Declaration"],
							"Type"=>$variable_type,
							"Side"=>"BOTH"
						),
						"Type"=>"EXPRESSION"
					);
				}
				break;
			case "value":
			case "typedvalue":
			case "convert":
			case "isvalid":
				$type=$path="";
				$context_value=1;
				$null=0;
				$skip_white_space=0;
				$elements=$arguments_code->structure[$arguments->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$arguments->path.",$element";
					$data=$arguments_code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "skipwhitespace"	:
								if(!$compiler->GetValidData($arguments->file,$element_path,$skip_white_space,"it was not specified a valid $function skipwhitespace argument"))
									return(0);
								if(strcmp($skip_white_space,"1")
								&& strcmp($skip_white_space,"0"))
								{
									$compiler->SetElementError($arguments->file,$element_path,"it was not specified a valid boolean $function skipwhitespace argument value");
									return(0);
								}
								break;
							case "type":
								if(strcmp($type,""))
								{
									$compiler->SetElementError($arguments->file,$element_path,"it was specified the $function type more than once");
									return(0);
								}
								if(!$compiler->GetValidData($arguments->file,$element_path,$type,"it was not specified a valid $function type"))
									return(0);
								switch($type)
								{
									case "INTEGER":
									case "BOOLEAN":
									case "FLOAT":
									case "DECIMAL":
										break;
									case "STRING":
									case "OBJECT":
									case "ARRAY":
									case "HASH":
										if($function!="isvalid")
											break;
									case "CHARACTER":
										if($function=="value"
										|| $function=="typedvalue")
											break;
									default:
										$compiler->SetElementError($arguments->file,$element_path,"it was not specified a valid $function type");
										return(0);
								}
								break;
							case "value":
								if($null)
								{
									$compiler->SetElementError($arguments->file,$element_path,"a specific value expression may not be null");
									return(0);
								}
								if(!$context_value)
								{
									$compiler->SetElementError($arguments->file,$element_path,"it was specified a value expression more than once");
									return(0);
								}
								$path=$element_path;
								$context_value=0;
								break;
							case "null":
								if($function=="value")
								{
									if(!$context_value)
									{
										$compiler->SetElementError($arguments->file,$element_path,"a specific value expression may not be null");
										return(0);
									}
									$null=1;
									break;
								}
							default:
								$compiler->SetElementError($arguments->file,$element_path,$data["Tag"]." is not a supported expressions object $function parameter");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($arguments->file,$data,$element_path))
							return(0);
					}
				}
				switch($function)
				{
					case "value":
						if($null)
						{
							switch($compiler->strtok($type,":"))
							{
								case "OBJECT":
								case "ARRAY":
								case "HASH":
									break;
								default:
									return($compiler->SetElementError($context->file,$context->path,$type." is not a supported type for null value"));
							}
							$message=array(
								"type"=>$type,
								"value"=>""
							);
							if(!$this->language_bindings->Execute($compiler,$context,$this,"null",$message))
								return(0);
						}
						else
						{
							if($context_value)
							{
								$result=array();
								if(!$this->GetValue($compiler,$code,$context,$result,"",$type,$skip_white_space))
									return(0);
							}
							else
							{
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->file=$arguments->file;
								$evaluate_context->path=$path;
								$evaluate_context->result=array();
								$result=array();
								if(!$this->GetValue($compiler,$arguments_code,$evaluate_context,$result,$path,$type,$skip_white_space))
									return(0);
							}
							for($value=0;$value<count($result);$value++)
								$context->result[]=$result[$value];
						}
						break;
					case "typedvalue":
						if($context_value)
						{
							$file=$context->file;
							$path=$context->path;
						}
						else
							$file=$arguments->file;
						if(!$compiler->GetValidData($file,$path,$data,"it was not specified a valid class variable value option")
						|| !$compiler->ConvertData($attributes,$type,$data,$converted))
							return(0);
						$context->result[]=array(
							"Data"=>$converted,
							"Type"=>"DATA"
						);
						break;
					case "convert":
					case "isvalid":
						$compiler->CopyEmptyContext($context,$evaluate_context);
						if(!$context_value)
						{
							$evaluate_context->file=$arguments->file;
							$evaluate_context->path=$path;
							$evaluate_context->result=array();
						}
						switch($type)
						{
							case "INTEGER":
							case "STRING":
							case "BOOLEAN":
							case "FLOAT":
							case "DECIMAL":
								break;
							default:
								$compiler->SetElementError($context->file,$context->path,"it was not specified a valid $function type");
								return(0);
						}
						$message=array(
							"type"=>$type
						);
						if(!$compiler->GetValidTypedExpression($evaluate_context,$function=="isvalid" ? "STRING" : "ANY","it was not specified a valid $function expression",0,$skip_white_space)
						|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message["expression"],$message["targettype"]))
							return(0);
						if($function=="convert")
						{
							if(!$this->language_bindings->Execute($compiler,$context,$this,"convert",$message))
								return(0);
							break;
						}
						else
						{
							switch($message["type"])
							{
								case "INTEGER":
									$expression_value="!strcmp(strval(intval(".$message["expression"].")),".$message["expression"].")";
									break;
								case "BOOLEAN":
									$expression_value="(!strcmp(".$message["expression"].",'0') || !strcmp(".$message["expression"].",'1'))";
									break;
								case "FLOAT":
									$expression_value="!strcmp(strval(doubleval(".$message["expression"].")),".$message["expression"].")";
									break;
								case "DECIMAL":
									$expression_value="ereg('^[0-9]+(\\.[0-9]*)?$',".$message["expression"].")";
									break;
								default:
									$compiler->SetElementError($context->file,$context->path,"it is not supported to determine if is valid an expression of type ".$message["type"]);
									return(0);
							}
							$context->result[]=array(
								"Data"=>array(
									"Value"=>$expression_value,
									"Type"=>"BOOLEAN",
									"Side"=>"RIGHT"
								),
								"Type"=>"EXPRESSION"
							);
							break;
						}
				}
				break;
			case "data":
				$error="it was not specified a valid data expression";
				if($arguments_code->structure[$arguments->path]["Elements"])
				{
					$file=$arguments->file;
					$path=$arguments->path;
				}
				else
				{
					$file=$context->file;
					$path=$context->path;
				}
				if(!$compiler->GetOutputData($file,$path,$result,$error,0))
						return(0);
				for($data="",$part=0;$part<count($result);$part++)
				{
					switch($result[$part]["Type"])
					{
						case "INITIALIZATION":
						case "FILE":
							$context->result[]=$result[$part];
							break;
						case "DATA":
							$data.=$result[$part]["Data"];
							break;
						default:
							$compiler->SetElementError($file,$path,$error);
							return(0);
					}
				}
				$context->result[]=array(
					"Data"=>$data,
					"Type"=>"DATA"
				);
				break;
			case "void":
				$message=array();
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,"ANY","NOTLEFT","it was not specified a valid void expression",0)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message["expression"],$expression_type))
					return(0);
				if(!$this->language_bindings->Execute($compiler,$context,$this,$function,$message))
					return(0);
				break;
			case "isnull":
				$message=array();
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,"ANY","NOTLEFT","it was not specified a valid expression",0)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message["expression"],$expression_type))
					return(0);
				switch($compiler->strtok($expression_type,":"))
				{
					case "OBJECT":
					case "HASH":
					case "ARRAY":
						break;
					default:
						return($compiler->SetElementError($context->file,$context->path,$expression_type." is not a valid isnull expression type"));
				}
				if(!$this->language_bindings->Execute($compiler,$context,$this,$function,$message))
					return(0);
				break;
			case "less":
			case "lessorequal":
			case "more":
			case "moreorequal":
			case "equal":
			case "different":
			case "equalstrings":
			case "differentstrings":
			case "plus":
			case "minus":
			case "multiply":
			case "integermultiply":
			case "divide":
			case "integerdivide":
			case "integerremainder":
			case "join":
			case "and":
			case "or":
			case "xor":
				if($code->structure[$context->path]["Elements"])
				{
					$compiler->SetElementError($context->file,$context->path.",0","it was specified some garbage within the $function operator expression definition");
					return(0);
				}
				$context->result[]=array(
					"Data"=>$function,
					"Type"=>"OPERATOR"
				);
				break;
			case "not":
				$message=array();
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,"BOOLEAN","NOTLEFT","it was not specified a valid not BOOLEAN expression",0)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message["expression"],$expression_type))
					return(0);
				if(!$this->language_bindings->Execute($compiler,$context,$this,$function,$message))
					return(0);
				break;
			case "length":
				$message=array();
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,"STRING","NOTLEFT","it was not specified a valid length STRING expression",0)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message["string"],$expression_type))
					return(0);
				if(!$this->language_bindings->Execute($compiler,$context,$this,"length",$message))
					return(0);
				break;
			case "code":
				$message=array();
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,"STRING","NOTLEFT","it was not specified a valid code STRING expression",0)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message["character"],$expression_type))
					return(0);
				if(!$this->language_bindings->Execute($compiler,$context,$this,"code",$message))
					return(0);
				break;
			case "setentry":
			case "entry":
			case "entryindex":
			case "entrydefined":
			case "undefineentry":
				$message=array(
					"hash"=>0
				);
				if($function=="entry"
				|| $function=="entryindex")
				{
					$types=array();
					$optional_types=$values=array(
						"type"=>"DATA"
					);
					if(!$compiler->GetOptionalArgumentValues($arguments,$message,$types,$optional_types,"expressions",$function,1))
						return(0);
					if(IsSet($message["type"]))
					{
						switch($message["type"])
						{
							case "INTEGER":
							case "BOOLEAN":
							case "FLOAT":
							case "DECIMAL":
							case "STRING":
							case "OBJECT":
							case "ARRAY":
							case "HASH":
								break;
							default:
								$compiler->SetElementError($context->file,$context->path,$message["type"]." is not a supported expressions $function type value");
								return(0);
						}
					}
					else
					{
						$compiler->SetElementError($context->file,$context->path,"it was not specified the $function type");
						return(0);
					}
				}
				if(!$compiler->GetOutputData($context->file,$context->path,$result,"it was not specified a valid entry command",0))
					return(0);
				for($error="",$argument="ARRAY",$position=0;$position<count($result);$position++)
				{
					switch($result[$position]["Type"])
					{
						case "INITIALIZATION":
						case "FILE":
							$context->result[]=$result[$position];
							break;
						case "EXPRESSION":
							switch($argument)
							{
								case "ARRAY":
									switch($result[$position]["Data"]["Type"])
									{
										case "ARRAY":
											$message["hash"]=0;
											break;
										case "HASH":
											$message["hash"]=1;
											break;
										default:
											$error="it was not specified a valid ARRAY expression (type \"".$result[$position]["Data"]["Type"]."\")";
											break 4;
									}
									switch($function)
									{
										case "entry":
										case "entrydefined":
											if($result[$position]["Data"]["Side"]=="LEFT")
											{
												$error="it was not defined a valid RIGHT hand ARRAY expression";
												break 4;
											}
											break;
										case "setentry":
										case "undefineentry":
										case "entryindex":
											if($result[$position]["Data"]["Side"]=="RIGHT")
											{
												$error="it was not defined a valid LEFT hand ARRAY expression";
												break 4;
											}
											break;
									}
									$message["array"]=$result[$position]["Data"]["Value"];
									$message["side"]=$result[$position]["Data"]["Side"];
									$argument="INDEX";
									break;
								case "INDEX":
									if($message["hash"])
									{
										if($result[$position]["Data"]["Type"]!="STRING")
										{
											$error="it was not specified a valid STRING index for the entry associative array";
											break 3;
										}
									}
									else
									{
										if($result[$position]["Data"]["Type"]!="INTEGER")
										{
											$error="it was not specified a valid INTEGER index for the entry array";
											break 3;
										}
									}
									if($result[$position]["Data"]["Side"]=="LEFT")
									{
										$error="it was not defined a valid RIGHT hand array entry index expression";
										break 3;
									}
									else
									{
										$message["index"]=$result[$position]["Data"]["Value"];
										$argument=($function=="setentry" ? "VALUE" : (($function=="entry" && $message["type"]=="OBJECT") ? "CLASS" : ""));
									}
									break;
								case "VALUE":
									if($result[$position]["Data"]["Side"]=="LEFT")
									{
										$error="it was not defined a valid array entry value expression";
										break 3;
									}
									else
									{
										$message["value"]=$result[$position]["Data"]["Value"];
										$message["type"]=$result[$position]["Data"]["Type"];
										$argument="";
									}
									break;
								default:
									$error="it was specified some garbage after the ARRAY ".($function=="setentry" ? "value" : "index")." entry expression";
									break 3;
							}
							break;
						default:
							if($argument=="CLASS"
							&& strlen($class=trim($result[$position]["Data"])))
							{
								$message["class"]=$class;
								$argument="";
								break;
							}
							if(!$compiler->CheckParsedWhiteSpace($context->file,$code,$result[$position]["Data"],$context->path))
								return(0);
							break;
					}
				}
				if(!strcmp($error,"")
				&& strcmp($argument,""))
					$error="it was not defined a complete $function expression (missing $argument)";
				if(strcmp($error,""))
				{
					$compiler->SetElementError($context->file,$context->path,$error);
					return(0);
				}
				if(!$this->language_bindings->Execute($compiler,$context,$this,$function,$message))
					return(0);
				break;
			case "entryisoftype":
				$types=array(
					"array"=>"HASH",
					"entry"=>"STRING",
					"type"=>"DATA"
				);
				$optional_types=array(
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"expressions",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$types,$optional_types,"expressions",$function,1))
					return(0);
				switch($values["type"])
				{
					case "STRING":
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,$values["type"]." is not a supported expressions $function type value");
						return(0);
				}
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"GetType(".$values["array"]."[".$values["entry"]."])=='string'",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "count":
				$message=array();
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if((!$compiler->GetValidExpression($evaluate_context,"HASH","NOTLEFT","it was not specified a valid count HASH expression",0)
				&& !$compiler->GetValidExpression($evaluate_context,"ARRAY","NOTLEFT","it was not specified a valid count ARRAY expression",0))
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message["array"],$message["type"]))
					return(0);
				if(!$this->language_bindings->Execute($compiler,$context,$this,$function,$message))
					return(0);
				break;
			case "reset":
			case "next":
				$types=array(
					"hash"=>"HASH",
					"cursor"=>"DATA",
					"key"=>"STRING:NOTRIGHT"
				);
				$optional_types=array(
					"end"=>"BOOLEAN:NOTRIGHT"
				);
				$message=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$message,$types,$optional_types,"expressions",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$message,$types,$optional_types,"expressions",$function,1))
					return(0);
				if(!$this->language_bindings->Execute($compiler,$context,$this,$function,$message))
					return(0);
				break;
			case "explode":
				$types=array(
					"string"=>"STRING",
					"separator"=>"STRING"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"expressions",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"explode(".$values["separator"].",".$values["string"].")",
						"Type"=>"ARRAY",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "implode":
				$types=array(
					"array"=>"ARRAY",
					"separator"=>"STRING"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"expressions",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"implode(".$values["separator"].",".$values["array"].")",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "increment":
			case "decrement":
			case "incrementbuffer":
			case "decrementbuffer":
				$message=array();
				$type=(($function=="increment" || $function=="decrement") ? "INTEGER" : "INTEGERBUFFER");
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,$type,"BOTH","it was not specified a valid $function $type expression",0)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message["expression"],$expression_type))
					return(0);
				if(!$this->language_bindings->Execute($compiler,$context,$this,$function,$message))
					return(0);
				break;
			case "concatenate":
				$types=array(
					"append"=>"STRING"
				);
				$optional_types=array(
					"string"=>"STRING:BOTH",
					"buffer"=>"STRINGBUFFER:BOTH"
				);
				$message=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$message,$types,$optional_types,"expressions",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$message,$types,$optional_types,"expressions",$function,1))
					return(0);
				if(!IsSet($message["string"])
				&& !IsSet($message["buffer"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified the string nor the buffer expressions concatenate value");
					return(0);
				}
				if(!$this->language_bindings->Execute($compiler,$context,$this,"concatenate",$message))
					return(0);
				break;
			case "format":
				$format=array();
				$values=array();
				if(!$this->GetFormatArguments($compiler,$arguments_code,$arguments,$format,$values)
				|| !$this->GetFormatArguments($compiler,$code,$context,$format,$values))
					return(0);
				if(count($format)==0)
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified a format STRING");
					return(0);
				}
				if(count($values)==0)
				{
					$compiler->SetElementError($context->file,$context->path,"it were not specified any format VALUES");
					return(0);
				}
				if(!$compiler->GetExpressionValue($context,$format,$format_expression_value,$expression_type))
					return(0);
				for($value=0;$value<count($values);$value++)
				{
					if(!$compiler->GetExpressionValue($context,$values[$value],$expression_value,$expression_type))
						return(0);
					$format_expression_value.=",".$expression_value;
				}
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"sprintf($format_expression_value)",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "replace":
				$replace=array();
				$elements=$code->structure[$context->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "string":
							case "text":
							case "by":
								if(IsSet($replace[$data["Tag"]]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified the replace ".$data["Tag"]." argument more than once");
									return(0);
								}
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid replace ".$data["Tag"]." expression")
								|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$replace[$data["Tag"]],$expression_type))
									return(0);
								break;
							default:
								$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported expressions object replace parameter");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				if(!IsSet($replace[$argument="string"])
				|| !IsSet($replace[$argument="text"])
				|| !IsSet($replace[$argument="by"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified the replace $argument argument");
					return(0);
				}
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"str_replace(".$replace["text"].",".$replace["by"].",".$replace["string"].")",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "substring":
				$elements=$code->structure[$context->path]["Elements"];
				for($message=array(),$element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch(count($message))
						{
							case 0:
								$type="STRING";
								$argument="string";
								break;
							case 1:
								$type="INTEGER";
								$argument="position";
								break;
							case 2:
								$type="INTEGER";
								$argument="length";
								break;
							default:
								$compiler->SetElementError($context->file,$element_path,"it were specified to many substring arguments");
								return(0);
						}
						$compiler->CopyEmptyContext($context,$evaluate_context);
						$evaluate_context->path=$element_path;
						if(!$compiler->GetValidTypedExpression($evaluate_context,$type,"it was not specified a valid substring $argument argument",1)
						|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message[$argument],$expression_type))
							return(0);
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				if(count($message)<2)
				{
					$compiler->SetElementError($context->file,$context->path,"it were not specified enough substring arguments");
					return(0);
				}
				if(!$this->language_bindings->Execute($compiler,$context,$this,"substring",$message))
					return(0);
				break;
			case "comparestrings":
				$elements=$code->structure[$context->path]["Elements"];
				for($values=array(),$element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch(count($values))
						{
							case 0:
							case 1:
								$type="STRING";
								$argument="string";
								break;
							default:
								$compiler->SetElementError($context->file,$element_path,"it were specified to many comparestrings arguments");
								return(0);
						}
						$compiler->CopyEmptyContext($context,$evaluate_context);
						$evaluate_context->path=$element_path;
						$evaluate_context->result=array();
						if(!$compiler->GetValidTypedExpression($evaluate_context,$type,"it was not specified a valid comparestrings $argument argument",1))
							return(0);
						$values[]=$evaluate_context->result;
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				if(count($values)<2)
				{
					$compiler->SetElementError($context->file,$context->path,"it were not specified enough comparestrings arguments");
					return(0);
				}
				for($comparestrings_expression_value="",$value=0;$value<count($values);$value++)
				{
					if(!$compiler->GetExpressionValue($context,$values[$value],$expression_value,$expression_type))
						return(0);
					if($value>0)
						$comparestrings_expression_value.=",";
					$comparestrings_expression_value.=$expression_value;
				}
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"strcmp($comparestrings_expression_value)",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "lowercase":
				$message=array();
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,"STRING","NOTLEFT","it was not specified a valid lowercase STRING expression",0)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message["string"],$expression_type))
					return(0);
				if(!$this->language_bindings->Execute($compiler,$context,$this,"lowercase",$message))
					return(0);
				break;
			case "uppercase":
				$message=array();
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,"STRING","NOTLEFT","it was not specified a valid uppercase STRING expression",0)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message["string"],$expression_type))
					return(0);
				if(!$this->language_bindings->Execute($compiler,$context,$this,"uppercase",$message))
					return(0);
				break;
			case "stringposition":
				$position=array();
				$elements=$code->structure[$context->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						$type="STRING";
						switch($data["Tag"])
						{
							case "position":
								$type="INTEGER";
							case "string":
							case "find":
								if(IsSet($position[$data["Tag"]]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified the stringposition ".$data["Tag"]." argument more than once");
									return(0);
								}
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidTypedExpression($evaluate_context,$type,"it was not specified a valid stringposition ".$data["Tag"]." expression")
								|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$position[$data["Tag"]],$expression_type))
									return(0);
								break;
							default:
								$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported expressions object stringposition parameter");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				if(!IsSet($position[$argument="string"])
				|| !IsSet($position[$argument="find"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified the stringposition $argument argument");
					return(0);
				}
				if(!IsSet($position["position"]))
					$position["position"]="0";
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>"stringposition"
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"StringPosition".$this->object_name."(".$position["string"].",".$position["find"].",".$position["position"].")",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "findstring":
				$types=array(
					"string"=>"STRING",
					"find"=>"STRING"
				);
				$optional_types=array(
					"start"=>"INTEGER",
					"position"=>"INTEGER:NOTRIGHT"
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"expressions",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$types,$optional_types,"expressions",$function,1))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"GetType(".(IsSet($values["position"]) ? $values["position"]."=" : "")."strpos(".$values["string"].",".$values["find"].(IsSet($values["start"]) ? ",".$values["start"] : "")."))=='integer'",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "matchregularexpression":
				$types=array(
					"string"=>"STRING",
					"regularexpression"=>"STRING"
				);
				$optional_types=array(
					"casesensitive"=>"DATA"
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"expressions",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$types,$optional_types,"expressions",$function,1))
					return(0);
				if(IsSet($values["casesensitive"]))
				{
					switch($values["casesensitive"])
					{
						case "0":
						case "1":
							$case_sensitive=intval($values["casesensitive"]);
							break;
						default:
							$compiler->SetElementError($context->file,$context->path,"it was not specified a valid BOOLEAN casesennsitive $function argument");
							return(0);
					}
				}
				else
					$case_sensitive=0;
				$context->result[]=array(
					"Data"=>array(
						"Value"=>($case_sensitive ? "ereg" : "eregi")."(".$values["regularexpression"].",".$values["string"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "conditional":
				$message=array();
				$elements=$code->structure[$context->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "istrue":
							case "isfalse":
								if(IsSet($message["condition"]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified more than one condition expression for the conditional function");
									return(0);
								}
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidExpression($evaluate_context,"BOOLEAN","NOTLEFT","it was not specified a valid conditional BOOLEAN expression",1)
								|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message["condition"],$expression_type))
									return(0);
								$message["not"]=(strcmp($data["Tag"],"istrue"));
								break;
							case "then":
								if(!IsSet($message["condition"]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified a then value before setting the condition expression for the conditional function");
									return(0);
								}
								if(IsSet($message["then"]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified more than one then value for the conditional function");
									return(0);
								}
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidExpression($evaluate_context,"ANY","NOTLEFT","it was not specified a valid conditional THEN expression",1)
								|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message["then"],$message["type"]))
									return(0);
								break;
							case "else":
								if(!IsSet($message["then"]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified a else value before setting the then and the condition expression for the conditional function");
									return(0);
								}
								if(IsSet($message["else"]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified more than one else value for the conditional function");
									return(0);
								}
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidExpression($evaluate_context,$message["type"],"NOTLEFT","it was not specified a valid conditional else EXPRESSION",1)
								|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message["else"],$expression_type))
									return(0);
								if($compiler->strtok($message["type"],":")!=$compiler->strtok($expression_type,":"))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified a conditional else expression type (".$expression_type.") that is different of the then expression type (".$message["type"].")");
									return(0);
								}
								break;
							default:
								$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a value EXPRESSIONS object conditional argument");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				if(!IsSet($message[$argument="condition"])
				|| !IsSet($message[$argument="then"])
				|| !IsSet($message[$argument="else"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified the $argument argument for the conditional function");
					return(0);
				}
				if(!$this->language_bindings->Execute($compiler,$context,$this,$function,$message))
					return(0);
				break;
			case "conditionalvalue":
				$values=array();
				$elements=$code->structure[$context->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "istrue":
							case "isfalse":
								if(IsSet($values["condition"]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified more than one condition expression for the conditionalvalue function");
									return(0);
								}
								if(!$compiler->GetValidData($context->file,$element_path,$values["condition"],"it was not specified a valid condition boolean value"))
									return(0);
								switch($values["condition"])
								{
									case "0":
									case "1":
										break;
									default:
										$compiler->SetElementError($context->file,$element_path,"it was specified an invalid condition boolean value (\"".$values["condition"]."\")");
										return(0);
								}
								if(!strcmp($data["Tag"],"isfalse"))
									$values["condition"]=(strcmp($values["condition"],"1") ? "1" : "0");
								break;
							case "then":
								if(!IsSet($values["condition"]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified a then value before specifying the condition for the conditionalvalue function");
									return(0);
								}
								if(IsSet($values["then"]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified more than one then value for the conditionalvalue function");
									return(0);
								}
								$values["then"]=$element_path;
								break;
							case "else":
								if(!IsSet($values["then"]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified a else value before setting the then and the then expression for the conditionalvalue function");
									return(0);
								}
								if(IsSet($values["else"]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified more than one else value for the conditionalvalue function");
									return(0);
								}
								$values["else"]=$element_path;
								break;
							default:
								$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a value EXPRESSIONS object conditionalvalue argument");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				if(!IsSet($values[$argument="condition"])
				|| !IsSet($values[$argument="then"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified the $argument argument for the conditionalvalue function");
					return(0);
				}
				if(!strcmp($values["condition"],"1"))
				{
					if(!$compiler->GetOutputData($context->file,$values["then"],$context->result,"it was not defined valid conditionalvalue",0))
						return(0);
				}
				else
				{
					if(IsSet($values["else"])
					&& !$compiler->GetOutputData($context->file,$values["else"],$context->result,"it was not defined valid conditionalvalue",0))
						return(0);
				}
				break;
			case "group":
				$message=array();
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,"ANY","NOTLEFT","it was not specified a valid group expression",1)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message["expression"],$message["type"])
				|| !$this->language_bindings->Execute($compiler,$context,$this,"group",$message))
					return(0);
				break;
			case "stringdata":
				if(!$compiler->GetOutputData($context->file,$context->path,$data,"it was not defined valid stringdata",0))
					return(0);
				for($string_data="",$part=0;$part<count($data);$part++)
				{
					switch($data[$part]["Type"])
					{
						case "DATA":
						  if(!$compiler->ConvertData($context,"STRING",$data[$part]["Data"],$string))
						  	return(0);
						  break;
						case "EXPRESSION":
							if($data[$part]["Data"]["Type"]!="STRING")
							{
								$compiler->SetElementError($context->file,$context->path,"it was specified a non STRING expression for stringdata");
								return(0);
							}
							if($data[$part]["Data"]["Side"]=="LEFT")
							{
								$compiler->SetElementError($context->file,$context->path,"it was specified an invalid STRING expression for stringdata");
								return(0);
							}
							$string=$data[$part]["Data"]["Value"];
					  	break;
					  case "INITIALIZATION":
					  case "FILE":
					  	$context->result[]=$data[$part];
					  	continue 2;
					  default:
					  	$compiler->SetElementError($context->file,$context->path,$data[$part]["Type"]." is not a valid stringdata part");
							return(0);
					}
					if(strcmp($string_data,""))
						$string_data.=".";
					$string_data.=$string;
				}
				if(strlen($string_data)==0
				&& !$compiler->ConvertData($context,"STRING","",$string_data))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$string_data,
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "randomize":
				$context->result[]=array(
					"Data"=>"srand(time());",
					"Type"=>"COMMAND"
				);
				break;
			case "random":
				$random=array();
				$elements=$code->structure[$context->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						$type="STRING";
						switch($data["Tag"])
						{
							case "minimum":
							case "maximum":
								if(IsSet($random[$data["Tag"]]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified the random ".$data["Tag"]." argument more than once");
									return(0);
								}
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidTypedExpression($evaluate_context,"INTEGER","it was not specified a valid random ".$data["Tag"]." INTEGER expression")
								|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$random[$data["Tag"]],$expression_type))
									return(0);
								break;
							default:
								$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported expressions object random parameter");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				if(!IsSet($random["maximum"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified the random maximum argument");
					return(0);
				}
				if(!IsSet($random["minimum"]))
					$random["minimum"]="0";
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"rand(".$random["minimum"].",".$random["maximum"].")",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "soundex":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,"STRING","NOTLEFT","it was not specified a valid soundex STRING expression",0)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$expression_value,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"soundex($expression_value)",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "utf8encode":
			case "utf8decode":
				$message=array();
				$types=array(
					"data"=>"STRING",
					($function=="utf8encode" ? "encoded" : "decoded")=>"STRING:NOTRIGHT",
				);
				$optional_types=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$message,$types,$optional_types,"expressions",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$message,$types,$optional_types,"expressions",$function,1))
					return(0);
				if(!$this->language_bindings->Execute($compiler,$context,$this,$function,$message))
					return(0);
				break;
			case "getbindingsproperty":
				if($arguments_code->structure[$arguments->path]["Elements"])
				{
					$file=$arguments->file;
					$path=$arguments->path;
				}
				else
				{
					$file=$context->file;
					$path=$context->path;
				}
				$error="it was not specified a valid bindings property name";
				if(!$compiler->GetValidName($file,$path,$property,"it was not specified a valid bindings property name")
				|| !$compiler->GetBindingsProperty($context,$property,$value))
					return(0);
				$context->result[]=array(
					"Data"=>strval($value),
					"Type"=>"DATA"
				);
				break;
			case "buffervalue":
				$message=array();
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,"ANY","NOTLEFT","it was not specified a valid buffervalue expression",1)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$message["buffer"],$type))
					return(0);
				switch($type)
				{
					case "INTEGERBUFFER":
						$message["type"]="INTEGER";
						break;
					case "STRINGBUFFER":
						$message["type"]="STRING";
						break;
					case "BOOLEANBUFFER":
						$message["type"]="BOOLEAN";
						break;
					case "FLOATBUFFER":
						$message["type"]="FLOAT";
						break;
					case "OBJECTBUFFER":
						$message["type"]="OBJECT";
						break;
					case "ARRAYBUFFER":
						$message["type"]="ARRAY";
						break;
					case "HASHBUFFER":
						$message["type"]="HASH";
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,"$type is not a supported buffer expression type");
						return(0);
				}
				if(!$this->language_bindings->Execute($compiler,$context,$this,$function,$message))
					return(0);
				break;
			case "compilerargument":
				$values=array();
				$types=array(
				);
				$optional_types=array(
					"optional"=>"BOOLEANDATA"
				);
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"xml",$function,1))
					return(0);
				if(IsSet($values["optional"])
				&& $values["optional"])
				{
					$values=array(
					);
					$types=array(
						"name"=>"NAME",
						"default"=>"CONTEXT"
					);
					$optional_types=array(
					);
					if(!$compiler->GetOptionalArgumentValues($context,$values,$types,$optional_types,"xml",$function,1))
						return(0);
					$argument=$values["name"];
					if(IsSet($compiler->arguments[$argument]))
						$value=$compiler->arguments[$argument];
					else
						if(!$compiler->GetValidData($values["default"]->file,$values["default"]->path,$value,"it was not specified a valid $function optional default value"))
							return(0);
				}
				else
				{
					if(!$compiler->GetValidData($context->file,$context->path,$argument,"it was not specified a valid build compiler argument argument"))
						return(0);
					if(!IsSet($compiler->arguments[$argument]))
					{
						$compiler->SetElementError($context->file,$context->path,$argument." is not a defined build object compiler argument");
						return(0);
					}
					$value=$compiler->arguments[$argument];
				}
				$context->result[]=array(
					"Data"=>$value,
					"Type"=>"DATA"
				);
				return(1);
			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported expressions object function");
				return(0);
		}
		return(1);
	}

	Function Initialization(&$compiler,&$context,$object_context)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the expressions class");
			return(0);
		}
		switch($object_context)
		{
			case "stringposition":
				$context->result[]=array(
					"Data"=>"Function StringPosition".$this->object_name."(\$string,\$find,\$position)",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>"{",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>1,
					"Type"=>"INDENT"
				);
				$context->result[]=array(
					"Data"=>"return(GetType(\$position=strpos(\$string,\$find,\$position))=='integer' ? \$position : -1);",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>1,
					"Type"=>"OUTDENT"
				);
				$context->result[]=array(
					"Data"=>"}",
					"Type"=>"COMMAND"
				);
				break;
		}
		return(1);
	}
};

}
?>