<?
if(!defined("METAL_LINK_INCLUDED"))
{
	define("METAL_LINK_INCLUDED",1);

/*
 * metal_link.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_link.php,v 1.8 2004/05/11 02:19:34 mlemos Exp $
 *
 */
 
class metal_link_class extends metal_base_class
{
	var $class_file="links.php";
	var $class_base_path="";
	var $tags=array(
		"url"=>"HREF",
		"data"=>"data",
		"values"=>"values",
		"accesskey"=>"ACCESSKEY"
	);

	Function Setup(&$compiler,&$code,&$attributes)
	{
		$elements=$code->structure[$attributes->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$attributes->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "classfile":
						if(!$compiler->GetValidData($attributes->file,$element_path,&$class_file,"it was not specified a valid link class file"))
							return(0);
						if(!file_exists($class_file))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was not specified an existing link class file (\"$class_file\")");
							return(0);
						}
						$this->class_file=$class_file;
						break;
					case "classbasepath":
						if(!$compiler->GetValidData($attributes->file,$element_path,&$this->class_base_path,"it was not specified a valid link class base path"))
							return(0);
						break;
					default:
						$compiler->SetElementError($attributes->file,$element_path,$data["Tag"]." is not a supported link object attribute");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($attributes->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the link class");
			return(0);
		}
		switch($function)
		{
			case "new":
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"new link_class",
						"Type"=>"OBJECT",
						"Class"=>"link_class",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "output":
			case "url":
			case "data":
			case "accesskey":
			case "values":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidTypedExpression(&$evaluate_context,"OBJECT","it was not specified a valid link output object expression")
				|| !$compiler->GetExpressionValue(&$context,&$evaluate_context->result,&$link,&$expression_type))
					return(0);
				$type="STRING";
				switch($function)
				{
					case "output":
						$context->result[]=array(
							"Data"=>array(
								"Value"=>"LinkString(".$link.")",
								"Type"=>"STRING",
								"Side"=>"RIGHT"
							),
							"Type"=>"EXPRESSION"
						);
						break;
					case "values":
						$type="HASH";
					case "url":
					case "data":
					case "accesskey":
						$context->result[]=array(
							"Data"=>array(
								"Value"=>$link."->".$this->tags[$function],
								"Type"=>$type,
								"Side"=>"BOTH"
							),
							"Type"=>"EXPRESSION"
						);
						break;
				}
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported link object function");
				return(0);
		}
		return(1);
	}

	Function Initialization(&$compiler,&$context,$object_context)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the form class");
			return(0);
		}
		$relative_path=$compiler->RelativePath($this->class_base_path,$this->class_file);
		$context->result[]=array(
			"Data"=>array(
				"Name"=>$this->class_file,
				"Type"=>"SUPPLIED"
			),
			"Type"=>"FILE"
		);
		$context->result[]=array(
			"Data"=>"require(\"$relative_path\");",
			"Type"=>"COMMAND"
		);
		return(1);
	}

};
 
}
?>