<?php
if(!defined("METAL_LOCALE_INCLUDED"))
{
	define("METAL_LOCALE_INCLUDED",1);

/*
 * metal_locale.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_locale.php,v 1.47 2004/05/11 04:52:04 mlemos Exp $
 *
 */
 
class metal_locale_class extends metal_base_class
{
	var $context="";
	var $locale_data=array();
	var $used_data=array("string"=>array(),"shortcutstring"=>array(),"shortcut"=>array(),"strippedstring"=>array(),"markpositions"=>array(),"marknames"=>array());
	var $output_directory="";
	var $base_path="";
	var $relative_path="";
	var $locale_set=array();
	var $locale_set_dynamically=0;
	var $shortcut_start_mark="%s";
	var $shortcut_end_mark="%s";
	var $mark_prefix="+";
	var $mark_suffix="-";
	var $marks=array();
	var $dependency_files=array();

	Function HandleLocale(&$compiler,&$locale_parser,$locale_file,$locale)
	{
		$locale_path="0";
	  if(strcmp($locale_parser->structure[$locale_path]["Tag"],"locale"))
	  {
			$compiler->SetParsedElementError($locale_file,$locale_parser,$locale_path,"it was not specified a valid locale file");
			return(0);
	  }
		$locale_elements=$locale_parser->structure[$locale_path]["Elements"];
		for($locale_element=0;$locale_element<$locale_elements;$locale_element++)
		{
			$locale_element_path=$locale_path.",$locale_element";
			$data=$locale_parser->structure[$locale_element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "string":
						$compiler->CreateFileContext($string_context,$locale_file);
						$string_context->path=$locale_element_path;
						$values=array();
						$required_types=array(
							"name"=>"DATA",
							"value"=>"CONTEXT"
						);
						$optional_types=array();
						if(!$compiler->GetOptionalArgumentValues($string_context,$values,$required_types,$optional_types,"locale","HandleLocale",1))
							return(0);
					  if(!strcmp($name=$values["name"],""))
					  {
							$compiler->SetParsedElementError($locale_file,$locale_parser,$locale_element_path,"it was not specified a valid locale string name");
							return(0);
					  }
					  if(IsSet($this->locale_data[$locale][$name]))
					  {
							$compiler->SetParsedElementError($locale_file,$locale_parser,$locale_element_path,"it was defined the same locale string name more than once");
							return(0);
					  }
					  Unset($shortcut_start);
					  $value_element_path=$values["value"]->path;
						$string_elements=$locale_parser->structure[$value_element_path]["Elements"];
						for($stripped_string=$string="",$mark_positions=array(),$mark_names=array(),$short_cut_set=0,$string_element=0;$string_element<$string_elements;$string_element++)
						{
							$string_element_path=$value_element_path.",$string_element";
							$data=$locale_parser->structure[$string_element_path];
							if(GetType($data)=="array")
							{
								switch($data["Tag"])
								{
									case "shortcut":
										if(IsSet($shortcut_start))
										{
											$compiler->SetParsedElementError($locale_file,$locale_parser,$string_element_path,"it was defined a shortcut more than once for a locale string");
											return(0);
										}
										if(!$compiler->GetValidParsedData($locale_file,$locale_parser,$string_element_path,$shortcut,"it was not specified valid locale string shortcut data"))
											return(0);
										$shortcut_start=strlen($string);
										$shortcut_length=strlen($shortcut);
										$string.=$shortcut;
										$stripped_string.=$shortcut;
										break;
									case "mark":
										if(!$compiler->GetValidParsedData($locale_file,$locale_parser,$string_element_path,$mark,"it was not specified valid locale string mark data"))
											return(0);
										$mark_data=$this->mark_prefix.$mark.$this->mark_suffix;
										$this->marks[$name][$mark]=$mark_data;
										$string.=$mark_data;
										$mark_positions[]=strlen($stripped_string);
										$mark_names[]=$mark;
										break;
									default:
										$compiler->SetParsedElementError($locale_file,$locale_parser,$string_element_path,$data["Tag"]." is not a supported locale string tag.");
										return(0);
								}
							}
							else
							{
								$string.=$data;
								$stripped_string.=$data;
							}
						}
						$definition=array(
						 "string"=>$string
						);
						if(strcmp($string,$stripped_string))
							$definition["strippedstring"]=$stripped_string;
						if(count($mark_positions)>0)
						{
							$definition["markpositions"]=$mark_positions;
							$definition["marknames"]=$mark_names;
						}
						if(IsSet($shortcut_start))
						{
							$definition["shortcut_start"]=$shortcut_start;
							$definition["shortcut_length"]=$shortcut_length;
						}
						$this->locale_data[$locale][$name]=$definition;
						break;
					default:
						$compiler->SetParsedElementError($locale_file,$locale_parser,$locale_element_path,$data["Tag"]." is not a supported locale definition type");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckParsedWhiteSpace($locale_file,$locale_parser,$data,$locale_element_path))
					return(0);
			}
		}
		return(1);
	}

	Function HandleCatalog(&$compiler,&$attributes,&$catalog_parser,$catalog_file)
	{
		$path="0";
	  if(strcmp($catalog_parser->structure[$path]["Tag"],"catalog"))
	  {
			$compiler->SetParsedElementError($catalog_file,$catalog_parser,$path,"it was not specified a valid locale catalog file");
			return(0);
	  }
		$elements=$catalog_parser->structure[$path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$path.",$element";
			$data=$catalog_parser->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "context":
						$context=array();
					  $context_elements=$catalog_parser->structure[$element_path]["Elements"];
						for($context_element=0;$context_element<$context_elements;$context_element++)
						{
							$context_element_path=$element_path.",$context_element";
							$data=$catalog_parser->structure[$context_element_path];
							if(GetType($data)=="array")
							{
								switch($data["Tag"])
								{
									case "name":
									case "locale":
										if(IsSet($context[$data["Tag"]]))
										{
											$compiler->SetParsedElementError($catalog_file,$catalog_parser,$context_element_path,"it was specified the locale context ".$data["Tag"]." more than once");
											return(0);
										}
										if(!$compiler->GetValidParsedName($catalog_file,$catalog_parser,$context_element_path,$context[$data["Tag"]],"it was not specified a valid locale context ".$data["Tag"]))
											return(0);
										break;
									case "file":
										if(!$compiler->GetValidParsedData($catalog_file,$catalog_parser,$context_element_path,$locale_file,"it was not specified a valid locale context file"))
											return(0);
										if(IsSet($context["Files"][$locale_file]))
										{
											$compiler->SetParsedElementError($catalog_file,$catalog_parser,$context_element_path,"it was specified locale file more than once");
											return(0);
										}
										$include_path=$compiler->GetIncludePath($locale_file);
										if(!file_exists($include_path.$locale_file))
										{
											$compiler->SetParsedElementError($catalog_file,$catalog_parser,$context_element_path,"it was not specified an existing locale file (\"$locale_file\")");
											return(0);
										}
										$compiler->CopyEmptyContext($attributes,$context["Files"][$locale_file]);
										$context["Files"][$locale_file]->path=$context_element_path;
										break;
									default:
										$compiler->SetParsedElementError($catalog_file,$catalog_parser,$context_element_path,$data["Tag"]." is not a supported catalog context attribute");
										return(0);
								}
							}
							else
							{
								if(!$compiler->CheckParsedWhiteSpace($catalog_file,$catalog_parser,$data,$context_element_path))
									return(0);
							}
						}
						if(!IsSet($context["name"]))
						{
							$compiler->SetParsedElementError($catalog_file,$catalog_parser,$element_path,"it was not specified the catalog context name");
							return(0);
						}
						if(!IsSet($context["locale"]))
						{
							$compiler->SetParsedElementError($catalog_file,$catalog_parser,$element_path,"it was not specified the catalog context locale");
							return(0);
						}
						if(!IsSet($context["Files"]))
						{
							$compiler->SetParsedElementError($catalog_file,$catalog_parser,$element_path,"it were not specified any catalog context files");
							return(0);
						}
						if(!strcmp($context["name"],$this->context))
						{
							for($file=0,Reset($context["Files"]);$file<count($context["Files"]);Next($context["Files"]),$file++)
							{
								$locale_file=Key($context["Files"]);
								if(!$compiler->ParseDefinitionFile($locale_file))
									return(0);
								$compiler->GetParser($locale_parser,$locale_file);
								if(!$this->HandleLocale($compiler,$locale_parser,$locale_file,$context["locale"]))
									return(0);
								$include_path=$compiler->GetIncludePath($locale_file);
								$compiler->CopyEmptyContext($context["Files"][$locale_file],$this->dependency_files[$include_path.$locale_file]);
							}
						}
						break;
					default:
						$compiler->SetParsedElementError($catalog_file,$catalog_parser,$element_path,$data["Tag"]." is not a supported catalog section");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckParsedWhiteSpace($catalog_file,$catalog_parser,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function Setup(&$compiler,&$code,&$attributes)
	{
		$elements=$code->structure[$attributes->path]["Elements"];
		for($catalog_file="",$element=0;$element<$elements;$element++)
		{
			$element_path=$attributes->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "context":
						if(!$compiler->GetValidName($attributes->file,$element_path,$this->context,"it was not specified a valid locale context"))
							return(0);
						break;
					case "catalog":
						if(!$compiler->GetValidData($attributes->file,$element_path,$catalog_file,"it was not specified a valid locale catalog file name"))
							return(0);
						$include_path=$compiler->GetIncludePath($catalog_file);
						if(strcmp($catalog_file,"")
						&& !file_exists($include_path.$catalog_file))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was not specified an existing locale catalog file");
							return(0);
						}
						$compiler->CopyEmptyContext($attributes,$this->dependency_files[$include_path.$catalog_file]);
						$this->dependency_files[$include_path.$catalog_file]->path=$element_path;
						break;
					case "output":
						if(!$compiler->GetValidData($attributes->file,$element_path,$this->output_directory,"it was not specified a valid locale output directory"))
							return(0);
						if(!$compiler->CreateContextOutputDirectory($this->output_directory,$attributes,"it was not possible to create the locale output directory \"".$this->output_directory."\""))
							return(0);
						break;
					case "basepath":
						if(!$compiler->GetValidData($attributes->file,$element_path,$base_path,"it was not specified a valid output base path"))
							return(0);
						$this->base_path=$base_path;
						break;
					case "set":
						$evaluate_context=$attributes;
						$evaluate_context->path=$element_path;
						if(!$compiler->GetValidExpression($evaluate_context,"STRING","NOTLEFT","it was not specified a valid locale set expression",0))
							return(0);
						$this->locale_set=$evaluate_context->result;
						break;
					default:
						$compiler->SetElementError($attributes->file,$element_path,$data["Tag"]." is not a supported locale object attribute");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($attributes->file,$data,$element_path))
					return(0);
			}
		}
		if(!strcmp($catalog_file,""))
		{
			$compiler->SetElementError($attributes->file,$attributes->path,"it was not specified a valid locale catalog file");
			return(0);
		}
		if(!strcmp($this->output_directory,""))
		{
			$compiler->SetElementError($attributes->file,$attributes->path,"it was not specified a valid locale output directory");
			return(0);
		}
		$this->relative_path=$compiler->RelativePath($this->base_path,$this->output_directory);
		if(!$compiler->ParseDefinitionFile($catalog_file))
			return(0);
		$compiler->GetParser($catalog_parser,$catalog_file);
		return($this->HandleCatalog($compiler,$attributes,$catalog_parser,$catalog_file));
	}

	Function GetMark(&$compiler,&$code,&$context,&$arguments)
	{
		$elements=$code->structure[$context->path]["Elements"];
		for($catalog_file="",$element=0;$element<$elements;$element++)
		{
			$element_path=$context->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "mark":
					case "string":
						if(IsSet($arguments[$data["Tag"]]))
						{
							$compiler->SetElementError($context->file,$element_path,"it was specified the locale getmark ".$data["Tag"]." argument more than once");
							return(0);
						}
						if(!$compiler->GetValidData($context->file,$element_path,$arguments[$data["Tag"]],"it was not specified a valid locale getmark ".$data["Tag"]." argument"))
							return(0);
						break;
					default:
						$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported locale getmark argument");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function AddInitialization(&$context)
	{
		$context->result[]=array(
			"Data"=>array(
				"Object"=>$this->object_name,
				"Context"=>""
			),
			"Type"=>"INITIALIZATION"
		);
		for(Reset($this->dependency_files),$dependency=0;$dependency<count($this->dependency_files);Next($this->dependency_files),$dependency++)
		{
			$context->result[]=array(
				"Data"=>array(
					"Name"=>Key($this->dependency_files),
					"Type"=>"DEPENDENCY"
				),
				"Type"=>"FILE"
			);
		}
	}

	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		switch($function)
		{
			case "string":
			case "shortcutstring":
			case "shortcut":
			case "strippedstring":
			case "markpositions":
			case "marknames":
				if(strcmp($compiler->language["name"],"PHP"))
				{
					$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the locale class");
					return(0);
				}
				$definitions=count($this->used_data["string"])+count($this->used_data["shortcutstring"])+count($this->used_data["shortcut"])+count($this->used_data["strippedstring"])+count($this->used_data["markpositions"])+count($this->used_data["marknames"]);
				if($definitions==0
				&& !$this->locale_set_dynamically
				&& count($this->locale_set)==0)
				{
					$compiler->SetElementError($context->file,$context->path,"it was not set the locale for the given context (\"".$this->context."\")");
					return(0);
				}
				$values=array(
				);
				$types=array(
				);
				$optional_types=array(
					"encoding"=>"DATA"
				);
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"xml",$function,0))
					return(0);
				if(!$compiler->GetValidData($context->file,$context->path,$string,"it was not specified a valid locale string"))
					return(0);
				if(!strcmp($string,""))
				{
					$compiler->SetElementError($context->file,$context->path,$error);
					return(0);
				}
				$value="\$GLOBALS[\"".$this->object_name."\"][\"$function\"][\"$string\"]";
				switch($function)
				{
					case "markpositions":
					case "marknames":
						$type="ARRAY";
						break;
					default:
						if(IsSet($values["encoding"]))
						{
							switch(strtolower($values["encoding"]))
							{
								case "iso-8859-1":
									$value="HtmlEntities($value)";
									break;
								default:
									return($compiler->SetElementError($context->file,$context->path,$values["encoding"]." is not yet a support encoding"));
							}
						}
						$type="STRING";
						break;
				}
				if($definitions==0)
					$this->AddInitialization($context);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$value,
						"Type"=>$type,
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				if(!IsSet($this->used_data[$function][$string]))
				{
					$this->used_data[$function][$string]=array(
						"file"=>$context->file,
						"path"=>$context->path,
						"uses"=>1
					);
				}
				else
					$this->used_data[$function][$string]["uses"]++;
				break;
			case "set":
				$types=array();
				$optional_types=array(
					"path"=>"STRING"
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"locale",$function,1))
					return(0);
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,"STRING","NOTLEFT","it was not specified a valid locale set expression",0))
					return(0);
				$this->AddInitialization($context);
				if(!$compiler->GetExpressionValue($context,$evaluate_context->result,$expression_value,$expression_type))
					return(0);
				$path=(IsSet($values["path"]) ? $values["path"].".\"" : "\"".$this->relative_path)."/".$this->context."-\".".$expression_value.".\".php\"";
				$context->result[]=array(
					"Data"=>"if(file_exists($path))",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>1,
					"Type"=>"INDENT"
				);
				$context->result[]=array(
					"Data"=>"include($path);",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>1,
					"Type"=>"OUTDENT"
				);
				$this->locale_set_dynamically=1;
				break;
			case "relativepath":
				$context->result[]=array(
					"Data"=>$this->relative_path,
					"Type"=>"DATA"
				);
				break;
			case "getmark":
				$get_mark=array();
				if(!$this->GetMark($compiler,$arguments_code,$arguments,$get_mark)
				|| !$this->GetMark($compiler,$code,$context,$get_mark))
					return(0);
				if(!IsSet($get_mark[$argument="mark"])
				|| !IsSet($get_mark[$argument="string"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified the locale getmark $argument argument");
					return(0);
				}
				if(!IsSet($this->marks[$get_mark["string"]]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not defined the specified locale string");
					return(0);
				}
				if(!IsSet($this->marks[$get_mark["string"]][$get_mark["mark"]]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not defined the specified locale string mark");
					return(0);
				}
				$context->result[]=array(
					"Data"=>$this->marks[$get_mark["string"]][$get_mark["mark"]],
					"Type"=>"DATA"
				);
				break;
			case "stringlist":
				if(strcmp($compiler->language["name"],"PHP"))
				{
					$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the locale class");
					return(0);
				}
				$error="it was not specified a valid locale string";
				if($arguments_code->structure[$arguments->path]["Elements"])
				{
					if(!$compiler->GetValidData($arguments->file,$arguments->path,$string,$error))
						return(0);
					$file=$arguments->file;
					$path=$arguments->path;
				}
				else
				{
					if(!$compiler->GetValidData($context->file,$context->path,$string,$error))
						return(0);
					$file=$context->file;
					$path=$context->path;
				}
				if(!strcmp($string,""))
				{
					$compiler->SetElementError($file,$path,$error);
					return(0);
				}
				for($list="",Reset($this->locale_data),$locale=0;$locale<count($this->locale_data);$locale++,Next($this->locale_data))
				{
					$locale_name=Key($this->locale_data);
					if(!IsSet($this->locale_data[$locale_name][$string]["string"]))
					{
						$compiler->SetElementError($file,$path,"stringlist string \"$string\" is not defined for locale \"$locale_name\"");
						return(0);
					}
					if(!$compiler->ConvertData($context,"STRING",$this->locale_data[$locale_name][$string]["string"],$list_string)
					|| !$compiler->ConvertData($context,"STRING",$locale_name,$locale_string))
					{
						$compiler->SetElementError($file,$path,"it was not possible to convert the locale string data \"$string\"");
						return(0);
					}
					if(strcmp($list,""))
						$list.=", ";
					$list.=$locale_string."=>".$list_string;
				}
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"array($list)",
						"Type"=>"HASH",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported locale object function");
				return(0);
		}
		return(1);
	}

	Function Initialization(&$compiler,&$context,$object_context)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the locale class");
			return(0);
		}
		$compiler->CopyEmptyContext($context,$error_context);
		$files=array();
		$string_types=array("string","shortcutstring","shortcut","strippedstring","markpositions","marknames");
		for($error="",$string_type=0;$string_type<count($string_types);$string_type++)
		{
			$type=$string_types[$string_type];
			for($entry=0,Reset($this->used_data[$type]);$entry<count($this->used_data[$type]);Next($this->used_data[$type]),$entry++)
			{
				$entry_name=Key($this->used_data[$type]);
				for($locale_data=0,Reset($this->locale_data);$locale_data<count($this->locale_data);Next($this->locale_data),$locale_data++)
				{
					$locale=Key($this->locale_data);
					$output=$this->output_directory."/".$this->context."-".$locale.".php";
					if(IsSet($files[$output]))
						$locale_file=$files[$output];
					else
					{
						if(!($locale_file=@fopen($output,"w")))
						{
							$error="it was not possible to open output locale file";
							break 3;
						}
						$files[$output]=$locale_file;
						if(!fputs($locale_file,"<?php\n\n"))
						{
							$error="it was not possible to write to the locale file";
							break 3;
						}
					}
					if(!IsSet($this->locale_data[$locale][$entry_name]["string"]))
					{
						$error="entry \"$entry_name\" is not defined in the file for locale \"$locale\"";
						$error_context->file=$this->used_data[$type][$entry_name]["file"];
						$error_context->path=$this->used_data[$type][$entry_name]["path"];
						break 3;
					}
					$value=$this->locale_data[$locale][$entry_name]["string"];
					switch($type)
					{
						case "shortcutstring":
						case "shortcut":
							if(!IsSet($this->locale_data[$locale][$entry_name]["shortcut_start"]))
							{
								$error="it was not defined the shortcut for the specified locale string";
								$error_context->file=$this->used_data[$type][$entry_name]["file"];
								$error_context->path=$this->used_data[$type][$entry_name]["path"];
								break 4;
							}
					}
					switch($type)
					{
						case "shortcutstring":
							$start=$this->locale_data[$locale][$entry_name]["shortcut_start"];
							$length=$this->locale_data[$locale][$entry_name]["shortcut_length"];
							$value=substr($value,0,$start).$this->shortcut_start_mark.substr($value,$start,$length).$this->shortcut_end_mark.substr($value,$start+$length);
							break;
						case "shortcut":
							$value=substr($value,$this->locale_data[$locale][$entry_name]["shortcut_start"],$this->locale_data[$locale][$entry_name]["shortcut_length"]);
							break;
						case "strippedstring":
						  if(IsSet($this->locale_data[$locale][$entry_name]["strippedstring"]))
							 	$value=$this->locale_data[$locale][$entry_name]["strippedstring"];
						 	break;
						case "markpositions":
						case "marknames":
						  $value=(IsSet($this->locale_data[$locale][$entry_name][$type]) ? $this->locale_data[$locale][$entry_name][$type] : array());
							break;
					}
					$value_type="STRING";
					switch($type)
					{
						case "markpositions":
							$value_type="INTEGER";
						case "marknames":
							for(Reset($value),$values="array(",$mark=0;$mark<count($value);Next($value),$mark++)
							{
								if($mark>0)
									$values.=",";
								if(!$compiler->ConvertData($context,$value_type,$value[$mark],$mark_value))
								{
									$error="it was not possible to convert the locale $type data";
									break 4;
								}
								$values.=$mark_value;
							}
							$value=$values.")";
							break;
						default:
							if(!$compiler->ConvertData($context,"STRING",$value,$value))
							{
								$error="it was not possible to convert the locale $type data";
								break 4;
							}
							break;
					}
					if(!fputs($locale_file,"\$GLOBALS[\"".$this->object_name."\"][\"".$type."\"][\"".$entry_name."\"]=".$value.";\n"))
					{
						$error="it was not possible to write to the locale file";
						break 3;
					}
				}
				if($locale_data==0)
				{
					$error="it were not defined any locale translations for the text in use (\"$entry_name\")";
					break 2;
				}
			}
		}
		for($file=0,Reset($files);$file<count($files);Next($files),$file++)
		{
			$locale_file=Key($files);
			if(!strcmp($error,"")
			&& !fputs($files[$locale_file],"\n?>"))
				$error="it was not possible to write to the locale file";
			else
			{
				$context->result[]=array(
					"Data"=>array(
						"Name"=>$locale_file,
						"Type"=>"GENERATED"
					),
					"Type"=>"FILE"
				);
			}
			$closed=fclose($files[$locale_file]);
			if(!strcmp($error,"")
			&& !$closed)
			{
				$compiler->CopyEmptyContext($context,$error_context);
				$error="it was not possible to close the output locale file";
			}
		}
		if(strcmp($error,""))
		{
			$compiler->SetElementError($error_context->file,$error_context->path,$error);
			return(0);
		}
		if(count($this->locale_set))
		{
			if(!$compiler->GetExpressionValue($context,$this->locale_set,$expression_value,$expression_type))
				return(0);
		}
		$context->result[]=array(
			"Data"=>"\$".$this->object_name."=array();",
			"Type"=>"COMMAND"
		);
		if(count($this->locale_set))
		{
			$context->result[]=array(
				"Data"=>"include(\"".$this->relative_path."/".$this->context."-\".".$expression_value.".\".php\");",
				"Type"=>"COMMAND"
			);
		}
		return(1);
	}

};
 
}
?>