<?
if(!defined("METAL_METABASE_INCLUDED"))
{
	define("METAL_METABASE_INCLUDED",1);

/*
 * metal_metabase.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_metabase.php,v 1.30 2004/05/11 02:19:34 mlemos Exp $
 *
 */
 
class metal_metabase_class extends metal_base_class
{
	var $metabase_path="";
	var $metabase_base_path="";
	var $needs_manager=0;
	var $needs_interface=0;

	Function Setup(&$compiler,&$code,&$attributes)
	{
		$elements=$code->structure[$attributes->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$attributes->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "metabasepath":
						if(!$compiler->GetValidData($attributes->file,$element_path,&$metabase_path,"it was not specified a valid metabase path"))
							return(0);
						if(!($directory=@opendir($metabase_path)))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was not specified an existing metabase path (\"$metabase_path\")");
							return(0);
						}
						closedir($directory);
						$this->metabase_path=$metabase_path;
						break;
					case "metabasebasepath":
						if(!$compiler->GetValidData($attributes->file,$element_path,&$this->metabase_base_path,"it was not specified a valid metabase base path"))
							return(0);
						break;
					default:
						$compiler->SetElementError($attributes->file,$element_path,$data["Tag"]." is not a supported metabase object attribute");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($attributes->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function GetObject(&$compiler,&$context,$element_path,&$object)
	{
		if(strcmp($object,""))
		{
			$compiler->SetElementError($context->file,$element_path,"it was specified the metabase object argument more than once");
			return(0);
		}
		$compiler->CopyEmptyContext($context,$evaluate_context);
		$evaluate_context->path=$element_path;
		if(!$compiler->GetValidExpression(&$evaluate_context,"OBJECT","NOTRIGHT","it was not specified a valid metabase object expression",1)
		|| !$compiler->GetExpressionValue(&$context,&$evaluate_context->result,&$object,&$expression_type))
			return(0);
		return(1);
	}

	Function GetObjectArguments(&$compiler,&$code,&$context,&$object)
	{
		$elements=$code->structure[$context->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$context->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "object":
						if(!$this->GetObject(&$compiler,&$context,$element_path,&$object))
							return(0);
						break;
					default:
						$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported metabase argument");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function VerifyObjectArguments(&$compiler,&$code,&$context,&$object)
	{
		$object="";
		if(!$this->GetObjectArguments(&$compiler,&$code,&$context,&$object))
			return(0);
		If(!strcmp($object,""))
		{
			$compiler->SetElementError($context->file,$context->path,"it was not specified the metabase object argument");
			return(0);
		}
		return(1);
	}

	Function NewHandle(&$compiler,&$result_context,&$code,&$context,&$new_handle)
	{
		$elements=$code->structure[$context->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$context->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "arguments":
						$compiler->CopyEmptyContext($context,$evaluate_context);
						$evaluate_context->path=$element_path;
						if(!$compiler->GetValidTypedExpression(&$evaluate_context,"HASH","it was not specified a valid metabase newhandle arguments argument")
						|| !$compiler->GetExpressionValue(&$result_context,&$evaluate_context->result,&$new_handle["arguments"],&$expression_type))
							return(0);
						break;
					case "handle":
						$compiler->CopyEmptyContext($context,$evaluate_context);
						$evaluate_context->path=$element_path;
						if(!$compiler->GetValidExpression(&$evaluate_context,"INTEGER","NOTRIGHT","it was not specified a valid metabase newhandle handle argument",1)
						|| !$compiler->GetExpressionValue(&$result_context,$evaluate_context->result,&$new_handle["handle"],&$expression_type))
							return(0);
						break;
					case "error":
						$compiler->CopyEmptyContext($context,$evaluate_context);
						$evaluate_context->path=$element_path;
						if(!$compiler->GetValidExpression(&$evaluate_context,"STRING","NOTRIGHT","it was not specified a valid metabase newhandle error argument",1)
						|| !$compiler->GetExpressionValue(&$result_context,$evaluate_context->result,&$new_handle["error"],&$expression_type))
							return(0);
						break;
					default:
						$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported metabase object newhandle parameter");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the metabase class");
			return(0);
		}
		switch($function)
		{
			case "newhandle":
				$new_handle=array();
				if(!$this->NewHandle(&$compiler,&$context,&$arguments_code,&$arguments,&$new_handle)
				|| !$this->NewHandle(&$compiler,&$context,&$code,&$context,&$new_handle))
					return(0);
				if(!IsSet($new_handle[$argument="arguments"])
				|| !IsSet($new_handle[$argument="handle"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not a specified the metabase newhandle $argument argument");
					return(0);
				}
				$this->needs_interface=1;
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$expression="MetabaseSetupDatabase(".$new_handle["arguments"].",".$new_handle["handle"].")";
				if(IsSet($new_handle["error"]))
					$expression="(".$new_handle["error"]."=$expression)";
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"!strcmp($expression,\"\")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "closesetup":
				$types=array(
					"handle"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>"MetabaseCloseSetup(".$values["handle"].");",
					"Type"=>"COMMAND"
				);
				break;
			case "setselectedrowrange":
				$types=array(
					"handle"=>"INTEGER",
					"first"=>"INTEGER",
					"limit"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseSetSelectedRowRange(".$values["handle"].",".$values["first"].",".$values["limit"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "query":
				$types=array(
					"handle"=>"INTEGER",
					"statement"=>"STRING"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseQuery(".$values["handle"].",".$values["statement"].")",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "preparequery":
				$types=array(
					"handle"=>"INTEGER",
					"query"=>"STRING"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabasePrepareQuery(".$values["handle"].",".$values["query"].")",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "executequery":
				$types=array(
					"handle"=>"INTEGER",
					"statement"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseExecuteQuery(".$values["handle"].",".$values["statement"].")",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "endofresult":
			case "resultrows":
				$types=array(
					"handle"=>"INTEGER",
					"result"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>($function=="endofresult" ? "MetabaseEndOfResult" : "MetabaseNumberOfRows")."(".$values["handle"].",".$values["result"].")",
						"Type"=>($function=="endofresult" ? "BOOLEAN" : "INTEGER"),
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "fetchresult":
				$types=array(
					"handle"=>"INTEGER",
					"result"=>"INTEGER",
					"row"=>"INTEGER",
					"type"=>"DATA"
				);
				$optional_types=array(
					"columnname"=>"STRING",
					"column"=>"INTEGER"
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues(&$arguments,&$values,&$types,&$optional_types,"metabase",$function,0)
				|| !$compiler->GetOptionalArgumentValues(&$context,&$values,&$types,&$optional_types,"metabase",$function,1))
					return(0);
				if(IsSet($values["column"]))
				{
					if(IsSet($values["columnname"]))
					{
						$compiler->SetElementError($context->file,$context->path,"it was specified both the column and the columnname arguments");
						return(0);
					}
					$column=$values["column"];
				}
				else
				{
					if(!IsSet($values["columnname"]))
					{
						$compiler->SetElementError($context->file,$context->path,"it was not specified either the column or the columnname argument");
						return(0);
					}
					$column=$values["columnname"];
				}
				$value="(".$values["handle"].",".$values["result"].",".$values["row"].",".$column.")";
				switch($values["type"])
				{
					case "TEXT";
						$value="MetabaseFetchResult$value";
						$type="STRING";
						break;
					case "INTEGER":
						$value="intval(MetabaseFetchResult$value)";
						$type="INTEGER";
						break;
					case "BOOLEAN":
						$value="intval(MetabaseFetchBooleanResult$value)";
						$type="BOOLEAN";
						break;
					case "DECIMAL":
						$value="MetabaseFetchDecimalResult$value";
						$type="STRING";
						break;
					case "FLOAT":
						$value="doubleval(MetabaseFetchFloatResult$value)";
						$type="FLOAT";
						break;
					case "DATE":
						$value="MetabaseFetchDateResult$value";
						$type="STRING";
						break;
					case "TIME":
						$value="MetabaseFetchTimeResult$value";
						$type="STRING";
						break;
					case "TIMESTAMP":
						$value="MetabaseFetchTimestampResult$value";
						$type="STRING";
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,"it was not specified a supported metabase fetch result type (\"".$values["type"]."\")");
						return(0);
				}
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$value,
						"Type"=>$type,
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "resultisnull":
				$types=array(
					"handle"=>"INTEGER",
					"result"=>"INTEGER",
					"row"=>"INTEGER",
					"columnname"=>"STRING"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseResultIsNull(".$values["handle"].",".$values["result"].",".$values["row"].",".$values["columnname"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "freequeryresult":
				$types=array(
					"handle"=>"INTEGER",
					"result"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>"MetabaseFreeResult(".$values["handle"].",".$values["result"].");",
					"Type"=>"COMMAND"
				);
				break;
			case "affectedrows":
				$types=array(
					"handle"=>"INTEGER",
					"rows"=>"INTEGER:NOTRIGHT"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseAffectedRows(".$values["handle"].",".$values["rows"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "querysettext":
			case "querysetinteger":
			case "querysetboolean":
			case "querysetdate":
			case "querysettimestamp":
			case "querysettime":
			case "querysetfloat":
			case "querysetdecimal":
				switch($function)
				{
					case "querysettext":
						$type="STRING";
						$call="MetabaseQuerySetText";
						break;
					case "querysetinteger":
						$type="INTEGER";
						$call="MetabaseQuerySetInteger";
						break;
					case "querysetboolean":
						$type="BOOLEAN";
						$call="MetabaseQuerySetBoolean";
						break;
					case "querysetdate":
						$type="STRING";
						$call="MetabaseQuerySetDate";
						break;
					case "querysettimestamp":
						$type="STRING";
						$call="MetabaseQuerySetTimeStamp";
						break;
					case "querysettime":
						$type="STRING";
						$call="MetabaseQuerySetTime";
						break;
					case "querysetfloat":
						$type="FLOAT";
						$call="MetabaseQuerySetFloat";
						break;
					case "querysetdecimal":
						$type="STRING";
						$call="MetabaseQuerySetDecimal";
						break;
				}
				$types=array(
					"handle"=>"INTEGER",
					"statement"=>"INTEGER",
					"argument"=>"INTEGER",
					"value"=>$type
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"$call(".$values["handle"].",".$values["statement"].",".$values["argument"].",".$values["value"].")",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "querysetnull":
				$types=array(
					"handle"=>"INTEGER",
					"statement"=>"INTEGER",
					"argument"=>"INTEGER",
					"type"=>"STRING"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseQuerySetNull(".$values["handle"].",".$values["statement"].",".$values["argument"].",".$values["type"].")",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "freepreparedquery":
				$types=array(
					"handle"=>"INTEGER",
					"statement"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseFreePreparedQuery(".$values["handle"].",".$values["statement"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "gettextfieldvalue":
			case "getintegerfieldvalue":
			case "getbooleanfieldvalue":
			case "getdatefieldvalue":
			case "gettimestampfieldvalue":
			case "gettimefieldvalue":
			case "getfloatfieldvalue":
			case "getdecimalfieldvalue":
				switch($function)
				{
					case "gettextfieldvalue":
						$type="STRING";
						$call="MetabaseGetTextFieldValue";
						break;
					case "getintegerfieldvalue":
						$type="INTEGER";
						$call="";
						break;
					case "getbooleanfieldvalue":
						$type="BOOLEAN";
						$call="MetabaseGetBooleanFieldValue";
						break;
					case "getdatefieldvalue":
						$type="STRING";
						$call="MetabaseGetDateFieldValue";
						break;
					case "gettimestampfieldvalue":
						$type="STRING";
						$call="MetabaseGetTimeStampFieldValue";
						break;
					case "gettimefieldvalue":
						$type="STRING";
						$call="MetabaseGetTimeFieldValue";
						break;
					case "getfloatfieldvalue":
						$type="FLOAT";
						$call="MetabaseGetFloatFieldValue";
						break;
					case "getdecimalfieldvalue":
						$type="STRING";
						$call="MetabaseGetDecimalFieldValue";
						break;
				}
				$types=array(
					"handle"=>"INTEGER",
					"value"=>$type
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>(strcmp($call,"") ? "$call(".$values["handle"].",".$values["value"].")" : $values["value"]),
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "support":
				$types=array(
					"handle"=>"INTEGER",
					"feature"=>"STRING"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseSupport(".$values["handle"].",".$values["feature"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "autocommit":
				$types=array(
					"handle"=>"INTEGER",
					"autocommit"=>"BOOLEAN"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseAutoCommitTransactions(".$values["handle"].",".$values["autocommit"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "rollback":
				$types=array(
					"handle"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseRollbackTransaction(".$values["handle"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "getsequencenextvalue":
				$types=array(
					"handle"=>"INTEGER",
					"name"=>"STRING",
					"sequence"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseGetSequenceNextValue(".$values["handle"].",".$values["name"].",".$values["sequence"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "setdatabase":
				$types=array(
					"handle"=>"INTEGER",
					"name"=>"STRING"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>"MetabaseSetDatabase(".$values["handle"].",".$values["name"].");",
					"Type"=>"COMMAND"
				);
				break;
			case "error":
				$types=array(
					"handle"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseError(".$values["handle"].")",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "newmanager":
				$this->needs_manager=$this->needs_interface=1;
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"new metabase_manager_class",
						"Type"=>"OBJECT",
						"Class"=>"metabase_manager_class",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "updatedatabase":
				if(!$this->VerifyObjectArguments(&$compiler,&$arguments_code,&$arguments,&$object))
					return(0);
				$update_database=array();
				$elements=$code->structure[$context->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "schema":
							case "installedschema":
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidTypedExpression(&$evaluate_context,"STRING","it was not specified a valid metabase updatedatabase ".$data["Tag"]." file argument")
								|| !$compiler->GetExpressionValue(&$context,&$evaluate_context->result,&$update_database[$data["Tag"]],&$expression_type))
									return(0);
								break;
							case "arguments":
							case "variables":
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidTypedExpression(&$evaluate_context,"HASH","it was not specified a valid metabase updatedatabase ".$data["Tag"]." argument")
								|| !$compiler->GetExpressionValue(&$context,&$evaluate_context->result,&$update_database[$data["Tag"]],&$expression_type))
									return(0);
								break;
							default:
								$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported metabase object updatedatabase parameter");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				if(!IsSet($update_database[$argument="schema"])
				|| !IsSet($update_database[$argument="installedschema"])
				|| !IsSet($update_database[$argument="arguments"])
				|| !IsSet($update_database[$argument="variables"]))
				{
					$compiler->SetElementError($context->file,$element_path,"it was not a specified the metabase updatedatabase $argument argument");
					return(0);
				}
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$object."->UpdateDatabase(".$update_database["schema"].",".$update_database["installedschema"].",".$update_database["arguments"].",".$update_database["variables"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "managererror":
				if(!$this->VerifyObjectArguments(&$compiler,&$arguments_code,&$arguments,&$object))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$object."->error",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "debugmessage":
				$types=array(
					"handle"=>"INTEGER",
					"message"=>"STRING"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>"MetabaseDebug(".$values["handle"].",".$values["message"].");",
					"Type"=>"COMMAND"
				);
				break;
			case "capturedebugoutput":
				$types=array(
					"handle"=>"INTEGER",
					"capture"=>"BOOLEAN"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>"MetabaseCaptureDebugOutput(".$values["handle"].",".$values["capture"].");",
					"Type"=>"COMMAND"
				);
				break;
			case "debugoutput":
				$types=array(
					"handle"=>"INTEGER"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MetabaseDebugOutput(".$values["handle"].")",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "managerdebugoutput":
				$types=array(
					"manager"=>"OBJECT"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"metabase",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"(".$values["manager"]."->database ? MetabaseDebugOutput(".$values["manager"]."->database) : \"\")",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "now":
			case "today":
			case "time":
			  $functions=array(
			   "now"=>"MetabaseNow",
			   "today"=>"MetabaseToday",
			   "time"=>"MetabaseTime"
			  );
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$functions[$function]."()",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported metabase object function");
				return(0);
		}
		return(1);
	}

	Function Initialization(&$compiler,&$context,$object_context)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the metabase class");
			return(0);
		}
		$relative_path=$compiler->RelativePath($this->metabase_base_path,$this->metabase_path);
		if(strcmp($relative_path,""))
			$relative_path.="/";
		$metabase_path=$this->metabase_path;
		if(strcmp($metabase_path,""))
			$metabase_path.="/";
		if($this->needs_manager)
		{
			$context->result[]=array(
				"Data"=>array(
					"Name"=>$metabase_path."metabase_manager.php",
					"Type"=>"SUPPLIED"
				),
				"Type"=>"FILE"
			);
			$context->result[]=array(
				"Data"=>"require(\"$relative_path"."metabase_manager.php\");",
				"Type"=>"COMMAND"
			);
			$context->result[]=array(
				"Data"=>array(
					"Name"=>$metabase_path."metabase_parser.php",
					"Type"=>"SUPPLIED"
				),
				"Type"=>"FILE"
			);
			$context->result[]=array(
				"Data"=>"require(\"$relative_path"."metabase_parser.php\");",
				"Type"=>"COMMAND"
			);
			$context->result[]=array(
				"Data"=>array(
					"Name"=>$metabase_path."xml_parser.php",
					"Type"=>"SUPPLIED"
				),
				"Type"=>"FILE"
			);
			$context->result[]=array(
				"Data"=>"require(\"$relative_path"."xml_parser.php\");",
				"Type"=>"COMMAND"
			);
		}
		if($this->needs_interface)
		{
			$context->result[]=array(
				"Data"=>array(
					"Name"=>$metabase_path."metabase_interface.php",
					"Type"=>"SUPPLIED"
				),
				"Type"=>"FILE"
			);
			$context->result[]=array(
				"Data"=>"require(\"$relative_path"."metabase_interface.php\");",
				"Type"=>"COMMAND"
			);
			$context->result[]=array(
				"Data"=>array(
					"Name"=>$metabase_path."metabase_database.php",
					"Type"=>"SUPPLIED"
				),
				"Type"=>"FILE"
			);
			$context->result[]=array(
				"Data"=>"require(\"$relative_path"."metabase_database.php\");",
				"Type"=>"COMMAND"
			);
		}
		return(1);
	}

};
 
}
?>