<?php
if(!defined("METAL_PERSISTENCE_FORM_GENERATOR_INCLUDED"))
{
	define("METAL_PERSISTENCE_FORM_GENERATOR_INCLUDED",1);

/*
 * metal_persistence_form_generator.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_persistence_form_generator.php,v 1.43 2005/06/06 02:05:29 mlemos Exp $
 *
 */

class metal_persistence_form_generator_class
{
	Function GenerateFormInput(&$module,&$compiler,&$context,$component,$form_name,$parent,&$input,&$path)
	{
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($path=$compiler->GetXMLNode()),
				"Parent"=>$parent,
				"Tag"=>"input",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$path,
				"Tag"=>"name",
				"Data"=>$input["name"]
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$path,
				"Tag"=>"id",
				"Data"=>(IsSet($input["id"]) ? $input["id"] : $input["name"])
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$path,
				"Tag"=>"type",
				"Data"=>$input["type"]
			),
			"Type"=>"XMLTAG"
		);
		if(IsSet($input["defaultvalueformvariable"]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($value=$compiler->GetXMLNode()),
					"Parent"=>$path,
					"Tag"=>"value"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$value,
					"Tag"=>"formvariable",
					"Data"=>$input["defaultvalueformvariable"]
				),
				"Type"=>"XMLTAG"
			);
		}
		elseif(IsSet($input["valueformvariable"]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($value=$compiler->GetXMLNode()),
					"Parent"=>$path,
					"Tag"=>"value"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$value,
					"Tag"=>"formvariable",
					"Data"=>$input["valueformvariable"]
				),
				"Type"=>"XMLTAG"
			);
		}
		elseif(IsSet($input["defaultvalue"]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($value=$compiler->GetXMLNode()),
					"Parent"=>$path,
					"Tag"=>"value",
					"Data"=>$input["defaultvalue"]
				),
				"Type"=>"XMLTAG"
			);
		}
		if(IsSet($input["labelformvariable"]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($label=$compiler->GetXMLNode()),
					"Parent"=>$path,
					"Tag"=>"label"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$label,
					"Tag"=>"formvariable",
					"Data"=>$input["labelformvariable"]
				),
				"Type"=>"XMLTAG"
			);
		}
		if(IsSet($input["accesskeyformvariable"]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($accesskey=$compiler->GetXMLNode()),
					"Parent"=>$path,
					"Tag"=>"accesskey"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$accesskey,
					"Tag"=>"formvariable",
					"Data"=>$input["accesskeyformvariable"]
				),
				"Type"=>"XMLTAG"
			);
		}
		if(IsSet($input["tabindex"]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$path,
					"Tag"=>"tabindex",
					"Data"=>$input["tabindex"]
				),
				"Type"=>"XMLTAG"
			);
		}
		if(IsSet($input["subform"]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$path,
					"Tag"=>"subform",
					"Data"=>$input["subform"]
				),
				"Type"=>"XMLTAG"
			);
		}
		if(IsSet($input["maxlength"]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$path,
					"Tag"=>"maxlength",
					"Data"=>$input["maxlength"]
				),
				"Type"=>"XMLTAG"
			);
		}
		if(IsSet($module->components[$component]["forms"][$form_name]["style"]["input"][$input["type"]]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($style=$compiler->GetXMLNode()),
					"Parent"=>$path,
					"Tag"=>"style"
				),
				"Type"=>"XMLTAG"
			);
			if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$style,$module->components[$component]["forms"][$form_name]["style"]["input"][$input["type"]]))
				return(0);
		}
		if(IsSet($module->components[$component]["forms"][$form_name]["class"]["input"][$input["type"]]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($class=$compiler->GetXMLNode()),
					"Parent"=>$path,
					"Tag"=>"class"
				),
				"Type"=>"XMLTAG"
			);
			if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$class,$module->components[$component]["forms"][$form_name]["class"]["input"][$input["type"]]))
				return(0);
		}
		return(1);
	}

	Function GenerateFormSubmitInput(&$module,&$compiler,&$context,$component,$form_name,&$submit_values,&$fields,$root,$submit_type,$sub_form,$tab_index)
	{
		if(IsSet($submit_values["value"]))
		{
			$input_name=(IsSet($submit_values["field"]) ? $submit_values["field"] : $submit_type);
			$input=array(
				"name"=>$input_name
			);
			if(IsSet($fields[$input_name]))
				return($compiler->SetElementError($submit_values->file,$submit_values->path,IsSet($submit_values["field"]) ? "there is already a form field named ".$input_name : "it was not specified the ".$submit_type." field label text"));
			$fields[$input_name]="";
			$input["type"]="submit";
			$input["valueformvariable"]=$input_name."value";
			if(IsSet($submit_values["label"]))
				$input["labelformvariable"]=$input_name."label";
			if(IsSet($submit_values["accesskey"]))
				$input["accesskeyformvariable"]=$input_name."accesskey";
			if(strlen($sub_form))
				$input["subform"]=$sub_form;
			$input["tabindex"]=$tab_index;
			if(!$this->GenerateFormInput($module,$compiler,$context,$component,$form_name,$root,$input,$path))
				return(0);
		}
		if(IsSet($submit_values["image"]))
		{
			$input_name=(IsSet($submit_values["field"]) ? $submit_values["field"] : $submit_type);
			$input=array(
				"id"=>$input_name."image",
				"name"=>$input_name
			);
			if(IsSet($fields[$input_name."image"]))
				return($compiler->SetElementError($submit_values->file,$submit_values->path,IsSet($submit_values["field"]) ? "there is already a form field named ".$input_name : "it was not specified the ".$submit_type." field label text"));
			$fields[$input_name."image"]="";
			$input["type"]="image";
			if(IsSet($submit_values["imagelabel"]))
				$input["labelformvariable"]=$input_name."imagelabel";
			if(IsSet($submit_values["imageaccesskey"]))
				$input["accesskeyformvariable"]=$input_name."imageaccesskey";
			if(strlen($sub_form))
				$input["subform"]=$sub_form;
			$input["tabindex"]=$tab_index;
			if(!$this->GenerateFormInput($module,$compiler,$context,$component,$form_name,$root,$input,$path))
				return(0);
			if(IsSet($submit_values["value"]))
			{
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($alt=$compiler->GetXMLNode()),
						"Parent"=>$path,
						"Tag"=>"alt"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$alt,
						"Tag"=>"formvariable",
						"Data"=>$input_name."value"
					),
					"Type"=>"XMLTAG"
				);
			}
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($src=$compiler->GetXMLNode()),
					"Parent"=>$path,
					"Tag"=>"src"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$src,
					"Tag"=>"formvariable",
					"Data"=>$input_name."image"
				),
				"Type"=>"XMLTAG"
			);
		}
		return(1);
	}

	Function Generate(&$module,&$compiler,&$context,$component,$form_name)
	{
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($root=$compiler->GetXMLNode()),
				"Tag"=>"form",
				"Indent"=>1,
				"Spacing"=>1
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$root,
				"Tag"=>"name",
				"Data"=>$form_name
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($action=$compiler->GetXMLNode()),
				"Parent"=>$root,
				"Tag"=>"action"
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($action=$compiler->GetXMLNode()),
				"Parent"=>$root,
				"Tag"=>"method",
				"Data"=>"post"
			),
			"Type"=>"XMLTAG"
		);

		$tab_index=1;
		$type=$module->components[$component]["forms"][$form_name]["type"];
		switch($type)
		{
			case "createobject":
				$class=$module->components[$component]["forms"][$form_name]["parameters"]["class"];
				for($fields=array(),Reset($module->components[$component]["classes"][$class]["variables"]);GetType($variable=Key($module->components[$component]["classes"][$class]["variables"]))=="string";Next($module->components[$component]["classes"][$class]["variables"]))
				{
					if(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["autocreate"])
					|| IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["autoupdate"]))
						continue;
					$input_name=$variable;
					$input=array(
						"name"=>$input_name
					);
					if(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["type"]))
					{
						$type=$module->components[$component]["classes"][$class]["variables"][$variable]["type"];
						switch($type)
						{
							case "text":
								if(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["multiline"]) && $module->components[$component]["classes"][$class]["variables"][$variable]["multiline"])
									$input["type"]="textarea";
								else
								{
									$input["type"]="text";
									if(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["length"]))
										$input["maxlength"]=$module->components[$component]["classes"][$class]["variables"][$variable]["length"];
								}
								if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]["defaultvalueformvariable"]))
									$input["defaultvalueformvariable"]=$input_name."defaultvalue";
								elseif(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["initialvalue"]))
									$input["defaultvalue"]=$module->components[$component]["classes"][$class]["variables"][$variable]["initialvalue"];
								break;
							default:
								return($compiler->SetElementError($context->file,$context->path,$type." is not yet a class variable type supported in createobject forms"));
						}
						if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]["label"]))
							$input["labelformvariable"]=$input_name."label";
						if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]["accesskey"]))
							$input["accesskeyformvariable"]=$input_name."accesskey";
						$input["tabindex"]=strval($tab_index++);
					}
					else
					{
						if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]))
						{
							if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]["defaultvalueformvariable"]))
							{
								$input["type"]="hidden";
								$input["defaultvalueformvariable"]=$input_name."defaultvalue";
							}
							else
								return($compiler->SetElementError($context->file,$context->path,"it was not specified the a form class variable that will hold the default value for the object variable (\"".$variable."\") of the form \"".$form_name."\""));
						}
						if(!IsSet($input["type"]))
							return($compiler->SetElementError($context->file,$context->path,"it were not specified the parameters for object variable (\"".$variable."\") of the createobject form \"".$form_name."\""));
				}
					if(IsSet($fields[$input_name]))
						return($compiler->SetElementError($context->file,$context->path,"there is already a form field named ".$field));
					$fields[$input_name]=$class;
					if(!$this->GenerateFormInput($module,$compiler,$context,$component,$form_name,$root,$input,$path))
						return(0);
					if(IsSet($module->components[$component]["forms"][$form_name]["validations"][$variable]))
					{
						for($validation=0;$validation<count($module->components[$component]["forms"][$form_name]["validations"][$variable]);$validation++)
						{
							$type=$module->components[$component]["forms"][$form_name]["validations"][$variable][$validation]["type"];
							$code=$module->components[$component]["forms"][$form_name]["validations"][$variable][$validation]["errorcode"];
							switch($type)
							{
								case "notempty":
									$context->result[]=array(
										"Data"=>array(
											"Node"=>($validation=$compiler->GetXMLNode()),
											"Parent"=>$path,
											"Tag"=>"validation",
											"Indent"=>1
										),
										"Type"=>"XMLTAG"
									);
									$context->result[]=array(
										"Data"=>array(
											"Parent"=>$validation,
											"Tag"=>"asnotempty"
										),
										"Type"=>"XMLTAG"
									);
									$context->result[]=array(
										"Data"=>array(
											"Node"=>($errormessage=$compiler->GetXMLNode()),
											"Parent"=>$validation,
											"Tag"=>"errormessage"
										),
										"Type"=>"XMLTAG"
									);
									$context->result[]=array(
										"Data"=>array(
											"Parent"=>$errormessage,
											"Tag"=>"formvariable",
											"Data"=>"errormessage".$code
										),
										"Type"=>"XMLTAG"
									);
									break;
								case "unique":
									break;
								default:
									return($compiler->SetElementError($context->file,$context->path,$type." is not yet a supported type of validation for variable ".$variable));
							}
						}
					}
				}

				if(!$this->GenerateFormSubmitInput($module,$compiler,$context,$component,$form_name,$module->components[$component]["forms"][$form_name]["parameters"]["submit"],$fields,$root,"submit","",$tab_index++))
					return(0);

				if(IsSet($module->components[$component]["forms"][$form_name]["parameters"]["cancel"])
				&& !$this->GenerateFormSubmitInput($module,$compiler,$context,$component,$form_name,$module->components[$component]["forms"][$form_name]["parameters"]["cancel"],$fields,$root,"cancel","cancel",$tab_index++))
					return(0);

				break;
			default:
				return($compiler->SetElementError($context->file,$context->path,$type." is not yet a supported component form type"));
		}
		return(1);
	}

	Function GenerateClassInput(&$module,&$compiler,&$context,$input_node,$component,$form_name,$factory_input,$form_file_name)
	{
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$input_node,
				"Tag"=>"includeonce",
				"Data"=>"include/form.input"
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$input_node,
				"Node"=>($object=$compiler->GetXMLNode()),
				"Tag"=>"object",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$object,
				"Tag"=>"name",
				"Data"=>$form_name."form"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$object,
				"Tag"=>"class",
				"Data"=>"form"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$object,
				"Node"=>($attributes=$compiler->GetXMLNode()),
				"Tag"=>"attributes",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$attributes,
				"Tag"=>"definition",
				"Data"=>$form_file_name
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$attributes,
				"Node"=>($classbasepath=$compiler->GetXMLNode()),
				"Tag"=>"classbasepath"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$classbasepath,
				"Tag"=>"formsclassbasepath"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$attributes,
				"Node"=>($classfile=$compiler->GetXMLNode()),
				"Tag"=>"classfile"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$classfile,
				"Tag"=>"formsclassfile"
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$input_node,
				"Node"=>($function=$compiler->GetXMLNode()),
				"Tag"=>"function",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$function,
				"Tag"=>"name",
				"Data"=>"for".$form_name."form"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$function,
				"Tag"=>"object",
				"Data"=>$form_name."form"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$function,
				"Tag"=>"call",
				"Data"=>"forform"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$function,
				"Tag"=>"arguments"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$input_node,
				"Tag"=>"includeonce",
				"Data"=>$factory_input
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$input_node,
				"Node"=>($object=$compiler->GetXMLNode()),
				"Tag"=>"object",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$object,
				"Tag"=>"name",
				"Data"=>$form_name."formtemplate"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$object,
				"Tag"=>"class",
				"Data"=>"template"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$object,
				"Node"=>($attributes=$compiler->GetXMLNode()),
				"Tag"=>"attributes",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$skin=IsSet($module->components[$component]["forms"][$form_name]["skin"]);

		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$attributes,
				"Tag"=>"file",
				"Data"=>$skin ? $module->components[$component]["forms"][$form_name]["skin"]["file"] : $module->components[$component]["forms"][$form_name]["page"][""]["template"]["file"]
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$attributes,
				"Tag"=>"startmark",
				"Data"=>"{"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$attributes,
				"Tag"=>"endmark",
				"Data"=>"}"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$attributes,
				"Tag"=>"clipstartmark",
				"Data"=>"{"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$attributes,
				"Tag"=>"clipendmark",
				"Data"=>"}"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$attributes,
				"Tag"=>"endclipmark",
				"Data"=>"{/"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$attributes,
				"Tag"=>"conditionalprefix",
				"Data"=>"?"
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$input_node,
				"Node"=>($function=$compiler->GetXMLNode()),
				"Tag"=>"function",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$function,
				"Tag"=>"name",
				"Data"=>$form_name."formtemplate"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$function,
				"Tag"=>"object",
				"Data"=>$form_name."formtemplate"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$function,
				"Tag"=>"call",
				"Data"=>"clip"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$function,
				"Node"=>($arguments=$compiler->GetXMLNode()),
				"Tag"=>"arguments",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$arguments,
				"Tag"=>"clip",
				"Data"=>$skin ? $module->components[$component]["forms"][$form_name]["skin"]["clip"] : $module->components[$component]["forms"][$form_name]["page"][""]["template"]["clip"]
			),
			"Type"=>"XMLTAG"
		);

		if($skin)
		{
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$input_node,
					"Node"=>($function=$compiler->GetXMLNode()),
					"Tag"=>"function",
					"Indent"=>1
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$function,
					"Tag"=>"name",
					"Data"=>$form_name."formskinclip"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$function,
					"Tag"=>"object",
					"Data"=>$form_name."formtemplate"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$function,
					"Tag"=>"call",
					"Data"=>"clip"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$function,
					"Node"=>($arguments=$compiler->GetXMLNode()),
					"Tag"=>"arguments"
				),
				"Type"=>"XMLTAG"
			);
		}

		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$input_node,
				"Tag"=>"includeonce",
				"Data"=>"include/cgi.input"
			),
			"Type"=>"XMLTAG"
		);
	}

	Function GenerateClassVariables(&$module,&$compiler,&$context,$class_node,$component,$form_name)
	{
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($variable=$compiler->GetXMLNode()),
				"Parent"=>$class_node,
				"Tag"=>"variable",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"name",
				"Data"=>"form"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"type",
				"Data"=>"OBJECT"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"protected"
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($variable=$compiler->GetXMLNode()),
				"Parent"=>$class_node,
				"Tag"=>"variable",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"name",
				"Data"=>"factory"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"type",
				"Data"=>"OBJECT:".$component."class"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"protected"
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($variable=$compiler->GetXMLNode()),
				"Parent"=>$class_node,
				"Tag"=>"variable",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"name",
				"Data"=>"verify"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"type",
				"Data"=>"HASH"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"value"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"protected"
			),
			"Type"=>"XMLTAG"
		);

		if(IsSet($module->components[$component]["forms"][$form_name]["errormessage"]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($variable=$compiler->GetXMLNode()),
					"Parent"=>$class_node,
					"Tag"=>"variable",
					"Indent"=>1
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$variable,
					"Tag"=>"name",
					"Data"=>$module->components[$component]["forms"][$form_name]["errormessage"]["formvariable"]
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$variable,
					"Tag"=>"type",
					"Data"=>"STRING"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$variable,
					"Tag"=>"value"
				),
				"Type"=>"XMLTAG"
			);
		}

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($variable=$compiler->GetXMLNode()),
				"Parent"=>$class_node,
				"Tag"=>"variable",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"name",
				"Data"=>"processed"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"type",
				"Data"=>"BOOLEAN"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"value",
				"Data"=>"0"
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($variable=$compiler->GetXMLNode()),
				"Parent"=>$class_node,
				"Tag"=>"variable",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"name",
				"Data"=>"error"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"type",
				"Data"=>"STRING"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"value"
			),
			"Type"=>"XMLTAG"
		);

		for(Reset($module->components[$component]["forms"][$form_name]["formvariables"]);GetType($variable=Key($module->components[$component]["forms"][$form_name]["formvariables"]))=="string";Next($module->components[$component]["forms"][$form_name]["formvariables"]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($variable_node=$compiler->GetXMLNode()),
					"Parent"=>$class_node,
					"Tag"=>"variable",
					"Indent"=>1
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$variable_node,
					"Tag"=>"name",
					"Data"=>$variable
				),
				"Type"=>"XMLTAG"
			);
			if(IsSet($module->components[$component]["forms"][$form_name]["formvariables"][$variable]["class"]))
			{
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$variable_node,
						"Tag"=>"type",
						"Data"=>"OBJECT:".$module->components[$component]["forms"][$form_name]["formvariables"][$variable]["class"]."class"
					),
					"Type"=>"XMLTAG"
				);
			}
			else
			{
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$variable_node,
						"Tag"=>"type",
						"Data"=>$module->components[$component]["forms"][$form_name]["formvariables"][$variable]["type"]
					),
					"Type"=>"XMLTAG"
				);
				if(IsSet($module->components[$component]["forms"][$form_name]["formvariables"][$variable]["value"]))
				{
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$variable_node,
							"Tag"=>"value",
							"Data"=>$module->components[$component]["forms"][$form_name]["formvariables"][$variable]["value"]
						),
						"Type"=>"XMLTAG"
					);
				}
			}
		}

		$needs_text=1;
		$type=$module->components[$component]["forms"][$form_name]["type"];
		switch($type)
		{
			case "createobject":
				$class=$module->components[$component]["forms"][$form_name]["parameters"]["class"];

				$context->result[]=array(
					"Data"=>array(
						"Node"=>($variable=$compiler->GetXMLNode()),
						"Parent"=>$class_node,
						"Tag"=>"variable",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$variable,
						"Tag"=>"name",
						"Data"=>$class
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$variable,
						"Tag"=>"type",
						"Data"=>"OBJECT:".$class."class"
					),
					"Type"=>"XMLTAG"
				);

				for($fields=array(),Reset($module->components[$component]["classes"][$class]["variables"]);GetType($variable=Key($module->components[$component]["classes"][$class]["variables"]))=="string";Next($module->components[$component]["classes"][$class]["variables"]))
				{
					if(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["autocreate"])
					|| IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["autoupdate"]))
						continue;
					$input_name=$variable;
					if(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["type"]))
					{
						$type=$module->components[$component]["classes"][$class]["variables"][$variable]["type"];
						switch($type)
						{
							case "text":
								if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]["defaultvalueformvariable"]))
								{
									$form_variable=$module->components[$component]["forms"][$form_name]["variables"][$variable]["defaultvalueformvariable"];
									$variable_type="STRING";
									if(!IsSet($module->components[$component]["forms"][$form_name]["formvariables"][$form_variable]))
										return($compiler->SetElementError($context->file,$context->path,$form_variable." is not declared form variable"));
									if(!IsSet($module->components[$component]["forms"][$form_name]["formvariables"][$form_variable]["type"])
									|| $module->components[$component]["forms"][$form_name]["formvariables"][$form_variable]["type"]!=$variable_type)
										return($compiler->SetElementError($context->file,$context->path,$form_variable." is not form variable of type ".$variable_type." as expected"));
								}
								break;
							default:
								return($compiler->SetElementError($context->file,$context->path,$type." is not yet a class variable type supported in createobject forms"));
						}
					}
					else
					{
						$variable_class=$module->components[$component]["classes"][$class]["variables"][$variable]["class"];
						if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]))
						{
							if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]["defaultvalueformvariable"]))
							{
								$form_variable=$module->components[$component]["forms"][$form_name]["variables"][$variable]["defaultvalueformvariable"];
								if(!IsSet($module->components[$component]["forms"][$form_name]["formvariables"][$form_variable]))
									return($compiler->SetElementError($context->file,$context->path,$form_variable." is not declared form variable"));
								if(!IsSet($module->components[$component]["forms"][$form_name]["formvariables"][$form_variable]["class"]))
									return($compiler->SetElementError($context->file,$context->path,$form_variable." is not class object form variable as expected"));
							}
						}
					}
				}

				$submit_values=$module->components[$component]["forms"][$form_name]["parameters"]["submit"];
				$input_name=(IsSet($submit_values["field"]) ? $submit_values["field"] : "submit");
				if(IsSet($fields[$input_name]))
					return($compiler->SetElementError($module->components[$component]["forms"][$form_name]["parameters"]["submit"]->file,$module->components[$component]["forms"][$form_name]["parameters"]["submit"]->path,IsSet($submit_values["field"]) ? "there is already a form field named ".$input_name : "it was not specified the submit field label text"));
				$fields[$input_name]="";

				if(IsSet($module->components[$component]["forms"][$form_name]["parameters"]["cancel"]))
				{
					$cancel_values=$module->components[$component]["forms"][$form_name]["parameters"]["cancel"];
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($variable=$compiler->GetXMLNode()),
							"Parent"=>$class_node,
							"Tag"=>"variable",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$variable,
							"Tag"=>"name",
							"Data"=>"canceled"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$variable,
							"Tag"=>"type",
							"Data"=>"BOOLEAN"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$variable,
							"Tag"=>"value",
							"Data"=>"0"
						),
						"Type"=>"XMLTAG"
					);
					$input_name=(IsSet($cancel_values["field"]) ? $cancel_values["field"] : "cancel");
					if(IsSet($fields[$input_name]))
						return($compiler->SetElementError($module->components[$component]["forms"][$form_name]["parameters"]["cancel"]->file,$module->components[$component]["forms"][$form_name]["parameters"]["cancel"]->path,IsSet($cancel_values["field"]) ? "there is already a form field named ".$input_name : "it was not specified the cancel field label text"));
					$fields[$input_name]="";
				}
				break;
			default:
				return($compiler->SetElementError($context->file,$context->path,$type." is not yet a supported component form type"));
		}
		if($needs_text)
		{
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($variable=$compiler->GetXMLNode()),
					"Parent"=>$class_node,
					"Tag"=>"variable",
					"Indent"=>1
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$variable,
					"Tag"=>"name",
					"Data"=>"text"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$variable,
					"Tag"=>"type",
					"Data"=>"HASH"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$variable,
					"Tag"=>"value"
				),
				"Type"=>"XMLTAG"
			);
		}
		return(1);
	}

	Function DefineFormVariable(&$compiler,&$context,$doforform,$name,&$value)
	{
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($setformvariable=$compiler->GetXMLNode()),
				"Parent"=>$doforform,
				"Tag"=>"setformvariable",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$setformvariable,
				"Tag"=>"name",
				"Data"=>$name
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($value=$compiler->GetXMLNode()),
				"Parent"=>$setformvariable,
				"Tag"=>"value"
			),
			"Type"=>"XMLTAG"
		);
	}

	Function DefineSubmitInput(&$module,&$compiler,&$context,$component,$form_name,&$submit_values,&$fields,$doforform,$submit_type)
	{
		$input=array();
		$input_name=(IsSet($submit_values["field"]) ? $submit_values["field"] : $submit_type);
		if(IsSet($fields[$input_name]))
			return($compiler->SetElementError($submit_values->file,$submit_values->path,IsSet($submit_values["field"]) ? "there is already a form field named ".$input_name : "it was not specified the ".$submit_type." field label text"));
		$fields[$input_name]="";
		if(IsSet($submit_values["value"]))
		{
			$this->DefineFormVariable($compiler,$context,$doforform,$input_name."value",$value);
			if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$value,$submit_values["value"]))
				return(0);
		}
		if(IsSet($submit_values["label"]))
		{
			$this->DefineFormVariable($compiler,$context,$doforform,$input_name."label",$value);
			if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$value,$submit_values["label"]))
				return(0);
		}
		if(IsSet($submit_values["accesskey"]))
		{
			$this->DefineFormVariable($compiler,$context,$doforform,$input_name."accesskey",$value);
			if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$value,$submit_values["accesskey"]))
				return(0);
		}
		if(IsSet($submit_values["image"]))
		{
			$this->DefineFormVariable($compiler,$context,$doforform,$input_name."image",$value);
			if(IsSet($submit_values["imagepath"]))
			{
				if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$value,$submit_values["imagepath"]))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$value,
						"Tag"=>"join"
					),
					"Type"=>"XMLTAG"
				);
			}
			if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$value,$submit_values["image"]))
				return(0);
			if(IsSet($submit_values["imagelabel"]))
			{
				$this->DefineFormVariable($compiler,$context,$doforform,$input_name."imagelabel",$value);
				if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$value,$submit_values["imagelabel"]))
					return(0);
			}
			if(IsSet($submit_values["imageaccesskey"]))
			{
				$this->DefineFormVariable($compiler,$context,$doforform,$input_name."imageaccesskey",$value);
				if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$value,$submit_values["imageaccesskey"]))
					return(0);
			}
		}
		return(1);
	}

	Function GenerateInitializeFunction(&$module,&$compiler,&$context,$class_node,$component,$form_name)
	{
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($function_node=$compiler->GetXMLNode()),
				"Parent"=>$class_node,
				"Tag"=>"function",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$function_node,
				"Tag"=>"name",
				"Data"=>"initialize"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$function_node,
				"Tag"=>"type",
				"Data"=>"BOOLEAN"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($argument=$compiler->GetXMLNode()),
				"Parent"=>$function_node,
				"Tag"=>"argument",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$argument,
				"Tag"=>"name",
				"Data"=>"factory"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$argument,
				"Tag"=>"type",
				"Data"=>"OBJECT:".$component."class"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($do=$compiler->GetXMLNode()),
				"Parent"=>$function_node,
				"Tag"=>"do",
				"Indent"=>1,
				"Spacing"=>1
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($if=$compiler->GetXMLNode()),
				"Parent"=>$do,
				"Tag"=>"if",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($istrue=$compiler->GetXMLNode()),
				"Parent"=>$if,
				"Tag"=>"istrue",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($length=$compiler->GetXMLNode()),
				"Parent"=>$istrue,
				"Tag"=>"length"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$length,
				"Tag"=>"this",
				"Data"=>"error"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$istrue,
				"Tag"=>"more"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$istrue,
				"Tag"=>"zero"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($then=$compiler->GetXMLNode()),
				"Parent"=>$if,
				"Tag"=>"then",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($return=$compiler->GetXMLNode()),
				"Parent"=>$then,
				"Tag"=>"return"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$return,
				"Tag"=>"false"
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($set=$compiler->GetXMLNode()),
				"Parent"=>$do,
				"Tag"=>"set",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$set,
				"Tag"=>"this",
				"Data"=>"factory"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$set,
				"Tag"=>"argument",
				"Data"=>"factory"
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($forform=$compiler->GetXMLNode()),
				"Parent"=>$do,
				"Tag"=>"for".$form_name."form",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($object=$compiler->GetXMLNode()),
				"Parent"=>$forform,
				"Tag"=>"object"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$object,
				"Tag"=>"this",
				"Data"=>"form"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($doforform=$compiler->GetXMLNode()),
				"Parent"=>$forform,
				"Tag"=>"do",
				"Indent"=>1,
				"Spacing"=>1
			),
			"Type"=>"XMLTAG"
		);

		$type=$module->components[$component]["forms"][$form_name]["type"];
		switch($type)
		{
			case "createobject":
				$class=$module->components[$component]["forms"][$form_name]["parameters"]["class"];
				for($fields=array(),Reset($module->components[$component]["classes"][$class]["variables"]);GetType($variable=Key($module->components[$component]["classes"][$class]["variables"]))=="string";Next($module->components[$component]["classes"][$class]["variables"]))
				{
					if(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["autocreate"])
					|| IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["autoupdate"]))
						continue;
					$input_name=$variable;
					if(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["type"]))
					{
						$type=$module->components[$component]["classes"][$class]["variables"][$variable]["type"];
						switch($type)
						{
							case "text":
								if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]["defaultvalueformvariable"]))
								{
									$this->DefineFormVariable($compiler,$context,$doforform,$input_name."defaultvalue",$value);
									$context->result[]=array(
										"Data"=>array(
											"Parent"=>$value,
											"Tag"=>"this",
											"Data"=>$module->components[$component]["forms"][$form_name]["variables"][$variable]["defaultvalueformvariable"]
										),
										"Type"=>"XMLTAG"
									);
								}
								break;
							default:
								return($compiler->SetElementError($context->file,$context->path,$type." is not yet a class variable type supported in createobject forms"));
						}
						if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]["label"]))
						{
							$this->DefineFormVariable($compiler,$context,$doforform,$input_name."label",$value);
							if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$value,$module->components[$component]["forms"][$form_name]["variables"][$variable]["label"]))
								return(0);
						}
						if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]["accesskey"]))
						{
							$this->DefineFormVariable($compiler,$context,$doforform,$input_name."accesskey",$value);
							if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$value,$module->components[$component]["forms"][$form_name]["variables"][$variable]["accesskey"]))
								return(0);
						}
					}
					else
					{
						$variable_class=$module->components[$component]["classes"][$class]["variables"][$variable]["class"];
						if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]))
						{
							if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]["defaultvalueformvariable"]))
							{
								$this->DefineFormVariable($compiler,$context,$doforform,$input_name."defaultvalue",$value);
								$context->result[]=array(
									"Data"=>array(
										"Node"=>($conditional=$compiler->GetXMLNode()),
										"Parent"=>$value,
										"Tag"=>"conditional",
										"Indent"=>1
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Node"=>($istrue=$compiler->GetXMLNode()),
										"Parent"=>$conditional,
										"Tag"=>"istrue"
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Parent"=>$istrue,
										"Tag"=>"thisisnotnull",
										"Data"=>$module->components[$component]["forms"][$form_name]["variables"][$variable]["defaultvalueformvariable"]
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Node"=>($then=$compiler->GetXMLNode()),
										"Parent"=>$conditional,
										"Tag"=>"then"
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Node"=>($converttostring=$compiler->GetXMLNode()),
										"Parent"=>$then,
										"Tag"=>"converttostring"
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Node"=>($classvariable=$compiler->GetXMLNode()),
										"Parent"=>$converttostring,
										"Tag"=>$variable_class."classvariable",
										"Indent"=>1
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Node"=>($object=$compiler->GetXMLNode()),
										"Parent"=>$classvariable,
										"Tag"=>"object"
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Parent"=>$object,
										"Tag"=>"this",
										"Data"=>$module->components[$component]["forms"][$form_name]["variables"][$variable]["defaultvalueformvariable"]
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Parent"=>$classvariable,
										"Tag"=>"variable",
										"Data"=>"id"
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Node"=>($else=$compiler->GetXMLNode()),
										"Parent"=>$conditional,
										"Tag"=>"else"
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Parent"=>$else,
										"Tag"=>"emptystring"
									),
									"Type"=>"XMLTAG"
								);
							}
						}
					}
					if(IsSet($module->components[$component]["forms"][$form_name]["validations"][$variable]))
					{
						for($validation=0;$validation<count($module->components[$component]["forms"][$form_name]["validations"][$variable]);$validation++)
						{
							$type=$module->components[$component]["forms"][$form_name]["validations"][$variable][$validation]["type"];
							$code=$module->components[$component]["forms"][$form_name]["validations"][$variable][$validation]["errorcode"];
							switch($type)
							{
								case "notempty":
									$this->DefineFormVariable($compiler,$context,$doforform,"errormessage".$code,$value);
									if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$value,$module->components[$component]["forms"][$form_name]["validations"][$variable][$validation]["message"]))
										return(0);
									break;
								case "unique":
									break;
								default:
									return($compiler->SetElementError($context->file,$context->path,$type." is not yet a supported type of validation for variable ".$variable));
							}
						}
					}
				}

				if(!$this->DefineSubmitInput($module,$compiler,$context,$component,$form_name,$module->components[$component]["forms"][$form_name]["parameters"]["submit"],$fields,$doforform,"submit"))
					return(0);

				if(IsSet($module->components[$component]["forms"][$form_name]["parameters"]["cancel"])
				&& !$this->DefineSubmitInput($module,$compiler,$context,$component,$form_name,$module->components[$component]["forms"][$form_name]["parameters"]["cancel"],$fields,$doforform,"cancel"))
					return(0);

				break;
			default:
				return($compiler->SetElementError($context->file,$context->path,$type." is not yet a supported component form type"));
		}

		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$doforform,
				"Tag"=>"newform",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($return=$compiler->GetXMLNode()),
				"Parent"=>$do,
				"Tag"=>"return"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$return,
				"Tag"=>"true"
			),
			"Type"=>"XMLTAG"
		);
		return(1);
	}

	Function GetFactoryFunctions(&$module,&$compiler,&$context,$component,$type,&$parameters,&$functions,$all=0)
	{
		for($functions=array(),$factory_function=0,Reset($module->components[$component]["factory"]["functions"]);$factory_function<count($module->components[$component]["factory"]["functions"]);$factory_function++,Next($module->components[$component]["factory"]["functions"]))
		{
			$function_name=Key($module->components[$component]["factory"]["functions"]);
			$function_arguments=$module->components[$component]["factory"]["functions"][$function_name];
			if($type==$function_arguments["type"])
			{
				switch($type)
				{
					case "createobject":
						if(!IsSet($function_arguments["parameters"]))
							return($compiler->SetElementError($function_arguments["function"]->file,$function_arguments["function"]->path,"it were not specified the function parameters"));
						$parameter_values=array();
						$required_types=array(
							"class"=>"NAME"
						);
						$optional_types=array();
						if(!$compiler->GetOptionalArgumentValues($function_arguments["parameters"],$parameter_values,$required_types,$optional_types,"persistence","function",1))
							return(0);
						if($parameter_values["class"]==$parameters["class"])
						{
							$functions[$function_name]=$parameter_values;
							if(!$all)
								break 2;
						}
						break;
					case "getobject":
						if(!IsSet($function_arguments["parameters"]))
							return($compiler->SetElementError($function_arguments["function"]->file,$function_arguments["function"]->path,"it were not specified the function parameters"));
						$parameter_values=array();
						$required_types=array(
							"id"=>"CONTEXT",
							"class"=>"NAME"
						);
						$optional_types=array();
						if(!$compiler->GetOptionalArgumentValues($function_arguments["parameters"],$parameter_values,$required_types,$optional_types,"persistence","function",1))
							return(0);
						if(!IsSet($module->components[$component]["classes"][$parameter_values["class"]]))
							return($compiler->SetElementError($function_arguments["parameters"]->file,$function_arguments["parameters"]->path,$values["class"]." is not a valid component class"));
						$id_values=array();
						$required_types=array(
							"argument"=>"NAME"
						);
						$optional_types=array();
						if(!$compiler->GetOptionalArgumentValues($parameter_values["id"],$id_values,$required_types,$optional_types,"persistence","function",1))
							return(0);
						if($parameter_values["class"]==$parameters["class"])
						{
							$functions[$function_name]=$parameter_values;
							$functions[$function_name]["id"]=$id_values;
							if(!$all)
								break 2;
						}
						break;
				}
			}
		}
		return(1);
	}

	Function GetClassFunctions(&$module,&$compiler,&$context,$component,$type,&$parameters,&$functions,$all=0)
	{
		$class=$parameters["class"];
		for($functions=array(),$class_function=0,Reset($module->components[$component]["classes"][$class]["functions"]);$class_function<count($module->components[$component]["classes"][$class]["functions"]);$class_function++,Next($module->components[$component]["classes"][$class]["functions"]))
		{
			$function_name=Key($module->components[$component]["classes"][$class]["functions"]);
			$function_arguments=$module->components[$component]["classes"][$class]["functions"][$function_name];
			if($type==$function_arguments["type"])
			{
				switch($type)
				{
					case "setreference":
						if(!IsSet($function_arguments["parameters"]))
							return($compiler->SetElementError($function_arguments["function"]->file,$function_arguments["function"]->path,"it were not specified the function parameters"));
						$parameter_values=array();
						$required_types=array(
							"variable"=>"NAME",
							"reference"=>"CONTEXT"
						);
						$optional_types=array(
						);
						if(!$compiler->GetOptionalArgumentValues($function_arguments["parameters"],$parameter_values,$required_types,$optional_types,"persistence","function",1))
							return(0);
						$reference_values=array();
						$required_types=array(
							"argument"=>"NAME"
						);
						$optional_types=array();
						if(!$compiler->GetOptionalArgumentValues($parameter_values["reference"],$reference_values,$required_types,$optional_types,"persistence","function",1))
							return(0);
						if($parameter_values["variable"]==$parameters["variable"])
						{
							$functions[$function_name]=$parameter_values;
							$functions[$function_name]["reference"]=$reference_values;
							if(!$all)
								break 2;
						}
						break;

					case "persist":
						$functions[$function_name]=array();
						if(!$all)
							break 2;
						break;

					case "validate":
						if(!IsSet($function_arguments["parameters"]))
							return($compiler->SetElementError($function_arguments["function"]->file,$function_arguments["function"]->path,"it were not specified the function parameters"));
						$parameter_values=array();
						$required_types=array(
							"errorcode"=>"CONTEXT"
						);
						$optional_types=array(
						);
						if(!$compiler->GetOptionalArgumentValues($function_arguments["parameters"],$parameter_values,$required_types,$optional_types,"persistence","function",1))
							return(0);
						$error_code_values=array();
						$required_types=array(
							"argument"=>"NAME"
						);
						$optional_types=array();
						if(!$compiler->GetOptionalArgumentValues($parameter_values["errorcode"],$error_code_values,$required_types,$optional_types,"persistence","function",1))
							return(0);
						$functions[$function_name]=$parameter_values;
						$functions[$function_name]["errorcode"]=$error_code_values;
						if(!$all)
							break 2;
						break;
				}
			}
		}
		return(1);
	}

	Function GenerateProcessFunction(&$module,&$compiler,&$context,$class_node,$component,$form_name)
	{
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($function_node=$compiler->GetXMLNode()),
				"Parent"=>$class_node,
				"Tag"=>"function",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$function_node,
				"Tag"=>"name",
				"Data"=>"process"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$function_node,
				"Tag"=>"type",
				"Data"=>"BOOLEAN"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($do=$compiler->GetXMLNode()),
				"Parent"=>$function_node,
				"Tag"=>"do",
				"Indent"=>1,
				"Spacing"=>1
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($if=$compiler->GetXMLNode()),
				"Parent"=>$do,
				"Tag"=>"if",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($istrue=$compiler->GetXMLNode()),
				"Parent"=>$if,
				"Tag"=>"istrue",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($length=$compiler->GetXMLNode()),
				"Parent"=>$istrue,
				"Tag"=>"length"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$length,
				"Tag"=>"this",
				"Data"=>"error"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$istrue,
				"Tag"=>"more"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$istrue,
				"Tag"=>"zero"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($then=$compiler->GetXMLNode()),
				"Parent"=>$if,
				"Tag"=>"then",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($return=$compiler->GetXMLNode()),
				"Parent"=>$then,
				"Tag"=>"return"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$return,
				"Tag"=>"false"
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($forform=$compiler->GetXMLNode()),
				"Parent"=>$do,
				"Tag"=>"for".$form_name."form",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($object=$compiler->GetXMLNode()),
				"Parent"=>$forform,
				"Tag"=>"object"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$object,
				"Tag"=>"this",
				"Data"=>"form"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($doforform=$compiler->GetXMLNode()),
				"Parent"=>$forform,
				"Tag"=>"do",
				"Indent"=>1,
				"Spacing"=>1
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($void=$compiler->GetXMLNode()),
				"Parent"=>$doforform,
				"Tag"=>"void"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$void,
				"Tag"=>"loadforminputvalues"
			),
			"Type"=>"XMLTAG"
		);

		$type=$module->components[$component]["forms"][$form_name]["type"];
		switch($type)
		{
			case "createobject":
				$class=$module->components[$component]["forms"][$form_name]["parameters"]["class"];
				if(IsSet($module->components[$component]["forms"][$form_name]["parameters"]["cancel"]))
				{
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($set=$compiler->GetXMLNode()),
							"Parent"=>$doforform,
							"Tag"=>"set",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$set,
							"Tag"=>"this",
							"Data"=>"processed"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$set,
							"Tag"=>"false"
						),
						"Type"=>"XMLTAG"
					);

					$context->result[]=array(
						"Data"=>array(
							"Node"=>($set=$compiler->GetXMLNode()),
							"Parent"=>$doforform,
							"Tag"=>"set",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$set,
							"Tag"=>"this",
							"Data"=>"canceled"
						),
						"Type"=>"XMLTAG"
					);
					$cancel_values=$module->components[$component]["forms"][$form_name]["parameters"]["cancel"];
					$input_name=(IsSet($cancel_values["field"]) ? $cancel_values["field"] : "cancel");
					if(IsSet($cancel_values["value"]))
					{
						if(IsSet($cancel_values["image"]))
						{
							$context->result[]=array(
								"Data"=>array(
									"Node"=>($group=$compiler->GetXMLNode()),
									"Parent"=>$set,
									"Tag"=>"group",
									"Indent"=>1
								),
								"Type"=>"XMLTAG"
							);
							$set=$group;
						}
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($formwassubmitted=$compiler->GetXMLNode()),
								"Parent"=>$set,
								"Tag"=>"formwassubmitted",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($input=$compiler->GetXMLNode()),
								"Parent"=>$formwassubmitted,
								"Tag"=>"input"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$input,
								"Tag"=>"string",
								"Data"=>$input_name
							),
							"Type"=>"XMLTAG"
						);
						if(IsSet($cancel_values["image"]))
						{
							$context->result[]=array(
								"Data"=>array(
									"Parent"=>$set,
									"Tag"=>"or"
								),
								"Type"=>"XMLTAG"
							);
						}
					}
					if(IsSet($cancel_values["image"]))
					{
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($formwassubmitted=$compiler->GetXMLNode()),
								"Parent"=>$set,
								"Tag"=>"formwassubmitted",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($input=$compiler->GetXMLNode()),
								"Parent"=>$formwassubmitted,
								"Tag"=>"input"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$input,
								"Tag"=>"string",
								"Data"=>$input_name."image"
							),
							"Type"=>"XMLTAG"
						);
					}

					$context->result[]=array(
						"Data"=>array(
							"Node"=>($if=$compiler->GetXMLNode()),
							"Parent"=>$doforform,
							"Tag"=>"if",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($istrue=$compiler->GetXMLNode()),
							"Parent"=>$if,
							"Tag"=>"istrue",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$istrue,
							"Tag"=>"this",
							"Data"=>"canceled"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$istrue,
							"Tag"=>"or"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($not=$compiler->GetXMLNode()),
							"Parent"=>$istrue,
							"Tag"=>"not"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($formwassubmitted=$compiler->GetXMLNode()),
							"Parent"=>$not,
							"Tag"=>"formwassubmitted",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($input=$compiler->GetXMLNode()),
							"Parent"=>$formwassubmitted,
							"Tag"=>"input"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$input,
							"Tag"=>"string",
							"Data"=>"submit"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($then=$compiler->GetXMLNode()),
							"Parent"=>$if,
							"Tag"=>"then",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($return=$compiler->GetXMLNode()),
							"Parent"=>$then,
							"Tag"=>"return"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$return,
							"Tag"=>"true"
						),
						"Type"=>"XMLTAG"
					);
				}

				$context->result[]=array(
					"Data"=>array(
						"Node"=>($set=$compiler->GetXMLNode()),
						"Parent"=>$doforform,
						"Tag"=>"set",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				if(IsSet($module->components[$component]["forms"][$form_name]["errormessage"]))
				{
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$set,
							"Tag"=>"this",
							"Data"=>$module->components[$component]["forms"][$form_name]["errormessage"]["formvariable"]
						),
						"Type"=>"XMLTAG"
					);
				}
				else
				{
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$set,
							"Tag"=>"variable",
							"Data"=>"errormessage"
						),
						"Type"=>"XMLTAG"
					);
				}
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($validateform=$compiler->GetXMLNode()),
						"Parent"=>$set,
						"Tag"=>"validateform",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($verifyfields=$compiler->GetXMLNode()),
						"Parent"=>$validateform,
						"Tag"=>"verifyfields"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$verifyfields,
						"Tag"=>"this",
						"Data"=>"verify"
					),
					"Type"=>"XMLTAG"
				);

				$context->result[]=array(
					"Data"=>array(
						"Node"=>($if=$compiler->GetXMLNode()),
						"Parent"=>$doforform,
						"Tag"=>"if",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($istrue=$compiler->GetXMLNode()),
						"Parent"=>$if,
						"Tag"=>"istrue",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($length=$compiler->GetXMLNode()),
						"Parent"=>$istrue,
						"Tag"=>"length"
					),
					"Type"=>"XMLTAG"
				);
				if(IsSet($module->components[$component]["forms"][$form_name]["errormessage"]))
				{
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$length,
							"Tag"=>"this",
							"Data"=>$module->components[$component]["forms"][$form_name]["errormessage"]["formvariable"]
						),
						"Type"=>"XMLTAG"
					);
				}
				else
				{
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$length,
							"Tag"=>"variable",
							"Data"=>"errormessage"
						),
						"Type"=>"XMLTAG"
					);
				}
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$istrue,
						"Tag"=>"more"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$istrue,
						"Tag"=>"zero"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($errormessagethen=$compiler->GetXMLNode()),
						"Parent"=>$if,
						"Tag"=>"then",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);

				$context->result[]=array(
					"Data"=>array(
						"Node"=>($return=$compiler->GetXMLNode()),
						"Parent"=>$errormessagethen,
						"Tag"=>"return"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$return,
						"Tag"=>"true"
					),
					"Type"=>"XMLTAG"
				);

				$parameters=array("class"=>$class);
				if(!$this->GetFactoryFunctions($module,$compiler,$context,$component,"createobject",$parameters,$functions))
					return(0);
				if(count($functions)==0)
					return($compiler->SetElementError($context->file,$context->path,"the factory class does not provide a createobject function for class ".$class." that is necessary to implement the form class ".$form_name));
				Reset($functions);
				$create_function=Key($functions);

				$context->result[]=array(
					"Data"=>array(
						"Node"=>($set=$compiler->GetXMLNode()),
						"Parent"=>$doforform,
						"Tag"=>"set",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$set,
						"Tag"=>"this",
						"Data"=>$class
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($call=$compiler->GetXMLNode()),
						"Parent"=>$set,
						"Tag"=>"call".$component."class"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($object=$compiler->GetXMLNode()),
						"Parent"=>$call,
						"Tag"=>"object"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$object,
						"Tag"=>"this",
						"Data"=>"factory"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$call,
						"Tag"=>"function",
						"Data"=>$create_function
					),
					"Type"=>"XMLTAG"
				);

				$context->result[]=array(
					"Data"=>array(
						"Node"=>($if=$compiler->GetXMLNode()),
						"Parent"=>$doforform,
						"Tag"=>"if",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($istrue=$compiler->GetXMLNode()),
						"Parent"=>$if,
						"Tag"=>"istrue",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($isnull=$compiler->GetXMLNode()),
						"Parent"=>$istrue,
						"Tag"=>"isnull"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$isnull,
						"Tag"=>"this",
						"Data"=>$class
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($nullobjectthen=$compiler->GetXMLNode()),
						"Parent"=>$if,
						"Tag"=>"then",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);

				$context->result[]=array(
					"Data"=>array(
						"Node"=>($set=$compiler->GetXMLNode()),
						"Parent"=>$nullobjectthen,
						"Tag"=>"set",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$set,
						"Tag"=>"this",
						"Data"=>"error"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($classvariable=$compiler->GetXMLNode()),
						"Parent"=>$set,
						"Tag"=>$component."classvariable",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($object=$compiler->GetXMLNode()),
						"Parent"=>$classvariable,
						"Tag"=>"object"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$object,
						"Tag"=>"this",
						"Data"=>"factory"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$classvariable,
						"Tag"=>"variable",
						"Data"=>"error"
					),
					"Type"=>"XMLTAG"
				);

				$context->result[]=array(
					"Data"=>array(
						"Node"=>($return=$compiler->GetXMLNode()),
						"Parent"=>$nullobjectthen,
						"Tag"=>"return"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$return,
						"Tag"=>"false"
					),
					"Type"=>"XMLTAG"
				);

				for(Reset($module->components[$component]["classes"][$class]["variables"]);GetType($variable=Key($module->components[$component]["classes"][$class]["variables"]))=="string";Next($module->components[$component]["classes"][$class]["variables"]))
				{
					$input=$variable;

					if(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["autocreate"])
					|| IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["autoupdate"]))
						continue;
					if(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["type"]))
					{
						$type=$module->components[$component]["classes"][$class]["variables"][$variable]["type"];
						switch($type)
						{
							case "text":
								$context->result[]=array(
									"Data"=>array(
										"Node"=>($set=$compiler->GetXMLNode()),
										"Parent"=>$doforform,
										"Tag"=>"set",
										"Indent"=>1
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Node"=>($classvariable=$compiler->GetXMLNode()),
										"Parent"=>$set,
										"Tag"=>$class."classvariable",
										"Indent"=>1
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Node"=>($object=$compiler->GetXMLNode()),
										"Parent"=>$classvariable,
										"Tag"=>"object"
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Parent"=>$object,
										"Tag"=>"this",
										"Data"=>$class
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Parent"=>$classvariable,
										"Tag"=>"variable",
										"Data"=>$variable
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Node"=>($getforminputvalue=$compiler->GetXMLNode()),
										"Parent"=>$set,
										"Tag"=>"getforminputvalue"
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Parent"=>$getforminputvalue,
										"Tag"=>"input",
										"Data"=>$input
									),
									"Type"=>"XMLTAG"
								);
								break;
							default:
								return($compiler->SetElementError($context->file,$context->path,$type." is not yet a class variable type supported in createobject forms"));
						}
					}
					else
					{
						$parameters=array("class"=>$module->components[$component]["classes"][$class]["variables"][$variable]["class"]);
						if(!$this->GetFactoryFunctions($module,$compiler,$context,$component,"getobject",$parameters,$functions))
							return(0);
						if(count($functions)==0)
							return($compiler->SetElementError($context->file,$context->path,"the factory class does not provide a getobject function for class ".$parameters["class"]." that is necessary to implement the form class ".$form_name));
						Reset($functions);
						$getobject_function=Key($functions);
						$id_parameter=$functions[$getobject_function]["id"]["argument"];

						$context->result[]=array(
							"Data"=>array(
								"Node"=>($set=$compiler->GetXMLNode()),
								"Parent"=>$doforform,
								"Tag"=>"set",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$set,
								"Tag"=>"variable",
								"Data"=>"value"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($getforminputvalue=$compiler->GetXMLNode()),
								"Parent"=>$set,
								"Tag"=>"getforminputvalue"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$getforminputvalue,
								"Tag"=>"input",
								"Data"=>$input
							),
							"Type"=>"XMLTAG"
						);

						$context->result[]=array(
							"Data"=>array(
								"Node"=>($isvalidintegerif=$compiler->GetXMLNode()),
								"Parent"=>$doforform,
								"Tag"=>"if",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($istrue=$compiler->GetXMLNode()),
								"Parent"=>$isvalidintegerif,
								"Tag"=>"istrue",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($isvalidinteger=$compiler->GetXMLNode()),
								"Parent"=>$istrue,
								"Tag"=>"isvalidinteger"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$isvalidinteger,
								"Tag"=>"variable",
								"Data"=>"value"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($isvalidintegerthen=$compiler->GetXMLNode()),
								"Parent"=>$isvalidintegerif,
								"Tag"=>"then",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);

						$context->result[]=array(
							"Data"=>array(
								"Node"=>($set=$compiler->GetXMLNode()),
								"Parent"=>$isvalidintegerthen,
								"Tag"=>"set",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$set,
								"Tag"=>"variable",
								"Data"=>$class."reference"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($callclass=$compiler->GetXMLNode()),
								"Parent"=>$set,
								"Tag"=>"call".$component."class",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($object=$compiler->GetXMLNode()),
								"Parent"=>$callclass,
								"Tag"=>"object"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$object,
								"Tag"=>"this",
								"Data"=>"factory"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$callclass,
								"Tag"=>"function",
								"Data"=>$getobject_function
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($arguments=$compiler->GetXMLNode()),
								"Parent"=>$callclass,
								"Tag"=>"arguments",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($id=$compiler->GetXMLNode()),
								"Parent"=>$arguments,
								"Tag"=>$id_parameter
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($converttointeger=$compiler->GetXMLNode()),
								"Parent"=>$id,
								"Tag"=>"converttointeger"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$converttointeger,
								"Tag"=>"variable",
								"Data"=>"value"
							),
							"Type"=>"XMLTAG"
						);

						$context->result[]=array(
							"Data"=>array(
								"Node"=>($nullreferenceif=$compiler->GetXMLNode()),
								"Parent"=>$isvalidintegerthen,
								"Tag"=>"if",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($istrue=$compiler->GetXMLNode()),
								"Parent"=>$nullreferenceif,
								"Tag"=>"istrue",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($isnull=$compiler->GetXMLNode()),
								"Parent"=>$istrue,
								"Tag"=>"isnull"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$isnull,
								"Tag"=>"variable",
								"Data"=>$class."reference"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($nullobjectthen=$compiler->GetXMLNode()),
								"Parent"=>$nullreferenceif,
								"Tag"=>"then",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);

						$context->result[]=array(
							"Data"=>array(
								"Node"=>($set=$compiler->GetXMLNode()),
								"Parent"=>$nullobjectthen,
								"Tag"=>"set",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$set,
								"Tag"=>"this",
								"Data"=>"error"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($classvariable=$compiler->GetXMLNode()),
								"Parent"=>$set,
								"Tag"=>$component."classvariable",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($object=$compiler->GetXMLNode()),
								"Parent"=>$classvariable,
								"Tag"=>"object"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$object,
								"Tag"=>"this",
								"Data"=>"factory"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$classvariable,
								"Tag"=>"variable",
								"Data"=>"error"
							),
							"Type"=>"XMLTAG"
						);

						$context->result[]=array(
							"Data"=>array(
								"Node"=>($return=$compiler->GetXMLNode()),
								"Parent"=>$nullobjectthen,
								"Tag"=>"return"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$return,
								"Tag"=>"false"
							),
							"Type"=>"XMLTAG"
						);

						$context->result[]=array(
							"Data"=>array(
								"Node"=>($isvalidintegerelse=$compiler->GetXMLNode()),
								"Parent"=>$isvalidintegerif,
								"Tag"=>"else",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($set=$compiler->GetXMLNode()),
								"Parent"=>$isvalidintegerelse,
								"Tag"=>"set",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$set,
								"Tag"=>"variable",
								"Data"=>$class."reference"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$set,
								"Tag"=>"nullobject"
							),
							"Type"=>"XMLTAG"
						);

						$parameters=array("class"=>$class,"variable"=>$variable);
						if(!$this->GetClassFunctions($module,$compiler,$context,$component,"setreference",$parameters,$functions))
							return(0);
						if(count($functions)==0)
							return($compiler->SetElementError($context->file,$context->path,"the class ".$class." does not provide a setreference function for variable ".$variable." that is necessary to implement the form class ".$form_name));
						Reset($functions);
						$setreference_function=Key($functions);
						$reference_parameter=$functions[$setreference_function]["reference"]["argument"];

						$context->result[]=array(
							"Data"=>array(
								"Node"=>($callclass=$compiler->GetXMLNode()),
								"Parent"=>$doforform,
								"Tag"=>"call".$class."class",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($object=$compiler->GetXMLNode()),
								"Parent"=>$callclass,
								"Tag"=>"object"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$object,
								"Tag"=>"this",
								"Data"=>$class
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$callclass,
								"Tag"=>"function",
								"Data"=>$setreference_function
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($arguments=$compiler->GetXMLNode()),
								"Parent"=>$callclass,
								"Tag"=>"arguments",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($reference=$compiler->GetXMLNode()),
								"Parent"=>$arguments,
								"Tag"=>$reference_parameter
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$reference,
								"Tag"=>"variable",
								"Data"=>$class."reference"
							),
							"Type"=>"XMLTAG"
						);
					}
				}

				if(count($module->components[$component]["forms"][$form_name]["validations"]))
				{
					$parameters=array("class"=>$class);
					if(!$this->GetClassFunctions($module,$compiler,$context,$component,"validate",$parameters,$functions))
						return(0);
					if(count($functions)==0)
						return($compiler->SetElementError($context->file,$context->path,"the class ".$class." does not provide a validate function that is necessary to implement the form class ".$form_name));
					Reset($functions);
					$validate_function=Key($functions);
					$errorcode_parameter=$functions[$validate_function]["errorcode"]["argument"];

					$context->result[]=array(
						"Data"=>array(
							"Node"=>($if=$compiler->GetXMLNode()),
							"Parent"=>$doforform,
							"Tag"=>"if",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($isfalse=$compiler->GetXMLNode()),
							"Parent"=>$if,
							"Tag"=>"isfalse",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($callclass=$compiler->GetXMLNode()),
							"Parent"=>$isfalse,
							"Tag"=>"call".$class."class",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($object=$compiler->GetXMLNode()),
							"Parent"=>$callclass,
							"Tag"=>"object"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$object,
							"Tag"=>"this",
							"Data"=>$class
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$callclass,
							"Tag"=>"function",
							"Data"=>$validate_function
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($arguments=$compiler->GetXMLNode()),
							"Parent"=>$callclass,
							"Tag"=>"arguments",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($errorcode=$compiler->GetXMLNode()),
							"Parent"=>$arguments,
							"Tag"=>$errorcode_parameter
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$errorcode,
							"Tag"=>"variable",
							"Data"=>"errorcode"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($validatethen=$compiler->GetXMLNode()),
							"Parent"=>$if,
							"Tag"=>"then",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);

					$context->result[]=array(
						"Data"=>array(
							"Node"=>($set=$compiler->GetXMLNode()),
							"Parent"=>$validatethen,
							"Tag"=>"set",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$set,
							"Tag"=>"this",
							"Data"=>"error"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($classvariable=$compiler->GetXMLNode()),
							"Parent"=>$set,
							"Tag"=>$component."classvariable",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($object=$compiler->GetXMLNode()),
							"Parent"=>$classvariable,
							"Tag"=>"object"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$object,
							"Tag"=>"this",
							"Data"=>"factory"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$classvariable,
							"Tag"=>"variable",
							"Data"=>"error"
						),
						"Type"=>"XMLTAG"
					);

					$context->result[]=array(
						"Data"=>array(
							"Node"=>($return=$compiler->GetXMLNode()),
							"Parent"=>$validatethen,
							"Tag"=>"return"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$return,
							"Tag"=>"false"
						),
						"Type"=>"XMLTAG"
					);

					$context->result[]=array(
						"Data"=>array(
							"Node"=>($switch=$compiler->GetXMLNode()),
							"Parent"=>$doforform,
							"Tag"=>"switch",
							"Indent"=>1,
							"Spacing"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($value=$compiler->GetXMLNode()),
							"Parent"=>$switch,
							"Tag"=>"value"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($buffervalue=$compiler->GetXMLNode()),
							"Parent"=>$value,
							"Tag"=>"buffervalue"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$buffervalue,
							"Tag"=>"variable",
							"Data"=>"errorcode"
						),
						"Type"=>"XMLTAG"
					);

					$context->result[]=array(
						"Data"=>array(
							"Node"=>($case=$compiler->GetXMLNode()),
							"Parent"=>$switch,
							"Tag"=>"case",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($value=$compiler->GetXMLNode()),
							"Parent"=>$case,
							"Tag"=>"value",
							"Data"=>"0"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($casedo=$compiler->GetXMLNode()),
							"Parent"=>$case,
							"Tag"=>"do",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$casedo,
							"Tag"=>"break"
						),
						"Type"=>"XMLTAG"
					);

					for(Reset($module->components[$component]["forms"][$form_name]["errors"]);GetType($error_code=Key($module->components[$component]["forms"][$form_name]["errors"]))=="integer";Next($module->components[$component]["forms"][$form_name]["errors"]))
					{
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($case=$compiler->GetXMLNode()),
								"Parent"=>$switch,
								"Tag"=>"case",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($value=$compiler->GetXMLNode()),
								"Parent"=>$case,
								"Tag"=>"value",
								"Data"=>$error_code
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($casedo=$compiler->GetXMLNode()),
								"Parent"=>$case,
								"Tag"=>"do",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);

						if(IsSet($module->components[$component]["forms"][$form_name]["errormessage"]))
						{
							$context->result[]=array(
								"Data"=>array(
									"Node"=>($set=$compiler->GetXMLNode()),
									"Parent"=>$casedo,
									"Tag"=>"set",
									"Indent"=>1
								),
								"Type"=>"XMLTAG"
							);
							$context->result[]=array(
								"Data"=>array(
									"Parent"=>$set,
									"Tag"=>"this",
									"Data"=>$module->components[$component]["forms"][$form_name]["errormessage"]["formvariable"]
								),
								"Type"=>"XMLTAG"
							);
							if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$set,$module->components[$component]["forms"][$form_name]["errors"][$error_code]["message"]))
								return(0);
						}

						for(Reset($module->components[$component]["forms"][$form_name]["errors"][$error_code]["variables"]);GetType($error_variable_name=Key($module->components[$component]["forms"][$form_name]["errors"][$error_code]["variables"]))=="string";Next($module->components[$component]["forms"][$form_name]["errors"][$error_code]["variables"]))
						{
							if(IsSet($module->components[$component]["classes"][$class]["variables"][$error_variable_name]["type"]))
							{
								$context->result[]=array(
									"Data"=>array(
										"Node"=>($setentry=$compiler->GetXMLNode()),
										"Parent"=>$casedo,
										"Tag"=>"setentry",
										"Indent"=>1
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Parent"=>$setentry,
										"Tag"=>"this",
										"Data"=>"verify"
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Parent"=>$setentry,
										"Tag"=>"string",
										"Data"=>$error_variable_name
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Parent"=>$setentry,
										"Tag"=>"emptystring"
									),
									"Type"=>"XMLTAG"
								);
							}
						}

						$context->result[]=array(
							"Data"=>array(
								"Node"=>($return=$compiler->GetXMLNode()),
								"Parent"=>$casedo,
								"Tag"=>"return"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$return,
								"Tag"=>"false"
							),
							"Type"=>"XMLTAG"
						);
					}

					$context->result[]=array(
						"Data"=>array(
							"Node"=>($default=$compiler->GetXMLNode()),
							"Parent"=>$switch,
							"Tag"=>"default",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($defaultdo=$compiler->GetXMLNode()),
							"Parent"=>$default,
							"Tag"=>"do",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($set=$compiler->GetXMLNode()),
							"Parent"=>$defaultdo,
							"Tag"=>"set",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$set,
							"Tag"=>"this",
							"Data"=>"error"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($stringdata=$compiler->GetXMLNode()),
							"Parent"=>$set,
							"Tag"=>"stringdata"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($converttostring=$compiler->GetXMLNode()),
							"Parent"=>$stringdata,
							"Tag"=>"converttostring"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($buffervalue=$compiler->GetXMLNode()),
							"Parent"=>$converttostring,
							"Tag"=>"buffervalue"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$buffervalue,
							"Tag"=>"variable",
							"Data"=>"errorcode"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$stringdata,
							"Data"=>"is not a expected ".$class." class object validate error code"
						),
						"Type"=>"XMLDATA"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($return=$compiler->GetXMLNode()),
							"Parent"=>$defaultdo,
							"Tag"=>"return"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$return,
							"Tag"=>"false"
						),
						"Type"=>"XMLTAG"
					);
				}

				$parameters=array("class"=>$class);
				if(!$this->GetClassFunctions($module,$compiler,$context,$component,"persist",$parameters,$functions))
					return(0);
				if(count($functions)==0)
					return($compiler->SetElementError($context->file,$context->path,"the class ".$class." does not provide a persist function that is necessary to implement the form class ".$form_name));
				Reset($functions);
				$persist_function=Key($functions);

				$context->result[]=array(
					"Data"=>array(
						"Node"=>($if=$compiler->GetXMLNode()),
						"Parent"=>$doforform,
						"Tag"=>"if",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($isfalse=$compiler->GetXMLNode()),
						"Parent"=>$if,
						"Tag"=>"isfalse",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($callclass=$compiler->GetXMLNode()),
						"Parent"=>$isfalse,
						"Tag"=>"call".$class."class",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($object=$compiler->GetXMLNode()),
						"Parent"=>$callclass,
						"Tag"=>"object"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$object,
						"Tag"=>"this",
						"Data"=>$class
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$callclass,
						"Tag"=>"function",
						"Data"=>$persist_function
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($persistthen=$compiler->GetXMLNode()),
						"Parent"=>$if,
						"Tag"=>"then",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);

				$context->result[]=array(
					"Data"=>array(
						"Node"=>($set=$compiler->GetXMLNode()),
						"Parent"=>$persistthen,
						"Tag"=>"set",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$set,
						"Tag"=>"this",
						"Data"=>"error"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($classvariable=$compiler->GetXMLNode()),
						"Parent"=>$set,
						"Tag"=>$component."classvariable",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($object=$compiler->GetXMLNode()),
						"Parent"=>$classvariable,
						"Tag"=>"object"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$object,
						"Tag"=>"this",
						"Data"=>"factory"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$classvariable,
						"Tag"=>"variable",
						"Data"=>"error"
					),
					"Type"=>"XMLTAG"
				);

				$context->result[]=array(
					"Data"=>array(
						"Node"=>($return=$compiler->GetXMLNode()),
						"Parent"=>$persistthen,
						"Tag"=>"return"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$return,
						"Tag"=>"false"
					),
					"Type"=>"XMLTAG"
				);
				break;

			default:
				return($compiler->SetElementError($context->file,$context->path,$type." is not yet a supported component form type"));
		}

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($set=$compiler->GetXMLNode()),
				"Parent"=>$do,
				"Tag"=>"set",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$set,
				"Tag"=>"this",
				"Data"=>"processed"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$set,
				"Tag"=>"true"
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($return=$compiler->GetXMLNode()),
				"Parent"=>$do,
				"Tag"=>"return"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$return,
				"Tag"=>"true"
			),
			"Type"=>"XMLTAG"
		);
		return(1);
	}

	Function GenerateParserVariableValue(&$module,&$compiler,&$context,$component,$form_name,&$parser,$variable_node,$variable_file,$variable_element_path)
	{
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($stringdata=$compiler->GetXMLNode()),
				"Parent"=>$variable_node,
				"Tag"=>"stringdata"
			),
			"Type"=>"XMLTAG"
		);
		$value_elements=$parser->structure[$variable_element_path]["Elements"];
		for($value_element=0;$value_element<$value_elements;$value_element++)
		{
			$value_element_path=$variable_element_path.",".$value_element;
			$element_data=$parser->structure[$value_element_path];
			if(GetType($element_data)=="array")
			{
				switch($element_data["Tag"])
				{
					case "errormessage":
						if(!IsSet($module->components[$component]["forms"][$form_name]["errormessage"]))
							return($compiler->SetElementError($variable_file,$value_element_path,"it was not defined the form error message variable"));
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($converthtmlentities=$compiler->GetXMLNode()),
								"Parent"=>$stringdata,
								"Tag"=>"converthtmlentities"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$converthtmlentities,
								"Tag"=>"this",
								"Data"=>$module->components[$component]["forms"][$form_name]["errormessage"]["formvariable"]
							),
							"Type"=>"XMLTAG"
						);
						break;
					case "formvariable":
						if(!$compiler->GetValidData($variable_file,$value_element_path,$variable,"it was not specified a valid class variable"))
							return(0);
						if(!IsSet($module->components[$component]["forms"][$form_name]["formvariables"][$variable]))
							return($compiler->SetElementError($variable_file,$value_element_path,$variable." is not a defined form variable"));
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$stringdata,
								"Tag"=>"this",
								"Data"=>$variable
							),
							"Type"=>"XMLTAG"
						);
						break;
					case "formtext":
						if(!$compiler->GetValidData($variable_file,$value_element_path,$text,"it was not specified a valid form text"))
							return(0);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($stringentry=$compiler->GetXMLNode()),
								"Parent"=>$stringdata,
								"Tag"=>"stringentry",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$stringentry,
								"Tag"=>"this",
								"Data"=>"text"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$stringentry,
								"Tag"=>"string",
								"Data"=>$text
							),
							"Type"=>"XMLTAG"
						);
						break;
					case "skinclip":
						if(!IsSet($module->components[$component]["forms"][$form_name]["skin"]))
							return($compiler->SetElementError($variable_file,$value_element_path,"it was not a specified a skin for the form ".$form_name));
						if(!$compiler->GetValidData($variable_file,$value_element_path,$clip,"it was not specified a valid class variable"))
							return(0);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($skinclip=$compiler->GetXMLNode()),
								"Parent"=>$stringdata,
								"Tag"=>$form_name."formskinclip",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$skinclip,
								"Tag"=>"clip",
								"Data"=>$clip
							),
							"Type"=>"XMLTAG"
						);
						if(IsSet($module->components[$component]["forms"][$form_name]["imagespath"]))
						{
							$context->result[]=array(
								"Data"=>array(
									"Node"=>($optional=$compiler->GetXMLNode()),
									"Parent"=>$skinclip,
									"Tag"=>"optional",
									"Indent"=>1
								),
								"Type"=>"XMLTAG"
							);
							$context->result[]=array(
								"Data"=>array(
									"Node"=>($images_path=$compiler->GetXMLNode()),
									"Parent"=>$optional,
									"Tag"=>"imagespath"
								),
								"Type"=>"XMLTAG"
							);
							if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$images_path,$module->components[$component]["forms"][$form_name]["imagespath"]))
								return(0);
						}
						break;
					case "conditional":
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($conditional=$compiler->GetXMLNode()),
								"Parent"=>$stringdata,
								"Tag"=>"conditional",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$compiler->CreateFileContext($conditional_context,$variable_file);
						$conditional_context->path=$value_element_path;
						if(!$this->GenerateConditional($module,$compiler,$context,$component,$form_name,$parser,$conditional_context,$conditional))
							return(0);
						break;
					case "objectvariable":
						$values=array();
						$required_types=array(
							"formvariable"=>"NAME",
							"variable"=>"NAME"
						);
						$optional_types=array(
						);
						$compiler->CreateFileContext($conditional_context,$variable_file);
						$conditional_context->path=$value_element_path;
						if(!$compiler->GetOptionalArgumentValues($conditional_context,$values,$required_types,$optional_types,"persistence","form",1))
							return(0);
						$form_variable=$values["formvariable"];
						if(!IsSet($module->components[$component]["forms"][$form_name]["formvariables"][$form_variable]))
							return($compiler->SetElementError($variable_file,$value_element_path,$variable." is not a defined form variable"));
						if(!IsSet($module->components[$component]["forms"][$form_name]["formvariables"][$form_variable]["class"]))
							return($compiler->SetElementError($variable_file,$value_element_path,$form_variable." is not object form variable"));
						$class=$module->components[$component]["forms"][$form_name]["formvariables"][$form_variable]["class"];
						$variable=$values["variable"];
						if(!IsSet($module->components[$component]["classes"][$class]["variables"][$variable]))
							return($compiler->SetElementError($variable_file,$value_element_path,$variable." is not a variable of the class of the specified object form variable"));
						if(!IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["type"]))
							return($compiler->SetElementError($variable_file,$value_element_path,"object variables are not supported as template values"));
						$type=$module->components[$component]["classes"][$class]["variables"][$variable]["type"];
						switch($type)
						{
							case "text":
								$context->result[]=array(
									"Data"=>array(
										"Node"=>($converthtmlentities=$compiler->GetXMLNode()),
										"Parent"=>$stringdata,
										"Tag"=>"converthtmlentities"
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Node"=>($classvariable=$compiler->GetXMLNode()),
										"Parent"=>$converthtmlentities,
										"Tag"=>$class."classvariable",
										"Indent"=>1
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Node"=>($object=$compiler->GetXMLNode()),
										"Parent"=>$classvariable,
										"Tag"=>"object"
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Parent"=>$object,
										"Tag"=>"this",
										"Data"=>$form_variable
									),
									"Type"=>"XMLTAG"
								);
								$context->result[]=array(
									"Data"=>array(
										"Node"=>($variable_node=$compiler->GetXMLNode()),
										"Parent"=>$classvariable,
										"Tag"=>"variable",
										"Data"=>$variable
									),
									"Type"=>"XMLTAG"
								);
								break;
							default:
								return($compiler->SetElementError($variable_file,$value_element_path,"object variables of type ".$type." are not yet supported as template values"));
						}
						break;
					case "roleimage":
						if(!$compiler->GetValidData($variable_file,$value_element_path,$role,"it was not specified a valid theme image"))
							return(0);
						for(Reset($module->components[$component]["forms"][$form_name]["images"]);GetType($image=Key($module->components[$component]["forms"][$form_name]["images"]))=="string";Next($module->components[$component]["forms"][$form_name]["images"]))
						{
							if(IsSet($module->components[$component]["forms"][$form_name]["images"][$image]["role"])
							&& !strcmp($module->components[$component]["forms"][$form_name]["images"][$image]["role"],$role))
							{
								$context->result[]=array(
									"Data"=>array(
										"Parent"=>$stringdata,
										"Data"=>$image
									),
									"Type"=>"XMLDATA"
								);
								break 2;
							}
						}
						return($compiler->SetElementError($variable_file,$value_element_path,"it was not defined a form image with role ".$role));
					default:
						return($compiler->SetElementError($variable_file,$value_element_path,$element_data["Tag"]." is not yet a supported form template expression type"));
				}
			}
			else
			{
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$stringdata,
						"Data"=>$element_data
					),
					"Type"=>"XMLDATA"
				);
			}
		}
		return(1);
	}

	Function GenerateVariableValue(&$module,&$compiler,&$context,$component,$form_name,$variable_node,&$variable_values)
	{
		$compiler->GetParser($variable_parser,$variable_values->file);
		return($this->GenerateParserVariableValue($module,$compiler,$context,$component,$form_name,$variable_parser,$variable_node,$variable_values->file,$variable_values->path));
	}

	Function GenerateParserConditionValue(&$module,&$compiler,&$context,$component,$form_name,&$parser,$condition_node,$condition_file,$condition_element_path)
	{
		$value_elements=$parser->structure[$condition_element_path]["Elements"];
		for($value_element=0;$value_element<$value_elements;$value_element++)
		{
			$value_element_path=$condition_element_path.",".$value_element;
			$element_data=$parser->structure[$value_element_path];
			if(GetType($element_data)=="array")
			{
				switch($element_data["Tag"])
				{
					case "errormessageset":
						if(!IsSet($module->components[$component]["forms"][$form_name]["errormessage"]))
							return($compiler->SetElementError($condition_file,$value_element_path,"it was not defined the form error message variable"));
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($length=$compiler->GetXMLNode()),
								"Parent"=>$condition_node,
								"Tag"=>"length"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$length,
								"Tag"=>"this",
								"Data"=>$module->components[$component]["forms"][$form_name]["errormessage"]["formvariable"]
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$condition_node,
								"Tag"=>"more"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$condition_node,
								"Tag"=>"zero"
							),
							"Type"=>"XMLTAG"
						);
						break;
					case "verifyvariable":
						if(!$compiler->GetValidData($condition_file,$value_element_path,$variable,"it was not specified a valid verify variable"))
							return(0);
						if(!IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]))
							return($compiler->SetElementError($condition_file,$value_element_path,$variable." is not a valid form input variable"));
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($entrydefined=$compiler->GetXMLNode()),
								"Parent"=>$condition_node,
								"Tag"=>"entrydefined"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$entrydefined,
								"Tag"=>"this",
								"Data"=>"verify"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$entrydefined,
								"Tag"=>"string",
								"Data"=>$variable
							),
							"Type"=>"XMLTAG"
						);
						break;
					case "formvariableisnotnull":
						if(!$compiler->GetValidData($condition_file,$value_element_path,$variable,"it was not specified a valid form variable"))
							return(0);
						if(!IsSet($module->components[$component]["forms"][$form_name]["formvariables"][$variable]))
							return($compiler->SetElementError($variable_file,$value_element_path,$variable." is not a defined form variable"));
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$condition_node,
								"Tag"=>"thisisnotnull",
								"Data"=>$variable
							),
							"Type"=>"XMLTAG"
						);
						break;
					default:
						return($compiler->SetElementError($condition_file,$value_element_path,$element_data["Tag"]." is not yet a supported form template condition expression type"));
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($condition_file,$element_data,$value_element_path))
					return(0);
			}
		}
		return(1);
	}

	Function GenerateTemplateVariables(&$module,&$compiler,&$context,$component,$form_name,&$parser,&$variables_context,$variables,&$template_variables)
	{
		$variable_elements=$parser->structure[$variables_context->path]["Elements"];
		for($variable_element=0;$variable_element<$variable_elements;$variable_element++)
		{
			$variable_element_path=$variables_context->path.",".$variable_element;
			$element_data=$parser->structure[$variable_element_path];
			if(GetType($element_data)=="array")
			{
				$template_variable=$element_data["Tag"];
				if(IsSet($template_variables[$template_variable]))
					return($compiler->SetElementError($template_variables[$template_variable]->file,$template_variables[$template_variable]->path,"the template variable ".$template_variable." is already defined from the form template variables"));
				$compiler->CopyEmptyContext($variables_context,$template_variables[$template_variable]);
				$template_variables[$template_variable]->path=$variable_element_path;
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($variable_node=$compiler->GetXMLNode()),
						"Parent"=>$variables,
						"Tag"=>$template_variable
					),
					"Type"=>"XMLTAG"
				);
				if(!$this->GenerateParserVariableValue($module,$compiler,$context,$component,$form_name,$parser,$variable_node,$variables_context->file,$variable_element_path))
					return(0);
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($variables_context->file,$element_data,$variable_element_path))
					return(0);
			}
		}
		return(1);
	}

	Function GenerateConditional(&$module,&$compiler,&$context,$component,$form_name,&$parser,&$conditional_context,$conditional_node)
	{
		$values=array();
		$required_types=array(
			"then"=>"CONTEXT"
		);
		$optional_types=array(
			"istrue"=>"CONTEXT",
			"isfalse"=>"CONTEXT",
			"else"=>"CONTEXT"
		);
		if(!$compiler->GetOptionalArgumentValues($conditional_context,$values,$required_types,$optional_types,"persistence","form",1))
			return(0);
		if(!IsSet($values["istrue"])
		&& !IsSet($values["isfalse"]))
			return($compiler->SetElementError($conditional_context->file,$conditional_context->path,"it was not specified the istrue condition for value ".$element_data["Tag"]));
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($condition=$compiler->GetXMLNode()),
				"Parent"=>$conditional_node,
				"Tag"=>(IsSet($values["istrue"]) ? "istrue" : "isfalse")
			),
			"Type"=>"XMLTAG"
		);
		if(!$this->GenerateParserConditionValue($module,$compiler,$context,$component,$form_name,$parser,$condition,IsSet($values["istrue"]) ? $values["istrue"]->file : $values["isfalse"]->file,IsSet($values["istrue"]) ? $values["istrue"]->path : $values["isfalse"]->path))
			return(0);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($then=$compiler->GetXMLNode()),
				"Parent"=>$conditional_node,
				"Tag"=>"then"
			),
			"Type"=>"XMLTAG"
		);
		if(!$this->GenerateParserVariableValue($module,$compiler,$context,$component,$form_name,$parser,$then,$values["then"]->file,$values["then"]->path))
			return(0);
		if(IsSet($values["else"]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($else=$compiler->GetXMLNode()),
					"Parent"=>$conditional_node,
					"Tag"=>"else"
				),
				"Type"=>"XMLTAG"
			);
			if(!$this->GenerateParserVariableValue($module,$compiler,$context,$component,$form_name,$parser,$else,$values["else"]->file,$values["else"]->path))
				return(0);
		}
		return(1);
	}

	Function GenerateTemplateConditional(&$module,&$compiler,&$context,$component,$form_name,&$parser,&$conditional_context,$conditional,&$template_variables)
	{
		$conditional_elements=$parser->structure[$conditional_context->path]["Elements"];
		for($conditional_element=0;$conditional_element<$conditional_elements;$conditional_element++)
		{
			$conditional_element_path=$conditional_context->path.",".$conditional_element;
			$element_data=$parser->structure[$conditional_element_path];
			if(GetType($element_data)=="array")
			{
				$template_variable=$element_data["Tag"];
				if(IsSet($template_variables[$template_variable]))
					return($compiler->SetElementError($template_variables[$template_variable]->file,$template_variables[$template_variable]->path,"the template variable ".$template_variable." is already defined from the form conditional template variables"));
				$compiler->CopyEmptyContext($conditional_context,$template_variables[$template_variable]);
				$template_variables[$template_variable]->path=$conditional_element_path;
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($conditional_node=$compiler->GetXMLNode()),
						"Parent"=>$conditional,
						"Tag"=>$template_variable,
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$compiler->CopyEmptyContext($conditional_context,$values_context);
				$values_context->path=$conditional_element_path;
				if(!$this->GenerateConditional($module,$compiler,$context,$component,$form_name,$parser,$values_context,$conditional_node))
					return(0);
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($conditional_context->file,$element_data,$conditional_element_path))
					return(0);
			}
		}
		return(1);
	}

	Function GenerateSubmitOutputFunction(&$compiler,&$context,&$submit_values,$variables,$submit_type)
	{
		if(IsSet($submit_values["value"]))
		{
			$input_name=(IsSet($submit_values["field"]) ? $submit_values["field"] : $submit_type);
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($input=$compiler->GetXMLNode()),
					"Parent"=>$variables,
					"Tag"=>$input_name."input"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($composeform=$compiler->GetXMLNode()),
					"Parent"=>$input,
					"Tag"=>"composeform",
					"Indent"=>1
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$composeform,
					"Tag"=>"input",
					"Data"=>$input_name
				),
				"Type"=>"XMLTAG"
			);
			if(IsSet($submit_values["label"]))
			{
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($input=$compiler->GetXMLNode()),
						"Parent"=>$variables,
						"Tag"=>$input_name."label"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($composeform=$compiler->GetXMLNode()),
						"Parent"=>$input,
						"Tag"=>"composeform",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($label=$compiler->GetXMLNode()),
						"Parent"=>$composeform,
						"Tag"=>"label",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$label,
						"Tag"=>"for",
						"Data"=>$input_name
					),
					"Type"=>"XMLTAG"
				);
			}
		}
		if(IsSet($submit_values["image"]))
		{
			$input_name=(IsSet($submit_values["field"]) ? $submit_values["field"] : $submit_type);
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($input=$compiler->GetXMLNode()),
					"Parent"=>$variables,
					"Tag"=>$input_name."imageinput"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($composeform=$compiler->GetXMLNode()),
					"Parent"=>$input,
					"Tag"=>"composeform",
					"Indent"=>1
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$composeform,
					"Tag"=>"input",
					"Data"=>$input_name."image"
				),
				"Type"=>"XMLTAG"
			);
			if(IsSet($submit_values["imagelabel"]))
			{
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($input=$compiler->GetXMLNode()),
						"Parent"=>$variables,
						"Tag"=>$input_name."imagelabel"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($composeform=$compiler->GetXMLNode()),
						"Parent"=>$input,
						"Tag"=>"composeform",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($label=$compiler->GetXMLNode()),
						"Parent"=>$composeform,
						"Tag"=>"label",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$label,
						"Tag"=>"for",
						"Data"=>$input_name."image"
					),
					"Type"=>"XMLTAG"
				);
			}
		}
	}

	Function GenerateOutputFunction(&$module,&$compiler,&$context,$class_node,$component,$form_name,$images)
	{
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($function_node=$compiler->GetXMLNode()),
				"Parent"=>$class_node,
				"Tag"=>"function",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$function_node,
				"Tag"=>"name",
				"Data"=>"output"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$function_node,
				"Tag"=>"type",
				"Data"=>"STRING"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($do=$compiler->GetXMLNode()),
				"Parent"=>$function_node,
				"Tag"=>"do",
				"Indent"=>1,
				"Spacing"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($if=$compiler->GetXMLNode()),
				"Parent"=>$do,
				"Tag"=>"if",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($istrue=$compiler->GetXMLNode()),
				"Parent"=>$if,
				"Tag"=>"istrue",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($group=$compiler->GetXMLNode()),
				"Parent"=>$istrue,
				"Tag"=>"group",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($length=$compiler->GetXMLNode()),
				"Parent"=>$group,
				"Tag"=>"length"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$length,
				"Tag"=>"this",
				"Data"=>"error"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$group,
				"Tag"=>"more"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$group,
				"Tag"=>"zero"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$istrue,
				"Tag"=>"or"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$istrue,
				"Tag"=>"this",
				"Data"=>"processed"
			),
			"Type"=>"XMLTAG"
		);
		if(IsSet($module->components[$component]["forms"][$form_name]["parameters"]["cancel"]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$istrue,
					"Tag"=>"or"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$istrue,
					"Tag"=>"this",
					"Data"=>"canceled"
				),
				"Type"=>"XMLTAG"
			);
		}
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($then=$compiler->GetXMLNode()),
				"Parent"=>$if,
				"Tag"=>"then",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($return=$compiler->GetXMLNode()),
				"Parent"=>$then,
				"Tag"=>"return"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$return,
				"Tag"=>"emptystring"
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($forform=$compiler->GetXMLNode()),
				"Parent"=>$do,
				"Tag"=>"for".$form_name."form",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($object=$compiler->GetXMLNode()),
				"Parent"=>$forform,
				"Tag"=>"object"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$object,
				"Tag"=>"this",
				"Data"=>"form"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($doforform=$compiler->GetXMLNode()),
				"Parent"=>$forform,
				"Tag"=>"do",
				"Indent"=>1,
				"Spacing"=>1
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($composeform=$compiler->GetXMLNode()),
				"Parent"=>$doforform,
				"Tag"=>"composeform",
				"Indent"=>1,
				"Spacing"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($data=$compiler->GetXMLNode()),
				"Parent"=>$composeform,
				"Tag"=>"data"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($formtemplate=$compiler->GetXMLNode()),
				"Parent"=>$data,
				"Tag"=>$form_name."formtemplate",
				"Indent"=>1,
				"Spacing"=>1
			),
			"Type"=>"XMLTAG"
		);

		$class=$module->components[$component]["forms"][$form_name]["parameters"]["class"];
		$clip_name=$module->components[$component]["forms"][$form_name]["page"][""]["template"]["clip"];
		if(IsSet($module->components[$component]["forms"][$form_name]["layout"]))
		{
			$type=$module->components[$component]["forms"][$form_name]["layout"]["type"];
			switch($type)
			{
				case "vertical":
					for($position=1,$positions=$rows=array(),Reset($module->components[$component]["classes"][$class]["variables"]);GetType($variable=Key($module->components[$component]["classes"][$class]["variables"]))=="string";Next($module->components[$component]["classes"][$class]["variables"]))
					{
						if(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["autocreate"])
						|| IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["autoupdate"]))
							continue;
						$marks=array();
						$input_name=$variable;
						if(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["type"]))
						{
							$type=$module->components[$component]["classes"][$class]["variables"][$variable]["type"];
							switch($type)
							{
								case "text":
									$marks["input"]=$input_name."input";
									break;
								default:
									return($compiler->SetElementError($parameter_values["object"]->file,$parameter_values["object"]->path,$type." is not yet a class variable type supported in createobject forms"));
							}
							if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]["label"]))
								$marks["label"]=$input_name."label";
							if(IsSet($module->components[$component]["forms"][$form_name]["marks"]))
								$marks["mark"]=$input_name."mark";
						}
						else
						{
							if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]))
							{
								if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]["display"]))
									$marks["input"]=$input_name."input";
								if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]["label"]))
									$marks["label"]=$input_name."label";
							}
						}
						if(count($marks))
						{
							$row=count($rows);
							$rows[$row]="<tr>\n".
								"<td align=\"right\">".(IsSet($marks["label"]) ? "{".$marks["label"]."}:" : "&nbsp;")."</td>\n".
								"<td>{".$marks["input"]."}</td>\n".
								(IsSet($marks["mark"]) ? "<td>{".$marks["mark"]."}</td>\n" : "").
								"</tr>\n";
							$positions[$row]=(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]["verticalposition"]) ? $module->components[$component]["forms"][$form_name]["variables"][$variable]["verticalposition"] : $position);
						}
						$position++;
					}
					asort($positions);
					$template_data="{".$clip_name."}";
					$template_data.="<center><table>\n";
					for(Reset($positions);GetType($position=Key($positions))=="integer";Next($positions))
						$template_data.=$rows[$position];
					$template_data.="</table></center>\n";
					if(!IsSet($module->components[$component]["forms"][$form_name]["skin"]))
					{
						$field=(IsSet($module->components[$component]["forms"][$form_name]["parameters"]["submit"]["field"]) ? $this->components[$component]["forms"][$form_name]["parameters"]["submit"]["field"] : "submit");
						$template_data.="<center>{".$field."input}";
						if(IsSet($module->components[$component]["forms"][$form_name]["parameters"]["cancel"]))
						{
							$field=(IsSet($module->components[$component]["forms"][$form_name]["parameters"]["submit"]["field"]) ? $this->components[$component]["forms"][$form_name]["parameters"]["cancel"]["field"] : "cancel");
							$template_data.="&nbsp;{".$field."input}";
						}
						$template_data.="</center>\n";
					}
					$template_data.="{/".$clip_name."}";
					break;
				default:
					return($compiler->SetElementError($module->components[$component]["forms"][$form_name]["layout"]["Context"]->file,$module->components[$component]["forms"][$form_name]["layout"]["Context"]->path,$type." is not a supported type of automatic form layout"));
			}
			$template_file_name=$module->components[$component]["forms"][$form_name]["page"][""]["template"]["file"];
			if(!$compiler->CreateContextOutputDirectory(dirname($template_file_name),$context,"could not create the directory for the generated template file ".$template_file_name))
				return(0);
			if(!($template_file=fopen($template_file_name,"wb")))
				return($compiler->SetElementError($module->components[$component]["forms"][$form_name]["layout"]["Context"]->file,$module->components[$component]["forms"][$form_name]["layout"]["Context"]->path,"could not open the file ".$template_file_name." to write the generated layout template"));
			$success=(strlen($template_data)==0 || (fwrite($template_file,$template_data) && fflush($template_file)));
			fclose($template_file);
			if(!$success)
				return($compiler->SetElementError($context->file,$context->path,"could not write the generated layout template to the file ".$template_file_name));
			$context->result[]=array(
				"Data"=>array(
					"Name"=>$template_file_name,
					"Type"=>"GENERATED"
				),
				"Type"=>"FILE"
			);
		}

		if(IsSet($module->components[$component]["forms"][$form_name]["skin"]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($include=$compiler->GetXMLNode()),
					"Parent"=>$formtemplate,
					"Tag"=>"include",
					"Indent"=>1
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($body=$compiler->GetXMLNode()),
					"Parent"=>$include,
					"Tag"=>$module->components[$component]["forms"][$form_name]["skin"]["bodyvariable"],
					"Indent"=>1
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$body,
					"Tag"=>"file",
					"Data"=>$module->components[$component]["forms"][$form_name]["page"][""]["template"]["file"]
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$body,
					"Tag"=>"clip",
					"Data"=>$clip_name
				),
				"Type"=>"XMLTAG"
			);
		}

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($variables=$compiler->GetXMLNode()),
				"Parent"=>$formtemplate,
				"Tag"=>"variables",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);


		if(IsSet($module->components[$component]["forms"][$form_name]["imagespath"]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($optional=$compiler->GetXMLNode()),
					"Parent"=>$formtemplate,
					"Tag"=>"optional",
					"Indent"=>1
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($images_path=$compiler->GetXMLNode()),
					"Parent"=>$optional,
					"Tag"=>"imagespath"
				),
				"Type"=>"XMLTAG"
			);
			if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$images_path,$module->components[$component]["forms"][$form_name]["imagespath"]))
				return(0);
		}

		if(IsSet($module->components[$component]["forms"][$form_name]["template"]["conditional"])
		|| IsSet($module->components[$component]["forms"][$form_name]["page"][""]["template"]["conditional"])
		|| IsSet($module->components[$component]["forms"][$form_name]["errormessage"]["templateconditional"])
		|| IsSet($module->components[$component]["forms"][$form_name]["marks"]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($conditional=$compiler->GetXMLNode()),
					"Parent"=>$formtemplate,
					"Tag"=>"conditional",
					"Indent"=>1
				),
				"Type"=>"XMLTAG"
			);
		}

		for($template_variables=array(),Reset($module->components[$component]["classes"][$class]["variables"]);GetType($variable=Key($module->components[$component]["classes"][$class]["variables"]))=="string";Next($module->components[$component]["classes"][$class]["variables"]))
		{
			if(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["autocreate"])
			|| IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["autoupdate"]))
				continue;
			$input_name=$variable;
			if(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["type"]))
			{
				$type=$module->components[$component]["classes"][$class]["variables"][$variable]["type"];
				switch($type)
				{
					case "text":
						$template_variable=$input_name."input";
						if(IsSet($template_variables[$template_variable]))
							return($compiler->SetElementError($template_variables[$template_variable]->file,$template_variables[$template_variable]->path,"the template variable ".$template_variable." is already defined from the form object variable fields"));
						$compiler->CopyEmptyContext($module->components[$component]["classes"][$class]["variables"][$variable]["Context"],$template_variables[$template_variable]);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($input=$compiler->GetXMLNode()),
								"Parent"=>$variables,
								"Tag"=>$template_variable
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($inputcomposeform=$compiler->GetXMLNode()),
								"Parent"=>$input,
								"Tag"=>"composeform",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$inputcomposeform,
								"Tag"=>"input",
								"Data"=>$input_name
							),
							"Type"=>"XMLTAG"
						);
						break;
					default:
						return($compiler->SetElementError($parameter_values["object"]->file,$parameter_values["object"]->path,$type." is not yet a class variable type supported in createobject forms"));
				}
				if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]["label"]))
				{
					$template_variable=$input_name."label";
					if(IsSet($template_variables[$template_variable]))
						return($compiler->SetElementError($template_variables[$template_variable]->file,$template_variables[$template_variable]->path,"the template variable ".$template_variable." is already defined from the form object variable field labels"));
					$compiler->CopyEmptyContext($module->components[$component]["classes"][$class]["variables"][$variable]["Context"],$template_variables[$template_variable]);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($input=$compiler->GetXMLNode()),
							"Parent"=>$variables,
							"Tag"=>$template_variable
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($labelcomposeform=$compiler->GetXMLNode()),
							"Parent"=>$input,
							"Tag"=>"composeform",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($label=$compiler->GetXMLNode()),
							"Parent"=>$labelcomposeform,
							"Tag"=>"label",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$label,
							"Tag"=>"for",
							"Data"=>$input_name
						),
						"Type"=>"XMLTAG"
					);
				}
				if(IsSet($module->components[$component]["forms"][$form_name]["marks"]))
				{
					$template_variable=$input_name."mark";
					if(IsSet($template_variables[$template_variable]))
						return($compiler->SetElementError($template_variables[$template_variable]->file,$template_variables[$template_variable]->path,"the template variable ".$template_variable." is already defined from the form object variable field verify mark"));
					$compiler->CopyEmptyContext($module->components[$component]["forms"][$form_name]["marks"]["Context"],$template_variables[$template_variable]);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($mark=$compiler->GetXMLNode()),
							"Parent"=>$conditional,
							"Tag"=>$template_variable,
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($istrue=$compiler->GetXMLNode()),
							"Parent"=>$mark,
							"Tag"=>"istrue"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($entrydefined=$compiler->GetXMLNode()),
							"Parent"=>$istrue,
							"Tag"=>"entrydefined"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$entrydefined,
							"Tag"=>"this",
							"Data"=>"verify"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$entrydefined,
							"Tag"=>"string",
							"Data"=>$variable
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($then=$compiler->GetXMLNode()),
							"Parent"=>$mark,
							"Tag"=>"then"
						),
						"Type"=>"XMLTAG"
					);
					if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$then,$module->components[$component]["forms"][$form_name]["marks"]["verify"]))
						return(0);
					$context->result[]=array(
						"Data"=>array(
							"Node"=>($else=$compiler->GetXMLNode()),
							"Parent"=>$mark,
							"Tag"=>"else"
						),
						"Type"=>"XMLTAG"
					);
					if(IsSet($module->components[$component]["forms"][$form_name]["marks"]["required"])
					&& !$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$else,$module->components[$component]["forms"][$form_name]["marks"]["required"]))
						return(0);
				}
			}
			else
			{
				if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]))
				{
					if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]["display"]))
					{
						$template_variable=$input_name."input";
						if(IsSet($template_variables[$template_variable]))
							return($compiler->SetElementError($template_variables[$template_variable]->file,$template_variables[$template_variable]->path,"the template variable ".$template_variable." is already defined from the form object variable fields"));
						$compiler->CopyEmptyContext($module->components[$component]["classes"][$class]["variables"][$variable]["Context"],$template_variables[$template_variable]);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($input=$compiler->GetXMLNode()),
								"Parent"=>$variables,
								"Tag"=>$template_variable
							),
							"Type"=>"XMLTAG"
						);
						if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$input,$module->components[$component]["forms"][$form_name]["variables"][$variable]["display"]))
							return(0);
					}
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$composeform,
							"Tag"=>"input",
							"Data"=>$input_name
						),
						"Type"=>"XMLTAG"
					);
					if(IsSet($module->components[$component]["forms"][$form_name]["variables"][$variable]["label"]))
					{
						$template_variable=$input_name."label";
						if(IsSet($template_variables[$template_variable]))
							return($compiler->SetElementError($template_variables[$template_variable]->file,$template_variables[$template_variable]->path,"the template variable ".$template_variable." is already defined from the form object variable field labels"));
						$compiler->CopyEmptyContext($module->components[$component]["classes"][$class]["variables"][$variable]["Context"],$template_variables[$template_variable]);
						$context->result[]=array(
							"Data"=>array(
								"Node"=>($label=$compiler->GetXMLNode()),
								"Parent"=>$variables,
								"Tag"=>$template_variable
							),
							"Type"=>"XMLTAG"
						);
						if(!$this->GenerateVariableValue($module,$compiler,$context,$component,$form_name,$label,$module->components[$component]["forms"][$form_name]["variables"][$variable]["label"]))
							return(0);
					}
				}
			}
		}

		$this->GenerateSubmitOutputFunction($compiler,$context,$module->components[$component]["forms"][$form_name]["parameters"]["submit"],$variables,"submit");

		if(IsSet($module->components[$component]["forms"][$form_name]["parameters"]["cancel"]))
			$this->GenerateSubmitOutputFunction($compiler,$context,$module->components[$component]["forms"][$form_name]["parameters"]["cancel"],$variables,"cancel");

		if(IsSet($module->components[$component]["forms"][$form_name]["template"]["variables"]))
		{
			for($variables_template=0;$variables_template<count($module->components[$component]["forms"][$form_name]["template"]["variables"]);$variables_template++)
			{
				$compiler->CopyEmptyContext($module->components[$component]["forms"][$form_name]["template"]["variables"][$variables_template],$variables_context);
				$compiler->GetParser($variable_parser,$variables_context->file);
				if(!$this->GenerateTemplateVariables($module,$compiler,$context,$component,$form_name,$variable_parser,$variables_context,$variables,$template_variables))
					return(0);
			}
		}

		if(IsSet($module->components[$component]["forms"][$form_name]["page"][""]["template"]["variables"]))
		{
			$variables_context=$module->components[$component]["forms"][$form_name]["page"][""]["template"]["variables"];
			$compiler->GetParser($variable_parser,$variables_context->file);
			if(!$this->GenerateTemplateVariables($module,$compiler,$context,$component,$form_name,$variable_parser,$variables_context,$variables,$template_variables))
				return(0);
		}

		if(IsSet($module->components[$component]["forms"][$form_name]["errormessage"]["templateconditional"]))
		{
			$template_variable=$module->components[$component]["forms"][$form_name]["errormessage"]["templateconditional"];
			if(IsSet($template_variables[$template_variable]))
				return($compiler->SetElementError($template_variables[$template_variable]->file,$template_variables[$template_variable]->path,"the template variable ".$template_variable." is already defined from the form error message template conditional variable"));
			$compiler->CopyEmptyContext($module->components[$component]["forms"][$form_name]["errormessage"]["Context"],$template_variables[$template_variable]);
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($conditionalvariable=$compiler->GetXMLNode()),
					"Parent"=>$conditional,
					"Tag"=>$template_variable,
					"Indent"=>1
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($istrue=$compiler->GetXMLNode()),
					"Parent"=>$conditionalvariable,
					"Tag"=>"istrue"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($length=$compiler->GetXMLNode()),
					"Parent"=>$istrue,
					"Tag"=>"length"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$length,
					"Tag"=>"this",
					"Data"=>$module->components[$component]["forms"][$form_name]["errormessage"]["formvariable"]
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$istrue,
					"Tag"=>"more"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$istrue,
					"Tag"=>"zero"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($then=$compiler->GetXMLNode()),
					"Parent"=>$conditionalvariable,
					"Tag"=>"then"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$then,
					"Tag"=>"this",
					"Data"=>$module->components[$component]["forms"][$form_name]["errormessage"]["formvariable"]
				),
				"Type"=>"XMLTAG"
			);
		}

		if(IsSet($module->components[$component]["forms"][$form_name]["template"]["conditional"]))
		{
			for($conditional_template=0;$conditional_template<count($module->components[$component]["forms"][$form_name]["template"]["conditional"]);$conditional_template++)
			{
				$compiler->CopyEmptyContext($module->components[$component]["forms"][$form_name]["template"]["conditional"][$conditional_template],$conditional_context);
				$compiler->GetParser($conditional_parser,$conditional_context->file);
				if(!$this->GenerateTemplateConditional($module,$compiler,$context,$component,$form_name,$conditional_parser,$conditional_context,$conditional,$template_variables))
					return(0);
			}
		}

		if(IsSet($module->components[$component]["forms"][$form_name]["page"][""]["template"]["conditional"]))
		{
			$conditional_context=$module->components[$component]["forms"][$form_name]["page"][""]["template"]["conditional"];
			$compiler->GetParser($conditional_parser,$conditional_context->file);
			if(!$this->GenerateTemplateConditional($module,$compiler,$context,$component,$form_name,$conditional_parser,$conditional_context,$conditional,$template_variables))
				return(0);
		}

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($return=$compiler->GetXMLNode()),
				"Parent"=>$doforform,
				"Tag"=>"return"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$return,
				"Tag"=>"outputform"
			),
			"Type"=>"XMLTAG"
		);

		if(count($module->components[$component]["forms"][$form_name]["images"]))
		{
			if(strlen($images)==0)
				return($compiler->SetElementError($context->file,$context->path,"it was not specified the images path"));
			if(!$compiler->CreateOutputDirectory($images))
				return($compiler->SetElementError($context->file,$context->path,"could not create the images directory ".$images));
			for(Reset($module->components[$component]["forms"][$form_name]["images"]);GetType($image=Key($module->components[$component]["forms"][$form_name]["images"]))=="string";Next($module->components[$component]["forms"][$form_name]["images"]))
			{
				$base_path=$module->components[$component]["forms"][$form_name]["images"][$image]["Base"];
				$include_path=$compiler->GetIncludePath($base_path.$image);
				$from=$include_path.$base_path.$image;
				$to=$images."/".basename($image);
				if(!file_exists($from))
					return($compiler->SetElementError($module->components[$component]["forms"][$form_name]["images"][$image]["Context"]->file,$module->components[$component]["forms"][$form_name]["images"][$image]["Context"]->path,"the image file ".$image." does not exist"));
				if(!copy($from,$to))
					return($compiler->SetElementError($module->components[$component]["forms"][$form_name]["images"][$image]["Context"]->file,$module->components[$component]["forms"][$form_name]["images"][$image]["Context"]->path,"could not copy the image file ".$image." to ".$to));
				$context->result[]=array(
					"Data"=>array(
						"Name"=>$from,
						"Type"=>"DEPENDENCY"
					),
					"Type"=>"FILE"
				);
				$context->result[]=array(
					"Data"=>array(
						"Name"=>$to,
						"Type"=>"GENERATED"
					),
					"Type"=>"FILE"
				);
			}
		}

		return(1);
	}

	Function GenerateClass(&$module, &$compiler, &$context, $component, $class_name, $form_name, $values)
	{
		if(IsSet($module->components[$component]["forms"][$form_name]["layout"])
		&& !IsSet($module->components[$component]["forms"][$form_name]["page"][""]["template"]["file"]))
			$module->components[$component]["forms"][$form_name]["page"][""]["template"]["file"]=$values["basefilename"].".html";
		$module->generator->GenerateStorageClass($module,$compiler,$context,$class_node,$component,$class_name."class",$values);
		if(!$this->GenerateClassVariables($module,$compiler,$context,$class_node,$component,$form_name)
		|| !$this->GenerateInitializeFunction($module,$compiler,$context,$class_node,$component,$form_name)
		|| !$this->GenerateProcessFunction($module,$compiler,$context,$class_node,$component,$form_name)
		|| !$this->GenerateOutputFunction($module,$compiler,$context,$class_node,$component,$form_name,IsSet($values["images"]) ? $values["images"] : ""))
			return(0);
		return(1);
	}

	Function GenerateClassDiagram(&$compiler,&$module,$component,$form_name,$indent,$linefeed,&$graph)
	{
		$module->generator->StartFormattingDiagramLines();
		$nodes="";

		$graph.=$indent."\"".$form_name."form\" [label=\"{".$form_name."form|";

		if(IsSet($module->components[$component]["forms"][$form_name]["errormessage"]))
			$graph.=$module->generator->FormatDiagramLine("+".$module->components[$component]["forms"][$form_name]["errormessage"]["formvariable"].":string")."\\l";
		$graph.=$module->generator->FormatDiagramLine("+processed:boolean")."\\l";
		$graph.=$module->generator->FormatDiagramLine("+error:string")."\\l";
		$needs_text=1;
		$type=$module->components[$component]["forms"][$form_name]["type"];
		switch($type)
		{
			case "createobject":
				$class=$module->components[$component]["forms"][$form_name]["parameters"]["class"];

				$graph.=$module->generator->FormatDiagramLine("+".$class.":".$class)."\\l";
				$nodes.=$indent."\"".$form_name."form\"->\"".$class."\" [taillabel=\"0..1 ".$class."\",headlabel=\"\",arrowhead=none]".$linefeed;

				if(IsSet($module->components[$component]["forms"][$form_name]["parameters"]["cancel"]))
					$graph.=$module->generator->FormatDiagramLine("+canceled:boolean")."\\l";
				break;
			default:
				return($compiler->SetElementError($context->file,$context->path,$type." is not yet a supported component form type"));
		}
		if($needs_text)
			$graph.=$module->generator->FormatDiagramLine("+text:hash")."\\l";
		for(Reset($module->components[$component]["forms"][$form_name]["formvariables"]);GetType($variable=Key($module->components[$component]["forms"][$form_name]["formvariables"]))=="string";Next($module->components[$component]["forms"][$form_name]["formvariables"]))
		{
			$line="+".$variable.":";
			if(IsSet($module->components[$component]["forms"][$form_name]["formvariables"][$variable]["class"]))
			{
				$line.=$module->components[$component]["forms"][$form_name]["formvariables"][$variable]["class"];
				$nodes.=$indent."\"".$form_name."form\"->\"".$module->components[$component]["forms"][$form_name]["formvariables"][$variable]["class"]."\" [taillabel=\"0..1 ".$variable."\",headlabel=\"\",arrowhead=none]".$linefeed;
			}
			else
				$line.=strtolower($module->components[$component]["forms"][$form_name]["formvariables"][$variable]["type"]);
			$graph.=$module->generator->FormatDiagramLine($line)."\\l";
		}

		$graph.="|";
		$graph.=$module->generator->FormatDiagramLine("+initialize( ".$component." ):boolean")."\\l";
		$graph.=$module->generator->FormatDiagramLine("+process():boolean")."\\l";
		$graph.=$module->generator->FormatDiagramLine("+output():string")."\\l";

		$graph.="}\",color=blue]".$linefeed.$nodes;

		return(1);
	}
};

}
?>