<?php
if(!defined("METAL_PERSISTENCE_REPORT_GENERATOR_INCLUDED"))
{
	define("METAL_PERSISTENCE_REPORT_GENERATOR_INCLUDED",1);

/*
 * metal_persistence_report_generator.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_persistence_report_generator.php,v 1.22 2005/06/06 02:05:29 mlemos Exp $
 *
 */

class metal_persistence_report_generator_class
{
	Function GenerateClassInput(&$module,&$compiler,&$context,$input_node,$component,$report_name,$factory_input)
	{
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$input_node,
				"Tag"=>"includeonce",
				"Data"=>$factory_input
			),
			"Type"=>"XMLTAG"
		);
	}

	Function GenerateClassVariables(&$module,&$compiler,&$context,$class_node,$component,$report_name)
	{
		$module->generator->GenerateStorageClassVariables($module,$compiler,$context,$class_node,$component);

		for($queries=array(),$report_function=0,Reset($module->components[$component]["reports"][$report_name]["functions"]);$report_function<count($module->components[$component]["reports"][$report_name]["functions"]);$report_function++,Next($module->components[$component]["reports"][$report_name]["functions"]))
		{
			$function_name=Key($module->components[$component]["reports"][$report_name]["functions"]);
			$function_arguments=$module->components[$component]["reports"][$report_name]["functions"][$function_name];
			switch($function_arguments["type"])
			{
				case "openreport":
					if(!$module->GetReportOpenReportParameters($compiler,$component,$report_name,$function_arguments,"report function parameter",$parameter_values))
						return(0);
					$queries[$parameter_values["query"]]=1;
					break;
			}
		}

		for($report_query=0,Reset($queries);$report_query<count($queries);$report_query++,Next($queries))
		{
			$query=Key($queries);

			$context->result[]=array(
				"Data"=>array(
					"Node"=>($variable=$compiler->GetXMLNode()),
					"Parent"=>$class_node,
					"Tag"=>"variable",
					"Indent"=>1
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$variable,
					"Tag"=>"name",
					"Data"=>$query."_result"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($type=$compiler->GetXMLNode()),
					"Parent"=>$variable,
					"Tag"=>"type"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$type,
					"Tag"=>"databasetyperesult"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$variable,
					"Tag"=>"protected"
				),
				"Type"=>"XMLTAG"
			);

			$context->result[]=array(
				"Data"=>array(
					"Node"=>($variable=$compiler->GetXMLNode()),
					"Parent"=>$class_node,
					"Tag"=>"variable",
					"Indent"=>1
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$variable,
					"Tag"=>"name",
					"Data"=>$query."_row"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Node"=>($type=$compiler->GetXMLNode()),
					"Parent"=>$variable,
					"Tag"=>"type",
					"Data"=>"INTEGER"
				),
				"Type"=>"XMLTAG"
			);
			$context->result[]=array(
				"Data"=>array(
					"Parent"=>$variable,
					"Tag"=>"protected"
				),
				"Type"=>"XMLTAG"
			);
		}

		return(1);
	}

	Function GetReportQueryParameters(&$module, &$compiler, &$context, $component, $report_name, &$function_arguments, &$parameter_values, &$parameters, $function)
	{
		$parameters=array();
		$query=$parameter_values["query"];
		$classes=$module->components[$component]["reports"][$report_name]["queries"][$query]["objects"];
		$parameters["tables"]=array();
		$module->AddObjectTables($classes, $parameters["tables"]);
		if(IsSet($module->components[$component]["reports"][$report_name]["queries"][$query]["filter"]))
		{
			$parameters["condition"]=array(
				array(
					"Data"=>array(
						"Node"=>($stringdata=$compiler->GetXMLNode()),
						"Tag"=>"stringdata"
					),
					"Type"=>"XMLTAG"
				)
			);
			$compiler->CopyEmptyContext($module->components[$component]["reports"][$report_name]["queries"][$query]["filter"], $filter_context);
			$compiler->GetParser($filter_parser,$filter_context->file);
			if(!$module->EvaluateFilterExpression($compiler, $filter_parser, $filter_context, $component, $classes, $parameters["tables"], $function_arguments, $condition, $stringdata, "boolean"))
				return(0);
			$module->ConcatenateResults($parameters["condition"], $condition);
		}
		else
			$parameters["condition"]=array();
		$parameters["types"]=array(
			array(
				"Data"=>array(
					"Node"=>($types_array=$compiler->GetXMLNode()),
					"Tag"=>"array",
					"Indent"=>1,
				),
				"Type"=>"XMLTAG"
			)
		);
		Reset($module->components[$component]["reports"][$report_name]["queries"][$query]["columns"]);
		$end=(GetType($column=Key($module->components[$component]["reports"][$report_name]["queries"][$query]["columns"]))!="string");
		for($get_first_type=1, $parameters["fields"]=array();!$end;)
		{
			$compiler->CopyEmptyContext($module->components[$component]["reports"][$report_name]["queries"][$query]["columns"][$column]["value"], $value_context);
			$compiler->GetParser($value_parser,$value_context->file);
			if(!$module->EvaluateArbitraryFilterExpression($compiler, $value_parser, $value_context, $component, $classes, $parameters["tables"], $function_arguments, $result, 0))
				return(0);
			switch(strtok($result["Data"]["Type"],":"))
			{
				case "OID":
					$type_name="integer";
					break;
				default:
					$type_name=$result["Data"]["Type"];
					break;
			}
			$parameters["types"][]=array(
				"Data"=>array(
					"Parent"=>$types_array,
					"Tag"=>"string",
					"Data"=>$type_name
				),
				"Type"=>"XMLTAG"
			);
			$module->ConcatenateResults($parameters["fields"], $result["Data"]["Value"]);
			$parameters["fields"][]=array(
				"Data"=>" AS ".$column,
				"Type"=>"DATA"
			);
			if($get_first_type)
			{
				$parameters["firsttype"]=$result["Data"]["Type"];
				$get_first_type=0;
			}
			Next($module->components[$component]["reports"][$report_name]["queries"][$query]["columns"]);
			$end=(GetType($column=Key($module->components[$component]["reports"][$report_name]["queries"][$query]["columns"]))!="string");
			if(!$end)
			{
				$parameters["fields"][]=array(
					"Data"=>", ",
					"Type"=>"DATA"
				);
			}
		}
		$parameters["order"]=array();
		if(IsSet($module->components[$component]["reports"][$report_name]["queries"][$query]["order"]))
		{
			for($order_by="",$column=0;$column<count($module->components[$component]["reports"][$report_name]["queries"][$query]["order"]);$column++)
			{
				if($column>0)
					$order_by.=", ";
				$order_by.=$module->components[$component]["reports"][$report_name]["queries"][$query]["order"][$column]["name"];
				if(IsSet($module->components[$component]["reports"][$report_name]["queries"][$query]["order"][$column]["ascending"]))
					$order_by.=" ASC";
				if(IsSet($module->components[$component]["reports"][$report_name]["queries"][$query]["order"][$column]["descending"]))
					$order_by.=" DESC";
			}
			$parameters["order"][]=array(
				"Data"=>$order_by,
				"Type"=>"DATA"
			);
		}

		if(IsSet($parameter_values["limit"]))
		{
			$compiler->GetParser($parser,$parameter_values["limit"]->file);
			if(!$module->EvaluateRuntimeExpression($compiler, $parser, $parameter_values["limit"], $function_arguments, $parameters["limit"], 0, "integer"))
				return(0);
			if(IsSet($parameter_values["first"]))
			{
				$compiler->GetParser($parser,$parameter_values["first"]->file);
				if(!$module->EvaluateRuntimeExpression($compiler, $parser, $parameter_values["first"], $function_arguments, $parameters["first"], 0, "integer"))
					return(0);
			}
			else
			{
				$parameters["first"]=array(
					array(
						"Data"=>"0",
						"Type"=>"DATA"
					)
				);
			}
		}
		else
			$parameters["first"]=$parameters["limit"]=array();

		if(IsSet($parameter_values["count"]))
		{
			$count_values=array();
			$required_types=array(
				"argument"=>"NAME"
			);
			$optional_types=array(
			);
			if(!$compiler->GetOptionalArgumentValues($parameter_values["count"],$count_values,$required_types,$optional_types,"persistence",$function,1))
				return(0);
			$parameters["countargument"]=$count_values["argument"];
			$parameters["count"]=array(
				array(
					"Data"=>$count_values["argument"],
					"Type"=>"DATA"
				)
			);
		}
		else
			$parameters["count"]=array();
		return(1);
	}

	Function GenerateFunction(&$module, &$compiler, &$context, $component, $report_name, $function_name, $class_node, $function, &$values, &$function_arguments)
	{
		$function_node=$module->GenerateFunctionDeclaration($compiler, $context, $function_name, $function_arguments, $class_node);
		switch($function_arguments["type"])
		{
			case "openreport":
				if(!$module->GetReportOpenReportParameters($compiler,$component,$report_name,$module->components[$component]["reports"][$report_name]["functions"][$function_name],"report function parameter",$parameter_values))
					return(0);

				if(!$this->GetReportQueryParameters($module, $compiler, $context, $component, $report_name, $function_arguments, $parameter_values, $parameters, $function))
					return(0);

				$query=$parameter_values["query"];

				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"Tag"=>"type",
						"Data"=>"BOOLEAN"
					),
					"Type"=>"XMLTAG"
				);

				if(IsSet($parameter_values["count"]))
				{
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$function_node,
							"Node"=>($argument_node=$compiler->GetXMLNode()),
							"Tag"=>"argument",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$argument_node,
							"Tag"=>"name",
							"Data"=>$parameters["countargument"]
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$argument_node,
							"Tag"=>"type",
							"Data"=>"INTEGER"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$argument_node,
							"Tag"=>"out"
						),
						"Type"=>"XMLTAG"
					);
				}

				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"TemplateFile"=>"template/persistence/report/openreport.xml",
						"Variables"=>array(
							"result"=>array(
								array(
									"Data"=>$query."_result",
									"Type"=>"DATA"
								)
							),
							"fields"=>$parameters["fields"],
							"tables"=>array(
								array(
									"Data"=>$module->GenerateTableList($parameters["tables"]),
									"Type"=>"DATA"
								)
							),
							"types"=>$parameters["types"],
							"row"=>array(
								array(
									"Data"=>$query."_row",
									"Type"=>"DATA"
								)
							),
							"first"=>$parameters["first"]
						),
						"Conditional"=>array(
							"condition"=>$parameters["condition"],
							"order"=>$parameters["order"],
							"limit"=>$parameters["limit"],
							"count"=>$parameters["count"]
						)
					),
					"Type"=>"XMLTEMPLATE"
				);
				break;

			case "getreportdata":
				if(!$module->GetReportGetReportDataParameters($compiler,$component,$report_name,$module->components[$component]["reports"][$report_name]["functions"][$function_name],"report function parameter",$parameter_values))
					return(0);
				$query=$parameter_values["query"];
				$data_values=array();
				$required_types=array(
					"argument"=>"NAME"
				);
				$optional_types=array();
				if(!$compiler->GetOptionalArgumentValues($parameter_values["data"],$data_values,$required_types,$optional_types,"persistence",$function,1))
					return(0);
				$endofdata_values=array();
				$required_types=array(
					"argument"=>"NAME"
				);
				$optional_types=array();
				if(!$compiler->GetOptionalArgumentValues($parameter_values["endofdata"],$endofdata_values,$required_types,$optional_types,"persistence",$function,1))
					return(0);

				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"Tag"=>"type",
						"Data"=>"BOOLEAN"
					),
					"Type"=>"XMLTAG"
				);

				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"Node"=>($argument_node=$compiler->GetXMLNode()),
						"Tag"=>"argument",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$argument_node,
						"Tag"=>"name",
						"Data"=>$data_values["argument"]
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$argument_node,
						"Tag"=>"type",
						"Data"=>"ARRAY"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$argument_node,
						"Tag"=>"out"
					),
					"Type"=>"XMLTAG"
				);

				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"Node"=>($argument_node=$compiler->GetXMLNode()),
						"Tag"=>"argument",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$argument_node,
						"Tag"=>"name",
						"Data"=>$endofdata_values["argument"]
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$argument_node,
						"Tag"=>"type",
						"Data"=>"BOOLEAN"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$argument_node,
						"Tag"=>"out"
					),
					"Type"=>"XMLTAG"
				);

				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"TemplateFile"=>"template/persistence/report/getreportdata.xml",
						"Variables"=>array(
							"result"=>array(
								array(
									"Data"=>$query."_result",
									"Type"=>"DATA"
								)
							),
							"query"=>array(
								array(
									"Data"=>$query,
									"Type"=>"DATA"
								)
							),
							"endofdata"=>array(
								array(
									"Data"=>$endofdata_values["argument"],
									"Type"=>"DATA"
								)
							),
							"data"=>array(
								array(
									"Data"=>$data_values["argument"],
									"Type"=>"DATA"
								)
							),
							"row"=>array(
								array(
									"Data"=>$query."_row",
									"Type"=>"DATA"
								)
							)
						)
					),
					"Type"=>"XMLTEMPLATE"
				);
				break;

			case "getallreportdata":
				if(!$module->GetReportGetAllReportDataParameters($compiler,$component,$report_name,$module->components[$component]["reports"][$report_name]["functions"][$function_name],"report function parameter",$parameter_values))
					return(0);

				if(!$this->GetReportQueryParameters($module, $compiler, $context, $component, $report_name, $function_arguments, $parameter_values, $parameters, $function))
					return(0);

				$data_values=array();
				$required_types=array(
					"argument"=>"NAME"
				);
				$optional_types=array();
				if(!$compiler->GetOptionalArgumentValues($parameter_values["data"],$data_values,$required_types,$optional_types,"persistence",$function,1))
					return(0);

				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"Tag"=>"type",
						"Data"=>"BOOLEAN"
					),
					"Type"=>"XMLTAG"
				);

				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"Node"=>($argument_node=$compiler->GetXMLNode()),
						"Tag"=>"argument",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$argument_node,
						"Tag"=>"name",
						"Data"=>$data_values["argument"]
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$argument_node,
						"Tag"=>"type",
						"Data"=>"ARRAY"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$argument_node,
						"Tag"=>"out"
					),
					"Type"=>"XMLTAG"
				);

				if(IsSet($parameter_values["count"]))
				{
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$function_node,
							"Node"=>($argument_node=$compiler->GetXMLNode()),
							"Tag"=>"argument",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$argument_node,
							"Tag"=>"name",
							"Data"=>$parameters["countargument"]
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$argument_node,
							"Tag"=>"type",
							"Data"=>"INTEGER"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$argument_node,
							"Tag"=>"out"
						),
						"Type"=>"XMLTAG"
					);
				}

				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"TemplateFile"=>"template/persistence/report/getallreportdata.xml",
						"Variables"=>array(
							"fields"=>$parameters["fields"],
							"tables"=>array(
								array(
									"Data"=>$module->GenerateTableList($parameters["tables"]),
									"Type"=>"DATA"
								)
							),
							"types"=>$parameters["types"],
							"first"=>$parameters["first"],
							"data"=>array(
								array(
									"Data"=>$data_values["argument"],
									"Type"=>"DATA"
								)
							),
						),
						"Conditional"=>array(
							"condition"=>$parameters["condition"],
							"order"=>$parameters["order"],
							"limit"=>$parameters["limit"],
							"count"=>$parameters["count"]
						)
					),
					"Type"=>"XMLTEMPLATE"
				);
				break;

			case "getreportfield":
				if(!$module->GetReportGetReportFieldParameters($compiler,$component,$report_name,$module->components[$component]["reports"][$report_name]["functions"][$function_name],"report function parameter",$parameter_values))
					return(0);

				if(!$this->GetReportQueryParameters($module, $compiler, $context, $component, $report_name, $function_arguments, $parameter_values, $parameters, $function))
					return(0);

				$field_values=array();
				$required_types=array(
					"argument"=>"NAME"
				);
				$optional_types=array();
				if(!$compiler->GetOptionalArgumentValues($parameter_values["field"],$field_values,$required_types,$optional_types,"persistence",$function,1))
					return(0);

				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"Tag"=>"type",
						"Data"=>"BOOLEAN"
					),
					"Type"=>"XMLTAG"
				);

				$valid_types=array(
					"integer"=>"INTEGER",
					"text"=>"STRING",
					"boolean"=>"BOOLEAN",
					"decimal"=>"STRING",
					"float"=>"FLOAT",
					"time"=>"STRING",
					"date"=>"STRING",
					"timestamp"=>"STRING"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"Node"=>($argument_node=$compiler->GetXMLNode()),
						"Tag"=>"argument",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$argument_node,
						"Tag"=>"name",
						"Data"=>$field_values["argument"]
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$argument_node,
						"Tag"=>"type",
						"Data"=>$valid_types[$parameters["firsttype"]]
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$argument_node,
						"Tag"=>"out"
					),
					"Type"=>"XMLTAG"
				);

				if(IsSet($parameter_values["count"]))
				{
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$function_node,
							"Node"=>($argument_node=$compiler->GetXMLNode()),
							"Tag"=>"argument",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$argument_node,
							"Tag"=>"name",
							"Data"=>$parameters["countargument"]
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$argument_node,
							"Tag"=>"type",
							"Data"=>"INTEGER"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$argument_node,
							"Tag"=>"out"
						),
						"Type"=>"XMLTAG"
					);
				}

				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"TemplateFile"=>"template/persistence/report/getreportfield.xml",
						"Variables"=>array(
							"fields"=>$parameters["fields"],
							"tables"=>array(
								array(
									"Data"=>$module->GenerateTableList($parameters["tables"]),
									"Type"=>"DATA"
								)
							),
							"type"=>array(
								array(
									"Data"=>$parameters["firsttype"],
									"Type"=>"DATA"
								)
							),
							"first"=>$parameters["first"],
							"field"=>array(
								array(
									"Data"=>$field_values["argument"],
									"Type"=>"DATA"
								)
							),
							"value"=>array(
								array(
									"Data"=>array(
										"Tag"=>$parameters["firsttype"]."variable",
										"Data"=>"value"
									),
									"Type"=>"XMLTAG"
								)
							),
						),
						"Conditional"=>array(
							"condition"=>$parameters["condition"],
							"order"=>$parameters["order"],
							"limit"=>$parameters["limit"],
							"count"=>$parameters["count"]
						)
					),
					"Type"=>"XMLTEMPLATE"
				);
				break;

			case "getreportrow":
				if(!$module->GetReportGetReportRowParameters($compiler,$component,$report_name,$module->components[$component]["reports"][$report_name]["functions"][$function_name],"report function parameter",$parameter_values))
					return(0);

				if(!$this->GetReportQueryParameters($module, $compiler, $context, $component, $report_name, $function_arguments, $parameter_values, $parameters, $function))
					return(0);

				$field_values=array();
				$required_types=array(
					"argument"=>"NAME"
				);
				$optional_types=array();
				if(!$compiler->GetOptionalArgumentValues($parameter_values["data"],$field_values,$required_types,$optional_types,"persistence",$function,1))
					return(0);

				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"Tag"=>"type",
						"Data"=>"BOOLEAN"
					),
					"Type"=>"XMLTAG"
				);

				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"Node"=>($argument_node=$compiler->GetXMLNode()),
						"Tag"=>"argument",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$argument_node,
						"Tag"=>"name",
						"Data"=>$field_values["argument"]
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$argument_node,
						"Tag"=>"type",
						"Data"=>"ARRAY"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$argument_node,
						"Tag"=>"out"
					),
					"Type"=>"XMLTAG"
				);

				if(IsSet($parameter_values["count"]))
				{
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$function_node,
							"Node"=>($argument_node=$compiler->GetXMLNode()),
							"Tag"=>"argument",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$argument_node,
							"Tag"=>"name",
							"Data"=>$parameters["countargument"]
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$argument_node,
							"Tag"=>"type",
							"Data"=>"INTEGER"
						),
						"Type"=>"XMLTAG"
					);
					$context->result[]=array(
						"Data"=>array(
							"Parent"=>$argument_node,
							"Tag"=>"out"
						),
						"Type"=>"XMLTAG"
					);
				}

				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"TemplateFile"=>"template/persistence/report/getreportrow.xml",
						"Variables"=>array(
							"types"=>$parameters["types"],
							"fields"=>$parameters["fields"],
							"tables"=>array(
								array(
									"Data"=>$module->GenerateTableList($parameters["tables"]),
									"Type"=>"DATA"
								)
							),
							"first"=>$parameters["first"],
							"row"=>array(
								array(
									"Data"=>$field_values["argument"],
									"Type"=>"DATA"
								)
							)
						),
						"Conditional"=>array(
							"condition"=>$parameters["condition"],
							"order"=>$parameters["order"],
							"limit"=>$parameters["limit"],
							"count"=>$parameters["count"]
						)
					),
					"Type"=>"XMLTEMPLATE"
				);
				break;

			case "getreportsql":
				if(!$module->GetReportGetReportSQLParameters($compiler,$component,$report_name,$module->components[$component]["reports"][$report_name]["functions"][$function_name],"report function parameter",$parameter_values))
					return(0);

				if(!$this->GetReportQueryParameters($module, $compiler, $context, $component, $report_name, $function_arguments, $parameter_values, $parameters, $function))
					return(0);

				$arguments=array("condition","tables","columns");

				for($argument=0;$argument<count($arguments);$argument++)
				{
					$argument_name=$arguments[$argument];
					if(IsSet($parameter_values[$argument_name]))
					{
						$field_values=array();
						$required_types=array(
							"argument"=>"NAME"
						);
						$optional_types=array();
						if(!$compiler->GetOptionalArgumentValues($parameter_values[$argument_name],$field_values,$required_types,$optional_types,"persistence",$function,1))
							return(0);
						$argumentvalues[$argument_name]=array(
							array(
								"Data"=>$field_values["argument"],
								"Type"=>"DATA"
							)
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$function_node,
								"Node"=>($argument_node=$compiler->GetXMLNode()),
								"Tag"=>"argument",
								"Indent"=>1
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$argument_node,
								"Tag"=>"name",
								"Data"=>$field_values["argument"]
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$argument_node,
								"Tag"=>"type",
								"Data"=>"STRING"
							),
							"Type"=>"XMLTAG"
						);
						$context->result[]=array(
							"Data"=>array(
								"Parent"=>$argument_node,
								"Tag"=>"out"
							),
							"Type"=>"XMLTAG"
						);
					}
					else
						$argumentvalues[$argument_name]=array();
				}

				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"Tag"=>"type",
						"Data"=>"VOID"
					),
					"Type"=>"XMLTAG"
				);

				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"TemplateFile"=>"template/persistence/report/getreportsql.xml",
						"Variables"=>array(
							"condition"=>$parameters["condition"],
							"tables"=>array(
								array(
									"Data"=>$module->GenerateTableList($parameters["tables"]),
									"Type"=>"DATA"
								)
							),
							"fields"=>$parameters["fields"]
						),
						"Conditional"=>array(
							"conditionargument"=>$argumentvalues["condition"],
							"tablesargument"=>$argumentvalues["tables"],
							"columnsargument"=>$argumentvalues["columns"]
						)
					),
					"Type"=>"XMLTEMPLATE"
				);
				break;

			default:
				return($compiler->SetElementError($context->file,$context->path,$function_arguments["type"]." is not yet a supported report class function"));
		}
		return(1);
	}

	Function GenerateClass(&$module, &$compiler, &$context, $component, $class_name, $report_name, $values, $function)
	{
		$module->generator->GenerateStorageClass($module,$compiler,$context,$class_node,$component,$class_name."class",$values);
		
		$this->GenerateClassVariables($module, $compiler, $context, $class_node, $component, $report_name);

		$module->generator->GenerateStorageInitializeFunction($module,$compiler,$context,$class_node);

		$module->generator->GenerateStorageFinalizeFunction($module,$compiler,$context,$class_node);

		for($report_function=0,Reset($module->components[$component]["reports"][$report_name]["functions"]);$report_function<count($module->components[$component]["reports"][$report_name]["functions"]);$report_function++,Next($module->components[$component]["reports"][$report_name]["functions"]))
		{
			$function_name=Key($module->components[$component]["reports"][$report_name]["functions"]);
			if(!$this->GenerateFunction($module,$compiler,$context,$component,$report_name,$function_name,$class_node,$function,$values,$module->components[$component]["reports"][$report_name]["functions"][$function_name]))
				return(0);
			if(!$module->VerifyUnusedArguments($compiler,$function_name,$module->components[$component]["reports"][$report_name]["functions"][$function_name]))
				return(0);
		}

		return(1);
	}

	Function GetDiagramCommonFunctionArguments(&$compiler, &$parameter_values, $function, &$arguments)
	{
		if(IsSet($parameter_values["count"]))
		{
			$count_values=array();
			$required_types=array(
				"argument"=>"NAME"
			);
			$optional_types=array(
			);
			if(!$compiler->GetOptionalArgumentValues($parameter_values["count"],$count_values,$required_types,$optional_types,"persistence",$function,1))
				return(0);
			if(strlen($arguments))
				$arguments.=", ";
			$arguments.=$count_values["argument"].":integer[1]";
		}
		return(1);
	}
	
	Function GenerateClassDiagram(&$compiler,&$module,$component,$report_name,$indent,$linefeed,&$graph)
	{
		$nodes="";

		$graph.=$indent."\"".$report_name."report\" [label=\"{".$report_name."report|";

		$module->generator->StartFormattingDiagramLines();
		if(!$module->generator->GenerateStorageClassVariablesDiagram($compiler,$module,$component,$indent,$linefeed,$variables_graph))
			return(0);
		$graph.=$variables_graph;

		$graph.="|";

		if(!$module->generator->GenerateStorageClassFunctionsDiagram($compiler,$module,$component,$indent,$linefeed,$functions_graph))
			return(0);
		$graph.=$functions_graph;

		for($function=0,Reset($module->components[$component]["reports"][$report_name]["functions"]);$function<count($module->components[$component]["reports"][$report_name]["functions"]);Next($module->components[$component]["reports"][$report_name]["functions"]),$function++)
		{
			$current_function=Key($module->components[$component]["reports"][$report_name]["functions"]);
			$function_type=$arguments="";
			$function_arguments=$module->components[$component]["reports"][$report_name]["functions"][$current_function];
			switch($module->components[$component]["reports"][$report_name]["functions"][$current_function]["type"])
			{
				case "openreport":
					if(!$module->GetReportOpenReportParameters($compiler,$component,$report_name,$module->components[$component]["reports"][$report_name]["functions"][$current_function],"report function parameter",$parameter_values))
						return(0);
					$arguments=$module->GenerateFunctionDotArgumentList($function_arguments);
					if(!$this->GetDiagramCommonFunctionArguments($compiler, $parameter_values, $current_function." report function", $arguments))
						return(0);
					$function_type="boolean";
					break;

				case "getreportdata":
					if(!$module->GetReportGetReportDataParameters($compiler,$component,$report_name,$module->components[$component]["reports"][$report_name]["functions"][$current_function],"report function parameter",$parameter_values))
						return(0);
					$arguments=$module->GenerateFunctionDotArgumentList($function_arguments);
					$data_values=array();
					$required_types=array(
						"argument"=>"NAME"
					);
					$optional_types=array();
					if(!$compiler->GetOptionalArgumentValues($parameter_values["data"],$data_values,$required_types,$optional_types,"persistence",$current_function." report function",1))
						return(0);
					if(strlen($arguments))
						$arguments.=", ";
					$arguments.=$data_values["argument"].":array[1]";
					$data_values=array();
					$required_types=array(
						"argument"=>"NAME"
					);
					$optional_types=array();
					if(!$compiler->GetOptionalArgumentValues($parameter_values["endofdata"],$end_of_data_values,$required_types,$optional_types,"persistence",$current_function." report function",1))
						return(0);
					if(strlen($arguments))
						$arguments.=", ";
					$arguments.=$end_of_data_values["argument"].":boolean[1]";
					$function_type="boolean";
					break;

				case "getallreportdata":
					if(!$module->GetReportGetAllReportDataParameters($compiler,$component,$report_name,$module->components[$component]["reports"][$report_name]["functions"][$current_function],"report function parameter",$parameter_values))
						return(0);
					$arguments=$module->GenerateFunctionDotArgumentList($function_arguments);
					$data_values=array();
					$required_types=array(
						"argument"=>"NAME"
					);
					$optional_types=array();
					if(!$compiler->GetOptionalArgumentValues($parameter_values["data"],$data_values,$required_types,$optional_types,"persistence",$current_function." report function",1))
						return(0);
					if(strlen($arguments))
						$arguments.=", ";
					$arguments.=$data_values["argument"].":array[1]";
					if(!$this->GetDiagramCommonFunctionArguments($compiler, $parameter_values, $current_function." report function", $arguments))
						return(0);
					$function_type="boolean";
					break;

				case "getreportfield":
					if(!$module->GetReportGetReportFieldParameters($compiler,$component,$report_name,$module->components[$component]["reports"][$report_name]["functions"][$current_function],"report function parameter",$parameter_values))
						return(0);
					if(!$this->GetReportQueryParameters($module, $compiler, $context, $component, $report_name, $function_arguments, $parameter_values, $parameters, $function))
						return(0);
					$arguments=$module->GenerateFunctionDotArgumentList($function_arguments);
					$field_values=array();
					$required_types=array(
						"argument"=>"NAME"
					);
					$optional_types=array();
					if(!$compiler->GetOptionalArgumentValues($parameter_values["field"],$field_values,$required_types,$optional_types,"persistence",$current_function." report function",1))
						return(0);
					if(strlen($arguments))
						$arguments.=", ";
					$arguments.=$field_values["argument"].":".$parameters["firsttype"]."[1]";
					if(!$this->GetDiagramCommonFunctionArguments($compiler, $parameter_values, $current_function." report function", $arguments))
						return(0);
					$function_type="boolean";
					break;

				case "getreportrow":
					if(!$module->GetReportGetReportRowParameters($compiler,$component,$report_name,$module->components[$component]["reports"][$report_name]["functions"][$current_function],"report function parameter",$parameter_values))
						return(0);
					$arguments=$module->GenerateFunctionDotArgumentList($function_arguments);
					$field_values=array();
					$required_types=array(
						"argument"=>"NAME"
					);
					$optional_types=array();
					if(!$compiler->GetOptionalArgumentValues($parameter_values["data"],$field_values,$required_types,$optional_types,"persistence",$current_function." report function",1))
						return(0);
					if(strlen($arguments))
						$arguments.=", ";
					$arguments.=$field_values["argument"].":array[1]";
					if(!$this->GetDiagramCommonFunctionArguments($compiler, $parameter_values, $current_function." report function", $arguments))
						return(0);
					$function_type="boolean";
					break;

				case "getreportsql":
					if(!$module->GetReportGetReportSQLParameters($compiler,$component,$report_name,$module->components[$component]["reports"][$report_name]["functions"][$current_function],"report function parameter",$parameter_values))
						return(0);
					$arguments=$module->GenerateFunctionDotArgumentList($function_arguments);
					$args=array("condition","tables","columns");
					for($argument=0;$argument<count($args);$argument++)
					{
						$argument_name=$args[$argument];
						if(IsSet($parameter_values[$argument_name]))
						{
							$field_values=array();
							$required_types=array(
								"argument"=>"NAME"
							);
							$optional_types=array();
							if(!$compiler->GetOptionalArgumentValues($parameter_values[$argument_name],$field_values,$required_types,$optional_types,"persistence",$current_function." report function",1))
								return(0);
							if(strlen($arguments))
								$arguments.=", ";
							$arguments.=$field_values["argument"].":string";
						}
					}
					$function_type="";
					break;

				default:
					return($compiler->SetElementError($function_arguments["function"]->file,$function_arguments["function"]->path,$module->components[$component]["reports"][$report_name]["functions"][$current_function]["type"]." is not yet a supported report function to generate in the graph"));
			}
			$graph.=$module->generator->FormatDiagramLine("+".$current_function."(".(strlen($arguments) ? " ".$arguments." " : "").")".(strlen($function_type) ? ":".$function_type : ""))."\\l";
		}


		$graph.="}\",color=blue]".$linefeed.$nodes;

		return(1);
	}
};

}
?>