<?php

if(!defined("METAL_TEMPLATE_INCLUDED"))
{
	define("METAL_TEMPLATE_INCLUDED",1);

/*
 * metal_template.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_template.php,v 1.36 2003/10/11 06:37:46 mlemos Exp $
 *
 */
 
class metal_template_class extends metal_base_class
{
	var $start_mark="<!--";
	var $end_mark="-->";
	var $clip_start_mark="<!--";
	var $clip_end_mark="-->";
	var $end_clip_mark="<!--/";
	var $conditional_prefix="?";
	var $template_file="";
	var $template_files=array();
	var $separator=array("Text"=>"separator");
	var $clips=array();
	var $empty_string="";

	Function OutputCommands(&$context,$conditional)
	{
		$from=count($conditional)-1;
		$to=$from-1;
		for($command_count=$statement=0;$statement<count($conditional[$from]["Output"]);$statement++)
		{
			switch($conditional[$from]["Output"][$statement]["Type"])
			{
				case "INITIALIZATION":
					$context->result[]=$conditional[$from]["Output"][$statement];
					break;
				case "COMMAND":
					$command_count++;
					break;
				default:
					$command_count+=2;
					break;
			}
		}
		if($command_count!=1)
		{
			$entry=array(
				"Data"=>"{",
				"Type"=>"COMMAND"
			);
			$this->ConditionalQueue($context,$conditional,$to,$entry);
		}
		$entry=array(
			"Data"=>1,
			"Type"=>"INDENT"
		);
		$this->ConditionalQueue($context,$conditional,$to,$entry);
		for($statement=0;$statement<count($conditional[$from]["Output"]);$statement++)
		{
			if(strcmp($conditional[$from]["Output"][$statement]["Type"],"INITIALIZATION"))
				$this->ConditionalQueue($context,$conditional,$to,$conditional[$from]["Output"][$statement]);
		}
		$entry=array(
			"Data"=>1,
			"Type"=>"OUTDENT"
		);
		$this->ConditionalQueue($context,$conditional,$to,$entry);
		if($command_count!=1)
		{
			$entry=array(
				"Data"=>"}",
				"Type"=>"COMMAND"
			);
			$this->ConditionalQueue($context,$conditional,$to,$entry);
		}
	}

	Function OpenTemplateFile(&$compiler,&$context,$file_name)
	{
		$include_path=$compiler->GetIncludePath($file_name);
		if(IsSet($this->template_files[$file_name]["Contents"]))
		{
			$context->result[]=array(
				"Data"=>array(
					"Name"=>$include_path.$file_name,
					"Type"=>"DEPENDENCY"
				),
				"Type"=>"FILE"
			);
			return(1);
		}
		if(strcmp($file_name,"")
		&& file_exists($include_path.$file_name)
		&& ($file_size=filesize($include_path.$file_name)))
		{
			if(($file=fopen($include_path.$file_name,"r")))
			{
				$this->template_files[$file_name]["Contents"]=fread($file,$file_size);
				$closed=fclose($file);
				if($this->template_files[$file_name]["Contents"]
				&& $closed)
				{
					$this->template_files[$file_name]["File"]=$include_path.$file_name;
					$context->result[]=array(
						"Data"=>array(
							"Name"=>$include_path.$file_name,
							"Type"=>"DEPENDENCY"
						),
						"Type"=>"FILE"
					);
					return(1);
				}
				Unset($this->template_files[$file_name]["Contents"]);
				$error="it was not possible to read the template file";
			}
			else
				$error="it was not possible to open the template file";
		}
		else
			$error="it was not specified a valid template file (\"$file_name\")";
		$compiler->SetElementError($context->file,$context->path,$error);
		Unset($this->template_files[$file_name]);
		return(0);
	}

	Function FindSeparator(&$compiler,&$context,$file_name)
	{
		if(IsSet($this->separator["Position"]))
			return(1);
		$separator_length=strlen($separator_text=$this->start_mark.$this->separator["Text"].$this->end_mark);
		$contents_length=strlen($this->template_files[$file_name]["Contents"]);
		if($contents_length>=$separator_length
		&& GetType($position=strpos($this->template_files[$file_name]["Contents"],$separator_text))=="integer")
		{
			$this->separator["HeaderLength"]=$position;
			$this->separator["FooterLength"]=$contents_length-($this->separator["FooterPosition"]=$position+$separator_length);
			return(1);
		}
		else
			$error="template file does not contain the text that separates the header from the footer";
		$compiler->SetElementError($context->file,$context->path,$error);
		return(0);
	}

	Function SetPositionError(&$compiler,$file_name,$byte_index,$error)
	{
		for($previous_return=0,$line=$column=1,$position=0;$position<$byte_index;$position++)
		{
			switch($this->template_files[$file_name]["Contents"][$position])
			{
				case "\n":
					if(!$previous_return)
						$line++;
					$column=1;
					$previous_return=0;
					break;
				case "\r":
					$line++;
					$column=1;
					$previous_return=1;
					break;
				default:
					$column++;
					$previous_return=0;
					break;
			}
		}
		$compiler->SetError($this->template_files[$file_name]["File"],$line,$column,$byte_index,$error);
	}

	Function ConditionalQueue(&$context,&$conditional,$to,&$entry)
	{
		if(count($conditional)
		&& $to>=0)
			$conditional[$to]["Output"][]=$entry;
		else
			$context->result[]=$entry;
	}

	Function LocateMarks(&$compiler,&$context,$data,$byte_offset,$file_name,&$variables,&$positions,&$unused_variables)
	{
		$conditional_marks=array();
		for($position=0;GetType($position=strpos($data,$this->start_mark,$position))=="integer";)
		{
			$position+=strlen($this->start_mark);
			if(GetType($mark_end=strpos($data,$this->end_mark,$position))!="integer")
				break;
			$mark=substr($data,$position,$mark_end-$position);
			if(($conditional_mark=!strcmp(substr($mark,0,strlen($this->conditional_prefix)),$this->conditional_prefix)))
			{
				if(IsSet($conditional_marks[$mark]))
					UnSet($conditional_marks[$mark]);
				else
					$conditional_marks[$mark]=$position;
			}
			if(IsSet($variables[$mark])
			|| $conditional_mark)
			{
				if(!$conditional_mark
				&& !strcmp($variables[$mark]["Type"],"include"))
				{
					$include_file=$variables[$mark]["TemplateFile"];
					$include_clip=$variables[$mark]["Clip"];
					if(!$this->OpenTemplateFile($compiler,$context,$include_file)
					|| !$this->FindClip($compiler,$context,$include_file,$include_clip)
					|| !$this->LocateMarks($compiler,$context,substr($this->template_files[$include_file]["Contents"],$this->clips[$include_file][$include_clip]["Start"],$this->clips[$include_file][$include_clip]["Length"]),$this->clips[$include_file][$include_clip]["Start"],$include_file,$variables,$positions,$unused_variables))
						return(0);
				}
				UnSet($unused_variables[$conditional_mark ? substr($mark,strlen($this->conditional_prefix)) : $mark]);
				$positions[$file_name][$byte_offset][$position-strlen($this->start_mark)]=$mark;
			}
			else
			{
				if(!IsSet($conditional_marks[$this->conditional_prefix.$mark]))
				{
					$this->SetPositionError($compiler,$file_name,$byte_offset+$position,"it was used a template mark (\"$mark\") for which it was not defined a variable value");
					return(0);
				}
			}
			$position=$mark_end+strlen($this->end_mark);
		}
		return(1);
	}

	Function ProcessMarkedData(&$compiler,&$context,$data,$byte_offset,$file_name,&$positions,&$variables)
	{
		for($conditional=array(),$start_position=0,$position=0,Reset($positions[$file_name][$byte_offset]);$position<count($positions[$file_name][$byte_offset]);Next($positions[$file_name][$byte_offset]),$position++)
		{
			$mark=$positions[$file_name][$byte_offset][$end_position=Key($positions[$file_name][$byte_offset])];
			$next_position=$end_position+strlen($this->start_mark.$mark.$this->end_mark);
			$top_conditional=count($conditional)-1;
			if($end_position>$start_position)
			{
				$entry=array(
					"Data"=>substr($data,$start_position,$end_position-$start_position),
					"Type"=>"DATA"
				);
				$this->ConditionalQueue($context,$conditional,$top_conditional,$entry);
			}
			if(!strcmp(substr($mark,0,strlen($this->conditional_prefix)),$this->conditional_prefix))
			{
				$conditional_mark=substr($mark,strlen($this->conditional_prefix));
				$byte_index=$end_position+$byte_offset;
				if(!IsSet($variables[$conditional_mark]))
				{
					for(;;)
					{
						$position++;
						if(!strcmp(Next($positions[$file_name][$byte_offset]),""))
						{
							$this->SetPositionError($compiler,$file_name,$byte_index,"matching conditional end mark \"".$conditional_mark."\" is missing in the template");
							return(0);
						}
						if(!strcmp($end_mark=$positions[$file_name][$byte_offset][$end_position=Key($positions[$file_name][$byte_offset])],$mark))
						{
							$start_position=$end_position+strlen($this->start_mark.$mark.$this->end_mark);
							break;
						}
					}
				}
				else
				{
					$end_conditional=(count($conditional) && !strcmp($conditional[$top_conditional]["Mark"],$mark));
					if($end_conditional)
					{
						switch($variables[$conditional_mark]["Type"])
						{
							case "variables":
							case "optional":
								for($mark_data=0;$mark_data<count($conditional[$top_conditional]["Output"]);$mark_data++)
									$this->ConditionalQueue($context,$conditional,$top_conditional-1,$conditional[$top_conditional]["Output"][$mark_data]);
								break;
							case "conditional":
								$parts=count($conditional[$top_conditional]["Output"]);
								for($string=$queued_data="",$part=0;$part<$parts;$part++)
								{
									switch($conditional[$top_conditional]["Output"][$part]["Type"])
									{
										case "INITIALIZATION":
										case "FILE":
											$context->result[]=$conditional[$top_conditional]["Output"][$part];
											break;
										case "DATA":
											$queued_data.=$conditional[$top_conditional]["Output"][$part]["Data"];
											break;
										case "EXPRESSION":
											if(strcmp($conditional[$top_conditional]["Output"][$part]["Data"]["Type"],"STRING"))
											{
												$compiler->SetElementError($context->file,$context->path,"it was specified a non STRING expression (".$conditional[$top_conditional]["Output"][$part]["Data"]["Type"].") within conditional template data");
												return(0);
											}
											if(!strcmp($conditional[$top_conditional]["Output"][$part]["Data"]["Side"],"LEFT"))
											{
												$compiler->SetElementError($context->file,$context->path,"it was specified a non readable STRING expression within conditional template data");
												return(0);
											}
											if(strcmp($queued_data,""))
											{
												if(strcmp($string,""))
													$string.=".";
												if(!$compiler->ConvertData($context,"STRING",$queued_data,$data_string))
													return(0);
												$string.=$data_string;
												$queued_data="";
											}
											if(strcmp($string,""))
												$string.=".";
											$string.=$conditional[$top_conditional]["Output"][$part]["Data"]["Value"];
											break;
										default:
											$compiler->SetElementError($variables[$conditional_mark]["File"],$variables[$conditional_mark]["Path"],"it was specified an non string data (\"".$conditional[$top_conditional]["Output"][$part]["Type"]."\") part in template conditional expression");
											return(0);
									}
								}
								if(strcmp($queued_data,""))
								{
									if(strcmp($string,""))
										$string.=".";
									if(!$compiler->ConvertData($context,"STRING",$queued_data,$data_string))
										return(0);
									$string.=$data_string;
								}
								if(strcmp($string,""))
								{
									if(!strcmp($this->empty_string,"")
									&& !$compiler->ConvertData($context,"STRING","",$this->empty_string))
										return(0);
									if(IsSet($variables[$conditional_mark]["False"]))
										return($compiler->SetElementError($variables[$conditional_mark]["File"],$variables[$conditional_mark]["Path"],"conditional values in optional template sections with then and else values are not yet supported"));
									$value="(".$variables[$conditional_mark]["Condition"]." ? ".$string." : ".$this->empty_string.")";
									$entry=array(
										"Data"=>array(
											"Value"=>$value,
											"Type"=>"STRING",
											"Side"=>"RIGHT"
										),
										"Type"=>"EXPRESSION"
									);
									$this->ConditionalQueue($context,$conditional,$top_conditional-1,$entry);
								}
								break;
							case "if":
								$entry=array(
									"Data"=>"if(".$variables[$conditional_mark]["Condition"].")",
									"Type"=>"COMMAND"
								);
								$this->ConditionalQueue($context,$conditional,$top_conditional-1,$entry);
								$this->OutputCommands($context,$conditional);
								break;
							default:
								return($compiler->SetElementError($variables[$conditional_mark]["File"],$variables[$conditional_mark]["Path"],$variables[$mark]["Type"]." is not yet a supported template conditional variable type"));
						}
						Unset($conditional[$top_conditional]);
					}
					else
						$conditional[count($conditional)]=array("Mark"=>$mark,"Index"=>$byte_index,"Output"=>array());
					$start_position=$next_position;
				}
			}
			else
			{
				switch($variables[$mark]["Type"])
				{
					case "variables":
					case "optional":
						for($mark_data=0;$mark_data<count($variables[$mark]["Output"]);$mark_data++)
							$this->ConditionalQueue($context,$conditional,$top_conditional,$variables[$mark]["Output"][$mark_data]);
						break;
					case "conditional":
						if(!strcmp($this->empty_string,"")
						&& !$compiler->ConvertData($context,"STRING","",$this->empty_string))
							return(0);
						if(!IsSet($variables[$mark]["True"]))
						{
							$compiler->SetElementError($variables[$mark]["File"],$variables[$mark]["Path"],"it was not specified the template conditional then argument");
							return(0);
						}
						if($top_conditional>=0
						&& !strcmp($mark,substr($conditional[$top_conditional]["Mark"],strlen($this->conditional_prefix)))
						&& !IsSet($variables[$mark]["False"]))
							$value=$variables[$mark]["True"];
						else
							$value="(".$variables[$mark]["Condition"]." ? ".$variables[$mark]["True"]." : ".(IsSet($variables[$mark]["False"]) ? $variables[$mark]["False"] : $this->empty_string).")";
						$entry=array(
							"Data"=>array(
								"Value"=>$value,
								"Type"=>"STRING",
								"Side"=>"RIGHT"
							),
							"Type"=>"EXPRESSION"
						);
						$this->ConditionalQueue($context,$conditional,$top_conditional,$entry);
						break;
					case "include":
						$include_file=$variables[$mark]["TemplateFile"];
						$include_clip=$variables[$mark]["Clip"];
						if(!$this->ProcessMarkedData($compiler,$context,substr($this->template_files[$include_file]["Contents"],$this->clips[$include_file][$include_clip]["Start"],$this->clips[$include_file][$include_clip]["Length"]),$this->clips[$include_file][$include_clip]["Start"],$include_file,$positions,$variables))
							return(0);
						break;
					default:
						return($compiler->SetElementError($variables[$mark]["File"],$variables[$mark]["Path"],$variables[$mark]["Type"]." is not yet a supported template variable type"));
				}
				$start_position=$next_position;
			}
		}
		if(count($conditional))
		{
			$this->SetPositionError($compiler,$file_name,$conditional[count($conditional)-1]["Index"],"matching conditional end mark \"".$conditional[count($conditional)-1]["Mark"]."\" is missing in the template");
			return(0);
		}
		if(strcmp($data=substr($data,$start_position,strlen($data)-$start_position),""))
		{
			$context->result[]=array(
				"Data"=>$data,
				"Type"=>"DATA"
			);
		}
		return(1);
	}

	Function AddMarkedData(&$compiler,&$context,$file_name,&$variables,$data,$byte_offset)
	{
		for($unused_variables=array(),$variable=0,Reset($variables);$variable<count($variables);Next($variables),$variable++)
		{
			$variable_name=Key($variables);
			if(strcmp($variables[$variable_name]["Type"],"optional"))
				$unused_variables[$variable_name]="";
		}
		$positions=array($file_name=>array($byte_offset=>array()));
		if(!$this->LocateMarks($compiler,$context,$data,$byte_offset,$file_name,$variables,$positions,$unused_variables))
			return(0);
		if(count($unused_variables))
		{
			Reset($unused_variables);
			$compiler->SetElementError($context->file,$context->path,"it was specified a template variable (\"".Key($unused_variables)."\") that does not match any of the template marks");
			return(0);
		}
		return($this->ProcessMarkedData($compiler,$context,$data,$byte_offset,$file_name,$positions,$variables));
	}

	Function FindClip(&$compiler,&$context,$file_name,$clip)
	{
		if(IsSet($this->clips[$file_name][$clip]))
			return(1);
		$start_clip_text=$this->clip_start_mark.$clip.$this->clip_end_mark;
		$contents_length=strlen($this->template_files[$file_name]["Contents"]);
		if(GetType($start_position=strpos($this->template_files[$file_name]["Contents"],$start_clip_text))=="integer")
		{
			$start_position+=strlen($start_clip_text);
			if(GetType($end_position=strpos($this->template_files[$file_name]["Contents"],$this->end_clip_mark.$clip.$this->clip_end_mark,$start_position))=="integer")
			{
				$this->clips[$file_name][$clip]=array(
					"Start"=>$start_position,
					"Length"=>$end_position-$start_position
				);
				return(1);
			}
			else
				$error="could not find the clip $clip end mark";
		}
		else
			$error="could not find the clip $clip start mark";
		$compiler->SetElementError($context->file,$context->path,$error);
		return(0);
	}

	Function Setup(&$compiler,&$code,&$attributes)
	{
		$elements=$code->structure[$attributes->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$attributes->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "startmark":
						if(!$compiler->GetValidData($attributes->file,$element_path,$this->start_mark,"it was not specified a valid template variable startmark"))
							return(0);
						break;
					case "endmark":
						if(!$compiler->GetValidData($attributes->file,$element_path,$this->end_mark,"it was not specified a valid template variable endmark"))
							return(0);
						break;
					case "clipstartmark":
						if(!$compiler->GetValidData($attributes->file,$element_path,$this->clip_start_mark,"it was not specified a valid template variable clipstartmark"))
							return(0);
						break;
					case "clipendmark":
						if(!$compiler->GetValidData($attributes->file,$element_path,$this->clip_end_mark,"it was not specified a valid template variable clipendmark"))
							return(0);
						break;
					case "endclipmark":
						if(!$compiler->GetValidData($attributes->file,$element_path,$this->end_clip_mark,"it was not specified a valid template endclipmark"))
							return(0);
					case "conditionalprefix":
						if(!$compiler->GetValidData($attributes->file,$element_path,$this->conditional_prefix,"it was not specified a valid template conditionalprefix"))
							return(0);
						break;
					case "file":
						if(!$compiler->GetValidData($attributes->file,$element_path,$this->template_file,"it was not specified a valid template file name"))
							return(0);
						$this->template_files[$this->template_file]=array(
							"File"=>$this->template_file,
							"Source"=>$attributes->file,
							"Path"=>$element_path.",0"
						);
						break;
					case "separator":
						if(!$compiler->GetValidData($attributes->file,$element_path,$this->separator["Text"],"it was not specified a valid separator text"))
							return(0);
						break;
					default:
						$compiler->SetElementError($attributes->file,$element_path,$data["Tag"]." is not a supported template object attribute");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($attributes->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function GetVariables(&$compiler,&$code,&$context,&$variables,$function,&$clip,$find_clip)
	{
		$elements=$code->structure[$context->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$context->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
				  case "do":
						if(!$compiler->GetOutputData($context->file,$element_path,$context->result,"invalid template do section",1))
							return(0);
				  	break;
					case "variables":
					case "optional":
					case "conditional":
					case "if":
					case "include":
						$variable_elements=$code->structure[$element_path]["Elements"];
						for($variable_element=0;$variable_element<$variable_elements;$variable_element++)
						{
							$variable_element_path=$element_path.",$variable_element";
							$element_data=$code->structure[$variable_element_path];
							if(GetType($element_data)=="array")
							{
								$variable=$element_data["Tag"];
								if(!strcmp($this->separator["Text"],$variable))
								{
									$compiler->SetElementError($context->file,$variable_element_path,"it was specified template variable with the name the header and footer separator text");
									return(0);
								}
								if(IsSet($variables[$variable]))
								{
									$compiler->SetElementError($context->file,$variable_element_path,"it was specified an already defined template clip variable");
									return(0);
								}
								$variables[$variable]=array("Type"=>$data["Tag"]);
								switch($data["Tag"])
								{
									case "variables":
									case "optional":
										if($find_clip)
										{
											if(!$compiler->GetOutputData($context->file,$variable_element_path,$variables[$variable]["Output"],"invalid variable",0))
												return(0);
										}
										else
										{
											if($compiler->GetValidData($context->file,$variable_element_path,$variable_data,"it was not specified a valid template clip mark text"))
											{
												$variables[$variable]["Output"]=array(
													array(
														"Data"=>$variable_data,
														"Type"=>"DATA"
													)
												);
											}
											else
											{
												$compiler->CopyEmptyContext($context,$evaluate_context);
												$evaluate_context->path=$variable_element_path;
												if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid variable value"))
													return(0);
												$variables[$variable]["Output"]=$evaluate_context->result;
											}
										}
										break;
									case "conditional":
									case "if":
										$types=array();
										$section_type=($data["Tag"]=="if" ? "PATH" : "STRING");
										$optional_types=array(
											"istrue"=>"BOOLEAN:NOTLEFT",
											"isfalse"=>"BOOLEAN:NOTLEFT",
											"then"=>$section_type,
											"else"=>$section_type
										);
										$values=array();
										$compiler->CopyEmptyContext($context,$evaluate_context);
										$evaluate_context->path=$variable_element_path;
										if(!$compiler->GetOptionalArgumentValues($evaluate_context,$values,$types,$optional_types,"template",$function,1))
											return(0);
										if($data["Tag"]=="if"
										&& (IsSet($values["then"])
										|| IsSet($values["else"])))
										{
											$compiler->SetElementError($context->file,$variable_element_path,"then and else sections are not yet support for template clip if variables");
											return(0);
										}
										if(!IsSet($values["istrue"])
										&& !IsSet($values["isfalse"]))
										{
											$compiler->SetElementError($context->file,$variable_element_path,"it was not specified template clip ".$data["Tag"]." variable condition");
											return(0);
										}
										$variables[$variable]["Condition"]=(IsSet($values["istrue"]) ? $values["istrue"] : "!".$values["isfalse"]);
										if(IsSet($values["then"]))
											$variables[$variable]["True"]=$values["then"];
										if(IsSet($values["else"]))
											$variables[$variable]["False"]=$values["else"];
										$variables[$variable]["File"]=$context->file;
										$variables[$variable]["Path"]=$variable_element_path;
										break;
									case "include":
										$values=array();
										$required_types=array(
											"file"=>"DATA",
											"clip"=>"DATA"
										);
										$optional_types=array(
										);
										$compiler->CopyEmptyContext($context,$include_context);
										$include_context->path=$variable_element_path;
										if(!$compiler->GetOptionalArgumentValues($include_context,$values,$required_types,$optional_types,"persistence","factory",1))
											return(0);
										$variables[$variable]["File"]=$context->file;
										$variables[$variable]["Path"]=$variable_element_path;
										$variables[$variable]["TemplateFile"]=$values["file"];
										$variables[$variable]["Clip"]=$values["clip"];
										break;
								}
							}
							else
							{
								if(!$compiler->CheckWhiteSpace($context->file,$element_data,$variable_element_path))
									return(0);
							}
						}
						break;
					case "clip":
						if($find_clip)
						{
							if(IsSet($clip))
							{
								$compiler->SetElementError($context->file,$element_path,"it was specified an already defined template clip");
								return(0);
							}
							if(!$compiler->GetValidData($context->file,$element_path,$clip,"it was not specified a valid template clip mark text"))
								return(0);
							break;
						}
					default:
						$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported template clip attribute");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		switch($function)
		{
			case "header":
				$variables=array();
				if(!$this->OpenTemplateFile($compiler,$context,$this->template_file)
				|| !$this->FindSeparator($compiler,$context,$this->template_file)
				|| !$this->GetVariables($compiler,$code,$context,$variables,$function,$clip,0)
				|| !$this->GetVariables($compiler,$arguments_code,$arguments,$variables,$function,$clip,0)
				|| !$this->AddMarkedData($compiler,$context,$this->template_file,$variables,substr($this->template_files[$this->template_file]["Contents"],0,$this->separator["HeaderLength"]),0))
					return(0);
				break;
			case "footer":
				$variables=array();
				if(!$this->OpenTemplateFile($compiler,$context,$this->template_file)
				|| !$this->FindSeparator($compiler,$context,$this->template_file)
				|| !$this->GetVariables($compiler,$code,$context,$variables,$function,$clip,0)
				|| !$this->GetVariables($compiler,$arguments_code,$arguments,$variables,$function,$clip,0)
				|| !$this->AddMarkedData($compiler,$context,$this->template_file,$variables,substr($this->template_files[$this->template_file]["Contents"],$this->separator["FooterPosition"],$this->separator["FooterLength"]),$this->separator["FooterPosition"]))
					return(0);
				break;
			case "clip":
				$variables=array();
				if(!$this->OpenTemplateFile($compiler,$context,$this->template_file)
				|| !$this->GetVariables($compiler,$code,$context,$variables,$function,$clip,1)
				|| !$this->GetVariables($compiler,$arguments_code,$arguments,$variables,$function,$clip,1)
				|| !$this->FindClip($compiler,$context,$this->template_file,$clip)
				|| !$this->AddMarkedData($compiler,$context,$this->template_file,$variables,substr($this->template_files[$this->template_file]["Contents"],$this->clips[$this->template_file][$clip]["Start"],$this->clips[$this->template_file][$clip]["Length"]),$this->clips[$this->template_file][$clip]["Start"]))
					return(0);
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported template object function");
				return(0);
		}
		return(1);
	}
};
 
}
?>