<?php
if(!defined("METAL_TIME_INCLUDED"))
{
	define("METAL_TIME_INCLUDED",1);

/*
 * metal_time.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_time.php,v 1.12 2004/09/11 01:13:22 mlemos Exp $
 *
 */

class metal_time_class extends metal_base_class
{
	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the time class");
			return(0);
		}
		switch($function)
		{
			case "isonow":
			case "isonowutc":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>(strcmp($function,"isonow") ? "gmstrftime" : "strftime")."('%Y-%m-%d %H:%M:%S')",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "isotoday":
			case "isotodayutc":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>(strcmp($function,"isotoday") ? "gmstrftime" : "strftime")."('%Y-%m-%d')",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "isotimenow":
			case "isotimenowutc":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>(strcmp($function,"isotimenow") ? "gmstrftime" : "strftime")."('%H:%M:%S')",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "isodatetime":
			case "isodate":
			case "isotime":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,"INTEGER","NOTLEFT","it was not specified a valid timestamp integer expression",1)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$expression_value,$expression_type))
					return(0);
				switch($function)
				{
					case "isodatetime":
						$format="%Y-%m-%d %H:%M:%S";
						break;
					case "isodate":
						$format="%Y-%m-%d";
						break;
					case "isotime":
						$format="%H:%M:%S";
						break;
				}
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"strftime('$format',$expression_value)",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "rfc822now":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"gmstrftime('%a, %d %b %Y %H:%M:%S GMT')",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "rfc822datetime":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,"INTEGER","NOTLEFT","it was not specified a valid timestamp integer expression",1)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$expression_value,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"gmstrftime('%a, %d %b %Y %H:%M:%S GMT',$expression_value)",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "timestampnow":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"time()",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "uniqueid":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,"STRING","NOTLEFT","it was not specified a valid time uniqueid string expression",1)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$expression_value,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"uniqid($expression_value)",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "isodatetimestamp":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidExpression($evaluate_context,"STRING","NOTLEFT","it was not specified a valid time ISO timestamp string expression",1)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$expression_value,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"mktime(substr($expression_value,11,2),substr($expression_value,14,2),substr($expression_value,17,2),substr($expression_value,5,2),substr($expression_value,8,2),substr($expression_value,0,4))",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported time object function");
				return(0);
		}
		return(1);
	}

};

}
?>