<?php
if(!defined("METAL_XML_INCLUDED"))
{
	define("METAL_XML_INCLUDED",1);

/*
 * metal_xml_parser.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_xml_parser.php,v 1.7 2004/05/11 04:23:44 mlemos Exp $
 *
 */
 
class metal_xml_parser_class extends metal_base_class
{
	var $class_file="xml.php";
	var $class_base_path="";

	Function Setup(&$compiler,&$code,&$attributes)
	{
		$elements=$code->structure[$attributes->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$attributes->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "classfile":
						if(!$compiler->GetValidData($attributes->file,$element_path,&$class_file,"it was not specified a valid xml parser class file"))
							return(0);
						if(!file_exists($class_file))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was not specified a valid an existing xml parser class file (\"$class_file\")");
							return(0);
						}
						$this->class_file=$class_file;
						break;
					case "classbasepath":
						if(!$compiler->GetValidData($attributes->file,$element_path,&$this->class_base_path,"it was not specified a valid xml parser class base path"))
							return(0);
						break;
					default:
						$compiler->SetElementError($attributes->file,$element_path,$data["Tag"]." is not a supported xml parser object attribute");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($attributes->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function GetObject(&$compiler,&$context,$element_path,&$object)
	{
		if(strcmp($object,""))
		{
			$compiler->SetElementError($context->file,$element_path,"it was specified the xml parser object argument");
			return(0);
		}
		$compiler->CopyEmptyContext($context,$evaluate_context);
		$evaluate_context->path=$element_path;
		if(!$compiler->GetValidExpression(&$evaluate_context,"OBJECT","NOTRIGHT","it was not specified a valid xml parser object expression",1)
		|| !$compiler->GetExpressionValue(&$context,&$evaluate_context->result,&$object,&$expression_type))
			return(0);
		return(1);
	}

	Function GetXMLArguments(&$compiler,&$code,&$context,&$object)
	{
		$elements=$code->structure[$context->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$context->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "object":
						if(!$this->GetObject(&$compiler,&$context,$element_path,&$object))
							return(0);
						break;
					default:
						$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported xml parser argument");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function VerifyXMLArguments(&$compiler,&$code,&$context,&$object)
	{
		$object="";
		if(!$this->GetXMLArguments(&$compiler,&$code,&$context,&$object))
			return(0);
		If(!strcmp($object,""))
		{
			$compiler->SetElementError($context->file,$context->path,"it was not specified the xml parser object argument");
			return(0);
		}
		return(1);
	}

	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the xml parser class");
			return(0);
		}
		switch($function)
		{
			case "new":
				if(!$this->VerifyXMLArguments(&$compiler,&$arguments_code,&$arguments,&$object))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>$object."=new xml_parser_class;",
					"Type"=>"COMMAND"
				);
				break;
			case "parse":
				$types=array(
					"object"=>"OBJECT",
					"data"=>"STRING",
					"endofdata"=>"BOOLEAN"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"xml parser",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$values["object"]."->Parse(".$values["data"].",".$values["endofdata"].")",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "structure":
				if(!$this->VerifyXMLArguments(&$compiler,&$arguments_code,&$arguments,&$object))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$object."->structure",
						"Type"=>"HASH",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "istag":
				$types=array(
					"object"=>"OBJECT",
					"path"=>"STRING"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"xml parser",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"(GetType(".$values["object"]."->structure[".$values["path"]."])==\"array\")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "tagname":
				$types=array(
					"object"=>"OBJECT",
					"path"=>"STRING"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"xml parser",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$values["object"]."->structure[".$values["path"]."][\"Tag\"]",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "element":
				$types=array(
					"object"=>"OBJECT",
					"path"=>"STRING"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"xml parser",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$values["object"]."->structure[".$values["path"]."]",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "tagelements":
				$types=array(
					"object"=>"OBJECT",
					"path"=>"STRING"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"xml parser",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$values["object"]."->structure[".$values["path"]."][\"Elements\"]",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "verifywhitespace":
				$types=array(
					"object"=>"OBJECT",
					"path"=>"STRING"
				);
				if(!$compiler->GetArgumentValues(&$arguments_code,&$arguments,&$code,&$context,&$values,&$types,"xml parser",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$values["object"]."->VerifyWhiteSpace(".$values["path"].")",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported xml parser object function");
				return(0);
		}
		return(1);
	}

	Function Initialization(&$compiler,&$context,$object_context)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the xml parser class");
			return(0);
		}
		$relative_path=$compiler->RelativePath($this->class_base_path,$this->class_file);
		$context->result[]=array(
			"Data"=>array(
				"Name"=>$this->class_file,
				"Type"=>"SUPPLIED"
			),
			"Type"=>"FILE"
		);
		$context->result[]=array(
			"Data"=>"require(\"$relative_path\");",
			"Type"=>"COMMAND"
		);
		return(1);
	}

};
 
}
?>