<?php
if(!defined("METAL_PHP_CLASS_BINDINGS_INCLUDED"))
{
	define("METAL_PHP_CLASS_BINDINGS_INCLUDED",1);

/*
 * php_class.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/php_class.php,v 1.26 2004/09/06 08:15:26 mlemos Exp $
 *
 */
 
class php_class_class extends metal_language_bindings_class
{
	Function GenerateComment(&$compiler,$comment,&$result)
	{
		for($line=$comment;strcmp($line,"");)
		{
			$line=$compiler->strtok($line,"\r\n");
			$result[]=array(
				"Data"=>" * $line",
				"Type"=>"COMMAND"
			);
			$line=$compiler->strtok("");
		}
	}

	Function GenerateVariables(&$module,&$result,&$variables,$class,$package,$protected)
	{
		for(Reset($module->classes[$class]["variables"]),$function=0;$function<count($module->classes[$class]["variables"]);$function++,Next($module->classes[$class]["variables"]))
		{
			$name=Key($module->classes[$class]["variables"]);
			if(($protected
			&& IsSet($module->classes[$class]["variables"][$name]["protected"]))
			|| ($package
			&& IsSet($module->classes[$class]["variables"][$name]["package"]))
			|| (!$protected
			&& !$package
			&& !IsSet($module->classes[$class]["variables"][$name]["protected"])
			&& !IsSet($module->classes[$class]["variables"][$name]["package"])))
			{
				if(count($variables)==0)
				{
					if(!$protected)
					{
						$result[]=array(
							"Data"=>"",
							"Type"=>"COMMAND"
						);
					}
					$result[]=array(
						"Data"=>"/*",
						"Type"=>"COMMAND"
					);
					$result[]=array(
						"Data"=>" * ".($protected ? "Protected variables" : ($package ? "Package variables" : "Public variables")),
						"Type"=>"COMMAND"
					);
					$result[]=array(
						"Data"=>" *",
						"Type"=>"COMMAND"
					);
					$result[]=array(
						"Data"=>" */",
						"Type"=>"COMMAND"
					);
				}
				$value=(IsSet($module->classes[$class]["variables"][$name]["value"]) ? "=".$module->classes[$class]["variables"][$name]["convertedvalue"] : "");
				$result[]=array(
					"Data"=>"var \$$name$value;",
					"Type"=>"COMMAND"
				);
				$variables[$name]=$class;
			}
		}
		if(IsSet($module->classes[$class]["parent"]))
		{
			$parent=$module->classes[$class]["parent"];
			if(IsSet($module->classes[$parent]["abstract"]))
				return($this->GenerateVariables($module,$result,$variables,$parent,$package,$protected));
		}
		return(1);
	}

	Function GenerateFunctions(&$module,&$compiler,&$result,&$functions,$class,$package,$protected)
	{
		for($output_function=0,Reset($module->classes[$class]["functions"]),$function=0;$function<count($module->classes[$class]["functions"]);$function++,Next($module->classes[$class]["functions"]))
		{
			$name=Key($module->classes[$class]["functions"]);
			if(!IsSet($functions[$name])
			&& (($protected
			&& IsSet($module->classes[$class]["functions"][$name]["protected"]))
			|| ($package
			&& IsSet($module->classes[$class]["functions"][$name]["package"]))
			|| (!$package
			&& !$protected
			&& !IsSet($module->classes[$class]["functions"][$name]["protected"])
			&& !IsSet($module->classes[$class]["functions"][$name]["package"]))))
			{
				$result[]=array(
					"Data"=>"",
					"Type"=>"COMMAND"
				);
				if(count($functions)==0)
				{
					$result[]=array(
						"Data"=>"/*",
						"Type"=>"COMMAND"
					);
					$result[]=array(
						"Data"=>" * ".($protected ? "Protected functions" : ($package ? "Package functions" : "Public functions")),
						"Type"=>"COMMAND"
					);
					$result[]=array(
						"Data"=>" *",
						"Type"=>"COMMAND"
					);
					$result[]=array(
						"Data"=>" */",
						"Type"=>"COMMAND"
					);
				}
				if(!$module->GenerateFunction($compiler,$class,$name))
					return(0);
				$argument_list="";
				if(IsSet($module->classes[$class]["functions"][$name]["Arguments"]))
				{
					$arguments=$module->classes[$class]["functions"][$name]["Arguments"];
					for(Reset($arguments),$argument=0;$argument<count($arguments);Next($arguments),$argument++)
					{
						if($argument>0)
							$argument_list.=",";
						$argument_list.=($arguments[Key($arguments)]["parameter"]=="in" ? "" : "&")."\$".Key($arguments);
					}
				}
				switch($compiler->strtok($module->classes[$class]["functions"][$name]["type"],":"))
				{
					case "OBJECT":
					case "ARRAY":
					case "HASH":
						$reference="&";
						break;
					default:
						$reference="";
						break;
				}
				$result[]=array(
					"Data"=>"Function $reference$name($argument_list)",
					"Type"=>"COMMAND"
				);
				$result[]=array(
					"Data"=>"{",
					"Type"=>"COMMAND"
				);
				$result[]=array(
					"Data"=>1,
					"Type"=>"INDENT"
				);
				for($part=0;$part<count($module->classes[$class]["functions"][$name]["do"]["code"]);$part++)
				{
					if(strcmp($module->classes[$class]["functions"][$name]["do"]["code"][$part]["Type"],"INITIALIZATION"))
						$result[]=$module->classes[$class]["functions"][$name]["do"]["code"][$part];
					else
						$initialization_result[]=$module->classes[$class]["functions"][$name]["do"]["code"][$part];
				}
				$result[]=array(
					"Data"=>1,
					"Type"=>"OUTDENT"
				);
				$result[]=array(
					"Data"=>"}",
					"Type"=>"COMMAND"
				);
				$functions[$name]=$class;
			}
		}
		if(IsSet($module->classes[$class]["parent"]))
		{
			$parent=$module->classes[$class]["parent"];
			if(IsSet($module->classes[$parent]["abstract"]))
				return($this->GenerateFunctions($module,$compiler,$result,$functions,$parent,$package,$protected));
		}
		return(1);
	}

	Function Execute(&$compiler,&$context,&$class,$function,&$message)
	{
		switch($function)
		{
			case "output":
				$message["result"]=array();
				$message["result"][]=array(
					"Data"=>0,
					"Type"=>"RESETINDENT"
				);
				if(strcmp($class->classes[$message["class"]]["file"],""))
				{
					if(!IsSet($class->classes[$message["class"]]["tag"]))
						$class->classes[$message["class"]]["tag"]="CLASS_".strtoupper(ereg_replace("[^A-Za-z0-9]","_",$class->classes[$message["class"]]["file"]));
					$message["result"][]=array(
						"Data"=>"if(!defined('".$class->classes[$message["class"]]["tag"]."'))",
						"Type"=>"COMMAND"
					);
					$message["result"][]=array(
						"Data"=>"{",
						"Type"=>"COMMAND"
					);
					$message["result"][]=array(
						"Data"=>1,
						"Type"=>"INDENT"
					);
					$message["result"][]=array(
						"Data"=>"define('".$class->classes[$message["class"]]["tag"]."',1);",
						"Type"=>"COMMAND"
					);
					$message["result"][]=array(
						"Data"=>1,
						"Type"=>"OUTDENT"
					);
				}
				$message["result"][]=array(
					"Data"=>"",
					"Type"=>"COMMAND"
				);
				if(IsSet($class->classes[$message["class"]]["version"])
				|| IsSet($class->classes[$message["class"]]["copyright"]))
				{
					$message["result"][]=array(
						"Data"=>"/*",
						"Type"=>"COMMAND"
					);
					$message["result"][]=array(
						"Data"=>" *",
						"Type"=>"COMMAND"
					);
					if(IsSet($class->classes[$message["class"]]["copyright"]))
					{
						$this->GenerateComment($compiler,$class->classes[$message["class"]]["copyright"],$message["result"]);
						if(IsSet($class->classes[$message["class"]]["version"]))
						{
							$message["result"][]=array(
								"Data"=>" *",
								"Type"=>"COMMAND"
							);
						}
					}
					if(IsSet($class->classes[$message["class"]]["version"]))
						$this->GenerateComment($compiler,$class->classes[$message["class"]]["version"],$message["result"]);
					$message["result"][]=array(
						"Data"=>" *",
						"Type"=>"COMMAND"
					);
					$message["result"][]=array(
						"Data"=>" */",
						"Type"=>"COMMAND"
					);
					$message["result"][]=array(
						"Data"=>"",
						"Type"=>"COMMAND"
					);
				}
				$message["result"][]=array(
					"Data"=>"class ".$class->classes[$message["class"]]["name"].((IsSet($class->classes[$message["class"]]["parent"]) && !IsSet($class->classes[$class->classes[$message["class"]]["parent"]]["abstract"])) ? " extends ".$class->classes[$class->classes[$message["class"]]["parent"]]["name"] : ""),
					"Type"=>"COMMAND"
				);
				$message["result"][]=array(
					"Data"=>"{",
					"Type"=>"COMMAND"
				);
				$message["result"][]=array(
					"Data"=>1,
					"Type"=>"INDENT"
				);
				$variables=array();
				if(!$this->GenerateVariables($class,$message["result"],$variables,$message["class"],0,1))
					return(0);
				$variables=array();
				if(!$this->GenerateVariables($class,$message["result"],$variables,$message["class"],1,0))
					return(0);
				$variables=array();
				if(!$this->GenerateVariables($class,$message["result"],$variables,$message["class"],0,0))
					return(0);
				if(count($class->classes[$message["class"]]["variables"])
				&& count($class->classes[$message["class"]]["functions"]))
				{
					$message["result"][]=array(
						"Data"=>"",
						"Type"=>"COMMAND"
					);
				}
				$functions=array();
				if(!$this->GenerateFunctions($class,$compiler,$message["result"],$functions,$message["class"],0,1))
					return(0);
				$functions=array();
				if(!$this->GenerateFunctions($class,$compiler,$message["result"],$functions,$message["class"],1,0))
					return(0);
				$functions=array();
				if(!$this->GenerateFunctions($class,$compiler,$message["result"],$functions,$message["class"],0,0))
					return(0);
				$message["result"][]=array(
					"Data"=>1,
					"Type"=>"OUTDENT"
				);
				$message["result"][]=array(
					"Data"=>"};",
					"Type"=>"COMMAND"
				);
				$message["result"][]=array(
					"Data"=>"",
					"Type"=>"COMMAND"
				);
				if(strcmp($class->classes[$message["class"]]["file"],""))
				{
					$message["result"][]=array(
						"Data"=>"}",
						"Type"=>"COMMAND"
					);
				}
				$message["result"][]=array(
					"Data"=>0,
					"Type"=>"RESTOREINDENT"
				);
				break;
			case "functionargument":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"\$".$message["name"],
						"Type"=>$class->classes[$message["class"]]["functions"][$class->classes[$message["class"]]["function_name"]]["Arguments"][$message["name"]]["type"],
						"Side"=>"BOTH"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "return":
				$context->result[]=array(
					"Data"=>"return ".$message["value"].";",
					"Type"=>"COMMAND"
				);
				break;
			case "instance":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"\$"."this",
						"Type"=>"OBJECT:".$class->classes[$message["class"]]["name"],
						"Side"=>"BOTH"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "instancevariable":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"\$"."this->".$message["name"],
						"Type"=>$class->classes[$message["class"]]["variables"][$message["name"]]["type"],
						"Side"=>"BOTH"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "instancevariableisnotnull":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"IsSet(\$"."this->".$message["name"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "setinstancevariablenull":
				$context->result[]=array(
					"Data"=>"UnSet(\$"."this->".$message["name"].");",
					"Type"=>"COMMAND"
				);
				break;
			case "instancecall":
			case "call":
				for($argument_list="",$argument=0;$argument<count($message["argumentlist"]);$argument++)
				{
					if($argument>0)
						$argument_list.=",";
					$argument_list.=$message["argumentlist"][$argument];
				}
				$statement=(strcmp($function,"instancecall") ? $message["object"] : "\$this")."->".$message["function"]."($argument_list)";
				if(strcmp($class->classes[$message["class"]]["functions"][$message["function"]]["type"],"VOID"))
				{
					$context->result[]=array(
						"Data"=>array(
							"Value"=>$statement,
							"Type"=>$class->classes[$message["class"]]["functions"][$message["function"]]["type"],
							"Side"=>"RIGHT"
						),
						"Type"=>"EXPRESSION"
					);
				}
				else
				{
					$context->result[]=array(
						"Data"=>$statement.";",
						"Type"=>"COMMAND"
					);
				}
				break;
			case "new":
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$class->object_name,
						"Context"=>$class->classes[$message["subclass"]]["name"]
					),
					"Type"=>"INITIALIZATION"
				);
				if(IsSet($message["classpointer"]))
					$class_name=$message["classpointer"];
				else
				{
					$class_name=$class->classes[$message["subclass"]]["name"];
					for($subclass=$message["subclass"];;$subclass=$class->classes[$subclass]["parent"])
					{
						$class->classes[$subclass]["staticload"]=1;
						if(!$subclass)
							break;
					}
				}
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"new $class_name",
						"Type"=>"OBJECT:$class_name",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "objectvariable":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$message["object"]."->".$message["name"],
						"Type"=>$class->classes[$message["subclass"]]["variables"][$message["name"]]["type"],
						"Side"=>"BOTH"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "objectvariableisnotnull":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"IsSet(".$message["object"]."->".$message["name"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "setobjectvariablenull":
				$context->result[]=array(
					"Data"=>"UnSet(".$message["object"]."->".$message["name"].");",
					"Type"=>"COMMAND"
				);
				break;
			case "examplecode":
				if($message["initialization"])
				{
					if(!$compiler->GenerateOutput($context,$message["result"],$output,"",0))
						return(0);
				}
				else
				{
					for($stripped=array(),$part=0;$part<count($message["result"]);$part++)
					{
						switch($message["result"][$part]["Type"])
						{
							case "INITIALIZATION":
								break;
							default:
								$stripped[]=$message["result"][$part];
								break;
						}
					}
					if(!$compiler->GenerateOutput($context,$stripped,$output,"",0))
						return(0);
				}
				$context->result[]=array(
					"Data"=>$output,
					"Type"=>"DATA"
				);
				break;
			case "typename":
				switch($compiler->strtok($message["type"],":"))
				{
					case "VOID":
						$message["name"]="";
						break;
					case "STRING":
						$message["name"]="string";
						break;
					case "INTEGER":
						$message["name"]="int";
						break;
					case "FLOAT":
						$message["name"]="double";
						break;
					case "BOOLEAN":
						$message["name"]="bool";
						break;
					case "OBJECT":
						$message["name"]="object";
						break;
					case "ARRAY":
						$message["name"]="array";
						break;
					case "HASH":
						$message["name"]="array";
						break;
					case "STRINGBUFFER":
						$message["name"]="string &";
						break;
					case "INTEGERBUFFER":
						$message["name"]="int &";
						break;
					case "FLOATBUFFER":
						$message["name"]="double &";
						break;
					case "BOOLEANBUFFER":
						$message["name"]="bool &";
						break;
					case "OBJECTBUFFER":
						$message["name"]="object &";
						break;
					case "ARRAYBUFFER":
						$message["name"]="array &";
						break;
					case "HASHBUFFER":
						$message["name"]="array &";
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,$message["type"]." is not a supported class data type");
						return(0);
				}
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,"bindings for function \"$function\" are not implemented for language ".$compiler->language["name"]);
				return(0);
		}
		return(1);
	}
};

}
?>