<?php
if(!defined("METAL_PHP_EXPRESSIONS_BINDINGS_INCLUDED"))
{
	define("METAL_PHP_EXPRESSIONS_BINDINGS_INCLUDED",1);

/*
 * php_expressions.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/php_expressions.php,v 1.27 2003/03/27 12:26:40 mlemos Exp $
 *
 */

class php_expressions_class extends metal_language_bindings_class
{
	Function Execute(&$compiler,&$context,&$class,$function,&$message)
	{
		switch($function)
		{
			case "value":
				switch($message["type"])
				{
					case "ARRAY":
					case "HASH":
						$value="array(";
						$elements=count($message["elements"]);
						for($element=0;$element<$elements;$element++)
						{
							if($element>0)
							{
								if($message["type"]=="ARRAY"
								|| ($element % 2)==0)
									$value.=",";
								else
									$value.="=>";
							}
							$value.=$message["elements"][$element];
						}
						$value.=")";
						$message["value"]=$value;
						$message["type"].="::REFERENCE";
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,$message["type"]." is not a supported $function type");
						return(0);
				}
				break;
			case "arrayreset":
				$context->result[]=array(
					"Data"=>$message["array"]."[".$message["index"]."]=array(",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>1,
					"Type"=>"INDENT"
				);
				for($element=0;$element<count($message["elements"]);$element++)
				{
					$context->result[]=array(
						"Data"=>$message["elements"][$element].($element+1<count($message["elements"]) ? "," : ""),
						"Type"=>"COMMAND"
					);
				}
				$context->result[]=array(
					"Data"=>1,
					"Type"=>"OUTDENT"
				);
				$context->result[]=array(
					"Data"=>");",
					"Type"=>"COMMAND"
				);
				break;
			case "hashreset":
				$context->result[]=array(
					"Data"=>$message["hash"]."[".$message["index"]."]=array(",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>1,
					"Type"=>"INDENT"
				);
				for($element=0;$element<count($message["elements"]);$element+=2)
				{
					$context->result[]=array(
						"Data"=>$message["elements"][$element]."=>".$message["elements"][$element+1].($element+2<count($message["elements"]) ? "," : ""),
						"Type"=>"COMMAND"
					);
				}
				$context->result[]=array(
					"Data"=>1,
					"Type"=>"OUTDENT"
				);
				$context->result[]=array(
					"Data"=>");",
					"Type"=>"COMMAND"
				);
				break;
			case "length":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"strlen(".$message["string"].")",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "substring":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"substr(".$message["string"].",".$message["position"].(IsSet($message["length"]) ? ",".$message["length"] : "").")",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "code":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"Ord(".$message["character"].")",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "group":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"(".$message["expression"].")",
						"Type"=>$message["type"],
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "convert":
				switch($message["type"])
				{
					case "INTEGER":
						if(strcmp($message["targettype"],"INTEGER"))
							$expression_value="intval(".$message["expression"].")";
						break;
					case "STRING":
						switch($message["targettype"])
						{
							case "STRING":
								break;
							case "BOOLEAN":
								$expression_value="(".$message["expression"]." ? '1' : '0')";
								break;
							default:
								$expression_value="strval(".$message["expression"].")";
								break;
						}
						break;
					case "BOOLEAN":
						if(strcmp($message["targettype"],"BOOLEAN"))
							$expression_value="(intval(".$message["expression"].")!=0)";
						break;
					case "FLOAT":
						if(strcmp($message["targettype"],"FLOAT"))
							$expression_value="(doubleval(".$message["expression"].")!=0)";
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,"it is not supported to convert a ".$message["targettype"]." expression to ".$message["type"]);
						return(0);
				}
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$expression_value,
						"Type"=>$message["type"],
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "concatenate":
				$context->result[]=array(
					"Data"=>(IsSet($message["string"]) ? $message["string"] : $message["buffer"]).".=".$message["append"].";",
					"Type"=>"COMMAND"
				);
				break;
			case "increment":
			case "incrementbuffer":
				$context->result[]=array(
					"Data"=>$message["expression"]."++;",
					"Type"=>"COMMAND"
				);
				break;
			case "decrement":
			case "decrementbuffer":
				$context->result[]=array(
					"Data"=>$message["expression"]."--;",
					"Type"=>"COMMAND"
				);
				break;
			case "lowercase":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"strtolower(".$message["string"].")",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "uppercase":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"strtoupper(".$message["string"].")",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "utf8encode":
			case "utf8decode":
				switch($function)
				{
					case "utf8encode":
						$encoding="utf8_encode";
						$value=$message["encoded"];
						break;
					case "utf8decode":
						$encoding="utf8_decode";
						$value=$message["decoded"];
						break;
				}
				$context->result[]=array(
					"Data"=>"$value=$encoding(".$message["data"].");",
					"Type"=>"COMMAND"
				);
				break;
			case "setentry":
			case "entry":
			case "entryindex":
			case "entrydefined":
			case "undefineentry":
				$value=$message["array"]."[".$message["index"]."]";
				switch($function)
				{
					case "setentry":
						switch($compiler->strtok($message["type"],":"))
						{
							case "OBJECT":
							case "ARRAY":
							case "HASH":
								$compiler->strtok(":");
								$reference=($compiler->strtok(":")=="REFERENCE" ? "" : "&");
								break;
							default:
								$reference="";
								break;
						}
						$context->result[]=array(
							"Data"=>$value."=".$reference.$message["value"].";",
							"Type"=>"COMMAND"
						);
						break;
					case "entry":
					case "entryindex":
						$context->result[]=array(
							"Data"=>array(
								"Value"=>$value,
								"Type"=>$message["type"],
								"Side"=>$function=="entry" ? "RIGHT" : "LEFT"
							),
							"Type"=>"EXPRESSION"
						);
						break;
					case "entrydefined":
						$context->result[]=array(
							"Data"=>array(
								"Value"=>"IsSet($value)",
								"Type"=>"BOOLEAN",
								"Side"=>"RIGHT"
							),
							"Type"=>"EXPRESSION"
						);
						break;
					case "undefineentry":
						$context->result[]=array(
							"Data"=>"UnSet($value);",
							"Type"=>"COMMAND"
						);
						break;
				}
				break;
			case "count":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"count(".$message["array"].")",
						"Type"=>"INTEGER",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "reset":
			case "next":
				$context->result[]=array(
					"Data"=>($function=="reset" ? "Reset" : "Next")."(".$message["hash"].");",
					"Type"=>"COMMAND"
				);
				$next=$message["key"]."=Key(".$message["hash"].")";
				if(IsSet($message["end"]))
				{
					$context->result[]=array(
						"Data"=>$message["end"]."=(GetType($next)!='string');",
						"Type"=>"COMMAND"
					);
				}
				else
				{
					$context->result[]=array(
						"Data"=>$next.";",
						"Type"=>"COMMAND"
					);
				}
				break;
			case "not":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"!".$message["expression"],
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "conditional":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"((".$message["condition"].") ? ".$message[$message["not"] ? "else" : "then"]." : ".$message[$message["not"] ? "then" : "else"].")",
						"Type"=>$message["type"],
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "void":
				$context->result[]=array(
					"Data"=>$message["expression"].";",
					"Type"=>"COMMAND"
				);
				break;
			case "isnull":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"!IsSet(".$message["expression"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "set":
			case "setbuffer":
				switch($compiler->strtok($message["type"],":"))
				{
					case "OBJECT":
					case "ARRAY":
					case "HASH":
						$compiler->strtok(":");
						$reference=($compiler->strtok(":")=="REFERENCE" ? "" : "&");
						break;
					default:
						$reference="";
						break;
				}
				$context->result[]=array(
					"Data"=>$message["left"]."=".$reference.$message["right"].";",
					"Type"=>"COMMAND"
				);
				break;
			case "buffervalue":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$message["buffer"],
						"Type"=>$message["type"],
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "null":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"null",
						"Type"=>$message["type"]."::REFERENCE",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,"bindings for function \"$function\" are not implemented for language ".$compiler->language["name"]);
				return(0);
		}
		return(1);
	}
};

}
?>