<?php
if(!defined("METAL_PHP_FLOW_BINDINGS_INCLUDED"))
{
	define("METAL_PHP_FLOW_BINDINGS_INCLUDED",1);

/*
 * php_flow.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/php_flow.php,v 1.9 2002/12/10 00:24:24 mlemos Exp $
 *
 */
 
class php_flow_class extends metal_language_bindings_class
{
	Function Execute(&$compiler,&$context,&$class,$function,&$message)
	{
		switch($function)
		{
			case "loop.while":
				if($message["loopstart"])
				{
					$message["commands"][]=array(
						"Data"=>"if(!(".$message["condition"]."))",
						"Type"=>"COMMAND"
					);
					$message["commands"][]=array(
						"Data"=>1,
						"Type"=>"INDENT"
					);
					$message["commands"][]=array(
						"Data"=>"break;",
						"Type"=>"COMMAND"
					);
					$message["commands"][]=array(
						"Data"=>1,
						"Type"=>"OUTDENT"
					);
				}
				else
				{
					$message["commands"]=array(
						array(
							"Data"=>"for(;".$message["condition"].";)",
							"Type"=>"COMMAND"
						),
						array(
							"Data"=>"{",
							"Type"=>"COMMAND"
						),
						array(
							"Data"=>1,
							"Type"=>"INDENT"
						)
					);
					$message["loopstart"]=1;
				}
				break;
			case "loop.do":
				if(!$message["loopstart"])
				{
					$message["commands"]=array(
						array(
							"Data"=>"for(;;)",
							"Type"=>"COMMAND"
						),
						array(
							"Data"=>"{",
							"Type"=>"COMMAND"
						),
						array(
							"Data"=>1,
							"Type"=>"INDENT"
						)
					);
					$message["loopstart"]=1;
				}
				if(!$class->GetDoCommands($compiler,$context,$message["path"],$message["commands"],"invalid loop do statments",$message["skipwhitespace"]))
					return(0);
				break;
			case "loop.end":
				if(!$message["loopstart"])
				{
					$message["commands"]=array(
						array(
							"Data"=>"for(;;)",
							"Type"=>"COMMAND"
						),
						array(
							"Data"=>"{",
							"Type"=>"COMMAND"
						),
						array(
							"Data"=>1,
							"Type"=>"INDENT"
						)
					);
					$message["loopstart"]=1;
				}
				$message["commands"][]=array(
					"Data"=>1,
					"Type"=>"OUTDENT"
				);
				$message["commands"][]=array(
					"Data"=>"}",
					"Type"=>"COMMAND"
				);
				break;
			case "switch":
				$context->result[]=array(
					"Data"=>"switch(".$message["value"].")",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>"{",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>1,
					"Type"=>"INDENT"
				);
				for($case=0,Reset($message["case"]);$case<count($message["case"]);Next($message["case"]),$case++)
				{
					$value=Key($message["case"]);
					$context->result[]=array(
						"Data"=>"case ".$message["case"][$value]["value"].":",
						"Type"=>"COMMAND"
					);
					$context->result[]=array(
						"Data"=>1,
						"Type"=>"INDENT"
					);
					if(!$class->GetDoCommands($compiler,$context,$message["case"][$value]["do"],$context->result,"invalid switch case do statments",1))
						return(0);
					$context->result[]=array(
						"Data"=>1,
						"Type"=>"OUTDENT"
					);
				}
				if(IsSet($message["default"]))
				{
					$context->result[]=array(
						"Data"=>"default:",
						"Type"=>"COMMAND"
					);
					$context->result[]=array(
						"Data"=>1,
						"Type"=>"INDENT"
					);
					if(!$class->GetDoCommands($compiler,$context,$message["default"],$context->result,"invalid switch case do statments",1))
						return(0);
					$context->result[]=array(
						"Data"=>1,
						"Type"=>"OUTDENT"
					);
				}
				$context->result[]=array(
					"Data"=>1,
					"Type"=>"OUTDENT"
				);
				$context->result[]=array(
					"Data"=>"}",
					"Type"=>"COMMAND"
				);
				break;
			case "break":
			case "continue":
				$message["commands"][]=array(
					"Data"=>$function.($message["level"]==1 ? "" : " ".$message["level"]).";",
					"Type"=>"COMMAND"
				);
				break;
			case "if":
				$message["commands"][]=array(
					"Data"=>"if(".(IsSet($message["istrue"]) ? $message["istrue"] : "!(".$message["isfalse"].")").")",
					"Type"=>"COMMAND"
				);
				if(!$class->GetCommands($compiler,$context,$message["then"],$message["commands"],"invalid then if statments",$message["skipwhitespace"]))
					return(0);
				if(IsSet($message["else"]))
				{
					$message["commands"][]=array(
						"Data"=>"else",
						"Type"=>"COMMAND"
					);
					if(!$class->GetCommands($compiler,$context,$message["else"],$message["commands"],"invalid then if statments",$message["skipwhitespace"]))
						return(0);
				}
				break;
			case "comment":
				for($line=0;$line<$message["linesbefore"];$line++)
				{
					$context->result[]=array(
						"Data"=>"",
						"Type"=>"COMMAND"
					);
				}
				$context->result[]=array(
					"Data"=>"/*",
					"Type"=>"COMMAND"
				);
				while(strcmp($message["comment"],""))
				{
					$message["comment"]=$compiler->strtok($message["comment"],"\r\n");
					$context->result[]=array(
						"Data"=>" *  ".$message["comment"],
						"Type"=>"COMMAND"
					);
					$message["comment"]=$compiler->strtok("");
				}
				$context->result[]=array(
					"Data"=>" */",
					"Type"=>"COMMAND"
				);
				for($line=0;$line<$message["linesafter"];$line++)
				{
					$context->result[]=array(
						"Data"=>"",
						"Type"=>"COMMAND"
					);
				}
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,"bindings for function \"$function\" are not implemented for language ".$compiler->language["name"]);
				return(0);
		}
		return(1);
	}
};

}
?>